public Action Admin_giveTitle(int client, int args)
{
	if (!IsValidClient(client))
		return Plugin_Handled;

	if (g_iCustomTitleCount == 0)
	{
		PrintToChat(client, "[%cCK%c] No custom titles loaded.", MOSSGREEN, WHITE);
		return Plugin_Handled;
	}

	g_iAdminSelectedClient[client] = -1;
	g_iAdminEditingType[client] = 1;
	Format(g_szAdminSelectedSteamID[client], 32, "");

	for (int i = 0; i < TITLE_COUNT; i++)
		g_bAdminFlagTitlesTemp[client][i] = false;

	if (args == 0)
	{
		Menu playerMenu = CreateMenu(Handler_selectPlayer);
		SetMenuTitle(playerMenu, "Select Player to give title to:");

		char szName[MAX_NAME_LENGTH], id[8];
		for (int i = 1; i < MAXPLAYERS; i++)
		{
			if (IsValidClient(i) && !IsFakeClient(i))
			{
				IntToString(i, id, 8);
				GetClientName(i, szName, MAX_NAME_LENGTH);
				AddMenuItem(playerMenu, id, szName);
			}
		}
		SetMenuExitButton(playerMenu, true);
		DisplayMenu(playerMenu, client, MENU_TIME_FOREVER);
		return Plugin_Handled;
	}
	if (args > 0)
	{
		char sResult[MAX_NAME_LENGTH], arg[MAX_NAME_LENGTH];

		GetCmdArg(1, arg, 32);

		if (StrContains(arg, "STEAM_", false) != -1)
		{
			for (int i = 1; i < (MAXPLAYERS + 1); i++)
			{
				if (IsValidClient(i) && !IsFakeClient(i))
				{
					GetClientAuthId(i, AuthId_Steam2, g_szAdminSelectedSteamID[client], MAX_NAME_LENGTH, true);
					if (StrEqual(g_szAdminSelectedSteamID[client], arg, false))
					{
						g_iAdminSelectedClient[client] = i;
						break;
					}
				}
			}
			db_checkPlayersTitles(client);
		}
		else
		{
			for (int i = 1; i < (MAXPLAYERS + 1); i++)
			{
				if (IsValidClient(i) && !IsFakeClient(i))
				{
					GetClientName(i, sResult, MAX_NAME_LENGTH);
					if (StrEqual(sResult, arg, false))
					{
						GetClientAuthId(i, AuthId_Steam2, g_szAdminSelectedSteamID[client], MAX_NAME_LENGTH, true);
						g_iAdminSelectedClient[client] = i;
						break;
					}
				}
			}
			if (g_iAdminSelectedClient[client] == -1)
			{
				PrintToChat(client, "[%cCK%c] Couldn't find player %s", MOSSGREEN, WHITE, arg);
			}
			else
			{
				db_checkPlayersTitles(client);
			}
		}
	}
	return Plugin_Handled;
}

public int Handler_selectPlayer(Handle tMenu, MenuAction action, int client, int item)
{
	switch (action)
	{
		case MenuAction_Select:
		{
			char aID[8];
			GetMenuItem(tMenu, item, aID, sizeof(aID));
			g_iAdminSelectedClient[client] = StringToInt(aID);
			GetClientAuthId(g_iAdminSelectedClient[client], AuthId_Steam2, g_szAdminSelectedSteamID[client], MAX_NAME_LENGTH, true);

			switch (g_iAdminEditingType[client])
			{
				case 1:db_checkPlayersTitles(client);
				case 2:db_deletePlayerTitles(client);
				case 3:db_checkPlayersTitles(client);
			}
		}
		case MenuAction_End:
		{
			CloseHandle(tMenu);
		}
	}
}

public int Handler_TitleMenu(Handle tMenu, MenuAction action, int client, int item)
{
	switch (action)
	{
		case MenuAction_Select:
		{
			char aID[8];
			GetMenuItem(tMenu, item, aID, sizeof(aID));
			int titleID = StringToInt(aID);

			if (titleID == -1)
				return;
			if (g_iAdminSelectedClient[client] != -1)
				Array_Copy(g_bflagTitles[client], g_bflagTitles_orig[client], TITLE_COUNT);

			if (g_bAdminFlagTitlesTemp[client][titleID])
				g_bAdminFlagTitlesTemp[client][titleID] = false;
			else
				g_bAdminFlagTitlesTemp[client][titleID] = true;

			if (g_bAdminSelectedHasFlag[client])
				db_updatePlayerTitles(client, titleID);
			else
				db_insertPlayerTitles(client, titleID);
		}
		case MenuAction_End:
		{
			CloseHandle(tMenu);
		}
	}
}

public Action Admin_deleteTitles(int client, int args)
{
	if (!IsValidClient(client))
		return Plugin_Handled;

	g_iAdminSelectedClient[client] = -1;
	g_iAdminEditingType[client] = 2;
	Format(g_szAdminSelectedSteamID[client], 32, "");

	for (int i = 0; i < TITLE_COUNT; i++)
		g_bAdminFlagTitlesTemp[client][i] = false;


	if (args == 0)
	{
		Menu playerMenu = CreateMenu(Handler_selectPlayer);
		SetMenuTitle(playerMenu, "Select player to delete titles from:");

		char szName[MAX_NAME_LENGTH], id[2];
		for (int i = 1; i < (MAXPLAYERS + 1); i++)
		{
			if (IsValidClient(i) && !IsFakeClient(i))
			{
				IntToString(i, id, 2);
				GetClientName(i, szName, MAX_NAME_LENGTH);
				AddMenuItem(playerMenu, id, szName);
			}
		}
		SetMenuExitButton(playerMenu, true);
		DisplayMenu(playerMenu, client, MENU_TIME_FOREVER);
		return Plugin_Handled;
	}
	if (args > 0)
	{
		char sResult[MAX_NAME_LENGTH], arg[MAX_NAME_LENGTH];

		GetCmdArg(1, arg, 32);

		if (StrContains(arg, "STEAM_", false) != -1)
		{
			for (int i = 1; i < (MAXPLAYERS + 1); i++)
			{
				if (IsValidClient(i) && !IsFakeClient(i))
				{
					GetClientAuthId(i, AuthId_Steam2, g_szAdminSelectedSteamID[client], MAX_NAME_LENGTH, true);
					//GetClientAuthString(i, g_szAdminSelectedSteamID[client], MAX_NAME_LENGTH, true);
					if (StrEqual(g_szAdminSelectedSteamID[client], arg, false))
					{
						g_iAdminSelectedClient[client] = i;
						break;
					}
				}
			}
			db_deletePlayerTitles(client);
		}
		else
		{
			for (int i = 1; i < (MAXPLAYERS + 1); i++)
			{
				if (IsValidClient(i) && !IsFakeClient(i))
				{
					GetClientName(i, sResult, MAX_NAME_LENGTH);
					if (StrEqual(sResult, arg, false))
					{
						GetClientAuthId(i, AuthId_Steam2, g_szAdminSelectedSteamID[client], MAX_NAME_LENGTH, true);
						//GetClientAuthString(i, g_szAdminSelectedSteamID[client], MAX_NAME_LENGTH, true);
						g_iAdminSelectedClient[client] = i;
						break;
					}
				}
			}
			if (g_iAdminSelectedClient[client] == -1)
			{
				PrintToChat(client, "[%cCK%c] Couldn't find player %s", MOSSGREEN, WHITE, arg);
			}
			else
			{
				db_deletePlayerTitles(client);
			}
		}
	}
	return Plugin_Handled;
}

public Action Admin_deleteTitle(int client, int args)
{
	g_iAdminSelectedClient[client] = -1;
	g_iAdminEditingType[client] = 3;
	Format(g_szAdminSelectedSteamID[client], 32, "");

	for (int i = 0; i < TITLE_COUNT; i++)
		g_bAdminFlagTitlesTemp[client][i] = false;

	if (!IsValidClient(client))
		return Plugin_Handled;

	if (args == 0)
	{
		Menu playerMenu = CreateMenu(Handler_selectPlayer);
		SetMenuTitle(playerMenu, "Select player to remove title from:");

		char szName[MAX_NAME_LENGTH], id[2];
		for (int i = 1; i < (MAXPLAYERS + 1); i++)
		{
			if (IsValidClient(i) && !IsFakeClient(i))
			{
				IntToString(i, id, 2);
				GetClientName(i, szName, MAX_NAME_LENGTH);
				AddMenuItem(playerMenu, id, szName);
			}
		}
		SetMenuExitButton(playerMenu, true);
		DisplayMenu(playerMenu, client, MENU_TIME_FOREVER);
		return Plugin_Handled;
	}
	if (args > 0)
	{
		char sResult[MAX_NAME_LENGTH], arg[MAX_NAME_LENGTH];

		GetCmdArg(1, arg, 32);

		if (StrContains(arg, "STEAM_", false) != -1)
		{
			for (int i = 1; i < (MAXPLAYERS + 1); i++)
			{
				if (IsValidClient(i) && !IsFakeClient(i))
				{
					GetClientAuthId(i, AuthId_Steam2, g_szAdminSelectedSteamID[client], MAX_NAME_LENGTH, true);
					//GetClientAuthString(i, g_szAdminSelectedSteamID[client], MAX_NAME_LENGTH, true);
					if (StrEqual(g_szAdminSelectedSteamID[client], arg, false))
					{
						g_iAdminSelectedClient[client] = i;
						break;
					}
				}
			}
			db_checkPlayersTitles(client);
		}
		else
		{
			for (int i = 1; i < (MAXPLAYERS + 1); i++)
			{
				if (IsValidClient(i) && !IsFakeClient(i))
				{
					GetClientName(i, sResult, MAX_NAME_LENGTH);
					if (StrEqual(sResult, arg, false))
					{
						GetClientAuthId(i, AuthId_Steam2, g_szAdminSelectedSteamID[client], MAX_NAME_LENGTH, true);
						//GetClientAuthString(i, g_szAdminSelectedSteamID[client], MAX_NAME_LENGTH, true);
						g_iAdminSelectedClient[client] = i;
						break;
					}
				}
			}
			if (g_iAdminSelectedClient[client] == -1)
			{
				PrintToChat(client, "[%cCK%c] Couldn't find player %s", MOSSGREEN, WHITE, arg);
			}
			else
			{
				db_checkPlayersTitles(client);
			}
		}
	}
	return Plugin_Handled;
}


public void Admin_renameZone(int client, const char[] name)
{
	if (!IsValidClient(client))
	{
		g_ClientRenamingZone[client] = false;
		return;
	}
	//avoid unnecessary calls by checking the first cell first. If it's 0 -> \0 then negating it will make the if check pass -> return
	if (!name[0] || StrEqual(name, " ") || StrEqual(name, ""))
	{
		PrintToChat(client, "[%CK%c] Please give the zone a valid name.", MOSSGREEN, WHITE);
		return;
	}
	if (strlen(name) > 128)
	{
		PrintToChat(client, "[%cCK%c] Zone name too long. Maximum is 128 characters.", MOSSGREEN, WHITE);
		return;
	}
	if (StrEqual(name, "!cancel", false)) //false -> non sensitive
	{
		PrintToChat(client, "[%cCK%c] Cancelled bonus renaming.", MOSSGREEN, WHITE);
		g_ClientRenamingZone[client] = false;
		ListBonusSettings(client);
		return;
	}
	char szZoneName[128];

	Format(szZoneName, 128, "%s", name);
	db_setZoneNames(client, szZoneName);
	g_ClientRenamingZone[client] = false;
}

public void OnAdminMenuReady(Handle topmenu)
{
	if (topmenu == g_hAdminMenu)
		return;

	g_hAdminMenu = topmenu;
	TopMenuObject serverCmds = FindTopMenuCategory(g_hAdminMenu, ADMINMENU_SERVERCOMMANDS);
	AddToTopMenu(g_hAdminMenu, "sm_ckadmin", TopMenuObject_Item, TopMenuHandler2, serverCmds, "sm_ckadmin", ADMFLAG_RCON);
}

public int TopMenuHandler2(Handle topmenu, TopMenuAction action, TopMenuObject object_id, int param, char[] buffer, int maxlength)
{
	if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "ckSurf");

	else
		if (action == TopMenuAction_SelectOption)
		Admin_ckPanel(param, 0);
}

public Action Admin_insertMapTier(int client, int args)
{
	if (!IsValidClient(client))
		return Plugin_Handled;

	if (args < 2)
	{
		ReplyToCommand(client, "[CK] Usage: sm_addmaptier <ZoneGroup> <Tier>");
		PrintToChat(client, "[%cCK%c] Zone Groups:", MOSSGREEN, WHITE);
		PrintToChat(client, "[%c0.%c] Map Tier", BLUE, WHITE);
		for (int i = 1; i < g_mapZoneGroupCount; i++)
		{
			PrintToChat(client, "[%c%i.%c] %s", YELLOW, i, WHITE, g_szZoneGroupName[i]);
		}
		return Plugin_Handled;
	}
	if (args > 1)
	{
		char arg1[3];
		int tier, zonegroup;
		GetCmdArg(2, arg1, sizeof(arg1));
		tier = StringToInt(arg1);
		GetCmdArg(1, arg1, sizeof(arg1));
		zonegroup = StringToInt(arg1);
		if ((tier < 7 || tier > 0) && (-1 < zonegroup < g_mapZoneGroupCount))
			db_insertMapTier(tier, zonegroup);
		else
			PrintToChat(client, "[%cCK%c] Invalid tier number or zone group. Please choose a tier number between 1-6 and a valid zone group.", MOSSGREEN, WHITE);
	}
	return Plugin_Handled;
}

public Action Admin_insertSpawnLocation(int client, int args)
{
	if (!IsValidClient(client))
		return Plugin_Handled;

	float SpawnLocation[3];
	float SpawnAngle[3];

	GetClientAbsOrigin(client, SpawnLocation);
	GetClientEyeAngles(client, SpawnAngle);

	SpawnLocation[2] += 3.0;

	if (g_bGotSpawnLocation[g_iClientInZone[client][2]])
	{
		db_updateSpawnLocations(SpawnLocation, SpawnAngle, g_iClientInZone[client][2]);
		PrintToChat(client, "[%cCK%c] Spawnpoint edited", MOSSGREEN, WHITE);
	}
	else
	{
		db_insertSpawnLocations(SpawnLocation, SpawnAngle, g_iClientInZone[client][2]);
		PrintToChat(client, "[%cCK%c] Spawnpoint added", MOSSGREEN, WHITE);
	}

	return Plugin_Handled;
}

public Action Admin_deleteSpawnLocation(int client, int args)
{
	if (!IsValidClient(client))
		return Plugin_Handled;
	if (g_bGotSpawnLocation[g_iClientInZone[client][2]])
	{
		db_deleteSpawnLocations(g_iClientInZone[client][2]);
		PrintToChat(client, "[%cCK%c] Spawnpoint deleted", MOSSGREEN, WHITE);
	}
	else
		PrintToChat(client, "[%cCK%c] No spawnpoint to delete!", MOSSGREEN, WHITE);

	return Plugin_Handled;
}

public Action Admin_ClearAssists(int client, int args)
{
	for (int i = 1; i <= MAXPLAYERS; i++)
		if (IsValidClient(i))
		{
			CS_SetClientAssists(i, 0);
			g_fMaxPercCompleted[0] = 0.0;
			CS_SetMVPCount(i, 0);
		}

	return Plugin_Handled;
}

public Action Admin_ckPanel(int client, int args)
{
	ckAdminMenu(client);
	if ((GetUserFlagBits(client) & g_AdminMenuFlag))
	{
		PrintToChat(client, "[%cCK%c] See console for more commands", LIMEGREEN, WHITE);
		PrintToConsole(client, "\n[ckSurf root admin]\n");
		PrintToConsole(client, "\n sm_refreshprofile <steamid> (recalculates player profile for given steamid)\n sm_deleteproreplay <mapname> (Deletes pro replay file for a given map)\n sm_deletetpreplay <mapname> (Deletes tp replay file for a given map)\n ");
		PrintToConsole(client, "\n sm_zones (Open up the zonee modification menu)\n sm_insertmapzones (Inserts premade map zones into the servers database. ONLY RUN THIS ONCE!)\n sm_insertmaptiers (Inserts premade map tier information into the servers database. ONLY RUN THIS ONCE!)\n");
		PrintToConsole(client, "[PLAYER RANKING]\n sm_resetranks (Drops playerrank table)\n sm_resetchallenges (Drops challenges table)\n sm_resetplayerchallenges <steamid> (Resets (won) challenges for given steamid)\n sm_resetextrapoints (Resets given extra points for all players)\n");
		PrintToConsole(client, "[PLAYER TIMES]\n sm_resettimes (Drops playertimes table)\n sm_resetmaptimes <map> (Resets player times for given map)\n sm_resetplayertimes <steamid> [<map>] (Resets players times + extra points for given steamid with or without given map.)\n");
		PrintToConsole(client, " sm_resetplayertime <steamid> <map> (Resets map time for given steamid and map)\n");
		PrintToConsole(client, "sm_deletecheckpoints (Deletes all checkpoint times in the current map)\n sm_deletebonus (Deletes all bonus times in the current map)\n \n");

	}
	return Plugin_Handled;
}

public void ckAdminMenu(int client)
{
	if (!IsValidClient(client))
		return;

	if (!(GetUserFlagBits(client) & g_AdminMenuFlag) && !(GetUserFlagBits(client) & ADMFLAG_ROOT))
	{
		PrintToChat(client, "[%cCK%c] You don't have access to the admin menu.", MOSSGREEN, WHITE);
		return;
	}

	char szTmp[128];

	Handle adminmenu = CreateMenu(AdminPanelHandler);
	if (GetUserFlagBits(client) & g_ZoneMenuFlag)
		Format(szTmp, sizeof(szTmp), "ckSurf %s Admin Menu (full access)", VERSION);
	else
		Format(szTmp, sizeof(szTmp), "ckSurf %s Admin Menu (limited access)", VERSION);
	SetMenuTitle(adminmenu, szTmp);

	if (!g_pr_RankingRecalc_InProgress)
		AddMenuItem(adminmenu, "[1.] Recalculate player ranks", "[1.] Recalculate player ranks");
	else
		AddMenuItem(adminmenu, "[1.] Recalculate player ranks", "[1.] Stop the recalculation");

	AddMenuItem(adminmenu, "", "", ITEMDRAW_SPACER);

	int menuItemNumber = 2;

	if (GetUserFlagBits(client) & g_ZoneMenuFlag)
	{
		Format(szTmp, sizeof(szTmp), "[%i.] Edit or create zones", menuItemNumber);
		AddMenuItem(adminmenu, szTmp, szTmp);
	}
	else
	{
		Format(szTmp, sizeof(szTmp), "[%i.] Edit or create zones", menuItemNumber);
		AddMenuItem(adminmenu, szTmp, szTmp, ITEMDRAW_DISABLED);
	}
	menuItemNumber++;

	if (GetConVarBool(g_hCvarGodMode))
		Format(szTmp, sizeof(szTmp), "[%i.] Godmode  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Godmode  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hCvarNoBlock))
		Format(szTmp, sizeof(szTmp), "[%i.] Noblock  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Noblock  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hAutoRespawn))
		Format(szTmp, sizeof(szTmp), "[%i.] Autorespawn  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Autorespawn  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hCleanWeapons))
		Format(szTmp, sizeof(szTmp), "[%i.] Strip weapons  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Strip weapons  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hcvarRestore))
		Format(szTmp, sizeof(szTmp), "[%i.] Restore function  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Restore function  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hPauseServerside))
		Format(szTmp, sizeof(szTmp), "[%i.] !pause command -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] !pause command  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hGoToServer))
		Format(szTmp, sizeof(szTmp), "[%i.] !goto command  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] !goto command  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hRadioCommands))
		Format(szTmp, sizeof(szTmp), "[%i.] Radio commands  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Radio commands  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	/*if (GetConVarBool(g_hAutoTimer))
		Format(szTmp, sizeof(szTmp), "[%i.] Timer starts at spawn  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Timer starts at spawn  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;*/

	if (GetConVarBool(g_hReplayBot))
		Format(szTmp, sizeof(szTmp), "[%i.] Replay bot  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Replay bot  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hPointSystem))
		Format(szTmp, sizeof(szTmp), "[%i.] Player point system  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Player point system  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hCountry))
		Format(szTmp, sizeof(szTmp), "[%i.] Player country tag  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Player country tag  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hPlayerSkinChange))
		Format(szTmp, sizeof(szTmp), "[%i.] Allow custom models  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Allow custom models  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hNoClipS))
		Format(szTmp, sizeof(szTmp), "[%i.] +noclip  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] +noclip (admin/vip excluded)  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hAutoBhopConVar))
		Format(szTmp, sizeof(szTmp), "[%i.] Auto bunnyhop (only surf_/bhop_ maps)  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Auto bunnyhop  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hAdminClantag))
		Format(szTmp, sizeof(szTmp), "[%i.] Admin clan tag  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Admin clan tag  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hMapEnd))
		Format(szTmp, sizeof(szTmp), "[%i.] Allow map changes  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[i.] Allow map changes  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hConnectMsg))
		Format(szTmp, sizeof(szTmp), "[%i.] Connect message  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Connect message  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hDisconnectMsg))
		Format(szTmp, sizeof(szTmp), "[%i.] Disconnect message - Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Disconnect message - Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hInfoBot))
		Format(szTmp, sizeof(szTmp), "[%i.] Info bot  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Info bot  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hAttackSpamProtection))
		Format(szTmp, sizeof(szTmp), "[%i.] Attack spam protection  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Attack spam protection  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hChallengePoints))
		Format(szTmp, sizeof(szTmp), "[%i.] Allow challenges points  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Allow challenges points  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	if (GetConVarBool(g_hAllowRoundEndCvar))
		Format(szTmp, sizeof(szTmp), "[%i.] Allow to end the current round  -  Enabled", menuItemNumber);
	else
		Format(szTmp, sizeof(szTmp), "[%i.] Allow to end the current round  -  Disabled", menuItemNumber);
	AddMenuItem(adminmenu, szTmp, szTmp);
	menuItemNumber++;

	SetMenuExitButton(adminmenu, true);
	SetMenuOptionFlags(adminmenu, MENUFLAG_BUTTON_EXIT);
	if (g_AdminMenuLastPage[client] < 6)
		DisplayMenuAtItem(adminmenu, client, 0, MENU_TIME_FOREVER);
	else
		if (g_AdminMenuLastPage[client] < 12)
			DisplayMenuAtItem(adminmenu, client, 6, MENU_TIME_FOREVER);
		else
			if (g_AdminMenuLastPage[client] < 18)
				DisplayMenuAtItem(adminmenu, client, 12, MENU_TIME_FOREVER);
			else
				if (g_AdminMenuLastPage[client] < 24)
					DisplayMenuAtItem(adminmenu, client, 18, MENU_TIME_FOREVER);
				else
					if (g_AdminMenuLastPage[client] < 30)
						DisplayMenuAtItem(adminmenu, client, 24, MENU_TIME_FOREVER);
					else
						if (g_AdminMenuLastPage[client] < 36)
							DisplayMenuAtItem(adminmenu, client, 30, MENU_TIME_FOREVER);
						else
							if (g_AdminMenuLastPage[client] < 42)
								DisplayMenuAtItem(adminmenu, client, 36, MENU_TIME_FOREVER);
}


public int AdminPanelHandler(Handle menu, MenuAction action, int param1, int param2)
{
	if (action == MenuAction_Select)
	{
		bool refresh = true;
		switch (param2)
		{
			case 0:
			{
				if (!g_pr_RankingRecalc_InProgress)
				{
					PrintToChat(param1, "%t", "PrUpdateStarted", MOSSGREEN, WHITE);
					g_bManualRecalc = true;
					g_pr_Recalc_AdminID = param1;
					RefreshPlayerRankTable(MAX_PR_PLAYERS);
				}
				else
				{
					for (int i = 66; i < MAX_PR_PLAYERS; i++)
						g_bProfileRecalc[i] = false;
					g_bManualRecalc = false;
					g_pr_RankingRecalc_InProgress = false;
					PrintToChat(param1, "%t", "StopRecalculation", MOSSGREEN, WHITE);
				}
			}

			case 2:
			{
				ZoneMenu(param1);
				refresh = false;
			}

			case 3:
			{
				if (!GetConVarBool(g_hCvarGodMode))
					ServerCommand("ck_godmode 1");
				else
					ServerCommand("ck_godmode 0");
			}

			case 4:
			{
				if (!GetConVarBool(g_hCvarNoBlock))
					ServerCommand("ck_noblock 1");
				else
					ServerCommand("ck_noblock 0");
			}

			case 5:
			{
				if (!GetConVarBool(g_hAutoRespawn))
					ServerCommand("ck_autorespawn 1");
				else
					ServerCommand("ck_autorespawn 0");
			}

			case 6:
			{
				if (!GetConVarBool(g_hCleanWeapons))
					ServerCommand("ck_clean_weapons 1");
				else
					ServerCommand("ck_clean_weapons 0");
			}

			case 7:
			{
				if (!GetConVarBool(g_hcvarRestore))
					ServerCommand("ck_restore 1");
				else
					ServerCommand("ck_restore 0");
			}

			case 8:
			{
				if (!GetConVarBool(g_hPauseServerside))
					ServerCommand("ck_pause 1");
				else
					ServerCommand("ck_pause 0");
			}

			case 9:
			{
				if (!GetConVarBool(g_hGoToServer))
					ServerCommand("ck_goto 1");
				else
					ServerCommand("ck_goto 0");
			}

			case 10:
			{
				if (!GetConVarBool(g_hRadioCommands))
					ServerCommand("ck_use_radio 1");
				else
					ServerCommand("ck_use_radio 0");
			}

			case 11:
			{
				if (!GetConVarBool(g_hReplayBot))
					ServerCommand("ck_replay_bot 1");
				else
					ServerCommand("ck_replay_bot 0");
			}

			case 12:
			{
				if (!GetConVarBool(g_hPointSystem))
					ServerCommand("ck_point_system 1");
				else
					ServerCommand("ck_point_system 0");
			}

			case 13:
			{
				if (!GetConVarBool(g_hCountry))
					ServerCommand("ck_country_tag 1");
				else
					ServerCommand("ck_country_tag 0");
			}

			case 14:
			{
				if (!GetConVarBool(g_hPlayerSkinChange))
					ServerCommand("ck_custom_models 1");
				else
					ServerCommand("ck_custom_models 0");
			}

			case 15:
			{
				if (!GetConVarBool(g_hNoClipS))
					ServerCommand("ck_noclip 1");
				else
					ServerCommand("ck_noclip 0");
			}

			case 16:
			{
				if (!GetConVarBool(g_hAutoBhopConVar))
					ServerCommand("ck_auto_bhop 1");
				else
					ServerCommand("ck_auto_bhop 0");
			}

			case 17:
			{
				if (!GetConVarBool(g_hAdminClantag))
					ServerCommand("ck_admin_clantag 1");
				else
					ServerCommand("ck_admin_clantag 0");
			}

			case 18:
			{
				if (!GetConVarBool(g_hMapEnd))
					ServerCommand("ck_map_end 1");
				else
					ServerCommand("ck_map_end 0");
			}

			case 19:
			{
				if (!GetConVarBool(g_hConnectMsg))
					ServerCommand("ck_connect_msg 1");
				else
					ServerCommand("ck_connect_msg 0");
			}

			case 20:
			{
				if (!GetConVarBool(g_hDisconnectMsg))
					ServerCommand("ck_disconnect_msg 1");
				else
					ServerCommand("ck_disconnect_msg 0");
			}

			case 21:
			{
				if (!GetConVarBool(g_hInfoBot))
					ServerCommand("ck_info_bot 1");
				else
					ServerCommand("ck_info_bot 0");
			}

			case 22:
			{
				if (!GetConVarBool(g_hAttackSpamProtection))
					ServerCommand("ck_attack_spam_protection 1");
				else
					ServerCommand("ck_attack_spam_protection 0");
			}

			case 23:
			{
				if (!GetConVarBool(g_hChallengePoints))
					ServerCommand("ck_challenge_points 1");
				else
					ServerCommand("ck_challenge_points 0");
			}

			case 24:
			{
				if (!GetConVarBool(g_hAllowRoundEndCvar))
					ServerCommand("ck_round_end 1");
				else
					ServerCommand("ck_round_end 0");
			}
		}

		g_AdminMenuLastPage[param1] = param2;
		if (menu != null)
			CloseHandle(menu);

		if (refresh)
			CreateTimer(0.1, RefreshAdminMenu, param1, TIMER_FLAG_NO_MAPCHANGE);
	}

	if (action == MenuAction_End)
	{
		//test
		if (IsValidClient(param1))
		{
			if (menu != null)
				CloseHandle(menu);
		}
	}
}

//Drop Map from DB
public Action Admin_DropAllMapRecords(int client, int args)
{
	db_dropPlayer(client);
	return Plugin_Handled;
}

public Action Admin_DropChallenges(int client, int args)
{
	db_dropChallenges(client);
	return Plugin_Handled;
}

public Action Admin_DropPlayerRanks(int client, int args)
{
	db_dropPlayerRanks(client);
	return Plugin_Handled;
}

public int MapTierHandler(Handle tMenu, MenuAction action, int client, int item)
{
	switch (action)
	{
		case MenuAction_Select:
		{
			char selection[12];
			GetMenuItem(tMenu, item, selection, sizeof(selection));
			if (StringToInt(selection) == 1)
				db_deleteAllMaptiers(client);
		}
		case MenuAction_End:
		{
			CloseHandle(tMenu);
		}
	}
}

public Action Admin_InsertMapTiers(int client, int args)
{
	if (g_insertingInformation)
	{
		PrintToChat(client, "[%cCK%c] Wait for inserting to finish, before starting it again..", MOSSGREEN, WHITE);
		return Plugin_Handled;
	}

	Handle MapTierMenu = CreateMenu(MapTierHandler);
	SetMenuTitle(MapTierMenu, "Insert MapTiers\n WARNING: This action will delete all existing maptier data and replace it with ckSurf's premade data.\n Do you wish to continue?");
	AddMenuItem(MapTierMenu, "0", "NO");
	AddMenuItem(MapTierMenu, "0", "NO");
	AddMenuItem(MapTierMenu, "0", "NO");
	AddMenuItem(MapTierMenu, "1", "YES");
	AddMenuItem(MapTierMenu, "0", "NO");
	SetMenuExitBackButton(MapTierMenu, true);
	DisplayMenu(MapTierMenu, client, MENU_TIME_FOREVER);

	return Plugin_Handled;
}

public void Admin_InsertMapTierstoDatabase(int client)
{
	if (!IsValidClient(client))
		return;

	g_insertingInformation = true;

	PrintToChat(client, "[%cCK%c] Maptier information is being inserted into the database. This might take a while.", MOSSGREEN, WHITE);

	Transaction h_addTiers = SQL_CreateTransaction();
	SQL_AddQuery(h_addTiers, "INSERT INTO `ck_maptier` (`mapname`, `tier`, `btier1`, `btier2`, `btier3`, `btier4`, `btier5`, `btier6`, `btier7`, `btier8`, `btier9`, `btier10`) VALUES ('surf_004_final1', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_1day', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_2012_beta12', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_3', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_4dimensional', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_6', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_81st_network_njv', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_abyss_fix', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_acp', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_acp_fix', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_adtr_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_advanced', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_aether', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_again_njv_rg', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_aircontrol_ksf', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_airflow', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_akai_final', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_akai_two_rg', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_alternation', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_amateur_v2b', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_amateur_v2b_', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ambient_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_amplitude_apex_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_amplitude_encore_nsf_v4', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_amplitude_light', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_and_destroy', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_animals', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_annoyance_njv', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_anonymity', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_anthropomorphic-', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_apollonian', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_arghmyeyes', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_artifex', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_aspiration', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_asrown', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_asrown-', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ataque_final', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_atlas_1', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_auroia_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_auroria2', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL); ");
	SQL_AddQuery(h_addTiers, "INSERT INTO `ck_maptier` (`mapname`, `tier`, `btier1`, `btier2`, `btier3`, `btier4`, `btier5`, `btier6`, `btier7`, `btier8`, `btier9`, `btier10`) VALUES ('surf_auroria_2', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_aux', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_awakening_rg', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_aweles', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_bbb', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_beginner', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_beginner_ug', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_beyer', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_beyer2', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_blackout_v1', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_blackside_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_blub_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_boatastic', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_bob', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_boring', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_bork_nbv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_broken', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_b_r_o_x_x_x', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_caca', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_calamity2', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_calamity_njv_', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_calibration', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_canisius', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_canisius2', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_canisius2_fix', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_catalyst', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_catalyst2', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_chaos_rg', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_christmas', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_classics', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_classics2', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_clockwork', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_collaboration', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_collection_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_colors_beta1', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_color_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_colours', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_commune_again_beta5-', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_commune_too_beta5', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_compact', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_compulsive_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL); ");
	SQL_AddQuery(h_addTiers, "INSERT INTO `ck_maptier` (`mapname`, `tier`, `btier1`, `btier2`, `btier3`, `btier4`, `btier5`, `btier6`, `btier7`, `btier8`, `btier9`, `btier10`) VALUES ('surf_concept_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_construction', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_cookiejar', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_coralis_ksf', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_coralis_ksf-', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_core_fix', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_creation', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_crystal', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_crzyfrog_reloaded', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_curious', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_cyanide_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_cyka', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_deceptive_final', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_delusional', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_delusional_', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_depressing', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_depths', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_derpis_ksf', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_deserted_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_destiny_fixed', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_diamond_beta1', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_dice_66_rc3', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_diminsion_', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_diminsion_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_dionysus', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_discovery', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_discovery_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_disneyland', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_distraction_v2', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_diverge', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_divided_nsf', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_doodles_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_dread', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_dreams', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_dusk', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_dynamics', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_dynamics_fixed', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_dynasty', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_eclipse', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ecosystem', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL); ");
	SQL_AddQuery(h_addTiers, "INSERT INTO `ck_maptier` (`mapname`, `tier`, `btier1`, `btier2`, `btier3`, `btier4`, `btier5`, `btier6`, `btier7`, `btier8`, `btier9`, `btier10`) VALUES ('surf_efficacy_rg', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_elements_beta3', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_elites_v2', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_elixor_rg', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_elysium', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ember_sns', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_entropy_finalv2', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_entropy_hardmode', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_epic', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_eternal_beta', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_euphoria', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_exclave', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_exile_njv', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_exocube', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_exocube_e', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_exocube_h', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_exocube_m', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_exogenesis', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_extremex', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_extremex2_5_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_extremex_', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_extrodinaire', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_exxak', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ez', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_faint', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_faint_fix', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_fast', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_finesse_final', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_flappybird', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_flyin_fortress', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_forbidden_swag', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_forbidden_tomb2_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_forbidden_tomb3', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_forbidden_tomb4_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_forbidden_tomb_sns', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_forbidden_ways_ksf', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_for_all', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_freaky_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_freedom', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_freedom-', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL); ");
	SQL_AddQuery(h_addTiers, "INSERT INTO `ck_maptier` (`mapname`, `tier`, `btier1`, `btier2`, `btier3`, `btier4`, `btier5`, `btier6`, `btier7`, `btier8`, `btier9`, `btier10`) VALUES ('surf_frequency_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_fruits', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_fruits2', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_funhouse_njv', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_furios-', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_gauntlet_final_rg', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_gettingharder', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ghost_busters_rg', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_glass7', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_glass9', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_globalchaos', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_goldarn', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_goodbye2', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_goodbye_rg', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_graphia', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_grassland', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_gurus_njv', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_halloween', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_halloween_tf', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_happyhands2', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_happyhands3', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_happyhands4', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_happyhands_test', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_healthy_e', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_heaven', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_helium_v2_rg', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_how2surf', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_hurrr', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_hydrogen_v2_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_hyper-', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_illumination_rg', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_imagine_fix', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_imex_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_impact_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_industries_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_infamous_ksf', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_infected_e', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_infected_h', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_infected_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_infected_njv_h', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL); ");
	SQL_AddQuery(h_addTiers, "INSERT INTO `ck_maptier` (`mapname`, `tier`, `btier1`, `btier2`, `btier3`, `btier4`, `btier5`, `btier6`, `btier7`, `btier8`, `btier9`, `btier10`) VALUES ('surf_ing_njv', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_inhuman', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_injection_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_inrage-', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_inrage2', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_inrage2_', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_insideout', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_insignia_b1', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_inspire', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_interceptor', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_in_progress', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_island', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ixtab_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_jenocide', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_jizznipples', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_junglespic_ksf', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_junglespic_ksf-', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_jusched', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_kalium', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_kalium2', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_kalium2_', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_kawaii', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_kitsune', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_koa', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_krow10', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_kz_mix_journeys_rg', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_kz_protraining', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lament_n2p', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_leet_xl_beta7z', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_leet_xl_beta7z_', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_legendary', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_legends', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_legends_lite', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_legends_lite_gfl', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lepidus', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lessons', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_liberation', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_liberation2', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_libya', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lies', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lighthouse', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL); ");
	SQL_AddQuery(h_addTiers, "INSERT INTO `ck_maptier` (`mapname`, `tier`, `btier1`, `btier2`, `btier3`, `btier4`, `btier5`, `btier6`, `btier7`, `btier8`, `btier9`, `btier10`) VALUES ('surf_like_a_boss', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lithium', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lithium-', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lithium2', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lithium2-', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lodypreview', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_loentra', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lolrevlis', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lolrevlis2', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lolwhut', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_long_as_my_pants2', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_looksmodern', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lore_e', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_love', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lt_omnific_', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lt_unicorn', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lullaby_ksf', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lux', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_map', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_map_h', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_map_h_', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_mash-up', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_masonry', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_masonry-', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_mellow', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_mesa', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_mesa_aether', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_mesa_mine', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_metallic', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_metalwall', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_metalwall-', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_methadone', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_minecraft', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_minuet_v1p', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_misc', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_missing_no', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_molstration', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_mom_rg', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_morbid', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_morbid-', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_motion_v2', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL); ");
	SQL_AddQuery(h_addTiers, "INSERT INTO `ck_maptier` (`mapname`, `tier`, `btier1`, `btier2`, `btier3`, `btier4`, `btier5`, `btier6`, `btier7`, `btier8`, `btier9`, `btier10`) VALUES ('surf_mushroom', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_mynah_final', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_mynah_final-', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_mynah_final_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_nemesis', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_neon_final', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_neoplasma', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_neo_njv', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_networked', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_networked_', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_network_2008_final', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_network_2009_njv', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_network_2013', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_newb_hazard_r1', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_new_001_001', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_nightmare', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_nikolo', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ninja_go_b5', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ninja_r4', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_not_so_sinister', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ny_advance_nsf_v2', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ny_momentum2_ksf', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ny_momentum_v3_1', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ny_platinum', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ny_superhappiest_b3', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_n_bhop_beta1', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_odyssey_', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_olympics_sns', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_oma', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_omnibus_sns', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_oompa_loompa', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_oompa_loompa_', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_orbion_x', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_overgrowth', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_overgrowth2', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_palette_v2', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_pandemonium', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_pandemonium_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_parc_colore', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_parrot_selector', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL); ");
	SQL_AddQuery(h_addTiers, "INSERT INTO `ck_maptier` (`mapname`, `tier`, `btier1`, `btier2`, `btier3`, `btier4`, `btier5`, `btier6`, `btier7`, `btier8`, `btier9`, `btier10`) VALUES ('surf_parrot_selector_h', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_pavilion_rg', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_perforated_restored', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_pinkbash', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_pinky', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_placid', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_plaguelands_beta7a', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_plethora_fix', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_polygon', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_porn_fix', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_portal_game4', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_pox', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_prelude_ksf', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_presmon_fix', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_primero_njv', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_prime_time_r3vamp', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_prolix', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_prosaic_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_prosperity_v2', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_proximity_final', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_pro_extreme', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_psi', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_psi_fixed', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_psycho_njv', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_pure-', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_pure_rg', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_purgatory', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_pyrism_njv', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_qlimax_q-', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_quantum_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_quartus_ksf', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_quasar_final', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_quasar_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_quattro-', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_quattro_rg', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_quilavar-', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ragequit', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ragequit_', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_rainbow', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_rands_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL); ");
	SQL_AddQuery(h_addTiers, "INSERT INTO `ck_maptier` (`mapname`, `tier`, `btier1`, `btier2`, `btier3`, `btier4`, `btier5`, `btier6`, `btier7`, `btier8`, `btier9`, `btier10`) VALUES ('surf_rapid', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_rapid_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_razer_final', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_rebel_resistance_njv', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_rebel_scaz_njv', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_redemption_b1', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_refraxis', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_reprise', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_retroartz_s', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ripper', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_roman', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_rookie', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_royal', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_rustic', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_salvia', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sanding', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sandman', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sandman_v2_njv', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_savant_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sci_fi', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sc_colours_rg', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sc_essence_v2_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_seaworld', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_seaworld_fix', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sempar_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sensation', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sentient', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sewers', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sexplizooimed', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sexyartz_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sh', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_shit_v3', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sh_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_simpsons_go_rc2', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_singletons', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sinister_evil', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sinsane_ksf', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_skill8_', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_skill8_e', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_skill8_h', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_skill8_m', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL); ");
	SQL_AddQuery(h_addTiers, "INSERT INTO `ck_maptier` (`mapname`, `tier`, `btier1`, `btier2`, `btier3`, `btier4`, `btier5`, `btier6`, `btier7`, `btier8`, `btier9`, `btier10`) VALUES ('surf_sky_ages', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sluice', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_smaragd', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_smile', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_smile_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_spacejam', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_spaceship_ksf', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_spectrum_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_stagejuan_ksf_', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_static', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_stick', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_stick-', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_stickybutt_alpha', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_stickybutt_alpha-', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_stoneage', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_stonework', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_stonework-', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_stonework2', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_stonework3', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sundown_njv', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sunnyhappylove', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sunset', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sunset2', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sunset_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sup_', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_symbiosis_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_syria_', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_syria_again_', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_system_lost_wr_rg', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_s_t_a_t_i_o_n', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_t6bonus_t_rg', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_take1', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_taq_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_teenpregnancy_lite_rg', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_tenacious', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_tensile_njv', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_thembrium_sns', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_theworldismine_njv', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_the_distance_', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_the_gloaming_rat', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL); ");
	SQL_AddQuery(h_addTiers, "INSERT INTO `ck_maptier` (`mapname`, `tier`, `btier1`, `btier2`, `btier3`, `btier4`, `btier5`, `btier6`, `btier7`, `btier8`, `btier9`, `btier10`) VALUES ('surf_the_lost_city', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_this_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_timewarp', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_timewarp_', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_togo_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_tomb_redone', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_torque2_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_torque_', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_trance_ksf', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_treefort', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_trinity', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_tronia_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_tronic_njv', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_tron_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_tundra', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_two_colour', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ultimate', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ultimatum', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_underworld_go', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_unreal2', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_unreal2_', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_unreal_njv', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_unreal_njv_', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_unusual_njv', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_utopia_njv', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_utopia_v3', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_val', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_vector_final', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_vegetables', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_velocity_nsf', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_voteforthisone', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_water-run_b5', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_water-run_banjo_skill', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_waterworks', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_wazor', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_whoknows', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_wood', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_xc_simplicity', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_x_rg', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_yay', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_year3000', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL); ");
	SQL_AddQuery(h_addTiers, "INSERT INTO `ck_maptier` (`mapname`, `tier`, `btier1`, `btier2`, `btier3`, `btier4`, `btier5`, `btier6`, `btier7`, `btier8`, `btier9`, `btier10`) VALUES ('surf_y_rg', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_zion_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_kitsune2_GO', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ace', 2, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_borderlands', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_cubic', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_elysium2', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_fathom', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_flatliners', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_iceworld', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_juturna', 2, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_mom', 1, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_the_gloaming_rat_gfl', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_milkyway', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_training', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_rebel_scaz_csgo', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_81st_network', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_again_njv', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_amplitude_apex', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_amplitude_encore', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_anthropomorphic', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_auroria_ksf', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_awakening', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_awp_sk337_v3', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_blackside', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_blub', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_calamity_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_chaos_fix', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_color_fix', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_commune_again_beta5', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_commune_beta11', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_compulsive_njv_h', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_concept', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_cyanide', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_diminsion', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_divided', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_efficacy', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_elixor', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ember', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_exclave_fix', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_exile', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL); ");
	SQL_AddQuery(h_addTiers, "INSERT INTO `ck_maptier` (`mapname`, `tier`, `btier1`, `btier2`, `btier3`, `btier4`, `btier5`, `btier6`, `btier7`, `btier8`, `btier9`, `btier10`) VALUES ('surf_extremex2_5', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_forbidden_tomb', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_forbidden_tomb2', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_forbidden_tomb4', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_freaky', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_funhouse_v1', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_furios', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_gauntlet_final', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ghost_busters', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_gurus', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_halloween_fix', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_halloween_tf2', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_happyhands', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_healthy', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_heaven_njv', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_helium_v2', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_hydrogen_v2', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_hyper', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_imex', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_impact', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_industries', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_infected', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ing', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_inrage', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_insideout_final', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ixtab', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_jusched_beta1', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_kz_mix_journeys', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lies_ksf', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lore', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_loves_spliff', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_lt_omnific', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_map_njv', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_mushroom_ksf', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_neoplasma_ksf', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_network2008_final', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_network_2009', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_ny_advance', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_odyssey', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_olympics', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL); ");
	SQL_AddQuery(h_addTiers, "INSERT INTO `ck_maptier` (`mapname`, `tier`, `btier1`, `btier2`, `btier3`, `btier4`, `btier5`, `btier6`, `btier7`, `btier8`, `btier9`, `btier10`) VALUES ('surf_omnibus', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_orbion', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_paranoid_enigma', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_pavilion', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_primero', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_prolix_fix', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_prosaic', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_psycho', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_pure', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_qlimax_q', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_quattro', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_quilavar', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_rands', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_rebel_resistance_final3', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_retroartz', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_rustic_v2', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sanding_ksf', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sandman_v2', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sc_colours', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sc_essence_v2', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sensation_ksf', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_simpsons_source', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_skill8', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_stagejuan_ksf', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sundown', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_sunset2_fix', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_symbiosis', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_syria', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_syria_again', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_taq', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_the_distance', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_the_gloaming', 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_thembrium_njv', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_togo', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_torque', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_torque2', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_tronia', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_underworld', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_velocity', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_wazor_ksf', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_x', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL); ");
	SQL_AddQuery(h_addTiers, "INSERT INTO `ck_maptier` (`mapname`, `tier`, `btier1`, `btier2`, `btier3`, `btier4`, `btier5`, `btier6`, `btier7`, `btier8`, `btier9`, `btier10`) VALUES ('surf_y', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_zion', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_numbers', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL), ('surf_milkyway_', 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);");
	SQL_ExecuteTransaction(g_hDb, h_addTiers, SQLTxn_TierInsertSuccess, SQLTxn_TierInsertFailed, client);
}

public void SQLTxn_TierInsertFailed(Handle db, any data, int numQueries, const char[] error, int failIndex, any[] queryData)
{
	if (IsValidClient(data))
		PrintToChat(data, "[%cCK%c] Inserting map tiers %cfailed!%c. Check error logs.", MOSSGREEN, WHITE, RED, WHITE);

	g_insertingInformation = false;
	LogError("[ckSurf] SQL Tier insertion failed! Index: %i Error: %s", failIndex, error);
}

public void SQLTxn_TierInsertSuccess(Handle db, any data, int numQueries, Handle[] results, any[] queryData)
{
	if (IsValidClient(data))
		PrintToChat(data, "[%cCK%c] Successfully inserted map tiers!", MOSSGREEN, WHITE);

	db_selectMapTier();
	g_insertingInformation = false;
}

public void Admin_InsertZonestoDatabase(int client)
{
	if (!IsValidClient(client))
		return;

	g_insertingInformation = true;

	PrintToChat(client, "[%cCK%c] Inserting zones to the database, this might take a while... You will get a confirmation after the zones are inserted.", MOSSGREEN, WHITE);

	Transaction h_addZones = SQL_CreateTransaction();
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_004_final1', 0, 2, 1, -2210.79, -1471.97, 0.03125, -2813.97, 1470.97, 100.031, 0, 0, 0, NULL), ('surf_004_final1', 1, 1, 1, -10240.4, 495.969, 15808, -10593.9, -495.969, 15908, 0, 0, 0, NULL), ('surf_1day', 0, 3, 9, -10656.4, 8545.39, -3649.97, -10721.4, 8478.62, -3547.97, 0, 0, 0, NULL), ('surf_1day', 1, 3, 8, -4614.87, -3654.2, 7870.03, -5629.14, -4143.97, 7972.03, 0, 0, 0, NULL), ('surf_1day', 2, 3, 6, 2867.13, -3631.97, 8126.03, 3304.92, -3306.18, 8228.03, 0, 0, 0, NULL), ('surf_1day', 3, 3, 7, -2858.19, -3971.13, 8126.03, -2305.42, -3683.49, 8228.03, 0, 0, 0, NULL), ('surf_1day', 4, 2, 0, -12609.8, 6976.84, -10896.4, -13232, 7864.49, -10600, 0, 0, 0, NULL), ('surf_1day', 5, 3, 5, -156.182, -4028, 8126.03, 201.998, -3689.19, 8228.03, 0, 0, 0, NULL), ('surf_1day', 6, 2, 1, -13232, 6984.71, -10702, -13221.3, 7878.96, -9959.18, 0, 0, 0, NULL), ('surf_1day', 7, 3, 4, -1483.52, -4333.14, -2625.97, -1034.06, -4818.06, -2523.97, 0, 0, 0, NULL), ('surf_1day', 8, 3, 3, -12467.1, -5467.63, 2494.02, -12054, -5917.16, 2596.03, 0, 0, 0, NULL), ('surf_1day', 9, 3, 2, -12531.1, -13607.2, 3517.95, -12042.9, -14070.7, 3620, 0, 0, 0, NULL), ('surf_1day', 10, 3, 1, -4020.12, -6162.85, -8894.1, -3406.55, -5437.18, -8737.44, 0, 0, 0, NULL), ('surf_1day', 11, 3, 0, 11568, -2217.01, -1761.97, 11467, -1739.43, -1659.97, 0, 0, 0, NULL), ('surf_1day', 12, 5, 0, 2013.15, 148.516, -149.969, 2486.33, -394.254, -47.9688, 0, 0, 0, NULL), ('surf_1day', 13, 1, 0, 5018.86, 9490.21, 4064.03, 4644.03, 9279.98, 4114.29, 0, 0, 1, NULL), ('surf_1day', 14, 2, 0, -10192, 8880.84, 7200.03, -10070.6, 8573.16, 7300.03, 0, 0, 1, NULL), ('surf_2012_beta12', 0, 3, 4, -291.67, 555.205, 11328, -568.846, 865.361, 11428, 0, 0, 0, NULL), ('surf_2012_beta12', 1, 2, 0, -1154.6, 10869.3, 7489.03, -1405.99, 11014.8, 7683.01, 0, 0, 0, NULL), ('surf_2012_beta12', 2, 3, 3, 7989.53, 8113.34, 9187.15, 8287.28, 7994.19, 9287.15, 0, 0, 0, NULL), ('surf_2012_beta12', 3, 3, 2, 7832, -3919.96, 1664.03, 8049.35, -4312.86, 1764.03, 0, 0, 0, NULL), ('surf_2012_beta12', 4, 1, 0, 4927.03, -3325.56, 1296.03, 5313.04, -3570.61, 1380.03, 0, 0, 0, NULL), ('surf_2012_beta12', 5, 3, 0, 13372.8, -668.424, 15360, 13593.2, -1042.87, 15460, 0, 0, 0, NULL), ('surf_2012_beta12', 6, 3, 1, -1457.81, -2968.9, 4484.03, -1153.5, -2645.08, 4580.03, 0, 0, 0, NULL), ('surf_2012_beta12', 7, 1, 0, 2464.03, -5491.55, 4194.21, 2567.71, -5574.63, 4064.03, 0, 0, 1, NULL), ('surf_2012_beta12', 8, 2, 0, 7263.84, -5506.87, -5918.97, 7169.44, -5566.97, -5731.47, 0, 0, 1, NULL), ('surf_3', 0, 2, 0, 2696.61, -6294.64, -10978, 3484, -5478.25, -10876, 0, 0, 0, NULL), ('surf_3', 1, 1, 0, -2999.05, 125.759, 7614.03, -3223.79, -130.836, 7716.03, 0, 0, 0, NULL), ('surf_3', 2, 4, 0, -2607.33, 671.969, 5497.17, -3303.19, -668.399, 4032.03, 0, 0, 0, NULL), ('surf_3', 3, 4, 1, 2448.03, -948.35, 3893.11, 3764.93, -279.609, 2424.03, 0, 0, 0, NULL), ('surf_3', 4, 4, 2, 2832.91, -6174.93, -1696.03, 3333.32, -5632.03, -2216.97, 0, 0, 0, NULL), ('surf_3', 5, 4, 3, 1385.72, -7639.93, -6400.03, 4874.62, -4141.72, -7919.97, 0, 0, 0, NULL), ('surf_4dimensional', 0, 3, 1, -815.969, -903.357, -6657.97, -559.993, -1154.98, -6612.5, 0, 0, 0, NULL), ('surf_4dimensional', 1, 2, 1, -3056, 335.969, 7534.03, -3754.43, -2431.97, 7636.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_4dimensional', 2, 3, 0, 991.969, -3848.08, 1774.03, -1487.97, -5039.97, 1876.03, 0, 0, 0, NULL), ('surf_4dimensional', 3, 1, 1, -2068.61, 335.969, 7534.03, -2768, -2431.97, 7636.03, 0, 0, 0, NULL), ('surf_4dimensional', 4, 1, 0, 14982, 8360.87, 5616.03, 15472, 7011.96, 5725.6, 0, 0, 1, NULL), ('surf_4dimensional', 5, 2, 0, -15312, -8864.03, -12402, -13968, -10366.3, -12300, 0, 0, 1, NULL), ('surf_6', 0, 2, 1, -10880.7, -511.104, -6335.97, -11312, 576.04, -6119.97, 0, 0, 0, NULL), ('surf_6', 1, 1, 1, 3455.95, 322.796, 6368.03, 3088.03, -320.212, 6468.03, 0, 0, 0, NULL), ('surf_abyss_fix', 0, 3, 3, 277.996, -5364.74, 2052.27, -424.273, -5826.73, 2154.03, 0, 0, 0, NULL), ('surf_abyss_fix', 1, 3, 4, -3194.21, -9346.78, 3498.03, -2981.66, -9560.75, 3600.03, 0, 0, 0, NULL), ('surf_abyss_fix', 2, 3, 0, 5049.86, 6286.21, 1900.03, 5485.27, 6078.75, 2002.03, 0, 0, 0, NULL), ('surf_abyss_fix', 3, 2, 1, 10551.3, -6092.24, -438.862, 10075.6, -6125.3, -2.10574, 0, 0, 0, NULL), ('surf_abyss_fix', 4, 2, 2, 10216.9, -453.893, -451.551, 10924.6, -439.612, 85.4582, 0, 0, 0, NULL), ('surf_abyss_fix', 5, 3, 5, 10918.5, -4738.35, 2477.83, 10827.8, -4924.97, 2607.88, 0, 0, 0, NULL), ('surf_abyss_fix', 6, 3, 2, -10247, -13047.2, 4622.03, -8487.03, -13321.4, 4724.03, 0, 0, 0, NULL), ('surf_abyss_fix', 7, 1, 1, 835.409, -633.181, 1692.11, -225.452, -1369.41, 1853.86, 0, 0, 0, NULL), ('surf_abyss_fix', 8, 3, 1, 7919.53, 5872.47, 4103.03, 9072.47, 5687.46, 4205.03, 0, 0, 0, NULL), ('surf_abyss_fix', 9, 2, 3, 10522, -470.888, -441.969, 10227.8, -439.486, -286.475, 0, 0, 0, NULL), ('surf_acp', 0, 1, 1, -11366.1, 2865.14, -12809.8, -11550.3, 3234.96, -12700.1, 0, 0, 0, NULL), ('surf_acp', 1, 3, 6, 1992.04, 11539.3, 406.031, 2098.44, 11884.7, 508.031, 0, 0, 0, NULL), ('surf_acp', 2, 2, 1, -13837.1, 15344, -38.9688, -15344, 13840, 63.0312, 0, 0, 0, NULL), ('surf_acp', 3, 3, 1, -11410, 12941.3, -12806.1, -12232.1, 13669.8, -12701.9, 0, 0, 0, NULL), ('surf_acp', 4, 3, 5, -11779, -14208, -5377.97, -11936, -14464, -5275.97, 0, 0, 0, NULL), ('surf_acp', 5, 3, 2, 7915.95, -8471.91, -8961.97, 7385.61, -8959.3, -8859.97, 0, 0, 0, NULL), ('surf_acp', 6, 3, 0, -11444.3, 6560.92, -12806, -12171.7, 5805.52, -12700.7, 0, 0, 0, NULL), ('surf_acp', 7, 3, 3, 223.177, 7397.92, -5121.97, -233.873, 6918.97, -5019.97, 0, 0, 0, NULL), ('surf_acp', 8, 3, 4, -12304, -13904, 6142.03, -13296, -13311.9, 6244.03, 0, 0, 0, NULL), ('surf_acp', 9, 3, 7, 11744.1, 14333.1, 7934.03, 11525.3, 14843.2, 8036.03, 0, 0, 0, NULL), ('surf_acp_fix', 0, 3, 1, -12273.9, 13748.1, -12806.6, -11356, 12812.4, -12642.7, 0, 0, 0, NULL), ('surf_acp_fix', 1, 3, 2, 7193.08, -8203.48, -8976.16, 8183.83, -9201.1, -8867.65, 0, 0, 0, NULL), ('surf_acp_fix', 2, 3, 3, -518.265, 7680.95, -5122.11, 518.025, 6654.6, -5022.82, 0, 0, 0, NULL), ('surf_acp_fix', 3, 3, 6, 2122.53, 11520.9, 408.031, 1970.76, 11920.4, 508.031, 0, 0, 0, NULL), ('surf_acp_fix', 4, 2, 0, -13840.3, 15359, -20.9688, -15357, 13825, 63.0312, 0, 0, 0, NULL), ('surf_acp_fix', 5, 3, 7, 11540.4, 14360, 7936.03, 11756.1, 14825, 8036.03, 0, 0, 0, NULL), ('surf_acp_fix', 6, 3, 0, -11388, 6602.23, -12823.8, -12327.4, 5652.24, -12649.3, 0, 0, 0, NULL), ('surf_acp_fix', 7, 1, 0, -11347.9, 3550.64, -12799.8, -12318.1, 2579.26, -12714.8, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_acp_fix', 8, 3, 4, -13296.3, -13907.4, 6130.69, -12291.4, -13316.8, 6230.74, 0, 0, 0, NULL), ('surf_acp_fix', 9, 3, 5, -11936, -14464, -5375.97, -11778, -14208, -5275.97, 0, 0, 0, NULL), ('surf_adtr_njv', 0, 1, 0, 1962.32, 2426.42, 1326.03, 877.762, 2494.46, 1549.97, 0, 0, 0, NULL), ('surf_adtr_njv', 1, 3, 2, -10864, 223.205, -35.5808, -10285.5, 861.08, -255.969, 0, 0, 0, NULL), ('surf_adtr_njv', 2, 3, 1, -5951.97, 3735.97, -1282.97, -5594.07, 3320.03, -1180.97, 0, 0, 0, NULL), ('surf_adtr_njv', 3, 2, 0, -1014.33, 442.128, -1659.05, -805.705, 645.288, -1543.13, 0, 0, 0, NULL), ('surf_adtr_njv', 4, 3, 0, 1697.21, -2048.37, 1134.03, 2173.18, -1667.1, 1236.03, 0, 0, 0, NULL), ('surf_adtr_njv', 5, 1, 0, -2285.42, -4640.5, -694.059, -2682.11, -4377.12, -558.712, 0, 0, 1, NULL), ('surf_adtr_njv', 6, 2, 0, 1533.35, -4832.73, -1506.97, 2175.15, -4592.78, -1404.97, 0, 0, 1, NULL), ('surf_advanced', 0, 1, 1, -13184.1, -382.969, 12560, -12416.2, -192.439, 12660, 0, 0, 0, NULL), ('surf_advanced', 1, 3, 4, 142.784, -2858.55, -3759.97, 719.387, -3042.22, -3659.97, 0, 0, 0, NULL), ('surf_advanced', 2, 3, 0, -10865.4, 495.999, 9872.03, -10161.2, 336.886, 9972.03, 0, 0, 0, NULL), ('surf_advanced', 3, 3, 1, -6964.09, -593.226, 7328.03, -7300.62, -747.354, 7428.03, 0, 0, 0, NULL), ('surf_advanced', 4, 2, 1, 3552.15, 379.969, -11690.8, 2580.43, 224.149, -11593.6, 0, 0, 0, NULL), ('surf_advanced', 5, 3, 5, 2550.04, -1238.36, -7487.97, 3638.85, -912.031, -7387.97, 0, 0, 0, NULL), ('surf_advanced', 6, 3, 2, -5459.59, 619.892, 4608.03, -4844.43, 469.71, 4708.03, 0, 0, 0, NULL), ('surf_advanced', 7, 3, 3, -2036.97, -1122.66, 640.031, -2591.21, -1353.47, 740.031, 0, 0, 0, NULL), ('surf_aether', 0, 1, 0, -9372.07, 8208.03, 13726, -9060.01, 8444.73, 13828, 0, 0, 0, NULL), ('surf_aether', 1, 2, 0, 1902.43, 14518.1, 6206.03, 2200.47, 14124.8, 6308.03, 0, 0, 0, NULL), ('surf_aether', 2, 4, 0, -10976, 8190.84, 11998.5, -10528, 8251.98, 11576.4, 0, 0, 0, NULL), ('surf_aether', 3, 4, 1, -10237.3, -3807.46, 8703.97, -10112, -3455.65, 8091.47, 0, 0, 0, NULL), ('surf_aether', 4, 4, 2, -11168, 12865.6, 1031.26, -10607.9, 13266.9, 281.268, 0, 0, 0, NULL), ('surf_aether', 5, 4, 3, -11885.8, 3690.18, 2609.71, -11360, 4314.86, 1847.7, 0, 0, 0, NULL), ('surf_aether', 6, 4, 4, -10757.8, -12992, -289.341, -10880, -11963.9, -1309.95, 0, 0, 0, NULL), ('surf_aether', 7, 4, 5, 5838.11, -5759.39, 1407.97, -597.753, -4471.21, -4991.97, 0, 0, 0, NULL), ('surf_again_njv_rg1', 0, 2, 1, -3.11752, -2257.89, -13595.5, -148.526, -2232.78, -13179.1, 0, 0, 0, NULL), ('surf_again_njv_rg1', 1, 2, 2, 50.2431, -2460.85, -13595.5, 77.0442, -2305.44, -13259.5, 0, 0, 0, NULL), ('surf_again_njv_rg1', 2, 2, 3, 1.44906, -2523.57, -13595.5, -146.559, -2549.75, -13261.6, 0, 0, 0, NULL), ('surf_again_njv_rg1', 3, 2, 4, -204.523, -2455.11, -13595.5, -230.067, -2317.38, -13248.1, 0, 0, 0, NULL), ('surf_again_njv_rg1', 4, 2, 5, 53.1581, -2265.55, -13592.5, -205.161, -2514.39, -13310.3, 0, 0, 0, NULL), ('surf_again_njv_rg1', 5, 1, 1, -252.69, 779.041, 5744.03, 120.567, 406.389, 5844.03, 0, 0, 0, NULL), ('surf_aircontrol_ksf', 0, 2, 1, 13840.4, 3267.57, -14018, 10592.8, 1740.89, -13916, 0, 0, 0, NULL), ('surf_aircontrol_ksf', 1, 1, 1, -2895.97, -9251.27, 14334, -816.031, -10128, 14436, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_aircontrol_ksf', 2, 4, 0, -14656, 1984.09, 12795, -11584, 3425.43, 8215.2, 0, 0, 0, NULL), ('surf_aircontrol_ksf', 3, 4, 1, 7615.97, 1130.31, 4505.64, 2882.56, 1775.22, 768.031, 0, 0, 0, NULL), ('surf_aircontrol_ksf', 4, 4, 2, -9434.32, 14015.6, -256.031, -10490, 9663.16, -7167.97, 0, 0, 0, NULL), ('surf_airflow', 0, 2, 0, -592.031, 3822.37, -11474, -2607.97, 4111.97, -11372, 0, 0, 0, NULL), ('surf_airflow', 1, 3, 0, 264.173, 6079.96, 3232.03, -403.431, 5440.03, 3361.86, 0, 0, 0, NULL), ('surf_airflow', 2, 3, 2, -335.969, -4773.63, 4613.1, 175.969, -4496.68, 4733.44, 0, 0, 0, NULL), ('surf_airflow', 3, 3, 4, -592.031, 4280.11, -7249.97, -2607.97, 3664.03, -7147.97, 0, 0, 0, NULL), ('surf_airflow', 4, 3, 3, 1021.07, 8713.58, -7169.97, 2069.46, 9711.97, -7067.97, 0, 0, 0, NULL), ('surf_airflow', 5, 3, 1, -556.605, -7033.94, -1121.97, 431.969, -6065.61, -1019.97, 0, 0, 0, NULL), ('surf_airflow', 6, 1, 0, -287.1, -1534.3, -385.969, 285.891, 509.072, -283.969, 0, 0, 0, NULL), ('surf_akai_final', 0, 2, 0, 9626.73, 5315.04, -14649, 10011, 4947.75, -14670.5, 0, 0, 0, NULL), ('surf_akai_final', 1, 1, 1, -12656, 11789.7, 1519.14, -12747.7, 11542.4, 1480.03, 0, 0, 0, NULL), ('surf_akai_final', 2, 1, 1, -12748.3, 8800.03, 1518.93, -12665, 9047.98, 1480.03, 0, 0, 0, NULL), ('surf_akai_two_rg', 0, 2, 1, 10838.8, 6310.17, 5534.03, 10423.5, 6739.78, 5639.03, 0, 0, 0, NULL), ('surf_akai_two_rg', 1, 1, 1, 4156.97, -1044.29, 14579, 3768.03, -1429.97, 14679, 0, 0, 0, NULL), ('surf_alternation', 0, 3, 1, -2227.28, -583.969, 204.031, -1943.89, -382.977, 304.031, 0, 0, 0, NULL), ('surf_alternation', 1, 3, 3, 6735.97, -1487.97, -4799.97, 5488, -1013.9, -4699.97, 0, 0, 0, NULL), ('surf_alternation', 2, 3, 5, 8452.05, -901.369, 992.031, 9151.8, -1520, 1092.03, 0, 0, 0, NULL), ('surf_alternation', 3, 3, 6, 10947.3, 2304.03, 864.031, 11588, 2668.28, 964.031, 0, 0, 0, NULL), ('surf_alternation', 4, 3, 7, -5069.97, -1721.76, 288.031, -4014.03, -2001.97, 388.031, 0, 0, 0, NULL), ('surf_alternation', 5, 3, 4, 14171.5, -1768, -27.9688, 14006.1, -1465.81, 72.0312, 0, 0, 0, NULL), ('surf_alternation', 6, 2, 1, -4000.01, 3485.97, -223.969, -5084.97, 3179.03, -123.969, 0, 0, 0, NULL), ('surf_alternation', 7, 3, 0, 2225.96, 2560.01, 976.031, 1904.95, 2863.68, 1076.03, 0, 0, 0, NULL), ('surf_alternation', 8, 1, 1, -158.969, -1216.87, 544.031, 606.969, -1584, 644.031, 0, 0, 0, NULL), ('surf_alternation', 9, 3, 2, 4171.13, -1568.14, 144.031, 3962.15, -1300.98, 244.031, 0, 0, 0, NULL), ('surf_amateur_v2b_', 0, 3, 0, 832.031, -4176.03, 718.031, 1055.97, -4415.97, 820.031, 0, 0, 0, NULL), ('surf_amateur_v2b_', 1, 3, 4, 5624.79, -5713.98, -504.369, 5860.47, -5859.87, -402.369, 0, 0, 0, NULL), ('surf_amateur_v2b_', 2, 3, 3, -1539.35, -5764.11, -41.9688, -1727.56, -6055.69, 68.0312, 0, 0, 0, NULL), ('surf_amateur_v2b_', 3, 3, 2, 6923.94, -2624.35, -409.969, 7273.83, -2308.03, -307.969, 0, 0, 0, NULL), ('surf_amateur_v2b_', 4, 1, 1, 1047.97, -2600.01, 14.0312, 616.031, -2911.97, 116.031, 0, 0, 0, NULL), ('surf_amateur_v2b_', 5, 2, 1, 4777.63, -5875.58, -6177.57, 4875.54, -5663.42, -6075.57, 0, 0, 0, NULL), ('surf_amateur_v2b_', 6, 3, 1, 5243.83, -3087.97, -3073.97, 5720.29, -2703.14, -2971.97, 0, 0, 0, NULL), ('surf_amateur_v2b_', 7, 1, 0, 3190.06, -2907.97, -799.535, 3431.27, -2439.04, -841.809, 0, 0, 1, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_ambient_njv', 0, 1, 1, -208.031, 4234.76, 241.031, -1341.97, 4547.47, 341.031, 0, 0, 0, NULL), ('surf_ambient_njv', 1, 2, 1, -8018.97, -12211, -11681, -6899.03, -13035, -11642, 0, 0, 0, NULL), ('surf_amplitude_apex', 0, 3, 0, 5617.17, 13633, 14758, 6026.52, 14134.6, 14860, 0, 0, 0, NULL), ('surf_amplitude_apex', 1, 2, 1, 13325, -5460.15, -9534.97, 14642, -4472.03, -9432.97, 0, 0, 0, NULL), ('surf_amplitude_apex', 2, 3, 1, -9367.51, -13737.6, 8485.03, -8967.2, -13178.7, 8587.03, 0, 0, 0, NULL), ('surf_amplitude_apex', 3, 1, 1, -13980.5, 12474, 1900.03, -14098.5, 11610, 1973.76, 0, 0, 0, NULL), ('surf_amplitude_apex_njv', 0, 1, 0, -14002.1, 11543.6, 1903.4, -14679.5, 12546.6, 1995.88, 0, 0, 0, NULL), ('surf_amplitude_apex_njv', 1, 2, 0, 13326.9, -5454.07, -9534.97, 14642, -4472.03, -9432.97, 0, 0, 0, NULL), ('surf_amplitude_apex_njv', 2, 3, 1, -9435.97, -13038.1, 8485.03, -8845.9, -13892.8, 8587.03, 0, 0, 0, NULL), ('surf_amplitude_apex_njv', 3, 3, 0, 6239.85, 13461.6, 14758, 5569.03, 14316.8, 14860, 0, 0, 0, NULL), ('surf_amplitude_encore_nsf_v4', 0, 1, 0, -10056.8, -3904.03, 9029.03, -10739, -5359.97, 9131.03, 0, 0, 0, NULL), ('surf_amplitude_encore_nsf_v4', 1, 2, 0, 374.367, 12880, -12802, -913.582, 11790.7, -12648.1, 0, 0, 0, NULL), ('surf_amplitude_encore_nsf_v4', 2, 4, 0, 198.534, -5375.97, 6962.44, 2226.44, -3888.03, 5219.58, 0, 0, 0, NULL), ('surf_amplitude_encore_nsf_v4', 3, 4, 1, 13361.7, -5143.97, 4388.36, 14860, -4122.93, 3830.18, 0, 0, 0, NULL), ('surf_amplitude_encore_nsf_v4', 4, 4, 2, 1953.07, -5295.6, 1502.52, 932.151, -3888.03, 87.3605, 0, 0, 0, NULL), ('surf_amplitude_encore_nsf_v4', 5, 4, 3, -202.411, -3032.03, 1524.81, -1671.62, -6231.97, -1906.18, 0, 0, 0, NULL), ('surf_amplitude_encore_nsf_v4', 6, 4, 4, -13320.1, -8905.74, -1352, -12487.3, -8180.35, -4376.14, 0, 0, 0, NULL), ('surf_amplitude_encore_nsf_v4', 7, 4, 5, -5844.08, -6689.97, -2500.04, -6685.85, -5270.88, -5512.86, 0, 0, 0, NULL), ('surf_amplitude_encore_nsf_v4', 8, 4, 6, 11953, -655.503, -6359.49, 10292.2, 303.969, -6929.99, 0, 0, 0, NULL), ('surf_amplitude_encore_nsf_v4', 9, 4, 7, 12007.8, 12864, -10308.4, 13161.5, 11840, -11065.2, 0, 0, 0, NULL), ('surf_amplitude_light', 0, 2, 0, 777.459, -16048, -11458, 1327.97, -14992, -11356, 0, 0, 0, NULL), ('surf_amplitude_light', 1, 5, 0, 13109.7, -9809.48, 12164.4, 13359.3, -9073.53, 12071, 0, 0, 0, NULL), ('surf_amplitude_light', 2, 2, 1, 1934.65, -15243.7, -11361.9, 1344.55, -15771.1, -11456, 0, 0, 0, NULL), ('surf_amplitude_light', 3, 4, 0, 3192.26, 3776.03, 11553.5, 1808.06, 5183.97, 8564.45, 0, 0, 0, NULL), ('surf_amplitude_light', 4, 4, 1, -6591.97, -5886.27, 7739.07, -5571.47, -4465.79, 6178.4, 0, 0, 0, NULL), ('surf_amplitude_light', 5, 4, 2, -8249.91, 1224.79, 3007.97, -7552.03, 2791.34, 1258.34, 0, 0, 0, NULL), ('surf_amplitude_light', 6, 4, 3, -4474.3, 4672.03, -7360.99, -3322.18, 5855.63, -9727.97, 0, 0, 0, NULL), ('surf_amplitude_light', 7, 4, 4, 4157.04, -13460.5, -8128.03, 2159.91, -14912, -11954.6, 0, 0, 0, NULL), ('surf_and_destroy', 0, 1, 1, 4476.67, 518.969, 7496.03, 4207.09, 123.068, 7598.03, 0, 0, 0, NULL), ('surf_and_destroy', 1, 2, 1, 4908.79, -12153.7, -4915.97, 4614.46, -11927.4, -4813.97, 0, 0, 0, NULL), ('surf_and_destroy', 2, 6, 0, 4966.02, -10824.7, -3519.44, 5171.97, -10570.4, -3680.54, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_and_destroy', 3, 6, 1, -2929.41, -3767.03, 4984.94, -4358.97, -5110.6, 3683.87, 0, 0, 0, NULL), ('surf_animals', 0, 3, 7, -12332, 12977, 297.031, -11889.5, 12537.4, 399.031, 0, 0, 0, NULL), ('surf_animals', 1, 3, 1, 3473.97, -2886.28, 1461.03, 3216.7, -3340, 1563.03, 0, 0, 0, NULL), ('surf_animals', 2, 3, 3, -7376.97, 2062, 612.031, -6793.42, 1709.56, 706.031, 0, 0, 0, NULL), ('surf_animals', 3, 3, 0, -13820.8, 2517.75, 916.031, -13441.4, 2163, 1018.03, 0, 0, 0, NULL), ('surf_animals', 4, 3, 4, 4788.36, -3337.23, -699.969, 4463.49, -2882.52, -597.969, 0, 0, 0, NULL), ('surf_animals', 5, 3, 5, -7710.33, 3962.82, 732.531, -8253.7, 3530.14, 834.531, 0, 0, 0, NULL), ('surf_animals', 6, 1, 1, -10881.6, -825.969, 147.531, -10660, -586.031, 249.531, 0, 0, 0, NULL), ('surf_animals', 7, 3, 6, -3611.48, 4754.97, 901.031, -3739.86, 4635.01, 1007.03, 0, 0, 0, NULL), ('surf_animals', 8, 3, 8, 2461.69, 4295.03, 1190.5, 2223.86, 4519.75, 1292.5, 0, 0, 0, NULL), ('surf_animals', 9, 3, 9, -6892.72, 5968.03, 340.031, -6485.64, 6146.04, 440.765, 0, 0, 0, NULL), ('surf_animals', 10, 2, 1, -6838.11, 9866.19, -253.252, -6530.79, 9858.08, -16.7649, 0, 0, 0, NULL), ('surf_animals', 11, 2, 2, -6497.31, 9870.07, -231.07, -6512.12, 9863.96, -133.866, 0, 0, 0, NULL), ('surf_animals', 12, 3, 2, -3035.14, 7043.03, 1266.03, -2549.09, 7266.97, 1368.03, 0, 0, 0, NULL), ('surf_annoyance_njv', 0, 3, 1, -1808.97, -15530.4, 10942, -2031.99, -15179.5, 11044, 0, 0, 0, NULL), ('surf_annoyance_njv', 1, 3, 2, -4918.29, -14102.7, 9216.98, -5541.02, -13564.6, 9199.75, 0, 0, 0, NULL), ('surf_annoyance_njv', 2, 3, 6, 5493.74, -6761.53, -2145.97, 5392.01, -6277.33, -2043.97, 0, 0, 0, NULL), ('surf_annoyance_njv', 3, 3, 3, 2535.61, -5137.69, 7039.97, 2696.99, -4920.31, 6531.43, 0, 0, 0, NULL), ('surf_annoyance_njv', 4, 3, 5, 7989.12, -1858.19, 5694.03, 7501.67, -1967.99, 5796.03, 0, 0, 0, NULL), ('surf_annoyance_njv', 5, 3, 4, 5809.51, -2879.97, 10174.5, 5579.37, -2609.36, 9572.9, 0, 0, 0, NULL), ('surf_annoyance_njv', 6, 2, 0, 11478.3, -6762.94, -1377.97, 11958.7, -6289.38, -1275.97, 0, 0, 0, NULL), ('surf_annoyance_njv', 7, 3, 0, -2596.58, -10793.5, 7342.03, -3565.66, -11248, 7444.03, 0, 0, 0, NULL), ('surf_annoyance_njv', 8, 1, 0, -478.233, -13124.6, 2568.91, 502.341, -13639.4, 2685.7, 0, 0, 0, NULL), ('surf_anonymity', 0, 1, 1, 7457.88, 4368.49, 185.155, 7338.09, 4471.05, 285.155, 0, 0, 0, NULL), ('surf_anonymity', 1, 3, 4, -4011.58, 2544.95, 20.9226, -3899.68, 2749.47, 120.923, 0, 0, 0, NULL), ('surf_anonymity', 2, 2, 1, -4106.55, 2772.64, -1154.06, -3800.5, 2544.67, -1054.06, 0, 0, 0, NULL), ('surf_anonymity', 3, 3, 1, 1473.02, 2178.96, -992.969, 1968.9, 1608.99, -892.969, 0, 0, 0, NULL), ('surf_anonymity', 4, 3, 0, 4278.7, 7517.42, 316.031, 3891.39, 7142.59, 416.031, 0, 0, 0, NULL), ('surf_anonymity', 5, 3, 2, -4952.11, 2065.69, -896.969, -5246.7, 2287.72, -796.969, 0, 0, 0, NULL), ('surf_anonymity', 6, 3, 3, 2381.05, -510.944, 1537.03, 1982.5, -191.795, 1637.03, 0, 0, 0, NULL), ('surf_anthropomorphic-', 0, 5, 0, -6940.59, -5695.25, 4029.53, -7431.25, -5408.35, 4088.84, 0, 0, 0, NULL), ('surf_anthropomorphic-', 1, 3, 0, -4450.35, -8588.97, -8.37062, -4143.62, -8403.58, -72.9688, 0, 0, 0, NULL), ('surf_anthropomorphic-', 2, 3, 1, -7489.9, -8302.61, 2027.03, -7719.36, -8534.67, 2129.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_anthropomorphic-', 3, 3, 7, -991.904, -10131, 3614.03, -827.39, -9996.72, 3714.03, 0, 0, 0, NULL), ('surf_anthropomorphic-', 4, 3, 6, -10606, -10589, -5501.97, -10782, -10757, -5401.97, 0, 0, 0, NULL), ('surf_anthropomorphic-', 5, 3, 5, 1359.95, -11718.4, -4712.97, 1469.17, -11838.2, -4612.97, 0, 0, 0, NULL), ('surf_anthropomorphic-', 6, 3, 8, 1801.95, -9001.6, -2047.97, 2925.11, -8554, -1947.97, 0, 0, 0, NULL), ('surf_anthropomorphic-', 7, 3, 3, -1347.83, -2321.05, -345.969, -1535.15, -3601.77, -243.969, 0, 0, 0, NULL), ('surf_anthropomorphic-', 8, 3, 4, 8224.01, -4872.14, -8495.97, 8489.73, -4487.8, -8395.97, 0, 0, 0, NULL), ('surf_anthropomorphic-', 9, 2, 0, 2026.3, -1900.85, -2399.97, 2696.09, -859.172, -2299.97, 0, 0, 0, NULL), ('surf_anthropomorphic-', 10, 3, 2, -3038.59, -119.994, -10443, -2798.33, 77.5035, -10341, 0, 0, 0, NULL), ('surf_anthropomorphic-', 11, 2, 0, 5449.03, -6074.28, -3175.97, 6453.46, -6066.84, -2985.42, 0, 0, 1, NULL), ('surf_anthropomorphic-', 12, 1, 0, 6430.99, -6200.38, -2069.97, 5451.03, -6082.01, -1969.97, 0, 0, 1, NULL), ('surf_apollonian', 0, 3, 1, -162.696, -5976.03, -7226.97, -457.969, -6565.97, -7124.97, 0, 0, 0, NULL), ('surf_apollonian', 1, 3, 4, 7184.03, 5583.98, 2558.03, 7542.72, 4656.03, 2660.03, 0, 0, 0, NULL), ('surf_apollonian', 2, 3, 3, -15874.6, 11361.1, -6771.47, -16178.9, 10750.7, -6669.47, 0, 0, 0, NULL), ('surf_apollonian', 3, 3, 2, 3049.83, -1071.97, 254.031, 3567.97, 1067.85, 356.031, 0, 0, 0, NULL), ('surf_apollonian', 4, 2, 1, 7087.97, 4656.03, 3582.03, 6729.34, 5583.97, 3684.03, 0, 0, 0, NULL), ('surf_apollonian', 5, 1, 1, -14256, -944.031, 1150.03, -13896.4, -1935.97, 1252.03, 0, 0, 0, NULL), ('surf_apollonian', 6, 3, 0, -8751.97, -14064, 1822.03, -7888.03, -13780.5, 1924.03, 0, 0, 0, NULL), ('surf_apollonian_', 0, 3, 0, -8751.97, -13663.6, 1822.03, -7888.03, -14064, 1924.03, 0, 0, 0, NULL), ('surf_apollonian_', 1, 3, 1, -166.096, -5976.03, -7226.97, -457.015, -6565.97, -7124.97, 0, 0, 0, NULL), ('surf_apollonian_', 2, 3, 2, 3045.04, -1071.97, 254.031, 3567.97, 1071.97, 356.031, 0, 0, 0, NULL), ('surf_apollonian_', 3, 1, 1, -13887.3, -944.031, 1150.03, -14255.8, -1935.97, 1252.03, 0, 0, 0, NULL), ('surf_apollonian_', 4, 3, 3, -15870.3, 11374.4, -6771.47, -16176.5, 10734.6, -6669.47, 0, 0, 0, NULL), ('surf_apollonian_', 5, 3, 4, 7184.03, 4656.03, 2558.03, 7544.31, 5583.97, 2660.03, 0, 0, 0, NULL), ('surf_arghmyeyes', 0, 1, 1, 947.259, -2942.85, 1186.83, 1488.69, -2421.52, 1317.68, 0, 0, 0, NULL), ('surf_artifex', 0, 3, 2, 8039.54, -9401.83, 11994, 8347.51, -8719.21, 12096, 0, 0, 0, NULL), ('surf_artifex', 1, 3, 0, 12424, 8303.98, -793.969, 12475.5, 8204.48, -691.969, 0, 0, 0, NULL), ('surf_artifex', 2, 1, 0, 13630.5, 1538.07, 10726, 13445, 1795.16, 10828, 0, 0, 0, NULL), ('surf_artifex', 3, 2, 0, -13983.3, -9279.98, 7354.03, -14188, -8857.95, 7456.03, 0, 0, 0, NULL), ('surf_artifex', 4, 3, 1, -1209.02, 1024.03, -1104.82, -949.329, 2794.5, -1147.97, 0, 0, 0, NULL), ('surf_artifex', 5, 1, 0, 8688.14, -3465.84, -1455.97, 7816.03, -4473.46, -1303.77, 0, 0, 1, NULL), ('surf_artifex', 6, 2, 0, 6471.73, -4831.97, -4428.77, 7451.94, -3328.03, -3942.66, 0, 0, 1, NULL), ('surf_aspiration', 0, 1, 1, -12595, 719.969, 11246, -12090.2, -515.969, 11348, 0, 0, 0, NULL), ('surf_aspiration', 1, 2, 1, 11352, 1319.97, -9241.97, 10299, -1122.97, -9139.97, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_asrown', 0, 2, 1, -10041.5, -3471.97, 1078.03, -10316.8, -2480.03, 1180.03, 0, 0, 0, NULL), ('surf_asrown', 1, 1, 1, -13287.4, 13885.3, 14096.1, -13200, 14128, 14198.1, 0, 0, 0, NULL), ('surf_asrown-', 0, 2, 1, -10041.5, -3471.97, 1078.03, -10316.8, -2480.03, 1180.03, 0, 0, 0, NULL), ('surf_asrown-', 1, 5, 1, -13287.4, 13885.3, 14096.1, -13200, 14128, 14198.1, 0, 0, 0, NULL), ('surf_ataque_final', 0, 3, 4, -1489.15, 6166.14, 4471.97, -1551.97, 6261.4, 4140.72, 0, 0, 0, NULL), ('surf_ataque_final', 1, 3, 2, 2080.03, -967.969, -10978, 2169.18, -544.863, -10868, 0, 0, 0, NULL), ('surf_ataque_final', 2, 3, 3, 251.931, 25.9659, 821.368, -253.344, -317.544, 980.451, 0, 0, 0, NULL), ('surf_ataque_final', 3, 3, 0, 2808.03, -2143.97, -9033.97, 3783.97, -1882.39, -8931.97, 0, 0, 0, NULL), ('surf_ataque_final', 4, 3, 1, 5120.03, 4791.3, -4873.97, 5295.71, 4608.03, -4771.97, 0, 0, 0, NULL), ('surf_ataque_final', 5, 2, 0, -1680.31, 5130.68, 2031.49, -1412.92, 4710.8, 1911.03, 0, 0, 0, NULL), ('surf_ataque_final', 6, 5, 0, 4813.88, -2134.46, -8431.97, 4221.66, -1813.48, -8240.03, 0, 0, 0, NULL), ('surf_ataque_final', 7, 6, 0, -1462.66, 4765.02, 1920.03, -1567.46, 4841.75, 1883.94, 0, 0, 0, NULL), ('surf_atlas', 0, 2, 1, -15251.6, 1746.97, -2289.94, -16284, -1362.97, -2190.97, 0, 0, 0, NULL), ('surf_atlas', 1, 1, 1, -7541.95, 397.274, 14848, -7748.04, -11.3336, 14948, 0, 0, 0, NULL), ('surf_atlas_1', 0, 2, 0, -16270, -1348, -2292.97, -15254.6, 1731.97, -2189.94, 0, 0, 0, NULL), ('surf_atlas_1', 1, 1, 0, -7571.6, 1494.97, 14735.1, -7947.28, -1107.97, 15056.4, 0, 0, 0, NULL), ('surf_auroia_njv', 0, 5, 0, -1425.97, 910.835, 2045.28, -569.917, 1347.97, 1969.95, 0, 0, 0, NULL), ('surf_auroia_njv', 1, 3, 0, 2145.06, -5691.33, 2877.03, 2305.94, -5348.17, 2858.03, 0, 0, 0, NULL), ('surf_auroia_njv', 2, 3, 1, -9465.46, 12426.3, 3066.03, -10402.6, 12620.5, 3044.03, 0, 0, 0, NULL), ('surf_auroia_njv', 3, 3, 2, 11723.7, -5482.42, 3107.03, 12025.3, -4876.32, 3080.03, 0, 0, 0, NULL), ('surf_auroia_njv', 4, 3, 3, 9017.82, 10024, 1899.52, 9372.55, 10683.8, 1856.03, 0, 0, 0, NULL), ('surf_auroia_njv', 5, 3, 4, 1562.03, 3954.77, 1223.65, 2164.6, 6134.46, 1166.39, 0, 0, 0, NULL), ('surf_auroia_njv', 6, 2, 0, -655.14, 4683.03, -149.48, -1448.97, 5064.19, 164.457, 0, 0, 0, NULL), ('surf_auroria2', 0, 3, 4, -10544, 1711.97, 10206, -10960, 1296.03, 10308, 0, 0, 0, NULL), ('surf_auroria2', 1, 3, 5, 11534, 14006.6, 15614, 11974.9, 13745.8, 15735.3, 0, 0, 0, NULL), ('surf_auroria2', 2, 1, 1, 1696.06, -12236.3, -3121.97, 944.678, -11793.9, -2991, 0, 0, 0, NULL), ('surf_auroria2', 3, 2, 1, 9717.01, 11261.2, -8145.97, 13823.5, 12784, -8043.97, 0, 0, 0, NULL), ('surf_auroria2', 4, 3, 3, -12576, -9055.97, -9937.97, -13568, -8561.56, -9835.97, 0, 0, 0, NULL), ('surf_auroria2', 5, 3, 0, -2651.03, -13868, -4649.97, -2874.97, -13413.6, -4547.97, 0, 0, 0, NULL), ('surf_auroria2', 6, 3, 1, -6142.39, -1840.03, -7057.97, -6365.09, -2301.53, -6955.97, 0, 0, 0, NULL), ('surf_auroria2', 7, 3, 2, -4961.84, 13481.2, 766.031, -5600.46, 13072, 868.031, 0, 0, 0, NULL), ('surf_auroria_2', 0, 1, 0, 1503.97, 13089.3, -6844.32, 1059.74, 13533.7, -6912.97, 0, 0, 1, NULL), ('surf_auroria_2', 1, 2, 0, 954.51, 13593.7, -14376, 1614.13, 12951.8, -14459, 0, 0, 1, NULL), ('surf_auroria_2', 2, 2, 0, 1584.4, 13058, -14436.1, 1645.48, 13483.9, -14507.9, 0, 0, 1, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_auroria_2', 3, 2, 0, 985.83, 13577.4, -14375.9, 923.922, 13123.8, -14419.1, 0, 0, 1, NULL), ('surf_auroria_2', 4, 5, 0, 942.581, -11787.9, -2949.97, 1702.32, -12222.1, -3119.97, 0, 0, 0, NULL), ('surf_auroria_2', 11, 3, 4, -10975.1, 1727.23, 10208, -10529.1, 1280.03, 10426.8, 0, 0, 0, ''), ('surf_auroria_2', 5, 5, 1, 937.869, -12237.1, -2919.97, 1702.43, -12224.4, -3119.97, 0, 0, 0, NULL), ('surf_auroria_2', 6, 3, 0, -2635.56, -13888, -4488.37, -2890.97, -13379.4, -4647.33, 0, 0, 0, NULL), ('surf_auroria_2', 7, 3, 1, -6373.62, -1828.57, -7055.97, -6136.03, -2320.22, -6947.69, 0, 0, 0, NULL), ('surf_auroria_2', 8, 3, 2, -4650.64, 13552, 1012.44, -5863.79, 13056, 768.571, 0, 0, 0, NULL), ('surf_auroria_2', 9, 3, 3, -13582.6, -9069.43, -9496.03, -12562.7, -8564.43, -9935.97, 0, 0, 0, NULL), ('surf_auroria_2', 10, 2, 0, 13756.9, 12800, -7851.49, 9732.94, 11266.9, -8143.97, 0, 0, 0, NULL), ('surf_auroria_ksf', 0, 1, 1, -1015.06, 926.031, 1962.03, -1409.99, 1331.97, 2064.03, 0, 0, 0, NULL), ('surf_aux', 0, 1, 1, 6368.03, 7611.78, 6318.03, 6719.97, 7376.03, 6420.03, 0, 0, 0, NULL), ('surf_aux', 1, 2, 1, 5701.01, 7475.18, 6894.85, 7384.59, 7246.54, 7262.04, 0, 0, 0, NULL), ('surf_aux', 2, 3, 0, -3631.97, -5968.03, 7680.03, -3472.03, -6332.91, 7780.03, 0, 0, 0, NULL), ('surf_awakening', 0, 3, 1, 10526.7, 3895.97, 514.031, 10032, 3416.03, 616.031, 0, 0, 0, NULL), ('surf_awakening', 1, 3, 0, -8366.03, -2898.58, -1409.97, -8688.04, -2626.77, -1307.97, 0, 0, 0, NULL), ('surf_awakening', 2, 1, 1, -2381.97, 2116.4, -781.969, -1902.03, 1723.65, -679.969, 0, 0, 0, NULL), ('surf_awakening', 3, 3, 2, -5063.94, 4174.11, 3614.03, -4781.09, 4513.29, 3716.03, 0, 0, 0, NULL), ('surf_awakening_rg', 0, 2, 1, -2928, 3601.62, 3776.03, -2297.27, 3850.8, 3876.03, 0, 0, 0, NULL), ('surf_awakening_rg', 1, 3, 0, -8373.15, -2909.79, -1407.97, -8697.92, -2602.78, -1306.19, 0, 0, 0, NULL), ('surf_awakening_rg', 2, 3, 2, -5043.38, 4113.37, 3616.63, -4658.44, 4578.3, 3716.68, 0, 0, 0, NULL), ('surf_awakening_rg', 3, 1, 1, -2381.97, 2114.88, -779.969, -1902.03, 1888.64, -679.969, 0, 0, 0, NULL), ('surf_awakening_rg', 4, 3, 1, 10524.2, 3895.97, 516.031, 10064.4, 3416.03, 616.031, 0, 0, 0, NULL), ('surf_aweles', 0, 2, 1, -2443.67, 7237.74, -5992.03, -1863.34, 4640.03, -6533.9, 0, 0, 0, NULL), ('surf_aweles', 1, 3, 0, 8596.03, 9600.45, 2594.03, 11580, 10069, 2696.03, 0, 0, 0, NULL), ('surf_aweles', 2, 3, 3, -5.45583, 11252.6, 428.031, -1013.22, 11041.4, 530.031, 0, 0, 0, NULL), ('surf_aweles', 3, 1, 1, 12445, 731.335, 2301.51, 14099, 1364.87, 2403.31, 0, 0, 0, NULL), ('surf_aweles', 4, 3, 2, 4642.88, 7430.97, -675.639, 3441.12, 7159.49, -573.639, 0, 0, 0, NULL), ('surf_aweles', 5, 3, 1, 5894.77, 5876.28, 222.031, 5397.59, 5489.85, 324.031, 0, 0, 0, NULL), ('surf_bbb', 0, 1, 0, -7640.01, 8532.14, -721.969, -8631.98, 8850.8, -619.969, 0, 0, 0, NULL), ('surf_bbb', 1, 2, 0, 4367.97, -9584.03, -1777.97, 3888.03, -10064, -1675.97, 0, 0, 0, NULL), ('surf_bbb', 2, 3, 1, 656.031, 1875.29, -603.146, 879.969, 2103.97, -443.976, 0, 0, 0, NULL), ('surf_bbb', 3, 3, 0, 8532.81, 3944.03, -2905.97, 8184.03, 4295.97, -2803.97, 0, 0, 0, NULL), ('surf_bbb', 4, 3, 2, -13848, -13736, 1014.03, -13624, -13486.3, 1116.03, 0, 0, 0, NULL), ('surf_bbb', 5, 3, 3, -2391.72, -6060.97, -305.969, -2631.97, -6303.97, -203.969, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_bbb', 6, 3, 4, 4784.01, -14422.9, -345.969, 5007.95, -14192, -243.969, 0, 0, 0, NULL), ('surf_bbb', 7, 1, 0, -4279.97, 9135.98, -257.969, -4172.97, 8656.03, -155.969, 0, 0, 1, NULL), ('surf_bbb', 8, 2, 0, -4304.26, 8272.49, -297.266, -4317.64, 8443.68, -161.728, 0, 0, 1, NULL), ('surf_beginner', 0, 3, 5, -5549.97, 560.003, 2638.03, -5073.36, 713.002, 2740.03, 0, 0, 0, NULL), ('surf_beginner', 1, 2, 1, -6076.64, 4870.66, -265.969, -4555.28, 5236.77, -80.8308, 0, 0, 0, NULL), ('surf_beginner', 2, 3, 1, 1328, -57.931, 766.031, 1652.07, 606.08, 868.031, 0, 0, 0, NULL), ('surf_beginner', 3, 3, 3, -5903.97, -1874.1, 2574.03, -5680.29, -1390.71, 2676.03, 0, 0, 0, NULL), ('surf_beginner', 4, 3, 2, 2767.99, 5492.56, 670.031, 2547.51, 6281.03, 772.031, 0, 0, 0, NULL), ('surf_beginner', 5, 3, 4, -2599.75, 48.0312, 2206.03, -2048.8, 269.431, 2308.03, 0, 0, 0, NULL), ('surf_beginner', 6, 3, 0, 2933.31, 2165.32, 510.031, 2061.78, 2399.17, 612.031, 0, 0, 0, NULL), ('surf_beginner', 7, 1, 1, -441.921, -47.9688, 318.031, 189.642, 255.787, 420.031, 0, 0, 0, NULL), ('surf_beginner_ug', 0, 3, 4, -2585.22, 267.321, 2206.03, -2025.65, 48.0312, 2308.03, 0, 0, 0, NULL), ('surf_beginner_ug', 1, 1, 1, -437.181, -47.9688, 318.031, 193.011, 254.409, 420.031, 0, 0, 0, NULL), ('surf_beginner_ug', 2, 2, 1, -4552.07, 4869.37, -265.969, -6073.72, 5245.62, -163.969, 0, 0, 0, NULL), ('surf_beginner_ug', 3, 3, 2, 2767.97, 5520.06, 670.031, 2542.93, 6265.89, 772.031, 0, 0, 0, NULL), ('surf_beginner_ug', 4, 3, 3, -5688.7, -1869.78, 2574.03, -5903.97, -1401.22, 2676.03, 0, 0, 0, NULL), ('surf_beginner_ug', 5, 3, 5, -5064.82, 726.962, 2638.03, -5553.77, 560.003, 2740.03, 0, 0, 0, NULL), ('surf_beginner_ug', 6, 3, 0, 2973.63, 2416.68, 510.031, 2025.3, 2160.03, 612.031, 0, 0, 0, NULL), ('surf_beginner_ug', 7, 3, 1, 1644.09, -64.0595, 766.031, 1328.03, 644.703, 868.031, 0, 0, 0, NULL), ('surf_beyer', 0, 1, 1, -11973.4, -13072, 14206, -12160.8, -11568, 14308, 0, 0, 0, NULL), ('surf_beyer', 1, 2, 1, 13648, 2191.97, -7298.47, 15632, 1819.75, -7213.56, 0, 0, 0, NULL), ('surf_beyer', 2, 1, 0, 9481.81, 13200, 14657.6, 9296.95, 12249.7, 14528, 0, 0, 1, NULL), ('surf_beyer', 3, 2, 0, 11084.6, 13199.2, 9870.03, 10496, 12243.6, 9964.03, 0, 0, 1, NULL), ('surf_beyer2', 0, 1, 1, 7167.4, 15584.3, 15808, 5888.7, 16080, 15908, 0, 0, 0, NULL), ('surf_beyer2', 1, 2, 1, -1919.62, 767.772, 13600, 638.911, 2045.61, 13700, 0, 0, 0, NULL), ('surf_blackout_v1', 0, 2, 0, 548.637, 11773.6, -5727.97, -470.41, 11264, -5605.82, 0, 0, 0, NULL), ('surf_blackout_v1', 1, 1, 0, -2070.9, -4559.99, 9470.03, -1823.7, -4072.11, 9572.03, 0, 0, 0, NULL), ('surf_blackout_v1', 2, 1, 1, 2073.97, -4080.03, 9470.03, 1861.16, -4576.19, 9572.03, 0, 0, 0, NULL), ('surf_blackout_v1', 3, 6, 0, -9055.97, -6599.4, 9343.63, -4117.25, -9086.05, 8032.03, 0, 0, 0, NULL), ('surf_blackout_v1', 4, 4, 0, 1326.96, 6485.53, 10240, -1287.11, 5634.51, 6272.03, 0, 0, 0, NULL), ('surf_blackout_v1', 5, 4, 1, 342.011, -5119.97, 4616.79, -430.82, -3371.25, 4331.2, 0, 0, 0, NULL), ('surf_blackout_v1', 6, 4, 2, 1023.97, 513.262, 3568.49, -1023.97, 2046.7, 2689.06, 0, 0, 0, NULL), ('surf_blackout_v1', 7, 4, 3, -991.171, 4306.9, 479.969, 1023.97, 4992.12, -613.071, 0, 0, 0, NULL), ('surf_blackout_v1', 8, 4, 4, 1279.97, -9471.14, -329.238, -1279.97, -11103.7, -653.601, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_blackout_v1', 9, 4, 5, -767.969, -11528.8, -4358.21, 767.969, -13014.6, -4614.17, 0, 0, 0, NULL), ('surf_blackout_v1', 10, 4, 6, -1276.39, -479.969, -5120.58, 1279.97, 1425.84, -5662.32, 0, 0, 0, NULL), ('surf_blackout_v1', 11, 6, 6, -7233.55, -8575.97, 9732.46, -6208.44, -7553.31, 9472.03, 0, 0, 0, NULL), ('surf_blackside', 0, 3, 0, -12088.6, 2494.19, 4000.03, -10200.6, 3389.13, 4100.03, 0, 0, 0, NULL), ('surf_blackside', 1, 1, 1, -11336.8, 12624, 12117.7, -11692.2, 15088, 12217.7, 0, 0, 0, NULL), ('surf_blackside_njv', 0, 3, 0, -10200.6, 2516.88, 3998.03, -12088.6, 3372.68, 4100.03, 0, 0, 0, NULL), ('surf_blackside_njv', 1, 1, 0, -11330, 12640.7, 12130.7, -12442.9, 15100.5, 12362, 0, 0, 0, NULL), ('surf_blackside_njv', 2, 3, 2, 12117.5, -13628.4, -5921.97, 10899.6, -13053.2, -5819.97, 0, 0, 0, NULL), ('surf_blackside_njv', 3, 3, 3, 6456.7, 8221.19, 9971.93, 5702.8, 8003.58, 10073.8, 0, 0, 0, NULL), ('surf_blackside_njv', 4, 2, 0, 6302.37, -11571.1, 3166.03, 5879.48, -12666.3, 3268.03, 0, 0, 0, NULL), ('surf_blackside_njv', 5, 3, 1, -3790.74, 9455.99, -3425.97, -4408.52, 7440, -3323.97, 0, 0, 0, NULL), ('surf_blub', 0, 3, 0, 1771.59, 2139.9, -513.969, 2042.84, 2250.37, -411.969, 0, 0, 0, NULL), ('surf_blub', 1, 1, 1, -143.969, -12336, 382.031, 591.999, -12040.4, 484.031, 0, 0, 0, NULL), ('surf_blub', 2, 3, 1, -8340.21, -2620.36, -225.969, -8815.97, -3095.87, -123.969, 0, 0, 0, NULL), ('surf_blub', 3, 3, 2, 7337.16, -153.002, -609.969, 7834.44, 409.178, -507.969, 0, 0, 0, NULL), ('surf_blub', 4, 3, 3, 3416.03, -6719.97, -1793.97, 4024, -6233.55, -1691.97, 0, 0, 0, NULL), ('surf_blub', 5, 2, 1, 3416.03, -6361.38, -6017.97, 4023.97, -6719.97, -5915.97, 0, 0, 0, NULL), ('surf_blub_njv', 0, 2, 0, 4039.97, -6734.42, -5802.17, 3401.21, -6356.76, -6015.97, 0, 0, 0, NULL), ('surf_blub_njv', 1, 3, 3, 3830.31, -6719.97, -1793.97, 3618.18, -6425.67, -1691.97, 0, 0, 0, NULL), ('surf_blub_njv', 2, 3, 2, 7724.19, -144.795, -609.969, 7467.38, 79.8988, -507.969, 0, 0, 0, NULL), ('surf_blub_njv', 3, 3, 1, -8606.34, -2884.03, -225.969, -8319.82, -2731.84, -123.969, 0, 0, 0, NULL), ('surf_blub_njv', 4, 3, 0, 1725.28, 2128.03, -513.969, 2039.12, 2255.01, -411.969, 0, 0, 0, NULL), ('surf_blub_njv', 5, 1, 0, 591.969, -12024.7, 382.031, -143.997, -12336, 484.031, 0, 0, 0, NULL), ('surf_boatastic', 0, 1, 1, 592.031, 16.0312, 9568.03, 1097.23, 495.981, 9668.03, 0, 0, 0, NULL), ('surf_boatastic', 1, 2, 1, -10571.5, 1999.97, -8191.97, -11248, 1600.14, -8091.97, 0, 0, 0, NULL), ('surf_boatastic', 2, 2, 2, -11248, -1488, -8191.97, -10563.8, 1591.26, -7502.09, 0, 0, 0, NULL), ('surf_boatastic', 3, 2, 3, -10556.3, -1487.97, -8191.97, -9348.49, 2000, -8091.97, 0, 0, 0, NULL), ('surf_bob', 0, 3, 8, 11187.9, -12269.8, 1790.03, 10476.7, -11798.4, 1892.03, 0, 0, 0, NULL), ('surf_bob', 1, 3, 6, 5359.98, -12176.3, 5758.03, 5140.93, -11922.1, 5876.88, 0, 0, 0, NULL), ('surf_bob', 2, 3, 5, 3277.38, -8208, 3838.03, 2829.93, -8430.04, 3940.03, 0, 0, 0, NULL), ('surf_bob', 3, 3, 4, 13224.2, -11668.5, 8062.03, 12944, -11881.9, 8164.03, 0, 0, 0, NULL), ('surf_bob', 4, 3, 3, 2558.05, -8192.03, 9853.11, 2049.15, -8575.97, 9731.13, 0, 0, 0, NULL), ('surf_bob', 5, 3, 2, 11297.8, -8248, 13950, 11567.8, -8542.95, 14052, 0, 0, 0, NULL), ('surf_bob', 6, 3, 1, 10224, -8431.97, 11774, 9561.56, -8208.01, 11876, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_bob', 7, 3, 0, 5638.85, -8531.3, 13310, 5147.71, -8208.01, 13412, 0, 0, 0, NULL), ('surf_bob', 8, 1, 0, 4079.97, -8208.03, 13182, 3585.2, -8705.54, 13284, 0, 0, 0, NULL), ('surf_bob', 9, 3, 7, 2065.58, -8380.53, 1790.03, 2674.9, -8802.7, 1875.12, 0, 0, 0, NULL), ('surf_bob', 10, 2, 0, 656.002, -12135.2, 15486, 1007.97, -11545.3, 15588, 0, 0, 0, NULL), ('surf_bob', 11, 3, 9, 10131.4, -10508.7, -5314.2, 9601.38, -9986.77, -5211.97, 0, 0, 0, NULL), ('surf_boring', 0, 3, 3, -4862.83, -1039.97, 1758.03, -4382.66, -814.597, 1860.03, 0, 0, 0, NULL), ('surf_boring', 1, 3, 11, 299.177, 8428.48, -3372.97, -60.4369, 8195.7, -3303.97, 0, 0, 0, NULL), ('surf_boring', 2, 3, 10, -8162.82, -1511.61, 638.031, -7579.62, -1111.27, 740.031, 0, 0, 0, NULL), ('surf_boring', 3, 3, 8, 6512.03, 5743.97, 318.031, 6655.97, 5584.01, 420.031, 0, 0, 0, NULL), ('surf_boring', 4, 3, 7, 6544, 3183.97, 318.031, 6687.97, 3024.03, 420.031, 0, 0, 0, NULL), ('surf_boring', 5, 3, 4, 2.20879, -3979.12, 4726.55, 422.974, -3623.52, 4850.11, 0, 0, 0, NULL), ('surf_boring', 6, 3, 5, -1585.85, -1123.01, 3308.87, -2057.49, -1472.98, 3363.87, 0, 0, 0, NULL), ('surf_boring', 7, 3, 6, 6512.03, 10896, 318.031, 6655.97, 10736, 420.031, 0, 0, 0, NULL), ('surf_boring', 8, 3, 2, -3429.58, 4699.63, 2078.03, -3761.84, 4393.16, 2229.27, 0, 0, 0, NULL), ('surf_boring', 9, 3, 1, -403.763, 1547.17, 326.031, -255.753, 1392.52, 428.031, 0, 0, 0, NULL), ('surf_boring', 10, 2, 0, -5495.53, -2857.02, -4813.97, -5283.84, -2959.31, -4711.97, 0, 0, 0, NULL), ('surf_boring', 11, 3, 14, -5481.99, -2608.21, -4413.97, -5301.64, -2402.09, -4354.97, 0, 0, 0, NULL), ('surf_boring', 12, 3, 13, 5480.1, -3758.73, -2620.97, 5899.66, -3547.24, -2508.97, 0, 0, 0, NULL), ('surf_boring', 13, 3, 12, 4745.06, -3718.95, -1642.97, 5090.88, -3571.1, -1540.97, 0, 0, 0, NULL), ('surf_boring', 14, 1, 0, 2298.38, 154.461, 4862.03, 2096, -159.766, 4964.03, 0, 0, 0, NULL), ('surf_boring', 15, 3, 9, 6512.03, 8335.97, 318.031, 6655.99, 8176.03, 420.031, 0, 0, 0, NULL), ('surf_boring', 16, 3, 0, -2807.73, 1540.6, 316.031, -2925.69, 1383.83, 418.031, 0, 0, 0, NULL), ('surf_bork_nbv', 0, 3, 2, -3872.07, 3531.38, -2622.97, -4369.15, 3663.97, -2520.97, 0, 0, 0, NULL), ('surf_bork_nbv', 1, 2, 0, 4192.03, -7369.97, -483.992, 4663.97, -6665.81, -387.969, 0, 0, 0, NULL), ('surf_bork_nbv', 2, 3, 3, -15484.7, -12274.8, 10174, -15654.6, -12634.4, 10276, 0, 0, 0, NULL), ('surf_bork_nbv', 3, 3, 4, 7516.37, 6261.7, 8270.03, 8735.97, 6975.97, 8372.03, 0, 0, 0, NULL), ('surf_bork_nbv', 4, 3, 0, -10022, 669.319, -8574.97, -10244.9, 448.031, -8472.97, 0, 0, 0, NULL), ('surf_bork_nbv', 5, 1, 0, -5443.61, 960.006, -6622.97, -5254.03, 1158.53, -6520.97, 0, 0, 0, NULL), ('surf_bork_nbv', 6, 3, 5, 10673.3, 3711.97, 10638, 11480, 3354.42, 10779, 0, 0, 0, NULL), ('surf_bork_nbv', 7, 3, 1, -2495.71, -128, -465.969, -2575.94, 133.945, -363.969, 0, 0, 0, NULL), ('surf_broken', 0, 3, 4, 1040.03, -1168, -2783.97, 1775.97, -1413.65, -2683.97, 0, 0, 0, NULL), ('surf_broken', 1, 3, 6, 1595.35, -5461.09, -6143.97, 1191.07, -5828.99, -6043.97, 0, 0, 0, NULL), ('surf_broken', 2, 3, 8, 1198.7, -9360.03, -9471.97, 1613.47, -9951.83, -9371.97, 0, 0, 0, NULL), ('surf_broken', 3, 3, 1, -693.169, -5473.77, -4479.97, -341.669, -5822.03, -4379.97, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_broken', 4, 3, 7, 1641.81, -7312.03, -7807.97, 1153.87, -7898.93, -7707.97, 0, 0, 0, NULL), ('surf_broken', 5, 3, 0, -681.395, -3445.91, -2783.97, -331.322, -3216.01, -2683.97, 0, 0, 0, NULL), ('surf_broken', 6, 2, 1, -2415.97, 623.969, 1248.03, -1680.03, 388.243, 1348.03, 0, 0, 0, NULL), ('surf_broken', 7, 3, 5, 1599.62, -3216, -4479.97, 1237.16, -3457.46, -4379.97, 0, 0, 0, NULL), ('surf_broken', 8, 2, 2, -1680.03, 379.036, 1248.03, -2415.99, -111.969, 1348.03, 0, 0, 0, NULL), ('surf_broken', 9, 1, 1, -689.327, -1168.03, -1087.97, -294.687, -1371.4, -987.969, 0, 0, 0, NULL), ('surf_broken', 10, 3, 2, -314.201, -7312.03, -6143.97, -726.881, -7898.21, -6043.97, 0, 0, 0, NULL), ('surf_broken', 11, 3, 3, -726.129, -9360.01, -7807.97, -305.41, -9951.54, -7707.97, 0, 0, 0, NULL), ('surf_broken', 12, 1, 2, -325.94, -1377.54, -1087.97, -682.085, -1773.61, -987.969, 0, 0, 0, NULL), ('surf_b_r_o_x_x_x', 0, 2, 0, 15672.8, -3176.04, -2602.97, 15273.7, -2740.87, -2486.27, 0, 0, 0, NULL), ('surf_b_r_o_x_x_x', 1, 2, 1, -10640, 3472.02, 142.031, -10992, 4079.98, 244.031, 0, 0, 0, NULL), ('surf_b_r_o_x_x_x', 2, 3, 2, 2255.85, -4153.61, -3363.4, 1747.2, -4681.44, -3062.03, 0, 0, 0, NULL), ('surf_b_r_o_x_x_x', 3, 3, 3, -865.969, -2367.03, 1910.03, 74.9688, -3616.97, 2012.03, 0, 0, 0, NULL), ('surf_b_r_o_x_x_x', 4, 1, 0, 4536.11, -1326.97, 930.031, 4750.12, -721.031, 1032.03, 0, 0, 0, NULL), ('surf_b_r_o_x_x_x', 5, 3, 0, -2295.03, -1329.97, 2102.03, -2551.72, -722.031, 2204.03, 0, 0, 0, NULL), ('surf_b_r_o_x_x_x', 6, 3, 1, 4083.13, -1076.9, -3320.88, 4242.04, -984.028, -3218.88, 0, 0, 0, NULL), ('surf_caca', 0, 3, 3, -1018.86, 16.0312, -1.96875, -16.0312, 2031.97, 133.227, 0, 0, 0, NULL), ('surf_caca', 1, 3, 0, -941.37, 11523.2, -1.96875, -617.017, 12016, 100.031, 0, 0, 0, NULL), ('surf_caca', 2, 1, 1, -1022.13, 13840, -1.96875, -687.489, 15856, 100.031, 0, 0, 0, NULL), ('surf_caca', 3, 2, 1, 1668.57, -8414.77, 8190.03, 209.069, -9843.73, 8292.03, 0, 0, 0, NULL), ('surf_caca', 4, 3, 2, 14347.6, 14416.4, -1.96875, 14943.4, 15347.6, 100.031, 0, 0, 0, NULL), ('surf_caca', 5, 3, 1, -1003.95, 7425.06, -1.96875, -452.943, 8193.07, 100.031, 0, 0, 0, NULL), ('surf_calamity2', 0, 1, 0, -784.031, 7685.26, 2603.03, -1974.97, 7446.9, 2705.03, 0, 0, 0, NULL), ('surf_calamity2', 1, 3, 1, 4042.1, 1159.34, 12844, 3000.03, 533.174, 12974, 0, 0, 0, NULL), ('surf_calamity2', 2, 3, 3, -5026.11, -12718.8, 2614.03, -6007.99, -11278.3, 2716.03, 0, 0, 0, NULL), ('surf_calamity2', 3, 2, 0, -4204.18, -13312, -8097.97, -5272.44, -10656, -7995.37, 0, 0, 0, NULL), ('surf_calamity2', 4, 3, 2, -12019.3, 6758.48, 14022, -10584, 7365.37, 14124, 0, 0, 0, NULL), ('surf_calamity2', 5, 3, 0, 10839.1, 8479.43, -6209.97, 10016, 8767.97, -6107.97, 0, 0, 0, NULL), ('surf_calamity_njv_', 0, 3, 1, 2431.7, -7217.99, 1375.03, 2767.95, -6871.29, 1475.03, 0, 0, 0, NULL), ('surf_calamity_njv_', 1, 3, 2, 4156.76, -10628.1, -9947.34, 5339.7, -11099.4, -9847.34, 0, 0, 0, NULL), ('surf_calamity_njv_', 2, 3, 0, 1558.98, 5723.36, -1377.97, 1982.97, 5338.03, -1277.97, 0, 0, 0, NULL), ('surf_calamity_njv_', 3, 3, 3, 8290.65, -8753.44, 4719.83, 9421.37, -9218.97, 4819.83, 0, 0, 0, NULL), ('surf_calamity_njv_', 4, 1, 0, 2558.03, -1000.99, -4890.97, 3731.97, -1498.54, -4790.97, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_calamity_njv_', 5, 2, 0, 10196.5, -2563.77, -10736, 7529.57, -3687.52, -10635, 0, 0, 0, NULL), ('surf_calibration', 0, 1, 1, -15.9688, 12704, 14270, 783.969, 11888, 14372, 0, 0, 0, NULL), ('surf_calibration', 1, 2, 1, -4025.2, 8906.67, -11266, -4921.11, 9518.83, -10585.2, 0, 0, 0, NULL), ('surf_canisius', 0, 3, 2, 2229.4, 14680.5, 1229.68, 1468.06, 14371.2, 1331.68, 0, 0, 0, NULL), ('surf_canisius', 1, 3, 3, 6904.47, 13650, 658.222, 6025.88, 13354.8, 760.222, 0, 0, 0, NULL), ('surf_canisius', 2, 3, 1, -5651.53, 14912.5, 1929.72, -6530.62, 14611.6, 2031.72, 0, 0, 0, NULL), ('surf_canisius', 3, 3, 0, -10127, 13075, 376.14, -11010.2, 12778.8, 478.14, 0, 0, 0, NULL), ('surf_canisius', 4, 1, 1, -12684.9, 11310.6, 1342.14, -13655.4, 11695.5, 1488.03, 0, 0, 0, NULL), ('surf_canisius', 5, 2, 1, 6796.62, 7354.8, -525.469, 6143.64, 7502.91, -426.469, 0, 0, 0, NULL), ('surf_canisius2', 0, 1, 0, -8849.42, 5091.47, 1143.03, -9805.98, 5410.57, 1244.21, 0, 0, 0, NULL), ('surf_canisius2', 1, 3, 0, -3858.7, 1734.85, -468.469, -4811.57, 2053.47, -370.938, 0, 0, 0, NULL), ('surf_canisius2', 2, 3, 1, 1035.25, 4104.14, 2502.03, 86.7998, 4420.97, 2632.61, 0, 0, 0, NULL), ('surf_canisius2', 3, 3, 2, 9995.03, 4755.93, 2758.03, 9047.14, 5072.97, 2867.86, 0, 0, 0, NULL), ('surf_canisius2', 4, 3, 3, -3458.97, -5732.08, 2721.52, -3180.1, -6570.01, 2619.41, 0, 0, 0, NULL), ('surf_canisius2', 5, 2, 0, 6701.03, -3587.62, -2380.55, 7031.48, -4554.97, -2693.39, 0, 0, 0, NULL), ('surf_canisius2', 6, 2, 1, 6701.36, -8882.97, -2368.25, 7032.99, -7911.03, -2694.33, 0, 0, 0, NULL), ('surf_canisius2_fix', 0, 3, 1, 49.5803, 4128.73, 2500.03, 959.969, 4404.97, 2602.03, 0, 0, 0, NULL), ('surf_canisius2_fix', 1, 3, 2, 9955.44, 4779.73, 2756.03, 9056.03, 5056.97, 2858.03, 0, 0, 0, NULL), ('surf_canisius2_fix', 2, 3, 3, -3442.97, -6678.95, 2614.03, -3090.7, -6012.79, 2716.03, 0, 0, 0, NULL), ('surf_canisius2_fix', 3, 3, 0, -4741.63, 1759.49, -470.469, -3979.88, 2026.83, -368.469, 0, 0, 0, NULL), ('surf_canisius2_fix', 4, 1, 1, -9869.78, 5092.27, 1141.03, -8846.77, 5148.58, 1243.03, 0, 0, 0, NULL), ('surf_canisius2_fix', 5, 2, 1, 6701.03, -8689.16, -2407.91, 7029.25, -8139.25, -2695.97, 0, 0, 0, NULL), ('surf_catalyst', 0, 2, 1, -479.538, 4451.87, -8255.97, -604.424, 4144.03, -8155.97, 0, 0, 0, NULL), ('surf_catalyst', 1, 1, 1, -8247.05, 687.969, 10752, -7938.05, -702.969, 10852, 0, 0, 0, NULL), ('surf_catalyst', 2, 2, 2, -799.539, 4607.04, -8255.97, -607.663, 4144, -8155.97, 0, 0, 0, NULL), ('surf_catalyst', 3, 2, 3, -927.32, 4447.39, -8255.97, -801.605, 4144, -8155.97, 0, 0, 0, NULL), ('surf_catalyst2', 0, 2, 0, -7454.52, 10884.4, -12965, -7597.2, 10713.9, -12859, 0, 0, 0, NULL), ('surf_catalyst2', 1, 2, 1, -7324.96, 10886.3, -12965, -7450.07, 10586.8, -12859, 0, 0, 0, NULL), ('surf_catalyst2', 2, 2, 2, -6956.99, 10878.7, -12965, -6809.37, 10593.2, -12859, 0, 0, 0, NULL), ('surf_catalyst2', 3, 2, 3, -6960.72, 10526.7, -12961, -7325.49, 10884.1, -12863, 0, 0, 0, NULL), ('surf_catalyst2', 4, 5, 0, -3958.45, 13180.3, 7139.03, -4332.31, 14613.9, 7241.03, 0, 0, 0, NULL), ('surf_catalyst2', 5, 2, 4, -7698.65, 11044.7, -12961, -6587.5, 10886.4, -12859, 0, 0, 0, NULL), ('surf_catalyst2', 6, 2, 5, -6805.99, 10880, -12965, -6716.09, 10669.9, -12859, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_catalyst2', 7, 6, 0, -173.988, -8031.49, -12389.9, -3647.72, -5750.73, -13203, 0, 0, 0, NULL), ('surf_catalyst2', 8, 4, 0, 4893.34, 14966, 5056.91, 5838.97, 12860.4, 4155.57, 0, 0, 0, NULL), ('surf_catalyst2', 9, 4, 1, 11487, 12848.6, 913.088, 10535.3, 14939.6, -58.9688, 0, 0, 0, NULL), ('surf_catalyst2', 10, 4, 2, 4022.3, 12878.8, -3387.03, 3424.57, 15019.1, -4650.97, 0, 0, 0, NULL), ('surf_catalyst2', 11, 4, 3, -7482.07, 8149.97, -6326.73, -6831.03, 9634.23, -6993.66, 0, 0, 0, NULL), ('surf_catalyst2', 12, 4, 4, -6260.24, -8121.53, -8370.03, -8018.65, -8473.47, -10583, 0, 0, 0, NULL), ('surf_catalyst2', 13, 4, 5, -6243.03, 3827.11, -11354.1, -8019.84, 2725.01, -11879, 0, 0, 0, NULL), ('surf_chaos_rg', 0, 1, 1, -11843, 14194, 11839, -11251, 14322.1, 11939, 0, 0, 0, NULL), ('surf_chaos_rg', 1, 2, 1, 14597.1, 11319.6, -14266, 13253.7, 12548.1, -14166, 0, 0, 0, NULL), ('surf_chaos_rg', 2, 3, 0, 11766.1, 14363.5, -167.969, 12321.3, 14919.2, -67.9688, 0, 0, 0, NULL), ('surf_chaos_rg', 3, 1, 2, -11849, 14194, 11839, -12483, 14321.5, 11939, 0, 0, 0, NULL), ('surf_chaos_rg', 4, 3, 1, -13324.2, -12880.1, -7386.97, -14044.4, -13488, -7286.97, 0, 0, 0, NULL), ('surf_cherryberry', 0, 1, 1, 1757.03, -258.352, 4008.03, 1414.03, 271.969, 4110.03, 0, 0, 0, NULL), ('surf_christmas', 0, 3, 0, -5655.97, -5707.77, -4594.47, -6112.47, -6432.47, -4492.47, 0, 0, 0, NULL), ('surf_christmas', 1, 3, 1, -8175.99, 9137.34, 7126.83, -6160.03, 8208.02, 7352.2, 0, 0, 0, NULL), ('surf_christmas', 2, 3, 2, -12890.4, -14426.6, -8077.52, -12189.4, -14084.9, -7971.15, 0, 0, 0, NULL), ('surf_christmas', 3, 3, 3, -1260.38, 6264.75, 510.031, -784.031, 6032.03, 612.031, 0, 0, 0, NULL), ('surf_christmas', 4, 3, 5, 8174.18, -320.062, -8769.91, 9128.44, -656.007, -8666.8, 0, 0, 0, NULL), ('surf_christmas', 5, 1, 0, -1706.86, -175.969, 14142, -2202.43, 1214.94, 14231.7, 0, 0, 0, NULL), ('surf_christmas', 6, 3, 6, 8208.03, 6136.55, 4286.03, 9199.98, 5637.13, 4388.03, 0, 0, 0, NULL), ('surf_christmas', 7, 3, 7, -239.82, 612.711, -1.96875, 239.969, 16.0312, 100.031, 0, 0, 0, NULL), ('surf_christmas', 8, 2, 0, -7733.24, -2141.75, -8001.24, -6821.27, -1286.43, -7878.54, 0, 0, 0, NULL), ('surf_christmas', 9, 2, 0, 10897.6, 9616.03, 11598, 11226.5, 10858.9, 11841.3, 0, 0, 1, NULL), ('surf_christmas', 10, 1, 0, 516.01, 9232.03, 14206, 847.998, 11248, 14308, 0, 0, 1, NULL), ('surf_classics', 0, 3, 27, 6950.54, -3371.44, 8262.03, 7268.73, -3671.9, 8364.03, 0, 0, 0, NULL), ('surf_classics', 1, 3, 18, 10408.2, -7326.97, 15549.5, 10732.6, -7003.07, 15651.5, 0, 0, 0, NULL), ('surf_classics', 2, 3, 17, -3781.95, 1828.6, 15421.5, -3482.12, 2146.47, 15523.5, 0, 0, 0, NULL), ('surf_classics', 3, 3, 16, -15198.8, 6999.14, 14322.1, -14978.3, 7678.2, 14424.1, 0, 0, 0, NULL), ('surf_classics', 4, 3, 1, -1024.28, -15814.2, 15369, -1430.97, -15429, 15471, 0, 0, 0, NULL), ('surf_classics', 5, 3, 15, -15780.1, 10969.6, 15143.5, -15561.2, 10388.3, 15241.4, 0, 0, 0, NULL), ('surf_classics', 6, 3, 2, -5011.62, -12873.2, 13353, -4434.69, -13240.7, 13455, 0, 0, 0, NULL), ('surf_classics', 7, 3, 3, 1086.94, -15107, 15527, 1415.97, -14786.2, 15629, 0, 0, 0, NULL), ('surf_classics', 8, 3, 0, -6199.97, -15193.4, 15499, -5872.03, -15550, 15601, 0, 0, 0, NULL), ('surf_classics', 9, 3, 5, 2127.48, -15368.4, 15594, 1785.46, -15642.2, 15696, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_classics', 10, 3, 6, -14989.7, -54.3038, 15114, -15275.1, -515.74, 15216, 0, 0, 0, NULL), ('surf_classics', 11, 3, 7, 486.485, -10615.3, 13146, 737.367, -11039.6, 13248, 0, 0, 0, NULL), ('surf_classics', 12, 3, 8, 10098.1, -4728.56, 15172, 10875.8, -4053.47, 15274, 0, 0, 0, NULL), ('surf_classics', 13, 3, 9, 10331, -9204.77, 15454, 10019.6, -9476.04, 15556, 0, 0, 0, NULL), ('surf_classics', 14, 3, 10, 14639.5, -13285.5, 15681, 14790.4, -13480.4, 15783, 0, 0, 0, NULL), ('surf_classics', 15, 3, 11, 13014.2, 3795.23, 15714, 12719.7, 3602.77, 15799.1, 0, 0, 0, NULL), ('surf_classics', 16, 3, 12, -15516.2, 1616.72, 15230, -15079.4, 1302.87, 15332, 0, 0, 0, NULL), ('surf_classics', 17, 1, 1, -7594.14, -14213, 14888.4, -7154.69, -15333, 14990.4, 0, 0, 0, NULL), ('surf_classics', 18, 3, 14, -15127.9, 16016.6, 14926, -15696.7, 15324.2, 15028, 0, 0, 0, NULL), ('surf_classics', 19, 3, 13, 11874.9, -8764.56, 15558.5, 12071.8, -9040.76, 15802, 0, 0, 0, NULL), ('surf_classics', 20, 3, 19, -223.223, -13713.2, -1794.08, -501.502, -14477, -1685.59, 0, 0, 0, NULL), ('surf_classics', 21, 3, 20, -6391.72, 5434.29, 2749.96, -7057.35, 5724.48, 2851.96, 0, 0, 0, NULL), ('surf_classics', 22, 3, 4, 8696.79, -7360.67, 14410, 8241.83, -7060.41, 14512, 0, 0, 0, NULL), ('surf_classics', 23, 3, 23, 11161.3, -2576.63, 467.031, 11459.8, -3056.59, 561.031, 0, 0, 0, NULL), ('surf_classics', 24, 2, 1, -1940.48, 10144, -13082, -2168.25, 10044.6, -12980, 0, 0, 0, NULL), ('surf_classics', 25, 3, 32, 4255.97, 224.003, -5625.97, 3550.24, 625.806, -5722.66, 0, 0, 0, NULL), ('surf_classics', 26, 3, 31, -2956.65, -5398.59, -136.459, -2412.11, -5171.26, -787.705, 0, 0, 0, NULL), ('surf_classics', 27, 3, 30, -864.031, -9550.87, 2790.03, -1333.81, -9257.65, 2906.13, 0, 0, 0, NULL), ('surf_classics', 28, 3, 29, 783.969, -1214.78, 8190.03, 690.768, -1015.41, 8291.57, 0, 0, 0, NULL), ('surf_classics', 29, 3, 28, 8815.97, -4192.03, 4654.03, 8672.03, -4447.97, 4756.03, 0, 0, 0, NULL), ('surf_classics', 30, 3, 33, 15477.9, -3621.86, 12877.1, 15534.6, -3575.61, 12998.4, 0, 0, 0, NULL), ('surf_classics', 31, 3, 22, 6163.97, 7124.97, 15790, 5933.45, 6910.12, 15884, 0, 0, 0, NULL), ('surf_classics', 32, 3, 24, -425.232, -13144.2, 7750.03, 24.1554, -13341.3, 7852.03, 0, 0, 0, NULL), ('surf_classics', 33, 3, 25, -2147.77, -7467.33, 8110.03, -2462.38, -7781.46, 8212.03, 0, 0, 0, NULL), ('surf_classics', 34, 3, 26, 6624.11, -5604.17, 4814.03, 6314.1, -5906.17, 4900.03, 0, 0, 0, NULL), ('surf_classics', 35, 3, 21, -7216.17, 5431.74, 2749.96, -7793.88, 5685.21, 2851.96, 0, 0, 0, NULL), ('surf_classics2', 0, 1, 0, 13336, 12883, 14785.9, 13127.1, 12512.8, 14887.9, 0, 0, 0, NULL), ('surf_classics2', 1, 3, 0, 7817.41, -14297.1, -535.1, 9235.59, -13108.7, -1744.12, 0, 0, 0, NULL), ('surf_classics2', 2, 3, 1, 3097.26, -15824.9, 14989.8, 3217.14, -15391.3, 15116, 0, 0, 0, NULL), ('surf_classics2', 3, 3, 2, 1918.49, 723.212, 979.031, 2465.94, 62.046, 1254.78, 0, 0, 0, NULL), ('surf_classics2', 4, 3, 3, -8850.19, -3056.03, 13259.3, -9852.64, -4079.97, 13040.1, 0, 0, 0, NULL), ('surf_classics2', 5, 3, 4, 9592, 5519.74, -6977.89, 8656.65, 4577.78, -6678.4, 0, 0, 0, NULL), ('surf_classics2', 6, 3, 6, 368.831, 11746.4, 11774, 957.484, 10857.5, 12652.5, 0, 0, 0, NULL), ('surf_classics2', 7, 3, 7, -1779.36, -6585.21, 3616.03, -2422.84, -7236.29, 3989.07, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_classics2', 8, 2, 0, -7630.49, -1822.14, -13529.2, -8630.38, -2429.69, -14113, 0, 0, 0, NULL), ('surf_classics2', 9, 3, 5, 14821.8, -448.031, -1817.97, 14259.3, -972.444, -1766.97, 0, 0, 0, NULL), ('surf_clockwork', 0, 2, 1, -7163.97, 4790.97, -8895.97, -6860.2, 4417, -8639.97, 0, 0, 0, NULL), ('surf_clockwork', 1, 1, 1, 159.002, 681.909, 64.0312, 736.178, 1279.91, 164.031, 0, 0, 0, NULL), ('surf_collaboration', 0, 3, 1, -1958.53, 4635.77, -318.3, -2096.47, 4956.47, -281.3, 0, 0, 0, NULL), ('surf_collaboration', 1, 2, 1, 2747.53, 5650.03, -5666.97, 3052.99, 6395.97, -5566.97, 0, 0, 0, NULL), ('surf_collaboration', 2, 3, 2, 2381.53, 4266.03, 4881.53, 2724.82, 4568.97, 4981.53, 0, 0, 0, NULL), ('surf_collaboration', 3, 3, 3, 370.031, 2185.91, -6658.39, 2064.56, 2528.97, -6726.81, 0, 0, 0, NULL), ('surf_collaboration', 4, 3, 4, 1610.62, -5959.97, 4224.41, 861.736, -5628.18, 4159.53, 0, 0, 0, NULL), ('surf_collaboration', 5, 3, 5, 3097.97, -6529.39, 782.91, 1890.03, -6071.12, 735.194, 0, 0, 0, NULL), ('surf_collaboration', 6, 1, 1, -1057.17, -38.0312, -1952.97, -1286.25, -334.969, -1852.97, 0, 0, 0, NULL), ('surf_collaboration', 7, 3, 6, 1977.73, 6184.38, -4052.77, 1626.74, 5855.06, -4131.97, 0, 0, 0, NULL), ('surf_collaboration', 8, 3, 0, -1861.51, -4122.53, -1378.97, -2029.97, -4482.83, -1314.97, 0, 0, 0, NULL), ('surf_collaboration', 9, 0, 1, 907.561, 587.506, -191.969, 965.969, -573.288, -38.7949, 0, 0, 0, NULL), ('surf_collection_njv', 0, 3, 5, 10283.9, 5734.8, 2062.03, 10625.5, 5512.97, 2164.03, 0, 0, 0, NULL), ('surf_collection_njv', 1, 3, 3, 4112.03, 163.347, -4081.97, 4326.46, -170.569, -3979.97, 0, 0, 0, NULL), ('surf_collection_njv', 2, 1, 1, 4346.67, 5008.03, 30.0312, 3832.54, 5243.29, 132.031, 0, 0, 0, NULL), ('surf_collection_njv', 3, 3, 0, 14451.9, 3295.48, -1025.97, 14273.9, 3115.76, -923.969, 0, 0, 0, NULL), ('surf_collection_njv', 4, 3, 1, -7871.15, 8240.47, 14.0312, -7456.54, 8440.29, 116.031, 0, 0, 0, NULL), ('surf_collection_njv', 5, 3, 2, -4030.72, 239.969, 734.031, -3630.15, -161.707, 836.031, 0, 0, 0, NULL), ('surf_collection_njv', 6, 3, 6, 6977.29, 5136.03, 14.0312, 7384.07, 5352.58, 116.031, 0, 0, 0, NULL), ('surf_collection_njv', 7, 2, 1, 7407.97, 3602.44, -1441.97, 6928, 3919.97, -1339.97, 0, 0, 0, NULL), ('surf_collection_njv', 8, 3, 4, -3252.88, 7297.97, 30.0312, -2929.39, 6986.3, 132.031, 0, 0, 0, NULL), ('surf_collection_njv', 9, 0, 1, -511.969, 3330.53, 4198.21, 511.969, 3838.72, 4131.13, 0, 0, 0, NULL), ('surf_colors_beta1', 0, 3, 4, -444.505, -7142.56, 158.031, -790.817, -7295.99, 260.031, 0, 0, 0, NULL), ('surf_colors_beta1', 1, 1, 0, -437.009, -1673.26, 766.031, 444.721, -1912.57, 868.031, 0, 0, 0, NULL), ('surf_colors_beta1', 2, 3, 0, 1420.9, -1737.34, 54.0312, 1637.58, -1924.5, 156.031, 0, 0, 0, NULL), ('surf_colors_beta1', 3, 3, 1, 4570.85, -1865.07, 386.031, 4266.14, -1678.07, 488.031, 0, 0, 0, NULL), ('surf_colors_beta1', 4, 2, 0, -3096.42, -1868.19, -113.969, -2685.26, -1462.1, -11.9688, 0, 0, 0, NULL), ('surf_colors_beta1', 5, 3, 7, -1325.27, 9234.3, 3646.03, -1551.97, 9639.97, 3716.03, 0, 0, 0, NULL), ('surf_colors_beta1', 6, 3, 6, 9385.29, -4810.55, 1202.03, 9554, -5114.56, 1304.03, 0, 0, 0, NULL), ('surf_colors_beta1', 7, 3, 5, 1725.13, -7125.08, 325.745, 1402.64, -7287.97, 427.745, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_colors_beta1', 8, 3, 3, 8995.32, -1978.67, 527.228, 9327.29, -1833.4, 629.228, 0, 0, 0, NULL), ('surf_colors_beta1', 9, 3, 2, 6845.16, -1936.41, 2045.53, 6646.44, -1781.34, 2147.53, 0, 0, 0, NULL), ('surf_color_njv', 0, 3, 2, -1357.97, 10583.5, 1498.03, -1264.15, 10782.4, 1598.03, 0, 0, 0, NULL), ('surf_color_njv', 1, 3, 0, -3647.97, 2087.97, 1880.03, -3487.51, 1922.26, 1980.03, 0, 0, 0, NULL), ('surf_color_njv', 2, 3, 1, -3551.97, 9560.49, 800.031, -3405.56, 9742.95, 900.031, 0, 0, 0, NULL), ('surf_color_njv', 3, 3, 3, -3127.97, -14628.1, 1328.03, -3021.4, -14759.7, 1428.03, 0, 0, 0, NULL), ('surf_color_njv', 4, 3, 4, -3046.76, 12320, 1200.03, -2971.67, 12411.5, 1300.03, 0, 0, 0, NULL), ('surf_color_njv', 5, 1, 1, 1356.94, -1715.62, 1612.03, 1289.94, -950.557, 1712.03, 0, 0, 0, NULL), ('surf_color_njv', 6, 2, 1, -2905.03, 13391.8, -1311.97, -3111.73, 13556, -1256.97, 0, 0, 0, NULL), ('surf_colours', 0, 3, 2, 5926.12, -1911.43, 766.031, 6366.66, -1684.94, 868.031, 0, 0, 0, NULL), ('surf_colours', 1, 3, 3, 8230.98, -1905.85, 766.031, 8685.74, -1679.19, 868.031, 0, 0, 0, NULL), ('surf_colours', 2, 3, 4, -854.575, -7216.81, 766.031, -405.633, -6987.71, 868.031, 0, 0, 0, NULL), ('surf_colours', 3, 3, 5, 1432.9, -6994.81, 766.031, 1892, -7213.83, 868.031, 0, 0, 0, NULL), ('surf_colours', 4, 3, 6, 3700.54, -7002.16, 766.031, 4159.47, -7214.04, 868.031, 0, 0, 0, NULL), ('surf_colours', 5, 3, 8, 8732, -7214.27, 766.031, 9195.66, -6999.16, 868.031, 0, 0, 0, NULL), ('surf_colours', 6, 2, 0, -2277.55, -2031.97, -1249.97, -1790.39, -1804.6, -1147.97, 0, 0, 0, NULL), ('surf_colours', 7, 3, 1, 4327, -1905.39, 766.031, 4777.95, -1678.56, 868.031, 0, 0, 0, NULL), ('surf_colours', 8, 3, 0, 1562.21, -1686.85, 766.031, 2039.77, -1912.38, 868.031, 0, 0, 0, NULL), ('surf_colours', 9, 3, 7, 5883.59, -7229.74, 766.031, 6388.52, -6990.63, 868.031, 0, 0, 0, NULL), ('surf_colours', 10, 1, 0, 456.888, -2008.59, 861.198, -443.603, -1669.37, 768.031, 0, 0, 0, NULL), ('surf_commune_too_beta5', 0, 3, 4, 10611, -11844.6, -5359.93, 10832, -12032, -5272.93, 0, 0, 0, NULL), ('surf_commune_too_beta5', 1, 2, 1, -2405.77, -6255.69, 2760.91, -3425.88, -5235.37, 2861.43, 0, 0, 0, NULL), ('surf_commune_too_beta5', 2, 1, 1, -550.775, -79.9688, 105.031, -285.788, 77.9688, 205.031, 0, 0, 0, NULL), ('surf_commune_too_beta5', 3, 3, 0, -9562.37, 2037.34, 2304.03, -9241.4, 1678.94, 2404.03, 0, 0, 0, NULL), ('surf_commune_too_beta5', 4, 3, 1, 13176.5, 5371.27, 3696.03, 13578.3, 5887.62, 3796.03, 0, 0, 0, NULL), ('surf_commune_too_beta5', 5, 3, 2, -10790.4, -3388.81, 509.969, -10969.5, -3119.44, 350.82, 0, 0, 0, NULL), ('surf_commune_too_beta5', 6, 3, 3, -7240.58, 4576.48, -7975.97, -7719.97, 4214.02, -7875.97, 0, 0, 0, NULL), ('surf_commune_too_beta5', 7, 3, 5, -7397.87, -8695.2, 8495.03, -7904.11, -9200.1, 8595.03, 0, 0, 0, NULL), ('surf_compact', 0, 3, 2, -586.469, -6738.67, 3927.38, 376.493, -6812.42, 4011.03, 0, 0, 0, NULL), ('surf_compact', 1, 3, 3, -457.969, -13695.3, 3643.53, 501.969, -14005.6, 3743.53, 0, 0, 0, NULL), ('surf_compact', 2, 3, 1, -1184.54, -1636.31, 3474.53, -1291.56, -1767.37, 3574.53, 0, 0, 0, NULL), ('surf_compact', 3, 3, 4, -66.565, 3356.1, 4076.53, 79.2057, 3296.44, 4176.53, 0, 0, 0, NULL), ('surf_compact', 4, 2, 1, -2021.97, 10180, -6261.97, -282.013, 9931.14, -6161.97, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_compact', 5, 1, 1, 1540.13, 9023.81, 4716.03, 1941, 9412.01, 4795.03, 0, 0, 0, NULL), ('surf_compulsive_njv', 0, 3, 0, 8082.53, 4786.01, -2751.97, 8483.22, 4935.58, -2649.97, 0, 0, 0, NULL), ('surf_compulsive_njv', 1, 3, 1, 11162.2, -398.062, 2958.03, 11634.1, 652.32, 3060.03, 0, 0, 0, NULL), ('surf_compulsive_njv', 2, 3, 2, -77.2771, -6783.99, -1359.97, 179.441, -5720.87, -1257.97, 0, 0, 0, NULL), ('surf_compulsive_njv', 3, 2, 0, 9749.32, -5982.73, -11542.6, 10250.7, -6511.67, -11413.8, 0, 0, 0, NULL), ('surf_compulsive_njv', 4, 1, 0, 9065.11, 9648, 12632, 9337.33, 10768, 12734, 0, 0, 0, NULL), ('surf_concept_njv', 0, 3, 4, -1251.03, -2938.97, 6931.03, -1644.72, -2521.03, 7043.03, 0, 0, 0, NULL), ('surf_concept_njv', 1, 1, 0, 3527.97, 1605.7, 3515.53, 3317.28, 1799.53, 3617.53, 0, 0, 0, NULL), ('surf_concept_njv', 2, 3, 3, -5065.26, 382.211, 126.031, -5451.99, 37.0495, 216.953, 0, 0, 0, NULL), ('surf_concept_njv', 3, 3, 1, 3202.99, 1033.34, 260.031, 3634.5, 1207.97, 377.031, 0, 0, 0, NULL), ('surf_concept_njv', 4, 3, 0, -869.031, -1304.97, 918.031, -1066.97, -1129.59, 1031.03, 0, 0, 0, NULL), ('surf_concept_njv', 5, 3, 5, -7063.81, -7039.97, -5507.97, -6571.3, -6713.03, -5405.97, 0, 0, 0, NULL), ('surf_concept_njv', 6, 2, 0, -8155.97, 8964.2, -9482.97, -5489.03, 8646.01, -9380.97, 0, 0, 0, NULL), ('surf_concept_njv', 7, 3, 2, -1685.97, -6547.97, -4186.97, -1418.03, -6347.3, -4074.97, 0, 0, 0, NULL), ('surf_construction', 0, 2, 0, 6095.97, 10704, -7137.97, 5168.03, 9776.03, -7035.97, 0, 0, 0, NULL), ('surf_construction', 1, 3, 0, 479.969, 261.623, 1534.03, 80.0312, -256.427, 1636.03, 0, 0, 0, NULL), ('surf_construction', 2, 1, 0, -11199, 4605.49, 2560.03, -10768.8, 3586.96, 2660.03, 0, 0, 0, NULL), ('surf_construction', 3, 3, 1, -11184, 10490.9, 2558.03, -10784, 9994.19, 2660.03, 0, 0, 0, NULL), ('surf_cookiejar', 0, 5, 0, -5784.11, -4080.03, 12803.4, -5953.42, -4293.3, 12704, 0, 0, 0, NULL), ('surf_cookiejar', 1, 4, 0, -3538.34, 8255.97, 11323.4, -1969.67, 6872.06, 10656, 0, 0, 0, NULL), ('surf_cookiejar', 2, 4, 1, -3841.94, 4761.69, 11296, -2592.34, 3853.58, 10656, 0, 0, 0, NULL), ('surf_cookiejar', 3, 4, 2, -10504, -10145.2, 5425.32, -8328.03, -9178.93, 4505.13, 0, 0, 0, NULL), ('surf_cookiejar', 4, 4, 3, 2629.48, -6868.86, 4895.05, 2074.82, -5139.34, 4054.6, 0, 0, 0, NULL), ('surf_cookiejar', 5, 4, 4, 6567.31, -45.8726, 4956.88, 5622.03, 422.626, 3410.91, 0, 0, 0, NULL), ('surf_cookiejar', 6, 2, 0, -518.229, 11765.2, -3504.05, 294.03, 12640.9, -4319.29, 0, 0, 0, NULL), ('surf_coralis', 0, 1, 1, 9720.03, -5726.16, 2046.03, 9092.37, -5232.02, 2148.03, 0, 0, 0, NULL), ('surf_coralis', 1, 2, 1, -1382.25, -8204.84, -10778, -1652.9, -9081.62, -10684, 0, 0, 0, NULL), ('surf_coralis_ksf', 0, 2, 1, -504.543, -8223.55, -10710.8, -2433.78, -10000.3, -10586.7, 0, 0, 0, NULL), ('surf_coralis_ksf', 1, 1, 1, 9719.43, -5730.7, 2048.03, 9085.2, -5232.03, 2148.03, 0, 0, 0, NULL), ('surf_coralis_ksf', 2, 1, 0, 13774.8, -11186, 13952, 13985.9, -11434.4, 14052, 0, 0, 1, NULL), ('surf_coralis_ksf', 3, 2, 0, -12452.9, -13200, 9854.92, -11897.7, -11197.6, 10233.9, 0, 0, 1, NULL), ('surf_halloween_tf', 3, 4, 1, -3024.03, 2543.64, 541.945, -3496.44, 51.7697, -1359.79, 0, 0, 0, NULL), ('surf_coralis_ksf-', 0, 1, 0, 9886.54, -5232.03, 2046.03, 9090.53, -5730.33, 2148.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_coralis_ksf-', 1, 1, 0, 13774.8, -11186, 13952, 13985.9, -11434.4, 14052, 0, 0, 1, NULL), ('surf_coralis_ksf-', 2, 2, 0, -12446.4, -11168, 9849.66, -11872, -13155.4, 10357.2, 0, 0, 1, NULL), ('surf_coralis_ksf-', 3, 1, 0, 13777.1, -13200, 13952, 13986.3, -12939.5, 14052, 0, 0, 1, NULL), ('surf_coralis_ksf-', 4, 2, 0, -1248.03, -8242.74, -10268.6, -1864.26, -9335.02, -10752, 0, 0, 0, NULL), ('surf_halloween_tf', 2, 4, 0, 7091.57, 2031.97, 6181.44, 8267.62, 560.031, 5929.97, 0, 0, 0, NULL), ('surf_core_fix', 0, 3, 4, -4049.66, -2415.2, -6398.47, -4537.53, -2147.63, -6296.47, 0, 0, 0, NULL), ('surf_core_fix', 1, 3, 2, 1771.17, 1536.67, -5146.48, 2099.91, 1799.38, -5044.48, 0, 0, 0, NULL), ('surf_core_fix', 2, 3, 3, 4320.53, -6215.47, -5726.72, 4743.72, -5701.03, -5622.47, 0, 0, 0, NULL), ('surf_core_fix', 3, 1, 1, -6318.47, -240.797, 8753.44, -6818.47, -1042.05, 8926.03, 0, 0, 0, NULL), ('surf_core_fix', 4, 3, 0, -7157.61, -504.77, 10085.5, -6883.51, -797.53, 10187.5, 0, 0, 0, NULL), ('surf_core_fix', 5, 3, 1, -4425.65, -5554.61, -6650.97, -4654.72, -5105.91, -6548.97, 0, 0, 0, NULL), ('surf_core_fix', 6, 2, 1, -7530.97, -2631.26, -10298, -7297.78, -1980.96, -9999.9, 0, 0, 0, NULL), ('surf_creation', 0, 3, 3, 9406.03, -639.972, 7884.03, 9706.43, 753.731, 7986.03, 0, 0, 0, NULL), ('surf_creation', 1, 2, 0, 3119.62, -271.055, 4044.03, 2494.03, 431.131, 4146.03, 0, 0, 0, NULL), ('surf_creation', 2, 3, 1, -1457.97, -164.431, -9347.97, -1077.23, 176.633, -9245.97, 0, 0, 0, NULL), ('surf_creation', 3, 3, 0, 7322.28, 219.605, -3502.64, 6830.03, -219.605, -3400.64, 0, 0, 0, NULL), ('surf_creation', 4, 3, 2, -4145.97, 455.969, -1827.97, -3779.19, 92.4015, -1729.67, 0, 0, 0, NULL), ('surf_creation', 5, 1, 0, -8734.78, 367.969, 1694.03, -8976, -47.9688, 1796.03, 0, 0, 0, NULL), ('surf_crystal', 0, 3, 1, -15157.8, 2161.47, -5086.97, -14805.8, 2655.94, -4984.97, 0, 0, 0, NULL), ('surf_crystal', 1, 3, 0, -14823.3, -1976.27, -449.969, -15280, -2394.85, -347.969, 0, 0, 0, NULL), ('surf_crystal', 2, 3, 2, 3177.43, -11856, 2622.03, 4126.3, -12588.2, 2724.03, 0, 0, 0, NULL), ('surf_crystal', 3, 1, 0, -7261.87, -253.472, 7953.03, -7138.03, -130.12, 8055.03, 0, 0, 0, NULL), ('surf_crystal', 4, 3, 3, -6703.97, 6499.78, -3558.97, -6462.42, 7397.16, -3456.97, 0, 0, 0, NULL), ('surf_crystal', 5, 3, 4, -14272, -10016.3, -9476.08, -14005.4, -9942.14, -9650.8, 0, 0, 0, NULL), ('surf_crystal', 6, 2, 0, 3415.08, 7049.43, -5151.97, 3599.33, 6699.21, -5152.3, 0, 0, 0, NULL), ('surf_crystal', 7, 6, 0, 76.4968, 2519.6, 1911.97, 48.279, 2597.09, 1680.03, 0, 0, 0, NULL), ('surf_crystal', 8, 1, 0, 369.913, 2963.97, 2928.02, 293.64, 2112.03, 2659.04, 0, 0, 1, NULL), ('surf_crystal', 9, 2, 0, 79.1097, 2507.05, 1911.97, 366.553, 2594.12, 1680.03, 0, 0, 1, NULL), ('surf_crzyfrog_reloaded', 0, 1, 1, 9819.97, -2180.71, 3149.03, 9092.03, -2381.61, 3251.03, 0, 0, 0, NULL), ('surf_crzyfrog_reloaded', 1, 1, 2, 9932.03, -2177.52, 3149.03, 10660, -2381.97, 3251.03, 0, 0, 0, NULL), ('surf_crzyfrog_reloaded', 2, 3, 0, -8988.42, 8074.56, 6981.03, -9225.05, 7727.44, 7083.03, 0, 0, 0, NULL), ('surf_crzyfrog_reloaded', 3, 3, 1, 9932.03, -4244.84, 3149.03, 10660, -3469.7, 3291.03, 0, 0, 0, NULL), ('surf_curious', 0, 2, 1, -7626.44, -181.415, -9137.97, -7993.78, 187.347, -9019.39, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_curious', 1, 1, 1, 743.195, 770.112, 15070, 1132.91, -772.338, 15140, 0, 0, 0, NULL), ('surf_curious', 2, 1, 1, -622.15, -945.948, 15296, 750.053, -742.014, 15072, 0, 0, 0, NULL), ('surf_curious', 3, 6, 0, -729.278, 232.788, 11480, 827.31, -251.668, 11332, 0, 0, 0, NULL), ('surf_cyanide_njv', 0, 3, 0, 6816.51, -6821.32, 5662.03, 7512.96, -7512.65, 5764.03, 0, 0, 0, NULL), ('surf_cyanide_njv', 1, 2, 0, 6686.25, -6684.2, -6657.97, 7675.96, -7681.86, -6555.97, 0, 0, 0, NULL), ('surf_cyanide_njv', 2, 1, 0, 315.191, -11270.5, 13814, -323.777, -11778.3, 13916, 0, 0, 0, NULL), ('surf_cyka', 0, 3, 2, 12260.5, -1811.41, 12010.5, 12536, 204.532, 12110.5, 0, 0, 0, NULL), ('surf_cyka', 1, 3, 0, -6432.35, 2005.81, 8350.03, -6108.87, 2333.37, 8452.03, 0, 0, 0, NULL), ('surf_cyka', 2, 3, 1, 5785.42, 1164.43, -124.488, 7117.13, 2388.75, -51.3882, 0, 0, 0, NULL), ('surf_cyka', 3, 2, 0, 1918.1, -423.757, 3910.49, 1616, -1192.84, 3996.49, 0, 0, 0, NULL), ('surf_cyka', 4, 1, 0, 1699.74, -1105.67, 6098.03, 2023.3, -228.316, 6200.03, 0, 0, 0, NULL), ('surf_deceptive_final', 0, 2, 1, -7860.77, -2960.03, -2193.97, -8545.93, -4379.38, -2046.98, 0, 0, 0, NULL), ('surf_deceptive_final', 6, 5, 0, -10303.9, 12596.4, -5818.03, -9568.12, 13006.1, -6153.97, 0, 0, 1, 'BONUS 1'), ('surf_deceptive_final', 1, 3, 3, 12923.7, -3853.39, 862.031, 12380.3, -3436.5, 964.031, 0, 0, 0, NULL), ('surf_deceptive_final', 2, 3, 1, 11819.6, -345.557, 15570, 11008.6, 656.694, 15684, 0, 0, 0, NULL), ('surf_deceptive_final', 3, 1, 1, -7001.98, 6752.97, 3456.03, -7498.99, 5281.03, 3558.03, 0, 0, 0, NULL), ('surf_deceptive_final', 4, 3, 0, 1417.2, -12551.1, 14054.7, 2187.78, -12083, 14168.4, 0, 0, 0, NULL), ('surf_deceptive_final', 5, 3, 2, 14363.5, -7607.24, -145.969, 13857.4, -7053.26, -43.9688, 0, 0, 0, NULL), ('surf_delusional_', 0, 3, 4, 4984.89, 3190.36, 9470.03, 5106, 3462.67, 9572.03, 0, 0, 0, NULL), ('surf_delusional_', 1, 3, 0, -9558.7, -4064.05, 5776.16, -9248.85, -3140.17, 5855.7, 0, 0, 0, NULL), ('surf_delusional_', 2, 2, 0, -3089.06, 8616.77, -1123.03, -2580.77, 9633.02, -432.089, 0, 0, 0, NULL), ('surf_delusional_', 3, 3, 6, -12372.8, 9369.58, 1982.03, -12713.4, 8856.35, 2084.03, 0, 0, 0, NULL), ('surf_delusional_', 4, 3, 5, 1135.97, 12592, 13662, 687.378, 13533, 13796, 0, 0, 0, NULL), ('surf_delusional_', 5, 5, 0, -6995.36, -141.931, 9342.03, -7248.57, -894.024, 9444.03, 0, 0, 0, NULL), ('surf_delusional_', 6, 3, 1, -3024, 8939.08, 4598.03, -2803.35, 8465.08, 4708.03, 0, 0, 0, NULL), ('surf_delusional_', 7, 3, 2, -356.573, -6313.32, 4942.03, -508.266, -6541.93, 5044.03, 0, 0, 0, NULL), ('surf_delusional_', 8, 3, 3, 89.3426, 13978.8, -11618, -159.145, 13461.7, -11516, 0, 0, 0, NULL), ('surf_depressing', 0, 3, 0, -13888.4, -8389.3, 775.031, -14406.7, -7967.58, 877.031, 0, 0, 0, NULL), ('surf_depressing', 1, 3, 1, -4148.39, 3771.35, -983.969, -4688.41, 4187.47, -881.969, 0, 0, 0, NULL), ('surf_depressing', 2, 3, 3, -10439, -4898.27, -12093, -10570.4, -4519.39, -11991, 0, 0, 0, NULL), ('surf_depressing', 3, 3, 4, -14381.5, 9411.97, 1009.03, -14882.6, 9332.28, 1111.03, 0, 0, 0, NULL), ('surf_depressing', 4, 3, 5, -8027.01, -6881.17, -5713.97, -8584.97, -6454.24, -5611.97, 0, 0, 0, NULL), ('surf_depressing', 5, 3, 6, -3999.03, 8065.97, 1809.03, -4222.97, 7842.03, 1911.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_depressing', 6, 3, 7, -86.0312, -1237.3, 5649.03, -309.969, -956.031, 5751.03, 0, 0, 0, NULL), ('surf_depressing', 7, 3, 9, 3436.94, 7558.99, 12092.5, 3719.35, 7022.45, 12194.5, 0, 0, 0, NULL), ('surf_depressing', 8, 2, 0, 1762.03, -9995.97, -5533.97, 3379.97, -8492.03, -5431.97, 0, 0, 0, NULL), ('surf_depressing', 9, 3, 8, -9925.81, 3351.07, 7380.8, -9651.04, 3634.91, 7482.8, 0, 0, 0, NULL), ('surf_depressing', 10, 1, 0, -6604.02, 6063.91, -100.969, -7155.97, 6315.46, 1.03125, 0, 0, 0, NULL), ('surf_depressing', 11, 3, 2, -815.969, 11454, -6014.97, -592.031, 11394, -5912.97, 0, 0, 0, NULL), ('surf_depressing', 12, 3, 10, 2718.52, -8005.03, -1660.97, 2426.3, -8411.19, -1558.97, 0, 0, 0, NULL), ('surf_depths', 0, 2, 1, -7131.15, -3894.6, -10187.4, -6847.48, -4179.91, -10015.2, 0, 0, 0, NULL), ('surf_depths', 1, 1, 1, 8205.94, 10413.6, 14625.8, 8029.44, 10057.8, 14727.8, 0, 0, 0, NULL), ('surf_depths', 2, 3, 0, -9916.16, 9764.8, 4051.83, -9506.68, 10779, 4085.83, 0, 0, 0, NULL), ('surf_depths', 3, 3, 1, -6529.73, 1918.61, 10245.8, -7500.61, 1264.03, 10310.5, 0, 0, 0, NULL), ('surf_depths', 4, 1, 0, 4016.03, -766.508, -3617.97, 4125.33, -1340.84, -3515.97, 0, 0, 1, NULL), ('surf_depths', 5, 2, 0, -2163.24, -779.874, -6950.92, -2677.66, -1382.93, -6405.4, 0, 0, 1, NULL), ('surf_derpis_ksf', 0, 3, 0, -9992.72, -6900.24, 11294, -10231.9, -6409.95, 11396, 0, 0, 0, NULL), ('surf_derpis_ksf', 1, 3, 2, -8080.06, 2287.97, 11294, -8316.46, 1808.03, 11396, 0, 0, 0, NULL), ('surf_derpis_ksf', 2, 3, 3, 3201.01, 6912.37, 12318, 3449.44, 7420.21, 12420, 0, 0, 0, NULL), ('surf_derpis_ksf', 3, 3, 4, 3082.04, 12551.4, 15070, 3325.58, 13051.6, 15172, 0, 0, 0, NULL), ('surf_derpis_ksf', 4, 2, 1, 2650.63, 12582.7, 6542.03, 2194.55, 13041.7, 6660.03, 0, 0, 0, NULL), ('surf_derpis_ksf', 5, 1, 1, -10884.3, -11526.7, 11294, -11130.7, -12025.8, 11396, 0, 0, 0, NULL), ('surf_derpis_ksf', 6, 3, 1, -5894.45, -2807.96, 11294, -6130.18, -2312.49, 11396, 0, 0, 0, NULL), ('surf_deserted_njv', 0, 1, 1, 515.288, 11713.8, -12125, 373.105, 12097.1, -12025, 0, 0, 0, NULL), ('surf_deserted_njv', 1, 2, 1, -508.341, 14489.8, -14583, -784.235, 13758.2, -14483, 0, 0, 0, NULL), ('surf_deserted_njv', 2, 3, 7, 620.933, -10191.1, 8069.93, 779.437, -9925.2, 8169.93, 0, 0, 0, NULL), ('surf_deserted_njv', 3, 3, 6, 676.674, -6928.12, 5406.93, 835.433, -6659.81, 5506.93, 0, 0, 0, NULL), ('surf_deserted_njv', 4, 3, 5, 661.186, -3646.53, 3085.93, 820.748, -3382.42, 3185.93, 0, 0, 0, NULL), ('surf_deserted_njv', 5, 3, 4, 290.859, -879.278, 416.051, 439.317, -612.087, 516.051, 0, 0, 0, NULL), ('surf_deserted_njv', 6, 3, 3, 295.047, 1390.75, -1631.97, 439.288, 1653.96, -1531.97, 0, 0, 0, NULL), ('surf_deserted_njv', 7, 3, 1, 261.161, 6235.52, -6851.97, 408.317, 6496.84, -6751.97, 0, 0, 0, NULL), ('surf_deserted_njv', 8, 3, 2, 239.756, 3736.92, -4275.95, 392.319, 4000.15, -4175.95, 0, 0, 0, NULL), ('surf_deserted_njv', 9, 3, 0, 492.316, 9080.8, -9119.95, 345.681, 9348.5, -9019.95, 0, 0, 0, NULL), ('surf_destiny_fixed', 0, 1, 0, 1719.97, -382.506, 6.03125, 72.0312, -131.162, 108.031, 0, 0, 0, NULL), ('surf_destiny_fixed', 1, 2, 0, 2770.16, 9055.97, -1601.97, 2902.12, 8494.28, -1531.97, 0, 0, 0, NULL), ('surf_destiny_fixed', 2, 3, 0, 3724.77, -6307.5, -1839.97, 1952.03, -5769.4, -1712.71, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_diamond_beta1', 0, 2, 1, 7696.03, -7760.03, -9409.97, 8316.01, -8815.97, -9307.97, 0, 0, 0, NULL), ('surf_diamond_beta1', 1, 3, 2, 10162.3, -6959.7, 62.0312, 9226.79, -6219.31, 164.031, 0, 0, 0, NULL), ('surf_diamond_beta1', 2, 3, 1, 464.031, 11824, 15998, 1468.43, 8912.03, 16100, 0, 0, 0, NULL), ('surf_diamond_beta1', 3, 2, 2, 8319.13, -5871.97, -9345.97, 7696.03, -4816.03, -9243.97, 0, 0, 0, NULL), ('surf_diamond_beta1', 4, 1, 1, -3199.85, -577.87, 15294, -2564.03, 59.1209, 15396, 0, 0, 0, NULL), ('surf_diamond_beta1', 5, 3, 0, 7234.17, -3375.97, 11838, 8047.97, -2501.86, 11940, 0, 0, 0, NULL), ('surf_dice_66_rc3', 0, 3, 4, -7488.03, -3562.33, -10492, -7951.97, -3168, -10390, 0, 0, 0, NULL), ('surf_dice_66_rc3', 1, 3, 3, 1430.24, -2078.21, -7169.97, 1744.59, -1459.74, -7067.97, 0, 0, 0, NULL), ('surf_dice_66_rc3', 2, 3, 2, -8730.58, 3920.8, -6577.97, -8353.62, 4221.85, -6475.97, 0, 0, 0, NULL), ('surf_dice_66_rc3', 3, 2, 1, -7480.03, 3018.71, -12932, -7951.99, 3439.97, -12832, 0, 0, 0, NULL), ('surf_dice_66_rc3', 4, 3, 0, -5570.03, 1506.97, 4150.03, -5864.14, 2067.7, 4255.11, 0, 0, 0, NULL), ('surf_dice_66_rc3', 5, 1, 1, -6281.55, 2573.6, -521.969, -5603.09, 2105.01, -447.6, 0, 0, 0, NULL), ('surf_dice_66_rc3', 6, 3, 1, -8402.29, 3862.21, 4639.03, -8023.71, 3551.32, 4741.03, 0, 0, 0, NULL), ('surf_diminsion_', 0, 2, 0, 6659, 4592, -10690, 8683.89, -493.166, -10304.5, 0, 0, 0, NULL), ('surf_diminsion_', 1, 1, 0, -9024.35, 1535.97, 14976.1, -10048, 2557.68, 15109, 0, 0, 0, NULL), ('surf_diminsion_', 2, 4, 0, -6806.08, 576.031, 10163.3, -7843.17, 3455.97, 8475.13, 0, 0, 0, NULL), ('surf_diminsion_', 3, 4, 1, 63.969, 637.052, 4391.06, -3068.63, 3519.97, 4119.15, 0, 0, 0, NULL), ('surf_diminsion_', 4, 4, 2, -11904, 2542.86, 2529.1, -10742.2, 1536.03, 1942.35, 0, 0, 0, NULL), ('surf_diminsion_', 5, 4, 3, -7680.03, 1563.04, -7145.41, -8951.07, 2559.97, -7651.76, 0, 0, 0, NULL), ('surf_diminsion_', 6, 4, 4, -2116.98, 4168.69, -8264.74, -517.771, -511.969, -10614.8, 0, 0, 0, NULL), ('surf_diminsion_', 7, 1, 0, -11392, -453.564, 7453.67, -11010.9, -762.061, 7296.03, 0, 0, 1, NULL), ('surf_diminsion_', 10, 1, 0, -3133.64, -11902.7, 14272, -2878.68, -11645.1, 14656, 0, 0, 2, 'BONUS 2'), ('surf_diminsion_', 11, 2, 0, -1340.95, -12217.6, 2848.03, -1280.03, -11330.2, 3116.32, 0, 0, 2, 'BONUS 2'), ('surf_diminsion_', 12, 2, 1, -2625.71, -10109.2, 2848.03, -3518.17, -10048, 2999.39, 0, 0, 2, 'BONUS 2'), ('surf_diminsion_', 8, 6, 0, -11705.8, -466.629, -7680.03, -11588.9, 4607.97, -7871.42, 0, 0, 0, NULL), ('surf_sinsane_ksf', 11, 4, 0, 8250.48, 1503.97, 11819.3, 7778.23, 544.031, 11387.3, 0, 0, 1, 'BONUS 1'), ('surf_sinsane_ksf', 10, 4, 4, 1100.03, 945.271, 3106.2, 1225.82, 1120.19, 2967.03, 0, 0, 0, ''), ('surf_sinsane_ksf', 9, 4, 3, -8721.17, 1136.83, 4727.97, -8337.03, 914.971, 4657.15, 0, 0, 0, ''), ('surf_sinsane_ksf', 8, 4, 2, 1831.26, 960.031, 7071.46, 1659.08, 1085.47, 6904.03, 0, 0, 0, ''), ('surf_sinsane_ksf', 7, 4, 1, 3073.29, 904.031, 8988.42, 3329.29, 1147.17, 8927.97, 0, 0, 0, ''), ('surf_sinsane_ksf', 6, 4, 0, 8228.23, 544.031, 11823.1, 7753.3, 1503.97, 11375.1, 0, 0, 0, ''), ('surf_disneyland', 0, 1, 0, -15504.8, -1703.32, 15040, -16078.9, -1198.32, 14614.4, 0, 0, 0, NULL), ('surf_disneyland', 1, 3, 0, -464.031, -1310.06, 11040.3, -1231.51, -224.043, 10704, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_disneyland', 2, 3, 1, 10367.4, 4215.87, -4327.97, 9984.46, 3448.03, -4072.61, 0, 0, 0, NULL), ('surf_disneyland', 3, 3, 2, 1616.5, 631.403, 4248.03, 2639.97, 88.1067, 4479.86, 0, 0, 0, NULL), ('surf_disneyland', 4, 3, 3, 13215.7, -627.57, -12640, 12833.3, 144.247, -12160, 0, 0, 0, NULL), ('surf_disneyland', 5, 3, 4, 4280.35, 1867.62, 11232, 4791.83, -10.397, 11759.2, 0, 0, 0, NULL), ('surf_disneyland', 6, 3, 5, -15008.7, 607.34, -807.969, -15520, -414.401, -562.917, 0, 0, 0, NULL), ('surf_disneyland', 7, 2, 0, -13856, 3616.87, -6447.83, -13280, 4063.85, -6273.95, 0, 0, 0, NULL), ('surf_distraction_v2', 0, 3, 2, -238.701, -4175.03, -3270.97, -508.215, -4486.41, -3248.97, 0, 0, 0, NULL), ('surf_distraction_v2', 1, 3, 0, 1848.03, 2565.03, 3375.03, 2273.31, 2879.97, 3477.03, 0, 0, 0, NULL), ('surf_distraction_v2', 2, 1, 1, 8300.31, -6075.25, -6400.97, 7439.58, -5965.97, -6298.97, 0, 0, 0, NULL), ('surf_distraction_v2', 3, 3, 1, 7199, 6242.17, 599.781, 7440.14, 5897.83, 701.781, 0, 0, 0, NULL), ('surf_distraction_v2', 4, 2, 1, 11817.5, 8263.49, -8222.97, 11484.2, 8367.1, -8106.87, 0, 0, 0, NULL), ('surf_distraction_v2', 5, 2, 2, 11739.9, 8222.27, -8222.97, 11564.8, 8257.1, -8120.97, 0, 0, 0, NULL), ('surf_distraction_v2', 6, 3, 3, 11409.9, -11510, -1501.47, 11898.6, -10986.7, -1399.47, 0, 0, 0, NULL), ('surf_distraction_v2', 7, 2, 3, 11874, 8372.24, -8208.87, 11444.6, 8633.47, -7914.85, 0, 0, 0, NULL), ('surf_diverge', 0, 2, 0, -2277.23, -11280.9, -11698, -2326.52, -13309.5, -10282.3, 0, 0, 0, NULL), ('surf_diverge', 1, 3, 3, 13131, -12163.4, -7089.97, 13002, -12406.5, -6987.97, 0, 0, 0, NULL), ('surf_diverge', 2, 3, 2, 1210.76, -7139.44, -5153.97, 1406.76, -7322.41, -5051.97, 0, 0, 0, NULL), ('surf_diverge', 3, 3, 1, 13053.6, 1454.46, 222.031, 13164.3, 1562.24, 324.031, 0, 0, 0, NULL), ('surf_diverge', 4, 1, 0, 12515.4, 13943.5, 10082, 12205, 13282, 10196.2, 0, 0, 0, NULL), ('surf_diverge', 5, 3, 0, 14032.4, 7146.43, 7758.03, 14188.9, 7291.79, 7860.03, 0, 0, 0, NULL), ('surf_diverge', 6, 1, 0, -13285.5, -641.955, -6249.97, -13112, -1788.57, -6147.97, 0, 0, 1, NULL), ('surf_diverge', 7, 2, 0, -11504, 13125, 12990, -10512, 13213, 13092, 0, 0, 1, NULL), ('surf_divided_nsf', 0, 2, 0, -6216.03, -12304, 5090.03, -6865.21, -13168, 5160.03, 0, 0, 0, NULL), ('surf_divided_nsf', 1, 3, 3, -14412.6, -13168, 6348.31, -14840, -12304, 6448.03, 0, 0, 0, NULL), ('surf_divided_nsf', 2, 3, 1, -9033.25, -10046.8, 12105.6, -8614.54, -10444.3, 12192, 0, 0, 0, NULL), ('surf_divided_nsf', 3, 3, 0, -4122.07, -7748.73, 12810, -3714.18, -8143.97, 12912, 0, 0, 0, NULL), ('surf_divided_nsf', 4, 1, 0, -9295.86, -8890.01, 7494.03, -8334.84, -9183.97, 7596.03, 0, 0, 0, NULL), ('surf_divided_nsf', 5, 3, 2, -13690, -8591.97, 14878, -13250.4, -8255.84, 14980, 0, 0, 0, NULL), ('surf_doodles_njv', 0, 3, 1, -9598.89, 8086.24, 1534.03, -9503.74, 8260.72, 1636.03, 0, 0, 0, NULL), ('surf_doodles_njv', 1, 2, 1, 14384, 10768, 15486, 14270.8, 11169.2, 15582.3, 0, 0, 0, NULL), ('surf_doodles_njv', 2, 3, 6, -657.272, 1074, -1537.97, -847.414, 976.435, -1413.91, 0, 0, 0, NULL), ('surf_doodles_njv', 3, 3, 5, 31.9688, 1694.87, -1537.97, -46.1263, 1900.37, -1435.97, 0, 0, 0, NULL), ('surf_doodles_njv', 4, 3, 4, 664.701, 992.031, -1537.97, 860.524, 1076.98, -1435.97, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_doodles_njv', 5, 3, 3, 31.9849, 338.274, -1537.97, -38.5443, 137.694, -1435.97, 0, 0, 0, NULL), ('surf_doodles_njv', 6, 3, 2, -9279.09, 8550.9, 1534.03, -9079.1, 8448.95, 1636.03, 0, 0, 0, NULL), ('surf_doodles_njv', 7, 3, 7, 5874.06, 514.86, 15412, 5394.19, 824.835, 15553.2, 0, 0, 0, NULL), ('surf_doodles_njv', 8, 3, 0, -9117.51, 7811.27, 1534.03, -9336.25, 7922.72, 1636.03, 0, 0, 0, NULL), ('surf_doodles_njv', 9, 1, 1, -8644.59, 8271.97, 1534.03, -8832.82, 8099.5, 1636.03, 0, 0, 0, NULL), ('surf_dread', 0, 3, 0, 2841.99, 71.8526, 80.0312, 2714.73, 205.969, 183.031, 0, 0, 0, NULL), ('surf_dread', 1, 3, 1, -1240.23, -1852.98, -511.969, -1529.33, -1612.02, -411.969, 0, 0, 0, NULL), ('surf_dread', 2, 3, 2, 554.695, -2151.33, -3640.97, 792.13, -1942.56, -3525.84, 0, 0, 0, NULL), ('surf_dread', 3, 2, 1, 608.001, -1317, -4248.97, 723.969, -1830.96, -4074.97, 0, 0, 0, NULL), ('surf_dread', 4, 1, 1, -1215.97, -74.6135, -543.969, -1079.58, 142.459, -443.969, 0, 0, 0, NULL), ('surf_dreams', 0, 3, 0, -431.969, 1028.66, -127.969, -192.086, 1535.7, -27.9688, 0, 0, 0, NULL), ('surf_dreams', 1, 2, 1, -2736, 848.031, -703.969, -848.031, 2735.97, -603.969, 0, 0, 0, NULL), ('surf_dreams', 2, 3, 3, 1021.66, -1023.11, -255.969, 1.17191, 0.107268, -155.969, 0, 0, 0, NULL), ('surf_dreams', 3, 3, 2, 2176.56, -194.333, -447.969, 1872.01, -831.126, -347.969, 0, 0, 0, NULL), ('surf_dreams', 4, 1, 1, -2498.41, -1216.04, -255.969, -1088.94, 191.643, -155.969, 0, 0, 0, NULL), ('surf_dreams', 5, 3, 1, -258.512, -2481.3, -1279.97, -431.969, -2128.33, -1179.97, 0, 0, 0, NULL), ('surf_dusk', 0, 2, 0, 10445.6, -5293.28, -509.969, 10597.5, -5153.61, -409.969, 0, 0, 0, NULL), ('surf_dusk', 1, 2, 1, 10326.8, -5506.5, -509.969, 10721.6, -5294.66, -409.969, 0, 0, 0, NULL), ('surf_dusk', 2, 3, 4, 8350.34, 1204.03, -5864.47, 8879.69, 1443.38, -5762.47, 0, 0, 0, NULL), ('surf_dusk', 3, 2, 2, 10219, -5711.97, -509.969, 10838.7, -5502.46, -409.969, 0, 0, 0, NULL), ('surf_dusk', 4, 3, 3, -9991.01, 14542.4, -8410.46, -9591.18, 14091.4, -8308.47, 0, 0, 0, NULL), ('surf_dusk', 5, 3, 5, 12689.8, -9292.53, 4444.03, 12316.2, -9109.94, 4550.03, 0, 0, 0, NULL), ('surf_dusk', 6, 1, 0, 238.233, -431.999, -1884.47, 774.028, 78.2297, -1777.8, 0, 0, 0, NULL), ('surf_dusk', 7, 3, 0, 5019.12, 8661.74, -3396.47, 4618.03, 8195.3, -3294.47, 0, 0, 0, NULL), ('surf_dusk', 8, 3, 1, -1101.72, -1135.97, -7761.47, -670.208, -710.539, -7659.47, 0, 0, 0, NULL), ('surf_dusk', 9, 3, 2, -7198.69, -988.6, -8336.47, -6737.97, -573.64, -8234.54, 0, 0, 0, NULL), ('surf_dynamics_fixed', 0, 1, 1, -255.908, -12013.2, 15326, 228.894, -12378.8, 15428, 0, 0, 0, NULL), ('surf_dynamics_fixed', 1, 2, 1, -261.835, -10576, -5609.97, 268.103, -10562.6, -5389.38, 0, 0, 0, NULL), ('surf_dynamics_fixed', 2, 2, 2, -115.853, -10278.2, -5609.97, 132.822, -10523.4, -5507.97, 0, 0, 0, NULL), ('surf_dynasty', 0, 2, 0, -4079.97, 11011.4, -8785.98, 1008.28, 13041.6, -8518, 0, 0, 0, NULL), ('surf_dynasty', 1, 1, 0, -6662.74, 12176, 14334, -6718.99, 12418.2, 14436, 0, 0, 0, NULL), ('surf_dynasty', 2, 1, 1, -7680.19, 12400, 14334, -7631.97, 12162.3, 14436, 0, 0, 0, NULL), ('surf_dynasty', 3, 2, 0, 15022.8, 4277.43, 5388.19, 15756, 3535.34, 5573.12, 0, 0, 1, NULL), ('surf_dynasty', 4, 1, 0, 9876.82, 12280.4, 16126, 9379.39, 11960.6, 16247.6, 0, 0, 1, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_dynasty', 5, 2, 0, 3524.08, 3561.69, 5447.34, 4251.32, 4287.39, 5367.23, 0, 0, 1, NULL), ('surf_dynasty', 6, 2, 0, 3515.67, 15779, 5458.65, 4251.48, 15047.1, 5356.82, 0, 0, 1, NULL), ('surf_dynasty', 7, 2, 0, 15748.8, 15772.5, 5472.52, 15008.4, 15040.2, 5375.16, 0, 0, 1, NULL), ('surf_dynasty', 8, 4, 0, -6720.03, -6407.94, 10236.3, -7615.97, -7184.14, 8993.31, 0, 0, 0, NULL), ('surf_dynasty', 9, 4, 1, -5474.26, -12224, 5631.08, -7837.02, -9359.78, 3584.03, 0, 0, 0, NULL), ('surf_dynasty', 10, 4, 2, 1213, -575.969, 5535.49, -382.706, 2367.97, 3585.79, 0, 0, 0, NULL), ('surf_dynasty', 11, 4, 3, 11328, -1476.29, -1891.21, 13945.7, -313.705, -4069.94, 0, 0, 0, NULL), ('surf_dynasty', 12, 4, 4, 11337.4, -9477.57, -320.031, 14282.9, -11616.4, -2353.01, 0, 0, 0, NULL), ('surf_dynasty', 13, 4, 5, -4109.61, -5313.85, 511.969, -6132.58, -8254.25, -2363.33, 0, 0, 0, NULL), ('surf_dynasty', 14, 4, 6, -4095.97, 8360.47, -12200.1, 975.256, 9882.31, -14241.1, 0, 0, 0, NULL), ('surf_eclipse', 0, 3, 0, -10418.6, -4215.55, 11726, -9802.56, -3958.83, 11742.3, 0, 0, 0, NULL), ('surf_eclipse', 1, 2, 0, 4407.26, -13765.5, -3852.97, 5515.62, -14844.2, -3750.97, 0, 0, 0, NULL), ('surf_eclipse', 2, 1, 0, -10853.1, 10063.4, 12112, -11255.3, 9683.5, 12214, 0, 0, 0, NULL), ('surf_eclipse', 3, 3, 1, 4616.02, -2637.62, 1897.03, 5127.34, -2134.7, 1999.03, 0, 0, 0, NULL), ('surf_ecosystem', 0, 1, 1, -2609.72, -175.066, 4814.03, -2428.54, 157.658, 4916.03, 0, 0, 0, NULL), ('surf_ecosystem', 1, 2, 1, -2194.99, 308.831, -6545.97, -2895.97, -298.553, -6443.97, 0, 0, 0, NULL), ('surf_ecosystem', 2, 2, 2, -2128.72, 163.203, -6545.97, -2187.83, -164.504, -6443.97, 0, 0, 0, NULL), ('surf_ecosystem', 3, 2, 3, -2286.99, 438.15, -6545.97, -2895.97, 309.382, -6443.97, 0, 0, 0, NULL), ('surf_ecosystem', 4, 2, 4, -2275.79, -432.621, -6545.97, -2894.73, -300.235, -6443.97, 0, 0, 0, NULL), ('surf_efficacy_rg', 0, 2, 1, -3358.16, 14576, -3302.78, -3768.52, 12802, -3171.97, 0, 0, 0, NULL), ('surf_efficacy_rg', 1, 1, 1, -9672, 13384, 13952, -10189.4, 14020.1, 14052, 0, 0, 0, NULL), ('surf_elements_beta3', 0, 3, 2, 6032, -2306.45, -1.96875, 6255.97, -2911.97, 100.031, 0, 0, 0, NULL), ('surf_elements_beta3', 1, 3, 0, 2159.97, -703.226, -513.969, 1936.01, -1051.65, -411.969, 0, 0, 0, NULL), ('surf_elements_beta3', 2, 3, 1, 8080.03, -1761.97, -1.96875, 8304, -2121.5, 100.031, 0, 0, 0, NULL), ('surf_elements_beta3', 3, 3, 3, 10128, -2287.97, 0.03125, 10352, -1791.88, 100.031, 0, 0, 0, NULL), ('surf_elements_beta3', 4, 3, 4, 12400, -4335.97, 0.03125, 12176, -3744.03, 100.031, 0, 0, 0, NULL), ('surf_elements_beta3', 5, 2, 0, 12120, -6138.66, -4791.97, 12469, -6640, -4699.97, 0, 0, 0, NULL), ('surf_elements_beta3', 6, 1, 0, 3973.43, -2282.3, -241.969, 4222.27, -2599.86, -139.969, 0, 0, 0, NULL), ('surf_elements_beta3', 7, 0, 0, -970.131, -1149.18, -2146.46, -105.141, -1938.1, -2093.57, 0, 0, 0, NULL), ('surf_elites_v2', 0, 2, 0, -111.969, 8704, -10944, 122.071, 8579.64, -10757.7, 0, 0, 0, NULL), ('surf_elites_v2', 1, 1, 0, 80.0312, -6099.2, 768.031, 510.873, -6592, 868.031, 0, 0, 0, NULL), ('surf_elites_v2', 2, 6, 4, -5768.54, -7314.66, 575.969, -3990.18, -8847.97, 9.54251, 0, 0, 0, NULL), ('surf_elites_v2', 3, 6, 0, 28.1159, -6440.9, 840.113, 28.1159, -6440.9, 840.113, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_elixor_rg', 0, 3, 1, -384.055, -1821.24, 846.171, -683.119, -2002.36, 946.171, 0, 0, 0, NULL), ('surf_elixor_rg', 1, 3, 2, 506.031, -2183.03, 1390.96, 921.843, -2214.53, 1490.96, 0, 0, 0, NULL), ('surf_elixor_rg', 2, 3, 3, -2972.71, -460.842, 1540.47, -3154.41, -667.789, 1590.55, 0, 0, 0, NULL), ('surf_elixor_rg', 3, 3, 4, 5557.03, -3345.97, 994.546, 5753.87, -3242.91, 1094.55, 0, 0, 0, NULL), ('surf_elixor_rg', 4, 3, 5, 2013.97, -4571.65, 4175.58, 1917.59, -4408.79, 4275.58, 0, 0, 0, NULL), ('surf_elixor_rg', 5, 3, 6, 173.529, -2649.03, 2575.03, 275.173, -3637.47, 2676.03, 0, 0, 0, NULL), ('surf_elixor_rg', 6, 3, 7, -6117.43, -3572.02, 4845.03, -6363.87, -3436.22, 4945.03, 0, 0, 0, NULL), ('surf_elixor_rg', 7, 2, 1, -6095.03, 1292, -2963.97, -6312.77, 1157.87, -2907.97, 0, 0, 0, NULL), ('surf_elixor_rg', 8, 3, 0, -1601.93, -3855, 650.505, -1332.26, -3688.79, 750.505, 0, 0, 0, NULL), ('surf_elixor_rg', 9, 1, 1, -2808.81, -4196.97, 880.994, -2313.46, -4006.18, 1039.05, 0, 0, 0, NULL), ('surf_elysium', 0, 2, 1, 5407.97, 11419.9, 8157.02, 5123.66, 10252.2, 7776.03, 0, 0, 0, NULL), ('surf_elysium', 1, 1, 1, -14632.6, -5010.88, -4417.97, -15201.5, -5920.67, -4315.97, 0, 0, 0, NULL), ('surf_elysium', 2, 3, 0, 6760.97, 4734.58, -8481.97, 6329.96, 5149.2, -8395.97, 0, 0, 0, NULL), ('surf_elysium', 3, 3, 1, 11449.6, 2678.16, 4718.03, 11839.7, 3075.87, 4804.03, 0, 0, 0, NULL), ('surf_elysium', 4, 3, 2, -14848.5, 12768.7, 15310, -15184, 13398.8, 15412, 0, 0, 0, NULL), ('surf_ember_sns', 0, 2, 0, -578.47, -1964.86, -6429.97, -111.891, -3468.83, -6327.97, 0, 0, 0, NULL), ('surf_ember_sns', 1, 3, 3, 20.9515, -2926.02, -509.969, -512.969, -2542.88, -407.969, 0, 0, 0, NULL), ('surf_ember_sns', 2, 3, 2, 13581.2, -3993.65, -1465.97, 13171.4, -3750.17, -1363.97, 0, 0, 0, NULL), ('surf_ember_sns', 3, 3, 1, -1540.16, 506.528, -11618, -2055.97, 128.156, -11475.5, 0, 0, 0, NULL), ('surf_ember_sns', 4, 3, 0, 125.707, -451.771, -609.969, 421.969, -26.5058, -507.969, 0, 0, 0, NULL), ('surf_ember_sns', 5, 1, 0, -4750.35, -333.969, -8600.97, -4453.33, -34.8222, -8498.97, 0, 0, 0, NULL), ('surf_entropy_finalv2', 0, 3, 2, 2285.97, -193.031, 5762.03, 2202.76, -448.608, 5862.03, 0, 0, 0, NULL), ('surf_entropy_finalv2', 1, 1, 0, 3446.38, 4091.97, 5593.03, 3201.48, 3245.83, 5695.03, 0, 0, 0, NULL), ('surf_entropy_finalv2', 2, 3, 1, 12368.4, -7574.46, -6228.97, 12178.1, -7772.83, -6126.97, 0, 0, 0, NULL), ('surf_entropy_finalv2', 3, 2, 0, 6407.66, 86.9688, 858.431, 5731.02, -712.969, 958.431, 0, 0, 0, NULL), ('surf_entropy_finalv2', 4, 3, 3, 5437.97, -107.882, 3071.43, 5175.54, -519.315, 3182.13, 0, 0, 0, NULL), ('surf_entropy_finalv2', 5, 3, 0, 2787.08, -7548.03, -4073.97, 2500.47, -7798.97, -3971.97, 0, 0, 0, NULL), ('surf_sinister_evil', 6, 1, 0, -12922.1, 4064.9, -8735.97, -13849.3, 4575.97, -8620.96, 0, 0, 1, NULL), ('surf_sinister_evil', 5, 1, 1, -9657.32, 14817.3, 12382, -8708.18, 15312, 12484, 0, 0, 0, NULL), ('surf_sinister_evil', 4, 3, 0, -5105.76, 8678.63, 7710.03, -4183.06, 9167.97, 7812.03, 0, 0, 0, NULL), ('surf_sinister_evil', 3, 3, 1, 297.981, -2638.24, 4190.03, 1229.41, -2144, 4292.03, 0, 0, 0, NULL), ('surf_sinister_evil', 2, 3, 2, 7379.28, 13831, -1473.97, 6438.94, 14320, -1371.97, 0, 0, 0, NULL), ('surf_epic', 0, 2, 0, 9168.43, -7694.31, 2704.04, 8866.72, -7394.68, 2832.38, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_epic', 1, 3, 0, -11518.4, 417.458, 1086.03, -11908.8, 741.873, 1188.03, 0, 0, 0, NULL), ('surf_epic', 2, 3, 4, -2976.38, -6407.4, 514.031, -3231.08, -6144.74, 616.031, 0, 0, 0, NULL), ('surf_epic', 3, 3, 1, -1216.33, 2845.09, 4318.03, -1470.27, 2658.92, 4420.03, 0, 0, 0, NULL), ('surf_epic', 4, 3, 3, -9964.59, -6067.22, 3966.03, -9699.84, -6544.6, 4068.03, 0, 0, 0, NULL), ('surf_epic', 5, 1, 0, -3658.55, 8399.67, -1.42687, -4522.65, 9034.64, 100.019, 0, 0, 0, NULL), ('surf_epic', 6, 3, 2, 3344.89, 2287.93, -329.969, 4078.19, 1597.63, -227.969, 0, 0, 0, NULL), ('surf_epic', 7, 3, 5, 7870.33, -6083.52, 3454.03, 7622.72, -6462.54, 3556.03, 0, 0, 0, NULL), ('surf_epic', 8, 2, 0, 9179.67, -4832.03, 2809.65, 8864.03, -5137.38, 2566.97, 0, 0, 0, NULL), ('surf_epic', 9, 1, 0, 6304.03, 9586.49, 2706.43, 6492.18, 9266.31, 2640.03, 0, 0, 1, NULL), ('surf_epic', 10, 2, 0, 10353.4, 10080, 2239.27, 10667.6, 8608.03, 2452.92, 0, 0, 1, NULL), ('surf_eternal_beta', 0, 1, 0, -14580.7, -14848, 15357.2, -14339.4, -13824.8, 14848.9, 0, 0, 0, NULL), ('surf_eternal_beta', 1, 3, 0, 387.946, -8577.59, -6952.68, 1734.83, -7282.42, -6806.85, 0, 0, 0, NULL), ('surf_eternal_beta', 2, 2, 0, -8354.64, -12379.4, 6393.49, -7779, -13479.1, 6499.18, 0, 0, 0, NULL), ('surf_euphoria', 0, 3, 0, 10636, -3601.83, 15608, 10156, -3370.79, 15791.5, 0, 0, 0, NULL), ('surf_euphoria', 1, 2, 0, 11212, -4488.06, -3663.97, 9580.03, -2646.31, -3561.97, 0, 0, 0, NULL), ('surf_euphoria', 2, 1, 0, -357.872, -8297.99, 15568, 352.031, -8570.01, 15670, 0, 0, 0, NULL), ('surf_exclave', 0, 2, 1, -1613.34, -3930.93, -11784.2, 981.183, -4920.99, -11677, 0, 0, 0, NULL), ('surf_exclave', 1, 1, 1, 7748.75, -3007.95, 8766.03, 7410.2, -4148.08, 8868.03, 0, 0, 0, NULL), ('surf_exclave', 2, 1, 2, 7743.78, -4159.22, 8766.03, 8139.33, -3005.49, 8868.03, 0, 0, 0, NULL), ('surf_sinister_evil', 1, 3, 3, 13872, 13962.7, -8577.97, 12368, 13472, -8431.67, 0, 0, 0, NULL), ('surf_sinister_evil', 0, 2, 1, 13904, -7031.39, -10210, 12336, -8031.97, -10108, 0, 0, 0, NULL), ('surf_sandman', 6, 3, 2, -7175.92, 1977.68, 7054.03, -7361.33, 1613.85, 7156.03, 0, 0, 0, NULL), ('surf_sandman', 5, 3, 1, -4377.53, -888.764, 4894.03, -4259.78, -1155.7, 4996.03, 0, 0, 0, NULL), ('surf_sandman', 4, 1, 1, 41.683, -6632.05, 3094.09, -97.6553, -5787.74, 3198.34, 0, 0, 0, NULL), ('surf_sandman', 3, 3, 3, -5894.83, 4479.64, 6218.03, -5781.33, 4745.3, 6320.03, 0, 0, 0, NULL), ('surf_exocube', 0, 3, 0, 1199.97, 6464.01, -3250.97, 848.003, 6604.4, -3150.97, 0, 0, 0, NULL), ('surf_exocube', 1, 3, 1, -2095.97, 11600, -3391.97, -1737.21, 11451, -3261.87, 0, 0, 0, NULL), ('surf_exocube', 2, 3, 3, -1838, -11351, 5186.04, -1584.03, -11808, 5284.03, 0, 0, 0, NULL), ('surf_exocube', 3, 1, 0, -91.9849, 10244.6, -3599.97, -443.953, 10384, -3499.97, 0, 0, 0, NULL), ('surf_exocube', 4, 3, 2, -3408.03, 7311.97, -2439.97, -3660.25, 6864.25, -2339.97, 0, 0, 0, NULL), ('surf_exocube', 5, 2, 0, -13744, -12240, -127.969, -13306.8, -10928, -27.9688, 0, 0, 0, NULL), ('surf_exocube_e', 0, 3, 1, -2095.97, 11600, -3391.97, -1734.43, 11452.3, -3254.01, 0, 0, 0, NULL), ('surf_exocube_e', 1, 3, 0, 1199.97, 6464.01, -3250.97, 848.031, 6600.37, -3150.97, 0, 0, 0, NULL), ('surf_exocube_e', 2, 3, 2, -3408.03, 7311.97, -2439.97, -3651.73, 6854.08, -2327.69, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_exocube_e', 3, 1, 1, -76.0156, 10240.7, -3599.97, -457.973, 10399.9, -3499.97, 0, 0, 0, NULL), ('surf_exocube_e', 4, 3, 3, -1584.03, -11360, 5184.03, -1834.22, -11819.4, 5289.81, 0, 0, 0, NULL), ('surf_exocube_e', 5, 2, 1, -13744, -12240, -127.969, -13313.4, -10928, -27.9688, 0, 0, 0, NULL), ('surf_exocube_h', 0, 2, 1, 1335.39, 2903.05, -4239.97, 1730.81, 3292.52, -4171.97, 0, 0, 0, NULL), ('surf_exocube_h', 1, 3, 3, -1584.03, -11360, 5184.03, -1838.38, -11824.6, 5285.67, 0, 0, 0, NULL), ('surf_exocube_h', 2, 3, 2, -3408.03, 7311.97, -2439.97, -3662.74, 6852.18, -2338.7, 0, 0, 0, NULL), ('surf_exocube_h', 3, 3, 1, -2095.97, 11600, -3391.97, -1739.88, 11451, -3282.54, 0, 0, 0, NULL), ('surf_exocube_h', 4, 3, 0, 848.031, 6596.64, -3250.97, 1199.97, 6464.01, -3150.97, 0, 0, 0, NULL), ('surf_exocube_h', 5, 1, 1, -92.0156, 10249.3, -3601.97, -443.953, 10384, -3499.97, 0, 0, 0, NULL), ('surf_exocube_h', 6, 6, 11, -5881.62, 13744.5, -3440.03, -6890.44, 12224, -3923.25, 0, 0, 0, NULL), ('surf_exocube_m', 0, 1, 1, -76.0156, 10240.2, -3599.97, -458.953, 10398, -3499.97, 0, 0, 0, NULL), ('surf_exocube_m', 1, 3, 2, -3408.03, 7311.97, -2439.97, -3662.27, 6854.92, -2338.23, 0, 0, 0, NULL), ('surf_exocube_m', 2, 3, 1, -1744.03, 11474.5, -3391.97, -2095.97, 11599.3, -3291.97, 0, 0, 0, NULL), ('surf_exocube_m', 3, 3, 0, 848.031, 6606.92, -3250.97, 1199.97, 6464.01, -3150.97, 0, 0, 0, NULL), ('surf_exocube_m', 4, 3, 3, -1584.03, -11808, 5184.03, -1847.24, -11347.6, 5284.03, 0, 0, 0, NULL), ('surf_exocube_m', 5, 2, 1, -13744, -12240, -127.969, -13308.2, -10928, -27.9688, 0, 0, 0, NULL), ('surf_exogenesis', 0, 2, 0, -3598.82, 1611.93, -8468.88, -3431.91, 1783.83, -8274.09, 0, 0, 0, NULL), ('surf_exogenesis', 1, 1, 0, 79.2507, 368.031, 7678.03, -331.549, 853.665, 7780.03, 0, 0, 0, NULL), ('surf_exogenesis', 2, 6, 7, -3590.03, -222.064, 3658.16, -4803.54, 479.969, 3428.77, 0, 0, 0, NULL), ('surf_exogenesis', 3, 1, 0, -6348.03, 1975.87, 3035.76, -6486.9, 1707.56, 2988.03, 0, 0, 1, NULL), ('surf_exogenesis', 4, 2, 0, -6491.01, -2215.97, 2462.97, -6348.03, -1972.42, 2416.78, 0, 0, 1, NULL), ('surf_exogenesis', 5, 4, 0, 664.158, 735.983, 4125.49, 411.303, 480.104, 4543.97, 0, 0, 0, NULL), ('surf_exogenesis', 6, 4, 1, 325.348, -872.319, 607.901, 98.771, 1994.58, 279.896, 0, 0, 0, NULL), ('surf_exogenesis', 7, 4, 2, 7359.97, -32.1, -4162.01, 6082.72, 1283.25, -3648.06, 0, 0, 0, NULL), ('surf_exogenesis', 8, 4, 3, -2879.97, 2011.93, -3649.73, -2944.03, 1359.18, -4407.72, 0, 0, 0, NULL), ('surf_exogenesis', 9, 6, 0, 370.975, 523.294, 7878.93, 649.791, 720.398, 7688.44, 0, 0, 0, NULL), ('surf_extremex', 0, 2, 1, -1040.03, 9232, -2559.97, -4079.98, 10224, -2459.97, 0, 0, 0, NULL), ('surf_extremex', 1, 3, 5, 1340.39, -1735.13, 1790.03, 1754.25, -1316.28, 1892.03, 0, 0, 0, NULL), ('surf_extremex', 2, 3, 0, 4455.97, 9635.22, 3686.03, 4739.94, 9912.77, 3788.03, 0, 0, 0, NULL), ('surf_extremex', 3, 3, 4, 10658.1, -9384.29, 4350.03, 10048.4, -8846.41, 4452.03, 0, 0, 0, NULL), ('surf_extremex', 4, 3, 3, -1351.3, 5008, 3982.03, -1871.97, 5231.97, 4084.03, 0, 0, 0, NULL), ('surf_extremex', 5, 3, 2, 15631.7, 4874.96, -2089.97, 16095, 4166.77, -1987.97, 0, 0, 0, NULL), ('surf_extremex', 6, 3, 1, 7650.39, 7985.56, 1486.03, 7391.61, 8455.97, 1588.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_extremex', 7, 1, 1, 1726.73, 12886.2, 6278.03, 1508.1, 12670.8, 6380.03, 0, 0, 0, NULL), ('surf_sandman', 2, 3, 0, -5353.22, -3707.92, 4542.03, -5190.16, -3424.59, 4644.03, 0, 0, 0, NULL), ('surf_sandman', 1, 2, 2, 6277.83, 4420.95, -649.969, 6455.97, 4774.97, -547.969, 0, 0, 0, NULL), ('surf_sandman', 0, 2, 1, 6188.36, 4330.56, -661.969, 6455.97, 4886.14, -571.969, 0, 0, 0, NULL), ('surf_rustic', 4, 2, 0, 13066.8, -528.031, 2910.37, 12402.5, -734.626, 2672.03, 0, 0, 1, NULL), ('surf_rustic', 2, 3, 0, -3264.03, 766.118, 1413.73, -4210.49, -182.342, 1248.03, 0, 0, 0, NULL), ('surf_rustic', 3, 1, 0, 12096, -14703.5, 7565.4, 13372.1, -14451.6, 7408.03, 0, 0, 1, NULL), ('surf_extrodinaire', 0, 3, 4, -8970.13, -463.371, -687.558, -8533.42, -586.685, -587.25, 0, 0, 0, NULL), ('surf_extrodinaire', 1, 3, 3, -3924.1, 1907.2, -986.641, -3499.78, 2025.76, -886.248, 0, 0, 0, NULL), ('surf_extrodinaire', 2, 1, 1, 1678.74, 1350.73, 626.923, 1211.14, 1230.37, 730.042, 0, 0, 0, NULL), ('surf_extrodinaire', 3, 3, 1, 1193.51, -853.342, 1735.24, 1592.51, -735.196, 1835.75, 0, 0, 0, NULL), ('surf_extrodinaire', 4, 2, 1, -6035.26, -739.642, -1074.06, -6403.79, -366.129, -974.059, 0, 0, 0, NULL), ('surf_extrodinaire', 5, 3, 0, -2537.56, 1962, 1614.92, -2322.81, 1852.88, 1714.92, 0, 0, 0, NULL), ('surf_extrodinaire', 6, 3, 2, 234.952, -2176.91, 4342.5, 677.604, -2058.15, 4442.75, 0, 0, 0, NULL), ('surf_exxak', 0, 1, 1, 528.031, 144.031, -1.96875, 1647.97, 385.711, 100.031, 0, 0, 0, NULL), ('surf_exxak', 1, 3, 0, 1808.03, 16.0312, 126.031, 2671.97, 382.687, 228.031, 0, 0, 0, NULL), ('surf_exxak', 2, 3, 1, 3695.97, 378.906, 510.031, 2832.03, 16.013, 612.031, 0, 0, 0, NULL), ('surf_exxak', 3, 3, 3, 272.031, -1040.37, 638.031, 771.443, -1391.99, 740.031, 0, 0, 0, NULL), ('surf_exxak', 4, 2, 1, -3328.9, -2335.97, -945.969, -3695.97, -1248.03, -843.969, 0, 0, 0, NULL), ('surf_exxak', 5, 3, 2, 111.969, -1263.97, 638.031, -367.998, -528.031, 740.031, 0, 0, 0, NULL), ('surf_exxak', 6, 3, 4, -2415.97, -2031.97, 126.031, -1921.87, -1552.03, 228.031, 0, 0, 0, NULL), ('surf_ez', 0, 3, 2, -7268.71, 557, 448.031, -6886.07, 437.288, 548.031, 0, 0, 0, NULL), ('surf_ez', 1, 2, 1, 2936.53, 3021.64, -7591.97, 577.568, 2243.42, -7395.97, 0, 0, 0, NULL), ('surf_ez', 2, 3, 1, -2379.21, 963.131, 218.031, -2641.92, 1216.06, 318.031, 0, 0, 0, NULL), ('surf_ez', 3, 3, 0, -2241.38, -224.943, 360.031, -2085.93, -554.167, 460.031, 0, 0, 0, NULL), ('surf_ez', 4, 1, 1, -2997.58, 3182.97, -79.9688, -3101.96, 2647.03, 20.0312, 0, 0, 0, NULL), ('surf_ez', 5, 3, 3, 2074.01, -1173.5, -40.3622, 1932.89, -1320.31, 117.975, 0, 0, 0, NULL), ('surf_ez', 6, 2, 2, 2937.79, 3038.05, -7587.97, 581.529, 4304.45, -7267.69, 0, 0, 0, NULL), ('surf_faint', 0, 1, 1, -5209.54, 645.985, -161.969, -4714.09, 400.797, -107.969, 0, 0, 0, NULL), ('surf_faint', 1, 2, 1, 501.031, 1308.97, -9899.97, 1895.82, -1050.97, -9797.97, 0, 0, 0, NULL), ('surf_faint_fix', 0, 1, 0, -4939.97, 656.665, -89.337, -4716.71, 403.344, -207.969, 0, 0, 0, NULL), ('surf_faint_fix', 1, 2, 0, 1917.26, -283.031, -9602.46, 485.031, -1065.41, -9894.59, 0, 0, 0, NULL), ('surf_faint_fix', 2, 2, 1, 1169.37, 1324.97, -9604.69, 485.031, -1061.41, -9894.62, 0, 0, 0, NULL), ('surf_faint_fix', 3, 2, 2, 1918.97, 543.468, -9601.33, 485.031, 1320.36, -9894.56, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_faint_fix', 4, 4, 0, -474.034, -174.969, -1997.01, 136.711, 1232.97, -2592.42, 0, 0, 0, NULL), ('surf_faint_fix', 5, 4, 1, 4404.41, -174.969, -4849.35, 4623.12, 1232.97, -5028.09, 0, 0, 0, NULL), ('surf_faint_fix', 6, 4, 2, 14564, 880.566, -8318.48, 15268, 178.32, -8826.13, 0, 0, 0, NULL), ('surf_faint_fix', 7, 4, 3, -5867.97, 1105.38, -2901.89, -5529, 133.744, -4143.97, 0, 0, 0, NULL), ('surf_faint_fix', 8, 4, 4, 5511.22, 24.3985, -9657.97, 5045.22, 234.969, -10454.9, 0, 0, 0, NULL), ('surf_faint_fix', 9, 4, 5, 3037.45, -257.071, -10982, 2419.22, 515.922, -11711, 0, 0, 0, NULL), ('surf_faint_fix', 10, 6, 0, -2565.74, -1033.69, -7016.01, -3491.68, -1835.5, -7121.59, 0, 0, 0, NULL), ('surf_faint_fix', 11, 8, 0, 148.031, 1235.89, -2832.85, 288.418, 1275.24, -3119.97, 0, 0, 0, NULL), ('surf_faint_fix', 12, 8, 1, 150.597, -176.395, -2832.03, 290.746, -220.011, -3119.97, 0, 0, 0, NULL), ('surf_faint_fix', 13, 7, 0, 12135.4, 129.031, -8833.13, 12467.2, 924.541, -9519.97, 0, 0, 0, NULL), ('surf_fast', 0, 1, 0, 505.155, 3061.65, -12930, 219.823, 2108.88, -12828, 0, 0, 0, NULL), ('surf_fast', 1, 3, 0, 9321.54, 13583.7, 14347.5, 9093.99, 13871.1, 14449.4, 0, 0, 0, NULL), ('surf_fast', 2, 3, 1, 13058.7, -11294.6, 5856.03, 13568, -10281.3, 5937.17, 0, 0, 0, NULL), ('surf_fast', 3, 3, 2, 1727.97, -14773.4, 13323.1, 1344.03, -15102.8, 13315.2, 0, 0, 0, NULL), ('surf_fast', 4, 2, 0, 7679.24, -10495.1, -5487.97, 6527.01, -9472.03, -5342.46, 0, 0, 0, NULL), ('surf_fast', 5, 1, 0, -14928.3, 1023.48, 13696, -15360, 514.773, 13313.9, 0, 0, 1, NULL), ('surf_fast', 6, 2, 0, -14750.5, 12163.9, 13696, -15360, 12925.4, 13316.4, 0, 0, 1, NULL), ('surf_fast_nsf_b8', 0, 1, 1, 512.042, 2052.79, -12930, 181.464, 3073.84, -12828, 0, 0, 0, NULL), ('surf_fast_nsf_b8', 1, 2, 1, 8656.51, -9336.77, -5505.97, 5920.37, -11039.1, -5403.97, 0, 0, 0, NULL), ('surf_finesse_final', 0, 3, 3, 2004.3, -9615, 7510.03, 1816.03, -10072, 7612.03, 0, 0, 0, NULL), ('surf_finesse_final', 1, 1, 0, -9056.43, 3795.23, 7407, -9194.25, 3389.9, 7494.66, 0, 0, 0, NULL), ('surf_finesse_final', 2, 3, 4, -2337.97, 2009.03, 176.031, -2140.75, 2466, 288.531, 0, 0, 0, NULL), ('surf_finesse_final', 3, 3, 1, -11580, -450.765, 7700.03, -11316.3, -297.352, 7761.03, 0, 0, 0, NULL), ('surf_finesse_final', 4, 3, 2, -6721.78, 9242.12, -1047.97, -7157.97, 9432.2, -997.57, 0, 0, 0, NULL), ('surf_finesse_final', 5, 2, 0, 5924.11, 1736.27, -5153.97, 6922.02, 2750.71, -5051.97, 0, 0, 0, NULL), ('surf_finesse_final', 6, 3, 0, -8479.6, -4436.5, 4528.03, -8330.36, -4184.24, 4630.03, 0, 0, 0, NULL), ('surf_flappybird', 0, 1, 1, -15565.1, 180.503, 1160.03, -15856, -498.968, 1262.03, 0, 0, 0, NULL), ('surf_flappybird', 1, 2, 1, -186.316, 1496.03, -9539.41, -565.969, 4025.97, -9439.41, 0, 0, 0, NULL), ('surf_flappybird', 2, 3, 0, -14559.8, 445.988, -2401.97, -15102, -33.9688, -2301.97, 0, 0, 0, NULL), ('surf_flappybird', 3, 3, 1, -6025.22, 301.969, -5553.97, -6145.97, 95.0312, -5453.97, 0, 0, 0, NULL), ('surf_flappybird', 4, 3, 2, 13037.8, 2534.93, -4686.52, 13359.7, 2837.85, -4586.52, 0, 0, 0, NULL), ('surf_flyin_fortress', 0, 2, 0, -1327.97, 6240.46, 211.923, -1200.03, 6314.93, -46.5464, 0, 0, 0, NULL), ('surf_flyin_fortress', 1, 2, 1, 656.263, 6316.84, 335.969, 565.929, 6192.03, -44.7201, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_flyin_fortress', 2, 5, 0, -975.969, -1554.69, 7038.03, 463.969, -2697.31, 7140.03, 0, 0, 0, NULL), ('surf_flyin_fortress', 3, 2, 0, -89.1803, -656.002, -9609.97, -414.265, -645.3, -9303.27, 0, 0, 1, NULL), ('surf_flyin_fortress', 4, 1, 0, -716.969, -3430.2, -5377.97, 210.969, -3887.98, -5275.97, 0, 0, 1, NULL), ('surf_flyin_fortress', 5, 2, 0, -413.998, -644.747, -9663.46, -94.8196, -628.633, -9341.73, 0, 0, 1, NULL), ('surf_flyin_fortress', 6, 2, 0, 242.612, -656.031, -9609.97, -749.969, -3375.97, -9819.97, 0, 0, 1, NULL), ('surf_flyin_fortress', 7, 2, 0, 242.612, -656.031, -9609.97, -527.385, -745.664, -9243.21, 0, 0, 1, NULL), ('surf_flyin_fortress', 8, 6, 1, 687.969, 6338.56, -72.9549, -1324.01, 6175.97, -184.008, 0, 0, 0, NULL), ('surf_flyin_fortress', 9, 6, 0, -247.414, 5712.03, -521.692, -400.958, 5856.03, -652.375, 0, 0, 0, NULL), ('surf_flyin_fortress', 10, 4, 0, -959.969, 658.754, 2641.14, 401.045, 1344.82, 1312.03, 0, 0, 0, NULL), ('surf_flyin_fortress', 11, 4, 1, -1112.69, -4909.97, 2260.04, 585.629, -3662.03, 1759.74, 0, 0, 0, NULL), ('surf_flyin_fortress', 12, 4, 2, 1503.97, 1334.69, 76.7095, -2031.97, 2192.71, -915.838, 0, 0, 0, NULL), ('surf_flyin_fortress', 13, 4, 3, -1138.16, 3185.97, -3232, 643.672, 3600.85, -4497.25, 0, 0, 0, NULL), ('surf_forbidden_swag', 0, 2, 0, -652.951, 175.992, 3222.03, 333.705, -607.969, 3332.03, 0, 0, 0, NULL), ('surf_forbidden_swag', 1, 3, 3, -4578.07, -423.275, 6046.03, -5047.73, 41.6178, 6148.03, 0, 0, 0, NULL), ('surf_forbidden_swag', 2, 3, 2, 1548.46, 1071.37, 4014.03, 1785.27, 1303.44, 4116.03, 0, 0, 0, NULL), ('surf_forbidden_swag', 3, 1, 0, -1781.07, -1622.53, 2174.01, -2202.25, -1298.44, 2276.03, 0, 0, 0, NULL), ('surf_forbidden_swag', 4, 3, 0, 2873.44, -3158.05, 2685.02, 2716.03, -3447.2, 2819.02, 0, 0, 0, NULL), ('surf_forbidden_swag', 5, 3, 1, -1935.9, -3061.61, 2679.77, -2479.63, -2619.3, 2781.77, 0, 0, 0, NULL), ('surf_forbidden_tomb2', 0, 3, 1, -4811.97, 7822.03, 1515.03, -4383.96, 8330.97, 1617.03, 0, 0, 0, NULL), ('surf_forbidden_tomb2', 1, 3, 3, 1564.58, -63.6516, 4581.03, 1798.74, 171.462, 4679.03, 0, 0, 0, NULL), ('surf_forbidden_tomb2', 2, 3, 5, -8696.62, -10244.4, 1471.03, -8463.33, -10019.7, 1569.03, 0, 0, 0, NULL), ('surf_forbidden_tomb2', 3, 3, 4, 3736.26, -5208.15, 806.031, 3529.95, -5013.4, 904.031, 0, 0, 0, NULL), ('surf_forbidden_tomb2', 4, 3, 0, -4323.57, 10958.6, 2079.03, -4036.17, 10727.8, 2181.03, 0, 0, 0, NULL), ('surf_forbidden_tomb2', 5, 3, 2, -1199.97, 5827.03, 2431.03, -968.031, 5608.03, 2529.03, 0, 0, 0, NULL), ('surf_forbidden_tomb2', 6, 1, 1, -1711.25, 14413.2, 711.031, -853.386, 13758, 797.031, 0, 0, 0, NULL), ('surf_forbidden_tomb2_njv', 0, 3, 5, 3544.29, -5212.56, 806.031, 3752.25, -5011.48, 908.031, 0, 0, 0, NULL), ('surf_forbidden_tomb2_njv', 1, 3, 6, -8478.97, -10038, 1471.03, -8696.34, -10247.8, 1573.03, 0, 0, 0, NULL), ('surf_forbidden_tomb2_njv', 2, 3, 2, -3960.91, 2602.68, 893.031, -3753.68, 2396.03, 995.031, 0, 0, 0, NULL), ('surf_forbidden_tomb2_njv', 3, 3, 1, -4564.54, 8175.68, 1519.03, -4766.19, 7979.73, 1621.03, 0, 0, 0, NULL), ('surf_forbidden_tomb2_njv', 4, 3, 0, -4054.45, 10938.6, 2083.03, -4269.03, 10736.8, 2185.03, 0, 0, 0, NULL), ('surf_forbidden_tomb2_njv', 5, 1, 0, -1333.55, 13682.1, 695.031, -851.875, 14510.9, 797.031, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_forbidden_tomb2_njv', 6, 2, 0, -3083.05, -10071, -2429.97, -3511.02, -10241.4, -2057.6, 0, 0, 0, NULL), ('surf_forbidden_tomb2_njv', 7, 3, 3, -968.031, 5608.03, 2427.03, -1199.97, 5839.97, 2529.03, 0, 0, 0, NULL), ('surf_forbidden_tomb2_njv', 8, 3, 4, 1791.56, -56.0204, 4581.03, 1574.61, 147.213, 4683.03, 0, 0, 0, NULL), ('surf_forbidden_tomb3', 0, 1, 0, 2515.36, 14561, 1534.03, 2733.94, 12897, 1636.03, 0, 0, 0, NULL), ('surf_forbidden_tomb3', 1, 3, 0, -2932.98, 11258.3, 1990.03, -3138.71, 11042.2, 2092.03, 0, 0, 0, NULL), ('surf_forbidden_tomb3', 2, 3, 1, -3687.35, 8696.22, 1846.03, -3886.35, 8887.78, 1948.03, 0, 0, 0, NULL), ('surf_forbidden_tomb3', 3, 2, 0, 10048.8, -8144.91, -1793.97, 10707.8, -9368.99, -1675.97, 0, 0, 0, NULL), ('surf_forbidden_tomb3', 4, 3, 2, 3384.26, 6119.65, 1718.03, 3563.01, 6326.89, 1820.03, 0, 0, 0, NULL), ('surf_forbidden_tomb3', 5, 3, 6, 10158.1, 5655.38, 3521.53, 10572.5, 6400.53, 3623.53, 0, 0, 0, NULL), ('surf_forbidden_tomb3', 6, 3, 5, 3556.05, -483.896, -3666.97, 3371.61, -686.84, -3564.97, 0, 0, 0, NULL), ('surf_forbidden_tomb3', 7, 3, 3, -1347.81, 3056.12, 5190.03, -1153.36, 2874.01, 5292.03, 0, 0, 0, NULL), ('surf_forbidden_tomb3', 8, 3, 4, 5994.09, 2964.11, 6409.03, 5792.14, 2751.79, 6503.03, 0, 0, 0, NULL), ('surf_forbidden_tomb3', 9, 2, 1, 11159.3, -8393.42, -1600.4, 9580.46, -8016.64, -1883.47, 0, 0, 0, NULL), ('surf_forbidden_tomb3', 10, 6, 2, 10831.7, -11776, -752.714, 9937.2, -12160, -1086.83, 0, 0, 0, NULL), ('surf_forbidden_tomb4_njv', 0, 1, 0, 2933.4, -9567.13, 14273, 3440.67, -9248.38, 14383, 0, 0, 0, NULL), ('surf_forbidden_tomb4_njv', 1, 2, 0, -7721.03, 925.715, -15315.4, -8896.45, 897.835, -14165.3, 0, 0, 0, NULL), ('surf_forbidden_tomb4_njv', 2, 1, 1, 3434.31, -8134.54, 14273, 2937.84, -8398.99, 14383, 0, 0, 0, NULL), ('surf_forbidden_tomb4_njv', 3, 4, 0, 2096.03, -10122.7, 9685.07, 4271.97, -7581.3, 9455.56, 0, 0, 0, NULL), ('surf_forbidden_tomb4_njv', 4, 4, 1, 1960.03, -7696.9, 4010.95, 4355.66, -10073, 3265.39, 0, 0, 0, NULL), ('surf_forbidden_tomb4_njv', 5, 4, 2, 1960.03, 4237.8, 909.613, 4363.16, 5191.56, 307.031, 0, 0, 0, NULL), ('surf_forbidden_tomb4_njv', 6, 4, 3, -7421.52, 3007.03, -1067.92, -7010.01, 4517.27, -1772.97, 0, 0, 0, NULL), ('surf_forbidden_tomb4_njv', 7, 4, 4, -5621.58, 358.969, -3643.28, -4885.75, 2358.97, -4364.44, 0, 0, 0, NULL), ('surf_forbidden_tomb4_njv', 8, 4, 5, -3696.03, 6169.36, -7606.35, -6767.97, 6686.49, -8942.57, 0, 0, 0, NULL), ('surf_forbidden_tomb4_njv', 9, 4, 6, -3736.03, -16133.8, -9153.7, -6735.97, -15218.2, -10873.6, 0, 0, 0, NULL), ('surf_forbidden_tomb4_njv', 10, 4, 7, -6724.02, -9726.49, -13333, -3736.03, -9186.41, -14466.2, 0, 0, 0, NULL), ('surf_forbidden_tomb4_njv', 11, 4, 8, -6693.06, 6660.83, -12053, -3761.1, 7504.17, -15160.1, 0, 0, 0, NULL), ('surf_forbidden_tomb4_njv', 12, 4, 9, -6807.67, 10625.4, -13037, -9799.97, 9426.01, -14954.4, 0, 0, 0, NULL), ('surf_forbidden_tomb4_njv', 13, 4, 10, 7535.97, -10318.2, 10688.5, -1167.97, -7377.76, 10127.1, 0, 0, 0, NULL), ('surf_forbidden_tomb4_njv', 14, 4, 11, 2243.88, -9791.17, 5570.97, 3978.76, -8046.04, 4745.01, 0, 0, 0, NULL), ('surf_forbidden_tomb4_njv', 15, 4, 12, 1960.03, 472.591, 1085.44, 4372.78, 2172.97, 123.031, 0, 0, 0, NULL), ('surf_forbidden_tomb4_njv', 16, 4, 13, -8431.97, 14080.9, -49.1682, -5674.29, 14330.2, -1318.88, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_forbidden_tomb4_njv', 17, 4, 14, -6241.68, -1804.74, -1901.03, -8207.97, -2428.72, -3528.49, 0, 0, 0, NULL), ('surf_forbidden_tomb4_njv', 18, 4, 15, -3696.03, 8915.26, -6337.86, -6767.97, 9812.62, -7676.5, 0, 0, 0, NULL), ('surf_auroria_2', 12, 3, 5, 11932.1, 13710.7, 15617, 11624.2, 14167.4, 15616, 0, 0, 0, ''), ('surf_map', 12, 2, 0, 3589.78, -4618.84, -3583.97, 4095.97, -5620.3, -3214.1, 0, 0, 1, 'BONUS 1'), ('surf_forbidden_tomb_sns', 0, 2, 1, -3786.99, 4609.42, -1545.97, -2732.03, 4774.42, -1352.47, 0, 0, 0, NULL), ('surf_forbidden_tomb_sns', 1, 3, 4, -800.47, -3873.65, 3656.03, -1048.77, -3630.05, 3758.03, 0, 0, 0, NULL), ('surf_map', 11, 1, 0, -5889.83, -5444.88, -3039.97, -6208.52, -4694.37, -2593.85, 0, 0, 1, 'BONUS 1'), ('surf_forbidden_tomb_sns', 2, 1, 0, 2185.67, -2144.97, 1707.03, 454.625, -1401.5, 1859.53, 0, 0, 0, NULL), ('surf_forbidden_tomb_sns', 3, 3, 5, -5631.09, 51.9006, 5404.03, -5870.13, 262.632, 5509.78, 0, 0, 0, NULL), ('surf_forbidden_tomb_sns', 4, 3, 6, -3336.2, 6638.97, 6808.03, -3176.51, 6502.33, 6910.03, 0, 0, 0, NULL), ('surf_forbidden_tomb_sns', 5, 3, 0, 4241.98, -3070.31, 3229.03, 5045.97, -2676.9, 3289.26, 0, 0, 0, NULL), ('surf_forbidden_tomb_sns', 6, 3, 3, 6110.03, 7617.31, 5274.03, 6307.73, 7827.41, 5376.03, 0, 0, 0, NULL), ('surf_forbidden_tomb_sns', 7, 3, 2, 11854.6, -5580.97, 5238.25, 11446.5, -5302.84, 5331.03, 0, 0, 0, NULL), ('surf_forbidden_tomb_sns', 8, 3, 1, 8255.41, -3925.55, 4102.03, 8072.31, -3692.32, 4204.03, 0, 0, 0, NULL), ('surf_forbidden_ways_ksf', 0, 1, 1, 407.655, -10584.7, 6334.03, -366.274, -10072.7, 6436.03, 0, 0, 0, NULL), ('surf_forbidden_ways_ksf', 1, 2, 1, 10317.8, 9441.94, -3309.97, 10544, 8544.03, -3211.97, 0, 0, 0, NULL), ('surf_forbidden_ways_ksf', 2, 2, 2, 10597.6, 9471.97, -3048.78, 10944, 8534.26, -3305.74, 0, 0, 0, NULL), ('surf_forbidden_ways_ksf', 3, 2, 0, -9534.59, 4733.97, -4089.01, -9216.03, 3665, -3867.98, 0, 0, 1, NULL), ('surf_forbidden_ways_ksf', 4, 1, 0, 9744, 2750.45, -1023.97, 10352, 2433.03, -923.969, 0, 0, 1, NULL), ('surf_forbidden_ways_ksf', 5, 4, 0, -516.072, -3407.97, 2059.46, 554.778, -1551.27, 1024.03, 0, 0, 0, NULL), ('surf_forbidden_ways_ksf', 6, 4, 1, 10352, 3555.27, -2299.91, 9398.89, 2462.4, -3583.97, 0, 0, 0, NULL), ('surf_forbidden_ways_ksf', 7, 4, 2, -559.969, 216.143, 3230.69, 582.183, 1546.76, 2080.03, 0, 0, 0, NULL), ('surf_forbidden_ways_ksf', 8, 4, 3, -1614.37, 16087.9, 367.969, -956.458, 15351.9, -767.969, 0, 0, 0, NULL), ('surf_forbidden_ways_ksf', 9, 4, 4, 5458.48, 3485.56, -528.031, 6450.79, 2432.03, -1531.35, 0, 0, 0, NULL), ('surf_forbidden_ways_ksf', 10, 4, 5, 2543.77, 11180.3, -2304.03, 1563.02, 9568.21, -3738.98, 0, 0, 0, NULL), ('surf_for_all', 0, 2, 1, 7616.83, 1589.6, 3518.03, 7112.89, 1807.97, 3620.03, 0, 0, 0, NULL), ('surf_for_all', 1, 1, 1, -236.495, 206.158, 62.0312, 212.535, -215.665, 180.031, 0, 0, 0, NULL), ('surf_for_all', 2, 3, 0, -1391.71, 2575.81, 566.031, -463.508, 3470.9, 668.031, 0, 0, 0, NULL), ('surf_for_all', 3, 3, 1, -7249.36, -7685.25, 4241.03, -6905.85, -8019.15, 4343.03, 0, 0, 0, NULL), ('surf_for_all', 4, 3, 2, 5393.58, 6852.46, 7422.03, 4817.6, 6244.44, 7524.03, 0, 0, 0, NULL), ('surf_for_all', 5, 3, 3, 7827.51, 10920.8, 7422.03, 6883.84, 10061.2, 7524.03, 0, 0, 0, NULL), ('surf_for_all', 6, 1, 2, 200.336, 431.946, 62.0312, -210.505, 206.514, 180.031, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_freaky', 0, 1, 1, -2217.04, -3460.36, 2355.41, -2669.79, -3766, 2448.87, 0, 0, 0, NULL), ('surf_freaky', 1, 3, 3, -5160.88, 4007.16, 2877.53, -4800.54, 3642.96, 2979.53, 0, 0, 0, NULL), ('surf_freaky', 2, 3, 2, -3758, 4634.61, 10173.5, -3038.03, 5262.97, 10275.5, 0, 0, 0, NULL), ('surf_freaky', 3, 3, 1, -2348.64, -1394.06, 6769.49, -2568.83, -1168.12, 6871.49, 0, 0, 0, NULL), ('surf_freaky', 4, 3, 0, -2349.88, 5849.92, 7741.53, -2562.21, 5977.9, 7843.53, 0, 0, 0, NULL), ('surf_freaky', 5, 3, 4, 4149.02, -229.511, 2942.53, 4616.97, -322.381, 3076.53, 0, 0, 0, NULL), ('surf_freaky_njv', 0, 3, 4, 4608.97, -301.969, 2944.53, 4399.74, -249.492, 3044.53, 0, 0, 0, NULL), ('surf_freaky_njv', 1, 2, 1, -15954, -15821, -15829, -15828, -14962.2, -15729, 0, 0, 0, NULL), ('surf_freaky_njv', 2, 1, 1, -2659.12, -3458.61, 2352.53, -2215.33, -3764.93, 2452.52, 0, 0, 0, NULL), ('surf_freaky_njv', 3, 3, 3, -5089.25, 3670.03, 2879.53, -4888.8, 3792.05, 2979.53, 0, 0, 0, NULL), ('surf_freaky_njv', 4, 3, 2, -3415.61, 4893.02, 10175.5, -3739.48, 5149.36, 10275.5, 0, 0, 0, NULL), ('surf_freaky_njv', 5, 3, 1, -2603.96, -1439.54, 6771.49, -2296.86, -1127.82, 6871.49, 0, 0, 0, NULL), ('surf_freaky_njv', 6, 3, 0, -2357.15, 5999.24, 7743.53, -2546.94, 5822.39, 7843.53, 0, 0, 0, NULL), ('surf_freedom', 0, 3, 1, -3073.82, -6080.26, 6364.75, -2928.77, -6229.53, 6411.92, 0, 0, 0, NULL), ('surf_freedom', 1, 3, 2, 8407.68, -217.116, 11262, 7990.31, 207.711, 11364, 0, 0, 0, NULL), ('surf_freedom', 2, 1, 1, -112, 5370.85, 11326, 263.429, 4603.54, 11417.8, 0, 0, 0, NULL), ('surf_freedom', 3, 3, 3, 14544, 10416, -2049.97, 14711.2, 10030.6, -1947.97, 0, 0, 0, NULL), ('surf_freedom', 4, 2, 1, 14082.7, 9599.17, -1281.97, 14840.9, 10906.2, -1179.97, 0, 0, 0, NULL), ('surf_freedom', 5, 3, 0, -495.969, 1997.07, 6014.03, -410.288, 1600.14, 6108.03, 0, 0, 0, NULL), ('surf_freedom-', 0, 6, 5, -572.757, 4787.61, 11680, -784.654, 5179.76, 11680, 0, 0, 0, NULL), ('surf_freedom-', 1, 6, 6, -812.016, 5110.84, 11648, -991.969, 4743.34, 11604.9, 0, 0, 0, NULL), ('surf_frequency_njv', 0, 2, 0, 1980.04, 6416, -9889.97, 937.233, 5809.87, -9515.97, 0, 0, 0, NULL), ('surf_frequency_njv', 1, 5, 0, -1168.03, 6426.35, 7850.03, -1551.04, 5834.71, 7971.23, 0, 0, 0, NULL), ('surf_frequency_njv', 2, 1, 0, 13374.6, -1356.03, 9012.23, 13084.8, -2140, 9108.03, 0, 0, 1, NULL), ('surf_frequency_njv', 3, 2, 0, 2566.44, -1909.15, 3951.52, 2145.79, -1518.1, 4000.57, 0, 0, 1, NULL), ('surf_fruits', 0, 3, 1, -1637.05, -1960.71, -1609.97, -1777.93, -2167.37, -1513.92, 0, 0, 0, NULL), ('surf_fruits', 1, 3, 0, -5961.32, -2691.87, -4896.78, -6301.13, -2845.83, -4792.78, 0, 0, 0, NULL), ('surf_fruits', 2, 3, 7, 1834.1, -11362, -5247.97, 2210.13, -11180.5, -5100.01, 0, 0, 0, NULL), ('surf_fruits', 3, 5, 0, -5103.38, 5312, -5769.97, -4810.24, 5067.09, -5667.97, 0, 0, 0, NULL), ('surf_fruits', 4, 3, 2, -805.989, 151.211, 1088.03, -531.707, -207.117, 1190.03, 0, 0, 0, NULL), ('surf_fruits', 5, 3, 3, 754.411, -6424.97, 990.031, 999.164, -6161.28, 1135.65, 0, 0, 0, NULL), ('surf_fruits', 6, 3, 4, -1539.4, 5999.97, -153.969, -1279.18, 5936.33, -80.808, 0, 0, 0, NULL), ('surf_fruits', 7, 3, 5, -6150, -5336.03, -3585.97, -5912.97, -5677.82, -3474.75, 0, 0, 0, NULL), ('surf_fruits', 8, 3, 6, -8471.94, 1989.65, 22.0312, -8108.18, 2563.45, 124.031, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_fruits', 9, 3, 8, -7202.35, -520.112, -3462.97, -6884.43, -786.208, -3360.97, 0, 0, 0, NULL), ('surf_fruits', 10, 2, 0, -9349.18, -446.114, -6862.13, -9650.34, -873.969, -6760.97, 0, 0, 0, NULL), ('surf_fruits', 11, 2, 0, -7657.9, -9184.02, -5377.72, -7809.97, -8854.24, -5576.89, 0, 0, 1, 'BONUS 1'), ('surf_fruits', 12, 1, 0, -6419.7, -8456.03, 950.031, -6713.97, -9575.97, 1051.53, 0, 0, 1, 'BONUS 1'), ('surf_fruits2', 0, 3, 9, 5778.84, 5148.66, 11218, 5952.45, 4936.03, 11320, 0, 0, 0, NULL), ('surf_fruits2', 1, 3, 8, -8612, 11012.4, 1060.03, -8520.01, 10822.7, 1162.03, 0, 0, 0, NULL), ('surf_fruits2', 2, 3, 10, 7339.08, -2563.2, 9682.03, 7153.02, -2741.05, 9784.03, 0, 0, 0, NULL), ('surf_fruits2', 3, 3, 11, -8354.99, 6500.03, 12358, -8315.03, 6569.97, 12460, 0, 0, 0, NULL), ('surf_fruits2', 4, 3, 12, -1413.74, 2857.62, 12154, -1263.57, 2745.09, 12255.3, 0, 0, 0, NULL), ('surf_fruits2', 5, 3, 13, -13670.5, -4955.39, 11233.1, -13144.4, -5176.4, 11335, 0, 0, 0, NULL), ('surf_fruits2', 6, 2, 1, -10940.2, -4865.42, 6621.03, -10546.2, -5258.75, 6723.03, 0, 0, 0, NULL), ('surf_fruits2', 7, 3, 6, -13502, -291.629, 13520, -13269.4, 215.064, 13622, 0, 0, 0, NULL), ('surf_fruits2', 8, 3, 5, -1928.9, -8527.45, 12813, -1752.41, -8695.93, 12915, 0, 0, 0, NULL), ('surf_fruits2', 9, 3, 4, -10917, 3621.97, 528.031, -10297.9, 3142.03, 630.031, 0, 0, 0, NULL), ('surf_fruits2', 10, 3, 7, 3679.21, -7799.78, 1579.83, 3367.51, -8475.73, 1681.83, 0, 0, 0, NULL), ('surf_fruits2', 11, 1, 1, -11702.6, 9051.17, 9836.01, -11987.3, 8180.71, 9938.03, 0, 0, 0, NULL), ('surf_fruits2', 12, 3, 0, -8270.3, 13191.1, 9596.03, -8715.17, 12795.8, 9698.03, 0, 0, 0, NULL), ('surf_fruits2', 13, 3, 1, -12765.8, 4384.12, 10782, -12557.8, 4236, 10884, 0, 0, 0, NULL), ('surf_fruits2', 14, 3, 2, -7242.54, -1208.53, 156.031, -7488, -1446.89, 258.031, 0, 0, 0, NULL), ('surf_fruits2', 15, 3, 3, -4432.61, 39.5068, 10899, -4298.48, 156.467, 11001, 0, 0, 0, NULL), ('surf_fruits2_final', 0, 1, 1, -11702.8, 9051.18, 9836.01, -11987.3, 8179.66, 9938.01, 0, 0, 0, NULL), ('surf_funhouse_njv', 0, 2, 1, 1450.61, -2032.03, 30.0312, 754.031, -2680.57, 132.031, 0, 0, 0, NULL), ('surf_funhouse_njv', 1, 1, 1, -13584, 10465.4, 14302.5, -13890.8, 11341.3, 14399.9, 0, 0, 0, NULL), ('surf_furios-', 0, 3, 2, 1255.03, -5472.77, 70.0312, 936.071, -5969.72, 112.822, 0, 0, 0, NULL), ('surf_furios-', 1, 1, 0, 2643.97, -2853.56, -605.969, 2288.95, -3345.55, -464.149, 0, 0, 0, NULL), ('surf_furios-', 2, 3, 0, -23.6783, 7387.97, -1061.97, 253.644, 6700.03, -959.969, 0, 0, 0, NULL), ('surf_furios-', 3, 3, 1, 1460.93, -7446.18, -129.969, 1823.97, -8018.38, -27.9688, 0, 0, 0, NULL), ('surf_furios-', 4, 2, 0, 1343.31, 102.889, -1023.97, 1242.03, -199.294, -764.969, 0, 0, 0, NULL), ('surf_furios-', 5, 3, 3, -243.969, 2228, -101.969, 299.969, 2305.87, 0.03125, 0, 0, 0, NULL), ('surf_furios-', 6, 3, 4, 2059.81, -314.962, 902.031, 2299.83, 194.025, 1004.03, 0, 0, 0, NULL), ('surf_gauntlet_final_rg', 0, 2, 1, -7034.54, -8949.22, 6088.03, -6777.72, -9198.35, 6188.03, 0, 0, 0, NULL), ('surf_gauntlet_final_rg', 1, 1, 1, -4926.29, -8866.96, 5888.03, -4413.07, -9605, 6058.57, 0, 0, 0, NULL), ('surf_gettingharder', 0, 3, 8, -3311.97, 16112, 3518.03, -2576.03, 15939.7, 3620.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_gettingharder', 1, 3, 9, -2031.97, 16112, 3518.03, -1296.03, 15939.5, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 2, 3, 10, -16.0312, 16112, 3518.03, -751.969, 15934.1, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 3, 3, 11, 528.051, 16112, 3518.03, 1263.99, 15937.8, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 4, 3, 12, 1808.03, 16112, 3518.03, 2543.97, 15935.1, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 5, 3, 13, 3344.03, 16112, 3518.03, 4079.97, 15937.5, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 6, 3, 14, 4880.03, 16112, 3518.03, 5615.97, 15939.1, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 7, 3, 15, 6160.03, 16112, 3518.03, 6895.97, 15934.1, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 8, 3, 7, -4591.97, 16112, 3518.03, -3856.03, 15938.1, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 9, 3, 6, -5871.97, 16112, 3518.03, -5136.03, 15934.9, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 10, 3, 16, 7440.03, 16112, 3518.03, 8172.35, 15945.4, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 11, 1, 1, -14096, 16112, 3518.03, -14832, 15941, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 12, 3, 0, -12826.8, 16112, 3518.03, -13550.3, 15946.6, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 13, 3, 1, -11539.3, 16112, 3518.03, -12272, 15923.2, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 14, 3, 2, -10256, 16112, 3518.03, -10992, 15937.1, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 15, 3, 3, -8976.03, 16112, 3518.03, -9711.97, 15936, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 16, 3, 4, -8431.97, 16112, 3518.03, -7696.03, 15941.7, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 17, 3, 5, -7151.97, 16112, 3518.03, -6416.03, 15941.3, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 18, 3, 17, 9455.97, 16112, 3518.03, 8720.03, 15935.7, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 19, 3, 18, 10736, 16112, 3518.03, 10000, 15942.6, 3620.03, 0, 0, 0, NULL), ('surf_gettingharder', 20, 2, 1, 11152, 48.0312, 94.0312, 11376, 785.648, 196.031, 0, 0, 0, NULL), ('surf_gettingharder', 21, 2, 2, 10000, 98.6808, 1085.74, 10736, 399.969, 1187.74, 0, 0, 0, NULL), ('surf_ghost_busters_rg', 0, 1, 1, -6787.44, 10971, -5151.97, -7160.97, 10721, -5051.97, 0, 0, 0, NULL), ('surf_ghost_busters_rg', 1, 3, 7, 6833.7, -10216, -468.11, 6988.86, -10022, -368.11, 0, 0, 0, NULL), ('surf_ghost_busters_rg', 2, 3, 6, -5892.52, 14332.2, -1471.97, -6383.97, 12804.7, -1371.97, 0, 0, 0, NULL), ('surf_ghost_busters_rg', 3, 3, 5, 2064.03, -13313.5, 0.03125, 4079.97, -13719.9, 100.031, 0, 0, 0, NULL), ('surf_ghost_busters_rg', 4, 3, 4, -8816.3, 2347.26, -133.457, -8538.5, 2234.52, -57.1501, 0, 0, 0, NULL), ('surf_ghost_busters_rg', 5, 3, 3, -6160, -1201.11, -1279.97, -6338.69, -849.046, -1179.97, 0, 0, 0, NULL), ('surf_ghost_busters_rg', 6, 2, 1, -1007.97, -4079.97, -5375.97, -16.0312, -3088, -5275.97, 0, 0, 0, NULL), ('surf_ghost_busters_rg', 7, 3, 1, 185.463, 8696.92, -1663.97, -303.999, 7679.71, -1563.97, 0, 0, 0, NULL), ('surf_ghost_busters_rg', 8, 3, 15, 11261.4, 5042.09, -2394.73, 11479.1, 5332.71, -2245.99, 0, 0, 0, NULL), ('surf_ghost_busters_rg', 9, 3, 8, -10500.7, 8453.06, 4288.03, -11001, 8656, 4388.03, 0, 0, 0, NULL), ('surf_ghost_busters_rg', 10, 3, 9, 10668.4, -3752.34, 2560.03, 10844.7, -3930.21, 2660.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_ghost_busters_rg', 11, 3, 0, -362.145, -6960.97, -5246.43, -16.0312, -6592.49, -5146.43, 0, 0, 0, NULL), ('surf_ghost_busters_rg', 12, 3, 14, 13161.2, 3143.79, -3695.97, 12790.5, 3530.34, -3597.39, 0, 0, 0, NULL), ('surf_ghost_busters_rg', 13, 3, 2, -2305.05, -4730.64, -159.969, -2192, -4482.43, -59.9688, 0, 0, 0, NULL), ('surf_ghost_busters_rg', 14, 3, 13, -495.969, 4.24913, 0.03125, 495.969, -815.969, 100.031, 0, 0, 0, NULL), ('surf_ghost_busters_rg', 15, 3, 12, -939.553, -10503.7, -5119.97, -304.018, -9938.28, -5019.97, 0, 0, 0, NULL), ('surf_ghost_busters_rg', 16, 3, 11, 8586.15, -10114.3, -639.969, 8825.84, -10224, -539.969, 0, 0, 0, NULL), ('surf_ghost_busters_rg', 17, 3, 10, 12415, -8024.05, -6184.84, 12295.6, -8377.93, -6091.97, 0, 0, 0, NULL), ('surf_glass7', 0, 1, 0, 96.0312, 1127.55, 8206.03, 1279.97, 1727.99, 8308.03, 0, 0, 0, NULL), ('surf_glass7', 1, 2, 0, 3375.97, 2527.97, -14194, 2849.27, 1346.65, -13829.2, 0, 0, 0, NULL), ('surf_glass9', 0, 2, 0, -8223.98, 6510.34, -7953.97, -7843.63, 5326.71, -7618.01, 0, 0, 0, NULL), ('surf_glass9', 1, 2, 1, -8223.98, 5326.4, -7953.97, -7837.86, 6510.34, -7851.97, 0, 0, 0, NULL), ('surf_glass9', 2, 1, 0, -8655.98, 2367.99, 6894.03, -7472.03, 1764.19, 6996.03, 0, 0, 0, NULL), ('surf_glass9', 3, 4, 0, -10015.4, 9967.97, 2348.43, -8800.03, 9571.31, 1015.27, 0, 0, 0, NULL), ('surf_glass9', 4, 4, 1, 1844.12, 10109.9, 2294.1, 1480.3, 11298.3, 901.399, 0, 0, 0, NULL), ('surf_glass9', 5, 4, 2, 1807.97, 7846.44, -357.846, 592.031, 7086.38, -1614.85, 0, 0, 0, NULL), ('surf_glass9', 6, 4, 3, 606.503, 103.171, -5312.03, 1807.97, 1119.33, -6537, 0, 0, 0, NULL), ('surf_globalchaos', 0, 2, 1, -12212, 7421.71, -8809.97, -12153.7, 7353.45, -8707.97, 0, 0, 0, NULL), ('surf_globalchaos', 1, 2, 2, -12214.8, 7321.82, -8809.97, -12391, 7424.91, -8707.97, 0, 0, 0, NULL), ('surf_globalchaos', 2, 2, 3, -12554.7, 7540.31, -8809.97, -12068.5, 7426.62, -8707.97, 0, 0, 0, NULL), ('surf_globalchaos', 3, 3, 1, -11840, 7308.71, -6889.97, -12768, 7575.97, -6787.97, 0, 0, 0, NULL), ('surf_globalchaos', 4, 3, 0, -3944.39, -11451.6, -7473.97, -4267.66, -10358.3, -7371.97, 0, 0, 0, NULL), ('surf_globalchaos', 5, 1, 1, 2115.57, -1146.71, 70.0312, 2299.46, -967.253, 172.031, 0, 0, 0, NULL), ('surf_globalchaos', 6, 2, 4, -12406.5, 7407.92, -8809.97, -12466.9, 7358.46, -8707.97, 0, 0, 0, NULL), ('surf_goldarn', 0, 2, 1, -10371.7, 10342, -6881.97, -11546, 13480, -6811.97, 0, 0, 0, NULL), ('surf_goldarn', 1, 1, 1, -9773.29, 9249.97, 15585, -9363.63, 8002.03, 15687, 0, 0, 0, NULL), ('surf_goldarn', 2, 4, 0, 2188.38, 9944.57, 11862.7, 1717.32, 7290.03, 9580.1, 0, 0, 0, NULL), ('surf_goldarn', 3, 4, 1, -630.086, 10648.7, 6706.97, 4294.8, 6474.48, 5211.03, 0, 0, 0, NULL), ('surf_goldarn', 4, 4, 2, 6989.15, 9793.46, 3674.97, 6136.44, 7370.03, 2355.53, 0, 0, 0, NULL), ('surf_goldarn', 5, 4, 3, -2632.2, 9883.97, -1744.51, -1945.65, 7427.78, -4045.97, 0, 0, 0, NULL), ('surf_goldarn', 6, 4, 4, 5239.03, 10675, 4845.23, 6169.76, 13148, 2532.76, 0, 0, 0, NULL), ('surf_goldarn', 7, 4, 5, -3983.03, 12912, 1759.43, -5158.97, 10857.2, 1185.54, 0, 0, 0, NULL), ('surf_goldarn', 8, 4, 6, -3875.25, 13477.4, -5380.03, -3011.03, 10455.7, -6323.57, 0, 0, 0, NULL), ('surf_goodbye2', 0, 2, 1, 5680.87, -10448.9, -2211.97, 5810.92, -10324.4, -2111.97, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_goodbye2', 1, 3, 0, -10937.1, -5411.09, -1165.99, -11373.3, -5732.68, -1081.59, 0, 0, 0, NULL), ('surf_goodbye2', 2, 2, 2, 4905.18, -9928.66, -2211.97, 5418.02, -10946.6, -2111.97, 0, 0, 0, NULL), ('surf_goodbye2', 3, 2, 3, 5929.18, -10441, -2211.97, 5413.1, -10949.3, -2111.97, 0, 0, 0, NULL), ('surf_goodbye2', 4, 1, 1, 4589.05, 8426.11, 13766.6, 3640.84, 7482.31, 13828.4, 0, 0, 0, NULL), ('surf_goodbye2', 5, 2, 4, 5418.76, -10444.2, -2211.97, 5681.16, -10190.4, -2111.97, 0, 0, 0, NULL), ('surf_goodbye2', 6, 3, 1, -2580.92, 1805.62, 6050.71, -3036.77, 1287.98, 6129.06, 0, 0, 0, NULL), ('surf_goodbye2', 7, 3, 2, -9640, 10204, 5300.48, -10250.2, 9620.16, 5354.51, 0, 0, 0, NULL), ('surf_goodbye2', 8, 3, 3, -642.706, 6930.59, -5307.69, -1195.59, 6367.8, -5244.51, 0, 0, 0, NULL), ('surf_goodbye2', 9, 2, 5, 5417.57, -10186.8, -2211.97, 5542.23, -10056.6, -2111.97, 0, 0, 0, NULL), ('surf_goodbye2', 10, 2, 6, 5416.05, -10058.6, -2211.97, 5481.82, -9991.88, -2111.97, 0, 0, 0, NULL), ('surf_goodbye2', 11, 2, 7, 5538.68, -10186.7, -2211.97, 5599.79, -10112.7, -2111.97, 0, 0, 0, NULL), ('surf_goodbye2', 12, 3, 4, -11295.2, -2025.26, 11286.1, -11856.3, -1430.3, 11354.1, 0, 0, 0, NULL), ('surf_goodbye2', 13, 3, 5, 6746.35, -9650.18, 6551.67, 6153.08, -9117.94, 6613.09, 0, 0, 0, NULL), ('surf_goodbye2', 14, 2, 8, 5678.71, -10327.7, -2211.97, 5745.33, -10255, -2111.97, 0, 0, 0, NULL), ('surf_goodbye2', 15, 2, 9, 5807.47, -10441.6, -2211.97, 5872.47, -10383.1, -2111.97, 0, 0, 0, NULL), ('surf_goodbye_rg', 0, 2, 1, 9606.58, -12702, 3389.03, 10483, -11972, 3561.03, 0, 0, 0, NULL), ('surf_goodbye_rg', 1, 1, 1, 13229.6, -12731.8, 13952, 11858.4, -12519.8, 13991, 0, 0, 0, NULL), ('surf_graphia', 0, 5, 0, 1418, -9268.91, 13939, 2143.97, -10223, 14041, 0, 0, 0, NULL), ('surf_graphia', 1, 5, 1, 2938.97, -9269.71, 13939, 2208.03, -10223, 14041, 0, 0, 0, NULL), ('surf_graphia', 2, 2, 0, 7251.31, 3550.83, -6464.82, 7758.35, 2585.02, -6353.66, 0, 0, 0, NULL), ('surf_graphia', 3, 2, 0, 4845.36, -2035.27, 3230.03, 4628.67, -2253.44, 3332.03, 0, 0, 1, NULL), ('surf_graphia', 4, 1, 0, 6664.68, 202.155, 6646.03, 7101, -221.997, 6748.03, 0, 0, 1, NULL), ('surf_graphia', 5, 4, 0, -716.167, -4220.97, 14338.3, 5111.97, -2997.64, 11708.4, 0, 0, 0, NULL), ('surf_graphia', 6, 4, 1, 1974.03, 3767.23, 12173.3, 2374.66, 4353.96, 11683.8, 0, 0, 0, NULL), ('surf_graphia', 7, 4, 2, 1753.47, 6352.03, 10472, 2683.79, 5700.57, 8239.03, 0, 0, 0, NULL), ('surf_graphia', 8, 4, 3, 7677.97, 5215.55, 10470.5, 6498.78, 4634.9, 5635.03, 0, 0, 0, NULL), ('surf_graphia', 9, 4, 4, 9309.97, 5418.27, 7941.96, 8356.46, 4095.97, 7127.07, 0, 0, 0, NULL), ('surf_graphia', 10, 4, 5, 3827.67, -4354.7, 5056.97, 4431.97, -2833.2, 3141.15, 0, 0, 0, NULL), ('surf_graphia', 11, 4, 6, -6595.18, -2553.67, 1372.97, -7474.97, -2822.28, 775.892, 0, 0, 0, NULL), ('surf_graphia', 12, 4, 7, -8346.09, 2660.07, -1573.03, -7573.22, 3580.97, -3904.18, 0, 0, 0, NULL), ('surf_graphia', 13, 4, 8, 2338.08, 4035.97, -2263.33, 3593, 2109.03, -7015.44, 0, 0, 0, NULL), ('surf_grassland', 0, 2, 0, -1047.97, 3263.97, -14098, 455.999, 2352.03, -13996, 0, 0, 0, NULL), ('surf_grassland', 1, 1, 0, -2424.86, 2000.03, 6686.03, -2743.97, 2992, 6788.03, 0, 0, 0, NULL), ('surf_grassland', 2, 4, 0, -1064.03, -3604.54, 3323, -2071.97, -2262.01, 1982.24, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_grassland', 3, 4, 1, 4823.89, 1567.88, 223.969, 2980.05, 815.353, -1279.97, 0, 0, 0, NULL), ('surf_grassland', 4, 4, 2, 8296.03, -805.972, -5327.5, 9473.74, 180.463, -6730.04, 0, 0, 0, NULL), ('surf_grassland', 5, 4, 3, 1016.03, -846.037, -6824.08, 1703.76, 383.969, -7534.94, 0, 0, 0, NULL), ('surf_grassland', 6, 4, 4, -1096.03, 3077.02, -10508.8, -1439.65, 2337.62, -11200, 0, 0, 0, NULL), ('surf_gurus', 0, 1, 1, 3345.97, 478.191, -1.96875, 2802.03, 785.969, 100.031, 0, 0, 0, NULL), ('surf_gurus', 1, 3, 5, 1476.16, -2668.48, -2482.97, 1903.46, -2055.36, -2389.19, 0, 0, 0, NULL), ('surf_gurus', 2, 3, 0, 21.2604, 2113.97, 1981.03, -536.969, 2562.08, 2083.03, 0, 0, 0, NULL), ('surf_gurus', 3, 3, 1, -571.784, 5954.64, -1232.46, -261.063, 6326.19, -1121.69, 0, 0, 0, NULL), ('surf_gurus', 4, 3, 2, -3986.05, 1110.84, 3089.02, -2961.17, 618.031, 3197.43, 0, 0, 0, NULL), ('surf_gurus', 5, 3, 3, 2979.03, 9431.97, 6874.03, 3106.61, 9368.03, 6976.03, 0, 0, 0, NULL), ('surf_gurus', 6, 3, 4, 7194.03, -259.969, 1403.03, 7311.58, -36.0312, 1505.03, 0, 0, 0, NULL), ('surf_rustic', 1, 1, 1, -14464, -335.969, 8862.03, -14736, 911.969, 8964.03, 0, 0, 0, NULL), ('surf_rustic', 0, 2, 1, 6816.03, 2207.08, -15398.7, 10647.6, -1375.97, -16133.9, 0, 0, 0, NULL), ('surf_royal', 5, 3, 1, 4557.74, -2043.82, 2439.03, 4860.1, -1745.57, 2541.03, 0, 0, 0, NULL), ('surf_royal', 4, 2, 1, -4548, -3186.97, -3890.12, -4344.42, -2884.71, -3771.97, 0, 0, 0, NULL), ('surf_royal', 3, 3, 3, -11797.2, -4541.69, 1246.03, -11521.7, -4305.15, 1348.03, 0, 0, 0, NULL), ('surf_royal', 2, 3, 2, -11461.2, -3770.7, 9323.03, -11681.5, -3498.49, 9425.03, 0, 0, 0, NULL), ('surf_royal', 1, 3, 0, 540.057, -4138.02, 3230.03, -285.204, -4464.34, 3332.03, 0, 0, 0, NULL), ('surf_halloween', 0, 3, 2, 4644.29, 12491.6, -5019.97, 4410.22, 13059.4, -4919.97, 0, 0, 0, NULL), ('surf_halloween', 1, 2, 1, -11654.5, -2498.22, 10802, -13222.5, -2372.03, 11031, 0, 0, 0, NULL), ('surf_halloween', 2, 2, 2, -13222.5, -2625.24, 10770, -11654.5, -2497.57, 10902, 0, 0, 0, NULL), ('surf_halloween', 3, 3, 3, -12263.8, -4691.88, 14306, -12610.3, -4336.44, 14406, 0, 0, 0, NULL), ('surf_halloween', 4, 3, 1, -13119.5, -13580.8, -8160.47, -12674, -13715.6, -8060.47, 0, 0, 0, NULL), ('surf_halloween', 5, 3, 0, 4074.83, -936.513, 14190.9, 4246.28, -1193.23, 14291, 0, 0, 0, NULL), ('surf_halloween', 6, 1, 1, -1796.14, 2116.15, -1952.09, -2146.5, 1387.13, -1852.09, 0, 0, 0, NULL), ('surf_halloween_tf', 0, 2, 0, 10352, -7670.6, -1400.95, 8822.97, -10167.9, -1612.87, 0, 0, 0, NULL), ('surf_halloween_tf', 1, 1, 0, -3964.85, 1535.97, 9766.03, -3658.01, 1049.1, 9868.03, 0, 0, 0, NULL), ('surf_happyhands2', 0, 1, 1, 4808.03, -6177.38, 13246, 5689.16, -6544, 13348, 0, 0, 0, NULL), ('surf_happyhands2', 1, 2, 1, -7550.95, -11504, -3564.99, -8176.44, -11981.9, -3139.18, 0, 0, 0, NULL), ('surf_happyhands3', 0, 2, 1, -9711.97, -2557.66, -11010, -9264.03, -2064.03, -10908, 0, 0, 0, NULL), ('surf_happyhands3', 1, 1, 1, 4220.69, -6929.82, 7638.03, 4672.25, -6533.16, 7740.03, 0, 0, 0, NULL), ('surf_happyhands4', 0, 1, 1, -1311.55, 15615.8, 10785.3, -1807.97, 14673.9, 10885.3, 0, 0, 0, NULL), ('surf_happyhands4', 1, 2, 1, -511.072, -13978, -7669.43, -2292.56, -15342.8, -6348.34, 0, 0, 0, NULL), ('surf_happyhands_test', 0, 2, 0, 10704, 12008.4, -2091.06, 9472.03, 12288, -1987.97, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_happyhands_test', 1, 1, 0, -10506.9, 13792, 9438.03, -10638.7, 14784, 9540.03, 0, 0, 0, NULL), ('surf_happyhands_test', 13, 1, 0, 9377.62, -9185.97, 7225.5, 9597.48, -8229.58, 7082.73, 0, 0, 2, 'BONUS 2'), ('surf_happyhands_test', 14, 2, 0, 12200, -9248.55, 5603.14, 12065.1, -8162.03, 5404.57, 0, 0, 2, 'BONUS 2'), ('surf_happyhands_test', 2, 2, 0, 6977.2, -5524.9, 7570.03, 6234.45, -5040, 7664.03, 0, 0, 1, NULL), ('surf_happyhands_test', 3, 1, 0, 6847.68, -10161.2, 10482, 6338.12, -10016, 10580.1, 0, 0, 1, NULL), ('surf_happyhands_test', 4, 4, 0, -12451, 13776, 8318.24, -12920.2, 14797.6, 7648.03, 0, 0, 0, NULL), ('surf_happyhands_test', 5, 4, 1, -6857.25, 10329.7, 6455.29, -6310.75, 11439, 5158.58, 0, 0, 0, NULL), ('surf_happyhands_test', 6, 4, 2, -5494.85, -2299.07, 3679.97, -6376.62, 79.9688, 2563.45, 0, 0, 0, NULL), ('surf_happyhands_test', 7, 4, 3, -5466.49, -1173.53, 4447.97, -4224.99, 91.7006, 3696.03, 0, 0, 0, NULL), ('surf_happyhands_test', 8, 4, 4, -7178.85, 7119.97, 2143.2, -7728.19, 6092.33, 1040.03, 0, 0, 0, NULL), ('surf_happyhands_test', 9, 4, 5, -13178.3, 8405.79, -300.487, -14448, 7528.11, -786.695, 0, 0, 0, NULL), ('surf_happyhands_test', 10, 4, 6, 919.099, 7504.03, 451.988, 590.637, 8819.13, -315.03, 0, 0, 0, NULL), ('surf_happyhands_test', 11, 4, 7, 13172.9, 1615.97, -683.004, 9040.2, 210.477, -1815.97, 0, 0, 0, NULL), ('surf_happyhands_test', 12, 2, 0, 10284.9, 12300.9, -1528.03, 9893.63, 11987.7, -2097.4, 0, 0, 0, NULL), ('surf_healthy_e', 0, 3, 4, -7999.95, 7600.03, -6064.85, -7855.67, 8660.63, -6102.33, 0, 0, 0, NULL), ('surf_healthy_e', 1, 3, 3, -14103.1, -13234.9, 15151, -15009.4, -13527, 15253, 0, 0, 0, NULL), ('surf_healthy_e', 2, 3, 7, -11231.7, 6400.63, 12994.5, -11417, 7114.5, 13096.5, 0, 0, 0, NULL), ('surf_healthy_e', 3, 3, 8, -12907, -4609.65, -5228.31, -12635.1, -5083.11, -5279.38, 0, 0, 0, NULL), ('surf_healthy_e', 4, 3, 2, -8241.97, 14608, -12198, -7777.98, 15074.1, -12096, 0, 0, 0, NULL), ('surf_healthy_e', 5, 3, 6, -6757.03, -2278.81, 5594.89, -7380.97, -1962.43, 5561.53, 0, 0, 0, NULL), ('surf_healthy_e', 6, 2, 0, -7628.47, -5743.97, -6660.47, -6011.03, -3728.03, -6446.47, 0, 0, 0, NULL), ('surf_healthy_e', 7, 3, 0, -11873.3, 1590.97, -14253.6, -12258.7, 1378.36, -14300, 0, 0, 0, NULL), ('surf_healthy_e', 8, 3, 1, -11174.4, 11850.3, 14832.5, -10667, 10670.7, 14934.5, 0, 0, 0, NULL), ('surf_healthy_e', 9, 1, 0, -6424.03, -792.774, -8834.97, -7391.97, -1351, -8732.97, 0, 0, 0, NULL), ('surf_healthy_e', 10, 3, 5, -9869.28, 5706.64, -11064.5, -9563.03, 4991.19, -10970, 0, 0, 0, NULL), ('surf_healthy_e', 11, 1, 0, -4888.97, 9147.49, -7382.67, -4668.08, 8650.28, -7445.47, 0, 0, 1, NULL), ('surf_healthy_e', 12, 2, 0, -2318.79, 6229.03, -12655.7, -2013.56, 6794.74, -12914.5, 0, 0, 1, NULL), ('surf_heaven', 0, 3, 4, 3281.74, -8752.32, 1274.03, 2905.67, -9103.97, 1376.03, 0, 0, 0, NULL), ('surf_heaven', 1, 2, 0, 3879.68, -5809.31, 431.72, 2330.32, -5120.05, 555.123, 0, 0, 0, NULL), ('surf_heaven', 2, 3, 3, -2803.3, -163.697, -1337.97, -3507.4, -681.899, -1235.97, 0, 0, 0, NULL), ('surf_heaven', 3, 1, 0, 2782.92, -956.025, 5156.03, 3228.82, -1755.97, 5258.03, 0, 0, 0, NULL), ('surf_heaven', 4, 3, 0, 7501.41, -4629.84, 1250.03, 7323.14, -4811.23, 1352.03, 0, 0, 0, NULL), ('surf_heaven', 5, 3, 1, 8299.89, 1494.51, 5994.03, 9531.97, 1817.97, 6096.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_heaven', 6, 3, 2, -1911.33, -3491.2, 6340.03, -1256.25, -4143.22, 6442.03, 0, 0, 0, NULL), ('surf_heaven', 7, 1, 0, 7536.38, -10237, -1840.23, 6905.75, -9704.98, -2039.97, 0, 0, 1, NULL), ('surf_heaven', 8, 2, 0, 7720.18, -7928.97, -3204.29, 6628.45, -7658.59, -3415.97, 0, 0, 1, NULL), ('surf_heaven', 9, 2, 0, 7440.96, -7387.11, -3415.97, 6901.22, -7665.61, -3065.03, 0, 0, 1, NULL), ('surf_helium_v2_rg', 0, 3, 1, 7514.55, -1131.14, -968.969, 7363.11, -1012.72, -868.969, 0, 0, 0, NULL), ('surf_helium_v2_rg', 1, 3, 2, 7524.49, -767.228, -8283.97, 7238.76, -590.161, -8183.97, 0, 0, 0, NULL), ('surf_helium_v2_rg', 2, 1, 1, -640.969, -1538.63, 2959.03, -236.031, -1785.97, 3059.03, 0, 0, 0, NULL), ('surf_helium_v2_rg', 3, 3, 4, -12870, -5094.97, -6583.97, -12470, -4870.81, -6483.97, 0, 0, 0, NULL), ('surf_helium_v2_rg', 4, 2, 1, -12847.7, 8385.59, -4307.83, -12735.6, 8406.38, -4159.34, 0, 0, 0, NULL), ('surf_helium_v2_rg', 5, 3, 3, -6317.15, -11231.1, -6583.97, -7052.97, -10830, -6483.97, 0, 0, 0, NULL), ('surf_helium_v2_rg', 6, 3, 0, -82.7109, -1784.97, 10320, -403.109, -1637.82, 10420, 0, 0, 0, NULL), ('surf_how2surf', 0, 3, 19, 3417.95, -10496, 112.031, 3075.86, -10273.3, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 1, 3, 18, 2378.77, -10496, 112.031, 2035.22, -10275.1, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 2, 3, 17, 1324.35, -10496, 112.031, 978.244, -10273.4, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 3, 3, 16, 3075.51, -8281.97, 112.031, 3422.93, -8059.27, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 4, 3, 15, 2378.11, -8282, 112.031, 2032.25, -8060.23, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 5, 3, 13, 3417.62, -6079.99, 112.031, 3074.82, -5856.99, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 6, 3, 12, 2378.67, -6079.97, 112.031, 2032.48, -5857.29, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 7, 3, 9, 2378.9, -3936, 112.031, 2026.39, -3708.94, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 8, 3, 8, 976.64, -3935.97, 112.031, 1325.43, -3707.22, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 9, 3, 7, 3419.08, -2751.97, 112.031, 3073.47, -2529.21, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 10, 3, 6, 2034.9, -2751.98, 112.031, 2382.21, -2529.87, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 11, 3, 5, 979.462, -2751.97, 112.031, 1327.31, -2528.95, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 12, 3, 4, 3421.12, -1567.97, 112.031, 3072.84, -1346.45, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 13, 3, 3, 2381.15, -1567.97, 112.031, 2033.74, -1344.88, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 14, 3, 1, 3072.23, -129.798, 112.031, 3423.5, -351.966, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 15, 1, 1, 1343.5, -226.216, 112.031, 960.581, -112.889, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 16, 3, 11, 1323.47, -6080, 112.031, 976.721, -5857.91, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 17, 2, 1, 3175.48, -9109.61, -609.969, 3324.27, -9471.97, -509.969, 0, 0, 0, NULL), ('surf_how2surf', 18, 3, 10, 3077.16, -3936, 112.031, 3425.11, -3700.02, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 19, 3, 14, 1324.99, -8288, 112.031, 977.741, -8064.71, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 20, 3, 0, 2379.8, -351.987, 112.031, 2033, -127.886, 212.031, 0, 0, 0, NULL), ('surf_how2surf', 21, 3, 2, 982.968, -1568, 112.031, 1326.28, -1343.77, 212.031, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_hurrr', 0, 2, 1, 1810.66, 4006.59, 8290.12, 1206.6, 5153.28, 8883.67, 0, 0, 0, NULL), ('surf_hurrr', 1, 1, 1, -9218.77, 991.969, 11286.8, -9487.12, -991.969, 11267.2, 0, 0, 0, NULL), ('surf_hurrr', 2, 4, 0, -9506.66, -3295.97, 3549.2, -10080, -2855.95, 2078.02, 0, 0, 0, NULL), ('surf_hurrr', 3, 4, 1, -5119.97, -4683.61, -794.494, -3961.87, -5412.28, -3455.97, 0, 0, 0, NULL), ('surf_hurrr', 4, 4, 2, -2187.9, 8191.97, -4388.17, -3327.97, 7626.09, -5541.22, 0, 0, 0, NULL), ('surf_hurrr', 5, 4, 3, 7713.81, 2080.03, 9847.38, 6413.51, 7135.97, 5723.58, 0, 0, 0, NULL), ('surf_hydrogen_v2_njv', 0, 1, 0, 1837.73, 8569.43, 11578, 2531.76, 8762.28, 11378, 0, 0, 0, NULL), ('surf_hydrogen_v2_njv', 1, 2, 0, 4279.03, 550.031, -12532, 4402.02, 1516.24, -12430, 0, 0, 0, NULL), ('surf_hydrogen_v2_njv', 2, 4, 0, -4584.63, 9217.97, 7670.87, -3893.48, 8101.03, 7544.51, 0, 0, 0, NULL), ('surf_hydrogen_v2_njv', 3, 4, 1, 3604.65, 8100.03, 2925.77, 3035.28, 9217.97, 1988.58, 0, 0, 0, NULL), ('surf_hydrogen_v2_njv', 4, 4, 2, 2493.96, 3252.14, 568.969, 1922.4, 3501.97, -56.5917, 0, 0, 0, NULL), ('surf_hydrogen_v2_njv', 5, 4, 3, 4387.1, 183.134, -4548.03, 4962.94, 536.969, -5082.76, 0, 0, 0, NULL), ('surf_hydrogen_v2_njv', 6, 4, 4, 4521.24, 819.088, -7196.93, 5539.13, 552.496, -7701.25, 0, 0, 0, NULL), ('surf_hydrogen_v2_njv', 7, 4, 5, 5512.02, 539.031, -9527.32, 4512.17, 1534.97, -9862.03, 0, 0, 0, NULL), ('surf_hydrogen_v2_njv', 8, 4, 6, 11054, 1487.36, -11462.9, 10567, 555.847, -12020.9, 0, 0, 0, NULL), ('surf_hydrogen_v2_njv', 9, 6, 0, 7959.61, 2974.81, 10180.1, 8168.17, 2727.96, 10559.1, 0, 0, 0, NULL), ('surf_hydrogen_v2_njv', 10, 6, 1, 9031.4, 2517.53, 10091.1, 9078.59, 2586.59, 9892.89, 0, 0, 0, NULL), ('surf_hydrogen_v2_njv', 11, 6, 2, 7241.47, 3358.82, 10162, 7149.15, 3262.62, 9889.48, 0, 0, 0, NULL), ('surf_hyper', 0, 3, 2, 13603.3, 10981.7, 11184.5, 13837.2, 11211.7, 11093.9, 0, 0, 0, NULL), ('surf_hyper', 1, 3, 1, -12002, -11509.2, 775.031, -11826, -11741.6, 877.031, 0, 0, 0, NULL), ('surf_hyper', 2, 2, 1, 186.596, -143.969, 62.0312, -127.131, -72.3343, 164.031, 0, 0, 0, NULL), ('surf_hyper', 3, 3, 0, 4153.08, -5421.66, 3617.11, 4307.89, -5310.06, 3709.83, 0, 0, 0, NULL), ('surf_hyper', 4, 1, 1, 7879.69, -1743.3, 1704.03, 7366.71, -1532.49, 1806.03, 0, 0, 0, NULL), ('surf_hyper-', 0, 2, 1, 13979.4, 10423.9, -874.027, 12875.4, 11824, -439.187, 0, 0, 0, NULL), ('surf_hyper-', 1, 3, 0, 7694.44, -1315.31, 1720.03, 7563.43, -1192.29, 1822.03, 0, 0, 0, NULL), ('surf_hyper-', 2, 3, 2, -11826, -11742.1, 777.031, -12011, -11499.6, 877.031, 0, 0, 0, NULL), ('surf_hyper-', 3, 3, 3, 14280, 11182, 10204, 14081.3, 10938.3, 10304, 0, 0, 0, NULL), ('surf_hyper-', 4, 3, 1, 4147.33, -5320.9, 3619.11, 4306.38, -5435.29, 3719.11, 0, 0, 0, NULL), ('surf_hyper-', 5, 5, 1, -318.002, 57.8741, 62.0312, 376.06, -123.457, 164.031, 0, 0, 0, NULL), ('surf_illumination', 0, 1, 1, 2207.24, -383.969, 11294, 2473.47, 191.969, 11396, 0, 0, 0, NULL), ('surf_illumination', 1, 2, 1, -15016.4, 3961.15, -3906.97, -15600, 2223.86, -3804.97, 0, 0, 0, NULL), ('surf_illumination_rg', 0, 2, 1, -15426.8, 3962.17, -3680.97, -16052.5, 2244.51, -3443.97, 0, 0, 0, NULL), ('surf_illumination_rg', 1, 2, 2, -15422.6, 7598.35, -3680.97, -16047.2, 5862.23, -3500.97, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_illumination_rg', 2, 1, 1, 2220.18, -430.972, 11296, 2467.12, 174.969, 11396, 0, 0, 0, NULL), ('surf_imagine_fix', 0, 3, 2, 3007.4, 3123.04, -5089.97, 2580.49, 4056.23, -4987.97, 0, 0, 0, NULL), ('surf_imagine_fix', 1, 2, 0, 7349.79, -12119.6, 3017.69, 10763.6, -8383.19, 1695.8, 0, 0, 0, NULL), ('surf_imagine_fix', 2, 3, 5, 8792.58, -9989.79, 12830, 9609.17, -10554.2, 12932, 0, 0, 0, NULL), ('surf_imagine_fix', 3, 1, 0, 3633.18, 7716.25, 2048.93, 4544.46, 8682.03, 2196.13, 0, 0, 0, NULL), ('surf_imagine_fix', 4, 3, 4, -3081.51, 4126.74, 3102.03, -3559.74, 5080.83, 3242.07, 0, 0, 0, NULL), ('surf_imagine_fix', 5, 3, 3, -2591.39, -12391.6, -5057.97, -2983.72, -10191.4, -4955.97, 0, 0, 0, NULL), ('surf_imagine_fix', 6, 3, 1, -7216.74, -4354.13, -6272.97, -7993.13, -3801.5, -6170.97, 0, 0, 0, NULL), ('surf_imagine_fix', 7, 3, 0, -7279.96, 11842, 11262, -8126.9, 12743.7, 11364, 0, 0, 0, NULL), ('surf_imex', 0, 3, 3, 6319.86, -5742.7, 2872.37, 5818.66, -5527.39, 2956.03, 0, 0, 0, NULL), ('surf_imex', 1, 2, 1, 6002.22, 3659.08, -1529.97, 6245.8, 3434, -1427.97, 0, 0, 0, NULL), ('surf_imex', 2, 3, 1, -424.031, -2882.62, -1105.97, -1400, -3151.99, -910.388, 0, 0, 0, NULL), ('surf_imex', 3, 3, 0, 2238.85, -5380.17, -305.969, 2942.13, -5751.97, -163.991, 0, 0, 0, NULL), ('surf_imex', 4, 1, 1, 1230.59, -1053.47, 630.031, 455.676, -927.805, 732.031, 0, 0, 0, NULL), ('surf_imex', 5, 3, 2, 4871.97, -5461.24, 4486.03, 3896.03, -5752, 4680.37, 0, 0, 0, NULL), ('surf_imex_njv', 0, 3, 0, 2223.83, -5264.04, -305.969, 3000.46, -5708.03, -203.969, 0, 0, 0, NULL), ('surf_imex_njv', 1, 3, 3, 5736.84, -5280.75, 2854.03, 6494.44, -5719.9, 2956.03, 0, 0, 0, NULL), ('surf_imex_njv', 2, 3, 1, -1294.86, -2672.11, -1105.97, -530.697, -3119.78, -1003.97, 0, 0, 0, NULL), ('surf_imex_njv', 3, 3, 2, 4000.44, -5285.26, 4486.03, 4760.1, -5715.53, 4588.03, 0, 0, 0, NULL), ('surf_imex_njv', 4, 2, 1, -5198.8, -2372.77, 2302.03, -5419.09, -2111.92, 2404.03, 0, 0, 0, NULL), ('surf_imex_njv', 5, 2, 2, -6895.35, -3826.57, 2302.03, -7071.64, -3984.15, 2404.03, 0, 0, 0, NULL), ('surf_imex_njv', 6, 1, 1, 1230.96, -1057.75, 630.031, 470.026, -592.973, 750.784, 0, 0, 0, NULL), ('surf_impact_njv', 0, 3, 4, 1147, -5735.03, 3574.25, 1147, -6214.97, 3676.25, 0, 0, 0, NULL), ('surf_impact_njv', 1, 1, 0, -3939.22, -2173.39, -322.866, -3529.34, -1477.81, -214.715, 0, 0, 0, NULL), ('surf_impact_njv', 2, 3, 2, -233.031, -3291.97, 1165.13, -408.561, -3004.03, 1267.13, 0, 0, 0, NULL), ('surf_impact_njv', 3, 2, 0, -6474.91, -6074.97, -8857.75, -6120.26, -5887, -8755.75, 0, 0, 0, NULL), ('surf_impact_njv', 4, 3, 3, -1594, -4796.28, 9290.25, -2067.42, -4481.82, 9392.25, 0, 0, 0, NULL), ('surf_impact_njv', 5, 3, 0, 5818, 1298.97, 2680.9, 5711.81, 1075, 2782.9, 0, 0, 0, NULL), ('surf_impact_njv', 6, 3, 1, 975.109, 6125.02, 3279.03, 710.883, 5817.06, 3381.03, 0, 0, 0, NULL), ('surf_impact_njv', 7, 6, 0, -3152.17, -2424.01, 533.478, -951.832, -1211.05, 90.6428, 0, 0, 0, NULL), ('surf_industries_njv', 0, 1, 1, -6099.02, 11.2006, 11643, -5516.39, 709.354, 11745, 0, 0, 0, NULL), ('surf_industries_njv', 1, 2, 1, 15152, 6448.03, -7937.97, 15856, 7375.97, -7835.97, 0, 0, 0, NULL), ('surf_royal', 0, 1, 1, -0.318029, 1007.97, -1.96875, -1007.97, -1007.97, 100.031, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_primero_njv', 11, 2, 0, -4000.03, 12674.8, -13439.8, -5533.55, 13696, -13094.1, 0, 0, 1, 'BONUS 1'), ('surf_primero_njv', 10, 1, 0, -4973.38, 9805.05, -9711.97, -4561.51, 9395.3, -9344.03, 0, 0, 1, 'BONUS 1'), ('surf_primero_njv', 9, 4, 7, -10636.3, -1535.97, -8193.42, -11127.8, 240.032, -8375.9, 0, 0, 0, NULL), ('surf_primero_njv', 8, 4, 6, -12859.7, 704.031, 1522.5, -12358.8, 3007.97, 640.743, 0, 0, 0, NULL), ('surf_infected_e', 0, 1, 1, -12641, -102.933, 9034.03, -12774.5, 101.538, 9134.03, 0, 0, 0, NULL), ('surf_infected_e', 1, 2, 1, 5607.54, 7940.95, -4863.97, 5263.96, 8007.57, -4763.97, 0, 0, 0, NULL), ('surf_infected_e', 2, 2, 2, 5779.02, 8012.13, -4863.97, 5088.58, 8415.97, -4763.97, 0, 0, 0, NULL), ('surf_infected_h', 0, 1, 1, -12640, -101.519, 9034.03, -12784.5, 102.287, 9134.03, 0, 0, 0, NULL), ('surf_infected_h', 1, 2, 1, 5783.69, 8013.09, -4863.97, 5090.46, 8416, -4763.97, 0, 0, 0, NULL), ('surf_infected_h', 2, 2, 2, 5610.05, 7937.01, -4863.97, 5265.38, 8011.38, -4763.97, 0, 0, 0, NULL), ('surf_infected_njv', 0, 1, 0, -12654, 104.822, 9032.03, -12765.3, -115.226, 9134.03, 0, 0, 0, NULL), ('surf_infected_njv', 1, 2, 0, 4987.45, 8431.97, -4574.24, 5789.38, 8021.13, -4863.97, 0, 0, 0, NULL), ('surf_infected_njv', 2, 6, 6, -12332.2, 2741.97, 10284, -9904.03, 1376.26, 9545.37, 0, 0, 0, NULL), ('surf_infected_njv', 3, 4, 0, -4826.99, 847.969, 7524.48, -4219.38, -840.596, 6954.03, 0, 0, 0, NULL), ('surf_infected_njv', 4, 4, 1, 107.969, 583.387, 9818.24, 485.312, -863.969, 9194.37, 0, 0, 0, NULL), ('surf_infected_njv', 5, 4, 2, -5201.53, 863.969, 6632.28, -5958.93, -863.969, 6193.89, 0, 0, 0, NULL), ('surf_infected_njv', 6, 4, 3, -3528.55, 840.444, 5001.97, -2406.12, -1011.45, 2208.03, 0, 0, 0, NULL), ('surf_infected_njv', 7, 4, 4, 8482.79, 801.776, 2741.97, 6783.27, -885.969, 2212.57, 0, 0, 0, NULL), ('surf_infected_njv', 8, 4, 5, 12265, -824.779, -196.031, 13322, 885.969, -2085.69, 0, 0, 0, NULL), ('surf_infected_njv', 9, 4, 6, 6395.44, 885.969, -2114.1, 5860.4, -883.96, -2527.97, 0, 0, 0, NULL), ('surf_infected_njv', 10, 4, 7, 5981.6, 1183.97, -3988.3, 4864.03, 672.785, -5751.5, 0, 0, 0, NULL), ('surf_infected_njv', 11, 4, 8, 6015.97, 2808.55, -5173.69, 4864.03, 1886.18, -6613.35, 0, 0, 0, NULL), ('surf_infected_njv_h', 0, 5, 1, -12638, 90.2162, 9161.4, -12728.9, -86.8366, 9034.03, 0, 0, 0, NULL), ('surf_infected_njv_h', 1, 2, 1, 5992.74, 8431.97, -4674.7, 4869.68, 8369.91, -4863.97, 0, 0, 0, NULL), ('surf_infected_njv_h', 2, 2, 2, 5566.6, 7934.35, -4855.97, 5312.41, 8407.97, -4814.54, 0, 0, 0, NULL), ('surf_infected_njv_h', 3, 2, 3, 5262.29, 8034.97, -4863.97, 5051.2, 8332.98, -4863.97, 0, 0, 0, NULL), ('surf_infected_njv_h', 4, 2, 4, 5917.48, 8144.32, -4863.97, 5617.22, 8373.14, -4863.97, 0, 0, 0, NULL), ('surf_ing', 0, 1, 1, 9964.51, 9776.03, 14942, 10622, 10050.8, 15044, 0, 0, 0, NULL), ('surf_ing', 1, 2, 1, 7664.03, -9220.48, -10242, 12816, -12272, -10140, 0, 0, 0, NULL), ('surf_ing', 2, 2, 2, 8208.03, -12272, -10754, 12272, -11521, -10647.7, 0, 0, 0, NULL), ('surf_ing_njv', 0, 1, 0, 10000, 9722.9, 14942, 10494.8, 9913.93, 15044, 0, 0, 0, NULL), ('surf_ing_njv', 1, 2, 0, 7664.03, -9224.15, -10242, 12816, -12272, -10140, 0, 0, 0, NULL), ('surf_ing_njv', 2, 1, 0, -5136.03, 9761.99, 11518, -7151.97, 10256, 11620, 0, 0, 1, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_ing_njv', 3, 2, 0, -5136.03, -11216, 8798.03, -7151.97, -10723.5, 8900.03, 0, 0, 1, NULL), ('surf_inhuman', 0, 1, 1, -3591.49, 456.108, 649.031, -3223.64, -49.4688, 749.031, 0, 0, 0, NULL), ('surf_inhuman', 1, 3, 0, 181.018, -266.174, 33.0312, 24.5021, -429.72, 133.031, 0, 0, 0, NULL), ('surf_inhuman', 2, 3, 3, 3610, 494.015, 2308.03, 3484.33, 615.56, 2408.03, 0, 0, 0, NULL), ('surf_inhuman', 3, 2, 1, 2504.13, 47.7188, 1139.02, 2618.24, 244.541, 1239.02, 0, 0, 0, NULL), ('surf_inhuman', 4, 3, 1, 1749.03, -427.999, 501.031, 1907.63, -264.978, 601.031, 0, 0, 0, NULL), ('surf_inhuman', 5, 3, 2, 2157.97, -263.141, 2308.03, 2010.5, -416.06, 2408.03, 0, 0, 0, NULL), ('surf_injection_njv', 0, 3, 2, -4370.55, 3608.01, 1798.03, -5010.42, 3938.66, 1900.03, 0, 0, 0, NULL), ('surf_injection_njv', 1, 3, 3, 3632, 662.844, 2310.03, 3449.47, 1286.66, 2412.03, 0, 0, 0, NULL), ('surf_injection_njv', 2, 3, 4, 5600, 3791.97, 1094.03, 5442.84, 3376.03, 1196.03, 0, 0, 0, NULL), ('surf_injection_njv', 3, 3, 1, 2032, 5424.03, 1086.03, 1884.62, 5839.97, 1188.03, 0, 0, 0, NULL), ('surf_injection_njv', 4, 3, 0, 2031.97, 2064.03, 1790.03, 1614.95, 2473.23, 1819.92, 0, 0, 0, NULL), ('surf_injection_njv', 5, 3, 5, 7184.03, -5064.33, 3694.03, 7491.81, -4151.65, 3799.78, 0, 0, 0, NULL), ('surf_injection_njv', 6, 2, 0, 5188.16, -4416.03, 289.563, 5210.51, -4799.97, 510.005, 0, 0, 0, NULL), ('surf_injection_njv', 7, 1, 0, 1541.6, 761.592, 1030.03, 2031.97, 255.921, 1132.03, 0, 0, 0, NULL), ('surf_injection_njv', 8, 0, 0, 3339.27, -1040.03, 199.11, 3498.66, -3055.97, 20.5911, 0, 0, 0, NULL), ('surf_inrage-', 0, 1, 0, 788.021, 16.0312, 14.0312, 254.868, 1007.97, 116.031, 0, 0, 0, NULL), ('surf_inrage-', 1, 2, 0, 703.461, 1496.96, -8508, 289.783, 1857.04, -8228.96, 0, 0, 0, NULL), ('surf_inrage-', 2, 4, 0, 801.317, -592.355, -1792.03, 194.462, -21.0945, -2079.97, 0, 0, 0, NULL), ('surf_inrage-', 3, 4, 1, 257.031, 1315.4, -3776.11, 745.375, 1982.97, -4184.9, 0, 0, 0, NULL), ('surf_inrage-', 4, 4, 2, -16.9688, -487.698, -6784.29, 1041.97, -118.714, -7721.3, 0, 0, 0, NULL), ('surf_inrage-', 5, 4, 3, 995.969, 5395.46, -8182.94, -32.0308, 5141.86, -8446.97, 0, 0, 0, NULL), ('surf_inrage2', 0, 2, 1, -3360.22, 8926.48, -278.574, -4018.51, 7430.07, 554.535, 0, 0, 0, NULL), ('surf_inrage2', 1, 1, 1, 4833.25, -2162.19, 6646.03, 7121.61, -2666.34, 6748.03, 0, 0, 0, NULL), ('surf_insideout', 0, 1, 1, -2.07169, -6112.99, 13021, -495.969, -5505.03, 13123, 0, 0, 0, NULL), ('surf_insideout', 1, 2, 1, 5490.52, 8966.73, 4674.03, 4052.08, 10293.7, 4836.03, 0, 0, 0, NULL), ('surf_insignia_b1', 0, 2, 1, -2988.97, 7532.53, -7127.97, -1153.03, 7228.03, -6701.97, 0, 0, 0, NULL), ('surf_insignia_b1', 1, 3, 3, -2972.99, 7526.61, -4071.97, -1169.03, 7242.03, -3971.97, 0, 0, 0, NULL), ('surf_insignia_b1', 2, 1, 1, 4216.72, -11727.6, 7706.03, 3883.98, -12508.4, 7806.77, 0, 0, 0, NULL), ('surf_insignia_b1', 3, 3, 2, 1732.84, 4540.34, -13670, 1334.19, 4184.69, -13570, 0, 0, 0, NULL), ('surf_insignia_b1', 4, 3, 0, 10410.3, 6486.61, 2672.71, 10775.3, 7802.39, 2774.71, 0, 0, 0, NULL), ('surf_insignia_b1', 5, 3, 1, 14622.1, 10183, 14761, 15104, 11687, 14861, 0, 0, 0, NULL), ('surf_inspire', 0, 2, 0, -3852.25, 154.125, -10178, -5487.97, -431.969, -10076, 0, 0, 0, NULL), ('surf_inspire', 1, 2, 1, -3333.47, 495.969, -10178, -3823.97, -751.969, -10076, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_inspire', 2, 1, 0, 2549.76, 239.969, 2814.03, 2102.54, -623.969, 2916.03, 0, 0, 0, NULL), ('surf_inspire', 3, 2, 0, -4382.34, 8472.95, 8198.03, -4342.55, 8991.13, 8740.81, 0, 0, 1, NULL), ('surf_inspire', 4, 1, 0, 504.055, 8921.38, 11514.7, 194.341, 8460.17, 11596, 0, 0, 1, NULL), ('surf_inspire', 5, 4, 0, 12860.8, -1471.97, -2408.12, 12060.6, 1087.97, -3344.02, 0, 0, 0, NULL), ('surf_inspire', 6, 4, 1, -5872.23, -1471.97, -2241.88, -6381.24, 1023.97, -2814.8, 0, 0, 0, NULL), ('surf_inspire', 7, 4, 2, -4746.78, 996.218, -5312.03, -2928.14, -1435.6, -7103.97, 0, 0, 0, NULL), ('surf_inspire', 8, 4, 3, 13820.9, 319.969, -8447.51, 14848, -755.094, -9342.29, 0, 0, 0, NULL), ('surf_inspire', 9, 4, 4, 3508.74, 1278.65, -10432, 5445.43, -1513.79, -13904.4, 0, 0, 0, NULL), ('surf_interceptor', 0, 2, 1, 1343.97, 9472.16, 4808.01, 836.397, 8198.34, 4464.03, 0, 0, 0, NULL), ('surf_interceptor', 1, 3, 2, 12579.9, -6152.87, 11808, 13136, -7350.14, 11884.8, 0, 0, 0, NULL), ('surf_interceptor', 2, 3, 1, 14853.6, -12816, 2558.03, 15600, -13552, 2660.03, 0, 0, 0, NULL), ('surf_interceptor', 3, 3, 3, -11805.2, 8999.32, 6670.03, -12266.4, 8665.92, 6772.03, 0, 0, 0, NULL), ('surf_interceptor', 4, 1, 1, 12393.6, -220.662, 11854, 12624, 143.217, 11956, 0, 0, 0, NULL), ('surf_interceptor', 5, 3, 0, 11741.6, -14234.3, -5308.54, 11345.7, -14546.7, -5228.1, 0, 0, 0, NULL), ('surf_in_progress', 0, 1, 1, -893.99, 633.695, 4007.94, -1279.9, 381.292, 4116.95, 0, 0, 0, NULL), ('surf_in_progress', 1, 2, 1, -3116.6, 2876.98, -1166.6, -3662.64, 3388.21, -860.333, 0, 0, 0, NULL), ('surf_in_progress', 2, 3, 0, -3488.89, 3359.37, 2432.03, -3949.95, 2919.11, 2532.03, 0, 0, 0, NULL), ('surf_island', 0, 1, 1, 446.813, 448.046, 14526, -449.152, -446.84, 14628, 0, 0, 0, NULL), ('surf_island', 1, 1, 0, 126.198, 450.931, 14526, -126.004, 596.842, 14610.8, 0, 0, 0, NULL), ('surf_island', 2, 2, 0, 5735.58, 5257.96, -11008, 13312, 7454.64, -10243.2, 0, 0, 0, NULL), ('surf_island', 3, 4, 0, -216.452, 13040, 7150.2, 487.92, 13274.3, 6586.78, 0, 0, 0, NULL), ('surf_island', 4, 4, 1, 10372.8, -9301.06, -345.311, 9216.03, -7908.83, -1604.03, 0, 0, 0, NULL), ('surf_island', 5, 4, 2, -2533.34, 13536, -4233.36, -2141.43, 15616.3, -5438.25, 0, 0, 0, NULL), ('surf_island', 6, 4, 3, 10240, -7152.34, -9033.66, 8192.03, -4758.51, -10689.4, 0, 0, 0, NULL), ('surf_ixtab_njv', 0, 3, 0, -359.981, -6073.45, 13792.9, -643.941, -6583.59, 13976.2, 0, 0, 0, NULL), ('surf_ixtab_njv', 1, 3, 4, 7322.72, 9035.24, 9138.28, 7206.6, 8861.46, 9240.28, 0, 0, 0, NULL), ('surf_ixtab_njv', 2, 1, 1, 6451.96, -900.579, -627.071, 6153.53, -1180.97, -522.235, 0, 0, 0, NULL), ('surf_ixtab_njv', 3, 3, 3, 6864.16, 5105.62, -110.719, 7095.39, 5496.45, -8.71875, 0, 0, 0, NULL), ('surf_ixtab_njv', 4, 3, 2, -8600.51, -10584.6, -318.675, -8487.31, -10370.1, -216.675, 0, 0, 0, NULL), ('surf_ixtab_njv', 5, 3, 1, -10845.5, 1773.59, -7855.22, -10662.9, 2264.63, -7753.22, 0, 0, 0, NULL), ('surf_ixtab_njv', 6, 2, 1, 8110.53, 8626.69, 1927.28, 8753.49, 9248.4, 2029.28, 0, 0, 0, NULL), ('surf_jenocide', 0, 1, 0, 2380.75, -336.623, -624.969, 2208, -554.924, -589.969, 0, 0, 0, NULL), ('surf_jenocide', 1, 3, 0, 3223, -2141.12, 346.031, 3469.55, -2446.4, 448.031, 0, 0, 0, NULL), ('surf_jenocide', 2, 5, 0, 2563.2, -543.969, -753.969, 2498.92, -352.031, -635.969, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_jenocide', 3, 3, 1, -928.031, -1804.49, -513.969, -1208.76, -1461, -411.969, 0, 0, 0, NULL), ('surf_jenocide', 4, 3, 2, 326.614, -7064.69, 181.985, 650.37, -7389.39, 283.985, 0, 0, 0, NULL), ('surf_jenocide', 5, 2, 0, 12635.2, -340.462, 1274.03, 12976, -607.969, 1360.03, 0, 0, 0, NULL), ('surf_jenocide', 6, 3, 3, 12968, 2657.03, 3578.03, 12627.5, 2374.23, 3680.03, 0, 0, 0, NULL), ('surf_jenocide', 7, 1, 0, 5535.84, -4672.03, 3168.28, 5985.54, -5161.44, 3269.24, 0, 0, 1, NULL), ('surf_jenocide', 8, 2, 0, 6472.14, -6367.97, -431.714, 6778.06, -6009.17, -311.904, 0, 0, 1, NULL), ('surf_jizznipples', 0, 3, 3, 8149, -4728.28, -1206.47, 8260.97, -4538.28, -1104.47, 0, 0, 0, NULL), ('surf_jizznipples', 1, 1, 0, 7646.1, 1851.6, -772.969, 7266.88, 1601.43, -711.969, 0, 0, 0, NULL), ('surf_jizznipples', 2, 3, 2, 1406.67, 3299.53, 2174.03, 1614.37, 2883.84, 2276.03, 0, 0, 0, NULL), ('surf_jizznipples', 3, 2, 0, 4908.93, -4869.49, -3750.47, 5277.88, -4371.4, -3584.47, 0, 0, 0, NULL), ('surf_jizznipples', 4, 3, 0, -6704.03, 1310.11, -513.969, -6863.97, 1668.45, -411.969, 0, 0, 0, NULL), ('surf_jizznipples', 5, 3, 1, -1151.86, -5245.47, 1078.03, -1872.22, -5551.97, 1179.91, 0, 0, 0, NULL), ('surf_junglespic_ksf-', 0, 2, 0, -527.994, -295.841, -10642, -613.754, -228.218, -10532, 0, 0, 0, NULL), ('surf_junglespic_ksf-', 1, 2, 1, -655.471, -423.942, -10634, -518.659, -303.722, -10540, 0, 0, 0, NULL), ('surf_junglespic_ksf-', 2, 2, 2, -368.031, -518.93, -10634, -519.185, -199.386, -10532, 0, 0, 0, NULL), ('surf_junglespic_ksf-', 3, 2, 3, -519.489, -423.187, -10642, -626.699, -492.133, -10532, 0, 0, 0, NULL), ('surf_junglespic_ksf-', 4, 1, 0, 59.692, 2420.38, 1062.03, -515.98, 2670.22, 1164.03, 0, 0, 0, NULL), ('surf_primero_njv', 7, 4, 5, 2559.97, 4101.97, 3071.9, 1152.03, 6235.82, 1465.43, 0, 0, 0, NULL), ('surf_primero_njv', 6, 4, 4, -6214.09, -14821.9, 8063.97, -7851.13, -14080, 6145.48, 0, 0, 0, NULL), ('surf_primero_njv', 5, 4, 3, -8464.55, -8978.15, 11797.8, -10073.1, -6958.91, 9226.63, 0, 0, 0, NULL), ('surf_primero_njv', 4, 4, 2, 12544, -16223.2, -3614.52, 10502.1, -15727.5, -4080.43, 0, 0, 0, NULL), ('surf_primero_njv', 3, 4, 1, 11874.6, 4160.03, -3748.14, 11264, 6265.85, -4105.59, 0, 0, 0, NULL), ('surf_primero_njv', 2, 4, 0, 11008, 15679.4, 887.794, 11913.5, 14764, -353.956, 0, 0, 0, NULL), ('surf_primero_njv', 1, 1, 1, 12272, -2566.14, 4862.03, 10768, -2441.46, 4964.03, 0, 0, 0, NULL), ('surf_primero_njv', 0, 2, 1, -4850.15, -8592.03, -13304.9, -6112.99, -10744, -12623.5, 0, 0, 0, NULL), ('surf_kalium', 0, 3, 2, 2139.99, 11256.8, -8705.97, 1868.03, 11748.7, -8604, 0, 0, 0, NULL), ('surf_kalium', 1, 3, 1, -6952.03, 4623.53, -2849.97, -7787.97, 5231.98, -2747.97, 0, 0, 0, NULL), ('surf_kalium', 2, 3, 0, -6875.66, -1591.97, 110.031, -7729.38, -1302.84, 212.031, 0, 0, 0, NULL), ('surf_kalium', 3, 1, 1, -12412, -4367.97, -673.969, -12112.1, -3888, -560.049, 0, 0, 0, NULL), ('surf_kalium', 4, 2, 1, 2417.59, -3792.89, -5153.13, 1428.69, -4732.22, -5020.6, 0, 0, 0, NULL), ('surf_kalium2', 0, 1, 1, 14686.1, 195.261, 14014, 14420.1, -281.968, 14116, 0, 0, 0, NULL), ('surf_kalium2', 1, 1, 2, 14356.8, -301.8, 14046, 13766.4, 294.543, 14148, 0, 0, 0, NULL), ('surf_kalium2', 2, 2, 1, 7495.87, 12036.3, -10847.3, 7575.34, 12624.7, -10351.6, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_kawaii', 0, 5, 0, 1167.02, 3835.03, 1989.03, 873.031, 4314.97, 2091.03, 0, 0, 0, NULL), ('surf_kawaii', 1, 3, 0, 2245.03, 497.969, 1849.03, 2611.25, 323.64, 1951.03, 0, 0, 0, NULL), ('surf_kawaii', 2, 3, 2, -3740.97, -5370.03, 497.031, -3446.33, -5782.95, 599.031, 0, 0, 0, NULL), ('surf_kawaii', 3, 2, 0, -1798.97, -5788.44, -374.969, -1701.76, -5335.07, -201.728, 0, 0, 0, NULL), ('surf_kawaii', 4, 3, 1, -5915.97, -3567.03, 2726.03, -5651.95, -3688.51, 2828.03, 0, 0, 0, NULL), ('surf_kitsune', 0, 5, 0, -15746, -14811.9, 814.031, -14969.8, -15168.9, 916.031, 0, 0, 0, NULL), ('surf_kitsune', 1, 3, 3, -5507.58, -14826.6, -5409.97, -4741.84, -15344, -5307.97, 0, 0, 0, NULL), ('surf_kitsune', 2, 3, 2, -8578.75, -14825.8, -2945.97, -7811.64, -15344, -2843.97, 0, 0, 0, NULL), ('surf_kitsune', 3, 3, 5, 132.61, -14542, -12130, 899.907, -15056, -12028, 0, 0, 0, NULL), ('surf_kitsune', 4, 3, 6, 8578.44, -754.306, 6550.03, 7810.9, -240.003, 6652.03, 0, 0, 0, NULL), ('surf_kitsune', 5, 3, 1, -11652.6, -14833.9, -1745.97, -10881.8, -15344, -1643.97, 0, 0, 0, NULL), ('surf_kitsune', 6, 3, 0, -13695.5, -14824.8, -465.969, -12925.9, -15344, -363.969, 0, 0, 0, NULL), ('surf_kitsune', 7, 2, 0, -16033, 10297.2, -11938, -16014.6, 10063.9, -11714.6, 0, 0, 0, NULL), ('surf_kitsune', 8, 2, 1, -15527.2, 10562.7, -11938, -16048, 9787.15, -11836, 0, 0, 0, NULL), ('surf_kitsune', 9, 3, 7, -14720.5, 14686.2, 10782, -15494.7, 15200, 10884, 0, 0, 0, NULL), ('surf_kitsune', 10, 3, 4, -2433.95, -14829.1, -7905.97, -1671.38, -15344, -7803.97, 0, 0, 0, NULL), ('surf_koa', 0, 1, 0, 5360.03, 728.76, 14526, 5978.7, -666.473, 14628, 0, 0, 0, NULL), ('surf_koa', 1, 2, 0, 14730.8, 1019.57, -12114, 15568, -761.144, -12012, 0, 0, 0, NULL), ('surf_koa', 2, 2, 0, 15216, 5978, 13258.1, 14131.9, 4195.1, 13024, 0, 0, 1, NULL), ('surf_koa', 3, 1, 0, 3107.33, 12864, 14965.3, 2556.02, 12543.8, 14896.1, 0, 0, 1, NULL), ('surf_koa', 4, 4, 0, 11872, 588.277, 11377.6, 13821.3, -663.579, 11008, 0, 0, 0, NULL), ('surf_koa', 5, 4, 1, 3904.03, -2795.27, 6237.18, 4935.02, 2879.97, 5551.15, 0, 0, 0, NULL), ('surf_koa', 6, 4, 2, -8213.19, -2431.97, 3406.99, -9299.08, 2495.97, 2012.52, 0, 0, 0, NULL), ('surf_koa', 7, 4, 3, -2770.76, 1215.97, -1836.34, -2177.9, -1078.84, -3327.97, 0, 0, 0, NULL), ('surf_koa', 8, 4, 4, 6706.6, -2495.97, -351.073, 6142.21, 2591.97, -2265.58, 0, 0, 0, NULL), ('surf_koa', 9, 4, 5, -1055.97, 716.865, -9782.57, 183.286, -151.294, -9642.17, 0, 0, 0, NULL), ('surf_krow10', 0, 2, 0, -4607.94, -720.102, -7233.97, -4147.9, -1136.39, -7131.97, 0, 0, 0, NULL), ('surf_krow10', 1, 2, 1, -4609.27, -1633.23, -7233.97, -4142.06, -1120.03, -7131.97, 0, 0, 0, NULL), ('surf_krow10', 2, 1, 0, 257.672, 511.559, 526.031, -918.929, -497.42, 628.031, 0, 0, 0, NULL), ('surf_krow10', 3, 2, 0, 7233.08, 3984.03, -273.969, 6800.03, 4911.97, -171.969, 0, 0, 1, NULL), ('surf_krow10', 4, 1, 0, 4048.03, 4991.97, 2110.03, 4584.13, 4128.01, 2212.03, 0, 0, 1, NULL), ('surf_krow10', 5, 4, 0, -5641.3, 636.527, -2918.75, -5239.96, -639.969, -3326.59, 0, 0, 0, NULL), ('surf_krow10', 6, 4, 1, 7106.76, -351.28, -3983.97, 6144.03, 430.326, -3806.64, 0, 0, 0, NULL), ('surf_krow10', 7, 4, 2, -6648.1, -655.969, -5553.42, -7097.95, 655.969, -5927.06, 0, 0, 0, NULL), ('surf_kz_mix_journeys_rg', 0, 1, 1, -7902.97, 3024.83, 11920, -7673.53, 2858.93, 12020, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_kz_mix_journeys_rg', 1, 2, 1, -7976.03, -4098.45, -8831.97, -8227.97, -4559.97, -8731.97, 0, 0, 0, NULL), ('surf_kz_protraining', 0, 3, 8, -4604.36, -266.349, 1166.03, -4356.85, -843.116, 1268.03, 0, 0, 0, NULL), ('surf_kz_protraining', 1, 3, 10, -4824.63, -8098.83, 574.031, -4572.35, -8712.59, 676.031, 0, 0, 0, NULL), ('surf_kz_protraining', 2, 1, 0, -12924.1, 1.02581, 574.031, -12668.1, -197.582, 676.031, 0, 0, 0, NULL), ('surf_kz_protraining', 3, 3, 14, 6657.16, -5437.19, 4974.03, 6912.31, -6000, 5076.03, 0, 0, 0, NULL), ('surf_kz_protraining', 4, 3, 12, 295.89, -5382.17, 4590.03, 542.846, -5999.97, 4692.03, 0, 0, 0, NULL), ('surf_kz_protraining', 5, 3, 9, -3416.53, 7301.06, 7230.03, -3678.87, 8017.27, 7332.03, 0, 0, 0, NULL), ('surf_kz_protraining', 6, 3, 13, 3198.77, -5451.5, 1166.03, 3452.83, -5999.97, 1268.03, 0, 0, 0, NULL), ('surf_kz_protraining', 7, 3, 5, -9819.79, -3.92299, 3294.03, -9571.1, -623.969, 3396.03, 0, 0, 0, NULL), ('surf_kz_protraining', 8, 2, 0, 6435.2, 9711.98, 2078.03, 6051.84, 9347.95, 2306.1, 0, 0, 0, NULL), ('surf_kz_protraining', 9, 3, 11, -1915.4, -5123.29, 574.031, -1665.22, -5743.97, 676.031, 0, 0, 0, NULL), ('surf_kz_protraining', 10, 3, 7, -7962.48, -387.382, 4142.03, -7710.19, -879.998, 4244.03, 0, 0, 0, NULL), ('surf_kz_protraining', 11, 3, 0, -12921.1, -10752, 574.031, -12676.9, -11120, 676.031, 0, 0, 0, NULL), ('surf_kz_protraining', 12, 3, 2, -11933.6, -10247.8, 1822.03, -11676.8, -10864, 1924.03, 0, 0, 0, NULL), ('surf_kz_protraining', 13, 3, 3, -10879.4, -7.42429, 574.031, -10626.1, -623.969, 676.031, 0, 0, 0, NULL), ('surf_kz_protraining', 14, 3, 4, -10879.1, -10748.5, 574.031, -10626.8, -11120, 676.031, 0, 0, 0, NULL), ('surf_kz_protraining', 15, 3, 6, -8830.68, 3.3196, 574.031, -8573.02, -623.969, 676.031, 0, 0, 0, NULL), ('surf_kz_protraining', 16, 3, 1, -11933.3, -3.00989, 1822.03, -11682.3, -623.969, 1924.03, 0, 0, 0, NULL), ('surf_kz_protraining', 17, 1, 0, -8870.43, -2108.45, -1968.11, -8983.43, -2002.42, -2009.57, 0, 0, 1, NULL), ('surf_kz_protraining', 18, 2, 0, -6721.85, -2095.86, 770.231, -6870.43, -2359.05, 755.231, 0, 0, 1, NULL), ('surf_lament_n2p', 0, 1, 1, 1281.88, 9583.98, 12302, -1276.97, 8828.18, 12483.9, 0, 0, 0, NULL), ('surf_lament_n2p', 1, 2, 1, 257.665, 7549.62, -12418, -271.94, 8175.97, -12348, 0, 0, 0, NULL), ('surf_lament_n2p', 2, 4, 0, -2613.46, -3967.81, 10523, 1740.1, -2538.79, 7330.61, 0, 0, 0, NULL), ('surf_lament_n2p', 3, 4, 1, 2047.97, -12305.8, 9691.04, -2047.97, -11624.3, 8109.46, 0, 0, 0, NULL), ('surf_lament_n2p', 4, 4, 2, 1856.67, 5433.15, 6911.97, -1919.97, 4439.87, 5066.5, 0, 0, 0, NULL), ('surf_lament_n2p', 5, 4, 3, -1952.67, 12928, 6899.66, 2717.65, 15488, 4990.84, 0, 0, 0, NULL), ('surf_lament_n2p', 6, 4, 4, -2661.18, 12819, 3071.97, 2111.97, 15484.6, 333.306, 0, 0, 0, NULL), ('surf_lament_n2p', 7, 4, 5, -1987.51, -6079.97, -2577.87, 1991.97, -3868.24, -4595.96, 0, 0, 0, NULL), ('surf_lament_n2p', 8, 4, 6, 6072.31, -8192.03, -8482.45, -6118.25, -10150.1, -10530.5, 0, 0, 0, NULL), ('surf_lament_n2p', 9, 6, 0, -390.706, -9627.89, -160.031, 143.093, -9404.88, -351.969, 0, 0, 0, NULL), ('surf_lament_n2p', 10, 6, 1, -411.771, -6726.38, -160.031, 162.369, -6973.61, -351.01, 0, 0, 0, NULL), ('surf_lament_n2p', 11, 6, 2, -183.804, 10272, 12616.8, 215.9, 11264, 12291.6, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_leet_xl_beta7z', 0, 1, 1, -7071.75, -11297, 14720, -5648.03, -11664, 14820, 0, 0, 0, NULL), ('surf_leet_xl_beta7z', 1, 2, 1, -10161.8, -5055.9, -11776, -10032.6, -2144.6, -11676, 0, 0, 0, NULL), ('surf_leet_xl_beta7z_', 0, 5, 1, -7070.74, -11677.4, 14720, -5699.77, -11232, 14979.3, 0, 0, 0, NULL), ('surf_leet_xl_beta7z_', 1, 5, 2, -7070.39, -10657.2, 14720, -5724.09, -11104, 14946.9, 0, 0, 0, NULL), ('surf_leet_xl_beta7z_', 2, 2, 1, -10032.9, -5055.13, -11776, -10156.9, -2147.33, -11761, 0, 0, 0, NULL), ('surf_leet_xl_beta7z_swg', 0, 2, 1, -2637.29, -1152.5, -11776, -2511.33, -4064.93, -11676, 0, 0, 0, NULL), ('surf_leet_xl_beta7z_swg', 1, 1, 1, 1887.97, -9666.03, 14720, 448.916, -10047, 14820, 0, 0, 0, NULL), ('surf_leet_xl_beta7z_swg', 2, 1, 2, 1888.97, -10686, 14720, 449.945, -10305, 14820, 0, 0, 0, NULL), ('surf_legendary', 0, 1, 0, -7442.97, 6219.31, 714.531, -6809.6, 6752.25, 773.449, 0, 0, 0, NULL), ('surf_legendary', 1, 3, 0, -5883.32, -2327.17, 4094.03, -6255.34, -1969.96, 4196.03, 0, 0, 0, NULL), ('surf_legendary', 2, 3, 1, -4775.97, 2204.65, 3582.03, -4369.25, 1701.71, 3684.03, 0, 0, 0, NULL), ('surf_legendary', 3, 3, 2, 12687.2, 1732.11, 1237.03, 12131.6, 2079.47, 1339.03, 0, 0, 0, NULL), ('surf_legendary', 4, 3, 4, 7635.65, -9187.89, 2558.03, 8462.02, -9863.06, 2660.03, 0, 0, 0, NULL), ('surf_legendary', 5, 3, 3, -9266.53, -9188.65, 3701.03, -8786.03, -9665.48, 3803.03, 0, 0, 0, NULL), ('surf_legendary', 6, 3, 5, -3271.19, 10960, 1334.03, -3489.39, 11472.1, 1436.03, 0, 0, 0, NULL), ('surf_legendary', 7, 2, 0, -13793.1, 11557.5, -1113.97, -14177, 10883.5, -1011.97, 0, 0, 0, NULL), ('surf_legends', 0, 1, 1, 6832.03, 7071.03, 12095, 7292.66, 7994.42, 12198.2, 0, 0, 0, NULL), ('surf_legends', 1, 2, 1, 8179.43, -10528, -2865.97, 9138.58, -9066.46, -2130.55, 0, 0, 0, NULL), ('surf_legends_lite', 0, 1, 1, 6816.65, 9048.91, 12097, 7290.26, 8089.16, 12186, 0, 0, 0, NULL), ('surf_legends_lite', 1, 1, 2, 6816.93, 7067.11, 12097, 7295.33, 8029.79, 12201.7, 0, 0, 0, NULL), ('surf_legends_lite', 2, 2, 1, 8173.03, -9058.34, -2862.63, 9151.97, -10520.6, -2783.86, 0, 0, 0, NULL), ('surf_legends_lite_gfl', 0, 1, 1, 7295.01, 8090.07, 12181.1, 6819.18, 9045.2, 12097, 0, 0, 0, NULL), ('surf_legends_lite_gfl', 1, 1, 2, 7283.96, 8027.01, 12186.9, 6818.48, 7070.15, 12097, 0, 0, 0, NULL), ('surf_legends_lite_gfl', 2, 2, 1, 8201.51, -9088.03, -2805.07, 9148.02, -10544, -2862.56, 0, 0, 0, NULL), ('surf_legends_lite_gfl', 3, 6, 0, 2751.74, 1284.97, -4629.24, 1190.99, -1449.93, -5198.97, 0, 0, 0, NULL), ('surf_legends_lite_gfl', 4, 6, 1, 2776.57, -1645.81, -3919.03, 3194.23, 1654.53, -4891.97, 0, 0, 0, NULL), ('surf_lepidus', 0, 3, 5, -8672, 6634.59, 5888.03, -8542.31, 6513.77, 5992.45, 0, 0, 0, NULL), ('surf_lepidus', 1, 3, 3, -8231.99, -7850.5, 984.031, -8106.38, -7970.17, 1087.43, 0, 0, 0, NULL), ('surf_lepidus', 2, 3, 4, -5335.97, 3665.84, 8864.03, -5206.5, 3544.56, 8968.42, 0, 0, 0, NULL), ('surf_lepidus', 3, 3, 0, -7863.82, -1384.01, -95.9688, -6960.03, -1959.97, 4.03125, 0, 0, 0, NULL), ('surf_lepidus', 4, 3, 1, -2215.97, -3426.05, -3791.97, -2077.6, -3555.2, -3685.38, 0, 0, 0, NULL), ('surf_lepidus', 5, 3, 2, -303.969, -5618.47, 2128.03, -180.051, -5733.83, 2231.01, 0, 0, 0, NULL), ('surf_lepidus', 6, 2, 1, 7431.97, 5747.19, -2095.97, 7096.03, 5264.03, -1995.97, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_lepidus', 7, 2, 2, 7096.01, 7402.86, -2095.97, 7431.97, 7887.97, -1995.97, 0, 0, 0, NULL), ('surf_lepidus', 8, 2, 3, 8100.14, 6743.97, -2095.97, 8575.97, 6408.03, -1995.97, 0, 0, 0, NULL), ('surf_lepidus', 9, 1, 1, -66.6165, 365.833, 3336.03, -274.827, -207.969, 3428.03, 0, 0, 0, NULL), ('surf_lepidus', 10, 2, 4, 6431.98, 6408.03, -2095.97, 5952.03, 6743.97, -1995.97, 0, 0, 0, NULL), ('surf_lessons', 0, 3, 0, 207.748, -1088.56, 14.0312, -62.9688, -1558.97, 116.031, 0, 0, 0, NULL), ('surf_lessons', 1, 3, 3, -323.969, -4439.35, 358.031, 204.051, -4714.38, 424.555, 0, 0, 0, NULL), ('surf_lessons', 2, 3, 4, 16.1594, -6284.86, 2456.03, 372.019, -5933.05, 2558.03, 0, 0, 0, NULL), ('surf_lessons', 3, 3, 5, -381.753, -7478, 1794.03, 211, -7174.56, 1896.03, 0, 0, 0, NULL), ('surf_lessons', 4, 2, 1, 2079.97, -8543.98, -4557.97, 1504.03, -8160.03, -4455.97, 0, 0, 0, NULL), ('surf_lessons', 5, 3, 2, -386.988, -3479.98, 330.031, 184.012, -3793.36, 421.671, 0, 0, 0, NULL), ('surf_lessons', 6, 1, 1, 156.308, 255.969, 47.1917, -150.105, -255.969, 3.30393, 0, 0, 0, NULL), ('surf_lessons', 7, 3, 1, -394.735, -2464.7, 330.031, 147.28, -2803.77, 472.543, 0, 0, 0, NULL), ('surf_lessons', 8, 0, 1, 1638.96, -9074.98, -4881.72, 2075.84, -9054.37, -4991.97, 0, 0, 0, NULL), ('surf_lessons', 9, 1, 0, 3411.97, -8664.03, 278.031, 3060.03, -8909.01, 384.031, 0, 0, 1, NULL), ('surf_lessons', 10, 2, 0, 3278.5, -10018.3, -1169.44, 3189.51, -9993.71, -1030.34, 0, 0, 1, NULL), ('surf_lessons', 11, 0, 1, 2020, -9097.19, -4812.03, 2092.62, -9177.34, -4991.97, 0, 0, 0, NULL), ('surf_liberation', 0, 1, 1, 8784.01, -3327.97, 1406.03, 9519.98, -2208.03, 1508.03, 0, 0, 0, NULL), ('surf_liberation', 1, 3, 1, 3728.03, 4919.97, 4550.03, 4080, 4560.8, 4660.03, 0, 0, 0, NULL), ('surf_liberation', 2, 3, 0, 6497.43, -2447.39, 2670.03, 7532.66, -2960.18, 2693.07, 0, 0, 0, NULL), ('surf_liberation', 3, 2, 1, -5327.97, 1552.03, -4353.97, -3312.03, 2031.97, -4251.97, 0, 0, 0, NULL), ('surf_liberation', 4, 3, 5, -4108.61, 1234.7, 5374.03, -4542.81, 802.433, 5476.03, 0, 0, 0, NULL), ('surf_liberation', 5, 3, 2, 2224.08, 2135.97, 2622.03, 2785.85, 1856.42, 2732.03, 0, 0, 0, NULL), ('surf_liberation', 6, 3, 4, -3183.97, 3279.97, 110.031, -1168.03, 3061.38, 222.666, 0, 0, 0, NULL), ('surf_liberation', 7, 3, 3, -150.47, -3963.31, 3156.44, 411.729, -4335.97, 3116.91, 0, 0, 0, NULL), ('surf_liberation', 8, 1, 0, -8006.66, -1029.04, 2158.03, -8595.04, -1232, 2263.09, 0, 0, 1, NULL), ('surf_liberation', 9, 2, 0, -8003.15, -1001.16, -657.969, -9782.42, -1229.2, -555.969, 0, 0, 1, NULL), ('surf_liberation2', 0, 1, 0, -11760, 506.607, -11234, -12752, 221.68, -11132, 0, 0, 0, NULL), ('surf_liberation2', 1, 3, 1, -3590.34, 48.0312, -6529.97, -4527.06, 383.947, -6427.97, 0, 0, 0, NULL), ('surf_liberation2', 2, 3, 0, -7531.35, 783.929, -8449.97, -6799.28, 1142.87, -8342.24, 0, 0, 0, NULL), ('surf_liberation2', 3, 1, 1, -12425.5, 515.566, -11234, -12105.4, 784.003, -11132, 0, 0, 0, NULL), ('surf_liberation2', 4, 3, 2, -1751.97, 176.031, -353.969, -1327.52, 591.268, -251.969, 0, 0, 0, NULL), ('surf_liberation2', 5, 3, 3, 1464.6, 1871.67, 3726.03, 528.601, 1584.03, 3844.03, 0, 0, 0, NULL), ('surf_liberation2', 6, 3, 4, 3227.51, 2053.68, 7326.03, 3964.3, 1785.38, 7361.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_liberation2', 7, 2, 0, 7628.23, 751.969, 9214.03, 5680.03, 34.3294, 9316.03, 0, 0, 0, NULL), ('surf_liberation2', 8, 3, 5, 7001.02, 94.4574, 15550, 6338.07, 383.088, 15652, 0, 0, 0, NULL), ('surf_liberation2', 9, 2, 0, 9392.95, -8015.65, -5759.97, 9047.64, -8191.97, -5455.27, 0, 0, 1, NULL), ('surf_liberation2', 10, 1, 0, 8848.01, -10512, -2689.97, 9583.98, -9855.47, -2587.97, 0, 0, 1, NULL), ('surf_libya', 0, 1, 1, 266.632, -639.772, 1600.03, -261.799, -125.106, 1700.03, 0, 0, 0, NULL), ('surf_libya', 1, 2, 1, 7999.83, -5468.48, 8864.03, 8384.83, -5360.03, 8964.03, 0, 0, 0, NULL), ('surf_libya', 2, 1, 2, -264.515, -753.553, 1600.03, 269.231, -650.441, 1700.03, 0, 0, 0, NULL), ('surf_libya', 3, 3, 2, -10121.4, 499.993, -2559.97, -10362.7, 64.9624, -2459.97, 0, 0, 0, NULL), ('surf_libya', 4, 2, 2, 7995.25, -5861.89, 8864.03, 8379.92, -5968, 8964.03, 0, 0, 0, NULL), ('surf_libya', 5, 2, 3, 8385.53, -5360.03, 8864.03, 8543.67, -5967.97, 8964.03, 0, 0, 0, NULL), ('surf_libya', 6, 3, 1, -8060.7, -7138.19, -763.832, -8321.28, -6942.93, -663.832, 0, 0, 0, NULL), ('surf_libya', 7, 3, 0, -4295.38, 12548.9, 7680.03, -3904.7, 12222.7, 7780.03, 0, 0, 0, NULL), ('surf_libya', 8, 3, 3, 8333.45, -6725.87, 10048, 8068.19, -7023.97, 10148, 0, 0, 0, NULL), ('surf_libya', 9, 2, 4, 7992.4, -5967.97, 8864.03, 7829.54, -5360.09, 8964.03, 0, 0, 0, NULL), ('surf_lies', 0, 1, 0, -547.075, 1152.03, 614.031, -396.432, 1415.97, 716.031, 0, 0, 0, NULL), ('surf_lies', 1, 2, 0, 10654, 1509.02, -396.877, 11409.2, 2531.97, -208.185, 0, 0, 0, NULL), ('surf_lies', 2, 3, 3, 10082, 2348.55, 3409.12, 9734.88, 1671.87, 3511.12, 0, 0, 0, NULL), ('surf_lies', 3, 3, 2, 6185.48, -1707.1, 3380.91, 5813.45, -1117.84, 3486.38, 0, 0, 0, NULL), ('surf_lies', 4, 3, 1, 7633.95, 4647.44, 3169.34, 7229.81, 3896.38, 3271.34, 0, 0, 0, NULL), ('surf_lies', 5, 3, 0, 1312.01, 2500.03, 2079.16, 1553.75, 2874.79, 2229.16, 0, 0, 0, NULL), ('surf_lighthouse', 0, 2, 0, 9536.03, -8148.66, -4705.97, 9985.79, -9433.88, -4373.03, 0, 0, 0, NULL), ('surf_lighthouse', 1, 3, 0, -7840.41, 714.282, 3230.03, -8431.99, 1866.66, 3332.03, 0, 0, 0, NULL), ('surf_lighthouse', 2, 3, 1, -15280, 4189, -865.969, -15004, 4868.26, -845.053, 0, 0, 0, NULL), ('surf_lighthouse', 3, 1, 0, -12873.6, -3681.36, 6782.03, -13263.2, -5598.64, 6884.03, 0, 0, 0, NULL), ('surf_lighthouse', 4, 3, 2, 9472.03, -5219.6, 1198.03, 10048, -4880.23, 1300.03, 0, 0, 0, NULL), ('surf_like_a_boss', 0, 3, 1, -13264, 12347, 1293.03, -13017.1, 11917.7, 1393.03, 0, 0, 0, NULL), ('surf_like_a_boss', 1, 3, 2, -8515.59, 5427.97, 3295.32, -8052.03, 4772.03, 3395.32, 0, 0, 0, NULL), ('surf_like_a_boss', 2, 3, 0, -10123, 783.715, 2306.37, -10379, 1348.21, 2406.37, 0, 0, 0, NULL), ('surf_like_a_boss', 3, 3, 3, -4539.38, 10017.7, -1850.97, -4361.3, 10807.3, -1750.97, 0, 0, 0, NULL), ('surf_like_a_boss', 4, 2, 1, -4584.73, 12052.6, -10395.3, -4350.8, 11199.6, -10190.3, 0, 0, 0, NULL), ('surf_like_a_boss', 5, 1, 1, -12353, 9522.7, 864.031, -12652, 8948.57, 964.031, 0, 0, 0, NULL), ('surf_lithium-', 0, 1, 0, -1021.52, -88.119, 3143.27, -1792.79, -675.827, 3626.57, 0, 0, 0, NULL), ('surf_lithium-', 1, 1, 1, -1224.71, 52.1048, 3618.15, -698.167, -64.1952, 3575.82, 0, 0, 0, NULL), ('surf_lithium-', 2, 3, 3, -12176.6, -7332.45, 3523.13, -11767.7, -7642.92, 3574.29, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_lithium-', 3, 3, 0, -10672, -79.9688, 3182.03, -10396.3, 80.5454, 3329.58, 0, 0, 0, NULL), ('surf_lithium-', 4, 2, 0, 2991.97, -9740.31, 1918.03, 2513.71, -10694.6, 2014.47, 0, 0, 0, NULL), ('surf_lithium-', 5, 3, 2, -11083.8, 5180.03, 6718.03, -10251.6, 4454.92, 6820.03, 0, 0, 0, NULL), ('surf_lithium-', 6, 1, 2, -1023.8, 96.6295, 3134.03, -1447.19, 687.969, 3236.03, 0, 0, 0, NULL), ('surf_lithium-', 7, 3, 1, -1041.75, -4028.68, 3134.03, -1882.89, -4666.78, 3236.03, 0, 0, 0, NULL), ('surf_lithium2-', 0, 5, 0, -1010.78, 943.998, 2110.03, -1455.99, -431.969, 2212.03, 0, 0, 0, NULL), ('surf_lithium2-', 1, 3, 2, -1546.3, 3617.06, 2142.03, -1136.85, 4075.73, 2244.03, 0, 0, 0, NULL), ('surf_lithium2-', 2, 3, 1, -1050.26, -5680.03, 2142.03, -1468.75, -7119.97, 2244.03, 0, 0, 0, NULL), ('surf_lithium2-', 3, 3, 3, -1553.43, 8609.67, 4268.15, -1202.87, 8103.58, 4242.58, 0, 0, 0, NULL), ('surf_lithium2-', 4, 2, 0, 4098.31, 9760.96, -911.969, 4880.73, 11221.8, -32.0312, 0, 0, 0, NULL), ('surf_lithium2-', 5, 3, 0, -1057.54, -1073.06, 2142.03, -1718.91, -2396.51, 2244.03, 0, 0, 0, NULL), ('surf_lodypreview', 0, 3, 6, -10558.7, -6451.97, 208.001, -10520, -6377.66, 310.031, 0, 0, 0, NULL), ('surf_lodypreview', 1, 3, 0, 7297.97, -11776.6, -6285.97, 7184.53, -11588.4, -6183.97, 0, 0, 0, NULL), ('surf_lodypreview', 2, 3, 1, -13515.9, 14482.6, 12724, -13765.8, 14731.3, 12826, 0, 0, 0, NULL), ('surf_lodypreview', 3, 3, 2, -13788.7, -12784, 6683.21, -13529.3, -12320, 6720.03, 0, 0, 0, NULL), ('surf_lodypreview', 4, 3, 4, -4208.03, 686.229, 10128, -4264.03, 808.04, 10230, 0, 0, 0, NULL), ('surf_lodypreview', 5, 2, 1, -3804.77, 8912.63, -7758.31, -4026.85, 9241.21, -7409.36, 0, 0, 0, NULL), ('surf_lodypreview', 6, 3, 3, -3555.15, -615.969, 10620, -3839.97, -136.023, 10722, 0, 0, 0, NULL), ('surf_lodypreview', 7, 3, 8, 8288.46, 1050.97, 3932.53, 8060, 708.358, 4034.53, 0, 0, 0, NULL), ('surf_lodypreview', 8, 3, 5, -10539.7, -7312.03, 1440.03, -10840, -7487.3, 1542.03, 0, 0, 0, NULL), ('surf_lodypreview', 9, 1, 1, 6364.03, 9216.76, 9540.03, 6731.97, 9718.7, 9594.03, 0, 0, 0, NULL), ('surf_lodypreview', 10, 3, 9, 6337, 821.87, 1312.53, 6144.01, 661.665, 1414.53, 0, 0, 0, NULL), ('surf_lodypreview', 11, 3, 10, -4232, 9102.98, -6175.97, -4074.74, 8973.95, -6073.97, 0, 0, 0, NULL), ('surf_lodypreview', 12, 3, 7, -10826, -1839.97, -795.969, -10607.7, -1748.03, -693.969, 0, 0, 0, NULL), ('surf_nikolo', 6, 4, 4, -13528, -1902.16, 84.2879, -11344.3, -2247.97, -715.599, 0, 0, 0, NULL), ('surf_nikolo', 5, 4, 3, -12235.5, -10640, 1868.65, -11608, -11406.5, 1292.77, 0, 0, 0, NULL), ('surf_nikolo', 4, 4, 2, -10977.9, -6373.61, 3095.97, -12968, -7595.05, 1347.07, 0, 0, 0, NULL), ('surf_nikolo', 3, 4, 1, -12968, -9732.57, 6138.16, -10880.1, -9263.77, 5304.03, 0, 0, 0, NULL), ('surf_lolrevlis', 0, 1, 1, -10256, 4779.04, 1662.03, -9776.03, 4510.31, 1764.03, 0, 0, 0, NULL), ('surf_lolrevlis2', 0, 2, 0, 2281.39, -4884.78, 8214.03, 2838.34, -4335.97, 8316.03, 0, 0, 0, NULL), ('surf_lolrevlis2', 1, 1, 0, -4134.34, 1712.98, 2174.03, -3815.46, 2407.94, 2276.03, 0, 0, 0, NULL), ('surf_lolrevlis2', 2, 0, 0, 383.969, -5061.53, 7219.48, -386.12, -4855.26, 7314.16, 0, 0, 0, NULL), ('surf_lolrevlis2', 3, 1, 0, -384.363, -7679.27, 7300.03, 383.727, -7431.51, 7000.03, 0, 0, 1, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_lolrevlis2', 4, 2, 0, 324.039, -8388.71, -169.969, -322.214, -7742.92, -67.9688, 0, 0, 1, NULL), ('surf_lolrevlis_rg', 0, 3, 3, 196.03, 4138.03, 1664.03, 687.969, 5113.97, 1764.03, 0, 0, 0, NULL), ('surf_lolrevlis_rg', 1, 1, 1, -10256, 4778.59, 1664.03, -9761.03, 4510.64, 1764.03, 0, 0, 0, NULL), ('surf_lolrevlis_rg', 2, 3, 0, -8592.03, 540.563, 1664.03, -9679.97, 889.984, 1764.03, 0, 0, 0, NULL), ('surf_lolrevlis_rg', 3, 3, 1, -8000.45, 5121.54, 1264.03, -7882.33, 5103.56, 1364.03, 0, 0, 0, NULL), ('surf_lolrevlis_rg', 4, 3, 2, -4838.69, 213.544, 1808.03, -4635.85, 522.661, 1908.03, 0, 0, 0, NULL), ('surf_lolrevlis_rg', 5, 3, 4, 2931.85, 3989.26, 1664.03, 3262.61, 4278.06, 1764.03, 0, 0, 0, NULL), ('surf_lolrevlis_rg', 6, 2, 1, -377.175, -751.998, 13456, 393.095, -646.586, 13556, 0, 0, 0, NULL), ('surf_lolrevlis_rg', 7, 3, 6, 8535.97, 5080.34, 1792.03, 8047.93, 4878.63, 1892.03, 0, 0, 0, NULL), ('surf_lolrevlis_rg', 8, 3, 7, 11478, 4897.12, 1792.03, 10719.9, 5114, 1892.03, 0, 0, 0, NULL), ('surf_lolrevlis_rg', 9, 3, 5, 4379.69, 4661.16, 1312.03, 4015.76, 5113.97, 1396.03, 0, 0, 0, NULL), ('surf_lolwhut', 0, 2, 1, -9988, -12712, -13840, -5536.03, -12799, -13759, 0, 0, 0, NULL), ('surf_lolwhut', 1, 1, 1, -3311.97, 1136, 64.0312, -2676.03, 272.031, 161.632, 0, 0, 0, NULL), ('surf_looksmodern', 0, 3, 2, 3760.03, 163.454, 512.031, 3912.67, -205.462, 612.031, 0, 0, 0, NULL), ('surf_looksmodern', 1, 1, 1, 3712.35, -751.969, 1536.03, 4079.97, 751.969, 1636.03, 0, 0, 0, NULL), ('surf_looksmodern', 2, 3, 3, 4474.97, 809.24, 1793.03, 4353.33, -817.477, 1948.03, 0, 0, 0, NULL), ('surf_looksmodern', 3, 3, 1, 3762.63, 768.438, 1024.03, 3908.77, -784.851, 1124.03, 0, 0, 0, NULL), ('surf_looksmodern', 4, 3, 0, -6889.46, -68.3548, -67.9688, -7094.12, 65.1824, 32.0312, 0, 0, 0, NULL), ('surf_lore_e', 0, 3, 3, -184.641, 1002.72, -333.969, -475.548, 863.034, -217.969, 0, 0, 0, NULL), ('surf_lore_e', 1, 3, 2, -6004.11, -2683.78, -3879.23, -6387.37, -2528.97, -3777.23, 0, 0, 0, NULL), ('surf_lore_e', 2, 3, 1, -10980.9, -2232.59, -268.969, -11279.6, -1968.45, -166.969, 0, 0, 0, NULL), ('surf_lore_e', 3, 3, 5, 3273.98, -3885.06, -484.969, 3033.86, -4323.77, -361.513, 0, 0, 0, NULL), ('surf_lore_e', 4, 3, 4, -2005.6, -2435.83, -853.969, -2365.82, -3088.49, -746.609, 0, 0, 0, NULL), ('surf_lore_e', 5, 3, 0, -8177.82, -7455.97, -978.399, -8281.89, -6991.29, -1073.97, 0, 0, 0, NULL), ('surf_lore_e', 6, 1, 0, 6055.97, -427.031, -431.969, 5809.16, -560.641, -329.969, 0, 0, 0, NULL), ('surf_lore_e', 7, 2, 0, 3209.48, 7587.78, -3118.97, 3093, 8123.71, -3016.97, 0, 0, 0, NULL), ('surf_love', 0, 3, 5, -2728.11, 10731, 805.986, -2953.88, 10423.9, 907.976, 0, 0, 0, NULL), ('surf_love', 1, 3, 4, -3583.97, -6383.97, 3166.03, -3360.03, -6232.26, 3268.03, 0, 0, 0, NULL), ('surf_love', 2, 2, 1, 1197.1, 1700.03, 56.0501, 132.451, 1967.97, 292.014, 0, 0, 0, NULL), ('surf_love', 3, 3, 3, 488.55, -2187.97, 1694.03, -53.0466, -2687.39, 1784.77, 0, 0, 0, NULL), ('surf_love', 4, 1, 1, 4129.33, 2498.47, -1767.97, 3992.26, 2363.89, -1665.97, 0, 0, 0, NULL), ('surf_love', 5, 3, 0, 8500.35, -5680.38, 3736.03, 8135.43, -5285.28, 3838.03, 0, 0, 0, NULL), ('surf_love', 6, 3, 2, 4678.6, -1360.03, 62.0312, 4360.21, -1763.32, 164.031, 0, 0, 0, NULL), ('surf_love', 7, 3, 1, 1199.99, 3825.38, 4358.03, 603.196, 4060.54, 4578.77, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_lt_omnific', 0, 3, 9, 240.031, -13936, 5278.03, 925.368, -12692, 5380.03, 0, 0, 0, NULL), ('surf_lt_omnific', 1, 3, 10, -2064.03, 14320, -5121.97, -3027.96, 12304, -5019.97, 0, 0, 0, NULL), ('surf_lt_omnific', 2, 3, 12, -11534.9, 10160, 4958.03, -10736, 8272.03, 5060.03, 0, 0, 0, NULL), ('surf_lt_omnific', 3, 3, 11, -7567.97, 12592, -3905.97, -6919.34, 14031.5, -3803.97, 0, 0, 0, NULL), ('surf_lt_omnific', 4, 3, 8, -12796.6, 13782.4, -13250, -11984, 12823.2, -13148, 0, 0, 0, NULL), ('surf_lt_omnific', 5, 3, 7, 7671.52, 6672.03, -1025.97, 6672.03, 7674.09, -923.969, 0, 0, 0, NULL), ('surf_lt_omnific', 6, 2, 1, -9427.97, -3372.12, -13570, -10028.5, -2769.38, -13468, 0, 0, 0, NULL), ('surf_lt_omnific', 7, 3, 6, -6095.97, 4144.03, -5665.97, -5131.07, 6095.97, -5563.97, 0, 0, 0, NULL), ('surf_lt_omnific', 8, 3, 5, 2128.03, 2159.99, -9953.97, 2852.32, -111.969, -9851.97, 0, 0, 0, NULL), ('surf_lt_omnific', 9, 3, 4, -12304, 4144.03, -6113.97, -13180.1, 6095.97, -6011.97, 0, 0, 0, NULL), ('surf_lt_omnific', 10, 3, 3, -5103.97, -2065.54, -5121.97, -4076.29, -4079.97, -5019.97, 0, 0, 0, NULL), ('surf_lt_omnific', 11, 3, 2, -14352, 6127.97, -9473.97, -14995.5, 4112.03, -9371.97, 0, 0, 0, NULL), ('surf_lt_omnific', 12, 3, 0, -13803.9, 8464.03, -10594, -14704, 9967.97, -10492, 0, 0, 0, NULL), ('surf_lt_omnific', 13, 3, 1, -12231.5, 8245.2, 7198.03, -11271.2, 10192, 7300.03, 0, 0, 0, NULL), ('surf_lt_omnific', 14, 1, 1, 7160.97, 12272, -769.969, 6538.94, 10256, -667.969, 0, 0, 0, NULL), ('surf_lt_omnific', 15, 3, 15, 975.969, -6160.03, -4385.97, 239.394, -8175.77, -4283.97, 0, 0, 0, NULL), ('surf_lt_omnific', 16, 2, 2, -9424.37, -10962.1, -13570, -10032.5, -11570.6, -13468, 0, 0, 0, NULL), ('surf_lt_omnific', 17, 3, 14, 6160.03, 16.0312, -1697.97, 7165.68, 2031.97, -1595.97, 0, 0, 0, NULL), ('surf_lt_omnific', 18, 3, 13, -10224, 2543.97, -961.969, -9225.21, -495.969, -859.969, 0, 0, 0, NULL), ('surf_lt_omnific', 19, 3, 16, -15344, -7791.97, -7009.97, -14635.4, -6544.03, -6907.97, 0, 0, 0, NULL), ('surf_lt_omnific_', 0, 2, 0, -9448.08, -2790.96, -13570, -10013.8, -3364.62, -13468, 0, 0, 0, NULL), ('surf_lt_omnific_', 1, 3, 13, -10224, 2543.97, -961.969, -9219.44, -495.969, -859.969, 0, 0, 0, NULL), ('surf_lt_omnific_', 2, 3, 0, -13795, 9967.99, -10594, -14704, 8464.03, -10492, 0, 0, 0, NULL), ('surf_lt_omnific_', 3, 3, 1, -11263.5, 10192, 7198.03, -12240, 8240.03, 7300.03, 0, 0, 0, NULL), ('surf_lt_omnific_', 4, 3, 2, -14352, 4112.03, -9473.97, -15005.5, 6127.97, -9371.97, 0, 0, 0, NULL), ('surf_lt_omnific_', 5, 3, 12, -10736, 8272.03, 4958.03, -11548.9, 10160, 5060.03, 0, 0, 0, NULL), ('surf_lt_omnific_', 6, 3, 3, -5103.97, -4079.97, -5121.97, -4066.73, -2064.03, -5019.97, 0, 0, 0, NULL), ('surf_lt_omnific_', 7, 3, 4, -12304, 6095.97, -6113.97, -13182.9, 4144.03, -6011.97, 0, 0, 0, NULL), ('surf_lt_omnific_', 8, 3, 11, -7567.97, 14032, -3905.97, -6919.66, 12592, -3803.97, 0, 0, 0, NULL), ('surf_lt_omnific_', 9, 3, 5, 2128.03, -111.969, -9953.97, 2843.19, 2159.97, -9851.97, 0, 0, 0, NULL), ('surf_lt_omnific_', 10, 3, 6, -6095.97, 6095.97, -5665.97, -5120.76, 4144.03, -5563.97, 0, 0, 0, NULL), ('surf_lt_omnific_', 11, 3, 8, -13488, 12848, -13250, -11984, 14320, -13148, 0, 0, 0, NULL), ('surf_lt_omnific_', 12, 3, 9, 240.031, -12688, 5278.03, 923.26, -13936, 5380.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_lt_omnific_', 13, 3, 10, -2064.03, 14320, -5121.97, -3040.44, 12304, -5019.97, 0, 0, 0, NULL), ('surf_lt_omnific_', 14, 1, 0, 7164.09, 12272, -769.969, 6847.26, 10256, -667.969, 0, 0, 0, NULL), ('surf_lt_omnific_', 15, 3, 14, 6160.03, 16.0312, -1697.97, 7160.51, 2031.97, -1595.97, 0, 0, 0, NULL), ('surf_lt_omnific_', 16, 3, 7, 6672.03, 6671.19, -1025.97, 7675.01, 7663.97, -923.969, 0, 0, 0, NULL), ('surf_lt_omnific_', 17, 2, 1, -9453.07, -10982, -13570, -10005.5, -11545.8, -13468, 0, 0, 0, NULL), ('surf_lt_omnific_', 18, 3, 16, -15344, -6544.03, -7009.97, -14629.3, -7791.97, -6907.97, 0, 0, 0, NULL), ('surf_lt_omnific_', 19, 3, 15, 975.969, -8175.97, -4385.97, 226.72, -6160.03, -4283.97, 0, 0, 0, NULL), ('surf_lt_omnific_', 20, 0, 0, -119.969, -2522.71, 4212.67, 90.1, -1530.19, 3976.03, 0, 0, 0, NULL), ('surf_lt_omnific_', 21, 1, 0, 9240.66, 10240, 14462.4, 9682.27, 15143.5, 14368, 0, 0, 1, NULL), ('surf_lt_omnific_', 22, 2, 0, 5129.71, 10240, 4737.23, 6143.97, 15342.8, 4649.23, 0, 0, 1, NULL), ('surf_lt_unicorn', 0, 3, 0, 15088, -11673.4, 8649.78, 14557, -10894.6, 8191.42, 0, 0, 0, NULL), ('surf_lt_unicorn', 1, 1, 0, 15104, -14234.7, 14634.4, 14298.8, -13478, 14176, 0, 0, 0, NULL), ('surf_lt_unicorn', 2, 2, 0, -9568.03, 5684.22, -397.612, -7444.03, 3717.77, -706.523, 0, 0, 0, NULL), ('surf_lt_unicorn', 3, 3, 1, 15104, -2460.67, 10001, 14373.9, -1818.93, 9536.15, 0, 0, 0, NULL), ('surf_lt_unicorn', 4, 3, 2, 15104, -11675.1, -96.0752, 14353.6, -11069.1, -559.849, 0, 0, 0, NULL), ('surf_lt_unicorn', 5, 3, 3, 15104, -11164.6, -9966.63, 14369.8, -10525.2, -10431.8, 0, 0, 0, NULL), ('surf_lt_unicorn', 6, 3, 4, 15104, 4692.73, 2464.54, 14369.1, 5329.56, 2000.03, 0, 0, 0, NULL), ('surf_lt_unicorn', 7, 1, 0, 2553.77, 8801.6, -8183.97, 3300.03, 8056.61, -8383.97, 0, 0, 1, NULL), ('surf_lt_unicorn', 8, 2, 0, 3465.83, 8931.18, -13280, 2365.83, 7931.18, -13680, 0, 0, 1, NULL), ('surf_lt_unicorn', 9, 7, 0, 16352, 10322.1, -13054.4, 8703.04, 16136, -16352, 0, 0, 0, NULL), ('surf_lt_unicorn', 10, 8, 0, 6157.34, 11293.2, -10416.3, 652.64, 6828.67, -14710.4, 0, 0, 0, NULL), ('surf_lt_unicorn', 11, 2, 1, -8171.38, 5709.65, -144.031, -9534.77, 6196.03, -758.061, 0, 0, 0, NULL), ('surf_lullaby_ksf', 0, 1, 1, -2751.51, -15248, 13377.9, -3056, -15728, 13479.9, 0, 0, 0, NULL), ('surf_lullaby_ksf', 1, 1, 2, 3055.97, -15728, 13326, 2756.72, -15248, 13428, 0, 0, 0, NULL), ('surf_lullaby_ksf', 2, 2, 1, -511.969, 952.028, -8832.05, 511.716, 1791.97, -8923.99, 0, 0, 0, NULL), ('surf_lullaby_ksf', 3, 4, 0, -655.969, -4887.05, 10261.2, 775.989, -3868.32, 9554.74, 0, 0, 0, NULL), ('surf_lullaby_ksf', 4, 4, 1, -655.969, -2437.03, 7546.63, 654.452, -1451.64, 5504.03, 0, 0, 0, NULL), ('surf_lullaby_ksf', 5, 4, 2, -2060.48, 6138.48, 4703.97, 1791.97, 5152.67, 3077.6, 0, 0, 0, NULL), ('surf_lullaby_ksf', 6, 4, 3, 473.303, -10880, 937.381, -479.969, -11984.9, 130.058, 0, 0, 0, NULL), ('surf_lullaby_ksf', 7, 4, 4, -469.028, -8192.87, -2816.03, 471.481, -9923.38, -4351.97, 0, 0, 0, NULL), ('surf_lullaby_ksf', 8, 4, 5, 1408.13, -6144.03, -7312.61, -1876.89, -7135.97, -8740.71, 0, 0, 0, NULL), ('surf_lux', 0, 1, 1, 382.332, 1921.75, 1598.03, -386.81, 2260.58, 1700.03, 0, 0, 0, NULL), ('surf_lux', 1, 2, 1, 7599.97, 14722.6, -8897.97, 6352, 15280, -8795.97, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_nikolo', 2, 4, 0, -12931.1, -9071.97, 7330.87, -10880, -7913.75, 6811.66, 0, 0, 0, NULL), ('surf_nikolo', 1, 1, 1, -11384, -3451.82, 11198, -12513.4, -3132.79, 11284, 0, 0, 0, NULL), ('surf_nikolo', 0, 2, 1, -10336, -5278.68, -2945.97, -13512, -4724.51, -2843.97, 0, 0, 0, NULL), ('surf_nightmare', 8, 2, 0, 12215.9, 2489.97, -1716.2, 11955.7, 1786.03, -1915.26, 0, 0, 1, 'BONUS 1'), ('surf_nightmare', 7, 1, 0, 5256.96, -5742.03, 2352.57, 5054.79, -6477.97, 2486.67, 0, 0, 1, 'BONUS 1'), ('surf_nightmare', 6, 3, 2, -2026.62, 12969.1, -1801.97, -1771.48, 13217, -1699.97, 0, 0, 0, NULL), ('surf_nightmare', 5, 3, 3, -9173.26, -9526.49, 3570.03, -9483.17, -9254.29, 3672.03, 0, 0, 0, NULL), ('surf_nightmare', 4, 3, 4, -8485.17, 412.385, 10062, -8218.43, 679.288, 10164, 0, 0, 0, NULL), ('surf_map_h_', 0, 2, 1, 6077.84, -3297.93, -6879.97, 6209.79, -3356.21, -6779.97, 0, 0, 0, NULL), ('surf_map_h_', 1, 2, 2, 6016.2, -3359.12, -6879.97, 6272.76, -4061.97, -6779.97, 0, 0, 0, NULL), ('surf_map_h_', 2, 1, 1, -126.552, -4708.4, 6400.03, 123.717, -4980.26, 6500.03, 0, 0, 0, NULL), ('surf_map_njv', 0, 1, 1, -138.312, -4716.24, 6398.03, 150.581, -5059.51, 6500.03, 0, 0, 0, NULL), ('surf_map_njv_h', 0, 2, 1, 6274.13, -3355.43, -6881.97, 6023.93, -4047.97, -6779.97, 0, 0, 0, NULL), ('surf_map_njv_h', 1, 1, 1, -142.61, -4719.11, 6398.03, 142.665, -4906.86, 6500.03, 0, 0, 0, NULL), ('surf_mash-up', 0, 3, 18, -8059.97, -8183.51, -4381.97, -7712.56, -9739.11, -4279.97, 0, 0, 0, NULL), ('surf_mash-up', 1, 3, 2, -11588.5, 4973.5, 10941.2, -11822.8, 6380.01, 11033.3, 0, 0, 0, NULL), ('surf_mash-up', 2, 3, 15, 8314, -13747.6, -6443.97, 8091.68, -12900.2, -6341.97, 0, 0, 0, NULL), ('surf_mash-up', 3, 3, 17, -4895.97, -2681.97, -7365.16, -4016.23, -2416.01, -7263.16, 0, 0, 0, NULL), ('surf_mash-up', 4, 2, 0, 5974, -64.9688, 1651.03, 6075.97, 852.969, 1753.03, 0, 0, 0, NULL), ('surf_mash-up', 5, 1, 0, -12002.7, 13208, 10745, -12304, 14584, 10847, 0, 0, 0, NULL), ('surf_mash-up', 6, 3, 14, -3801.97, -12222.1, 3274.8, -3515.79, -12823, 3367.04, 0, 0, 0, NULL), ('surf_mash-up', 7, 3, 13, 7286.52, -9012.18, 2317.03, 7724.05, -9716.29, 2419.03, 0, 0, 0, NULL), ('surf_mash-up', 8, 3, 12, 6183.86, -9691.24, 6335.03, 6603.99, -10114, 6437.03, 0, 0, 0, NULL), ('surf_mash-up', 9, 3, 4, -13451.6, 2422.65, 8141.87, -12967.2, 2130.16, 8434.83, 0, 0, 0, NULL), ('surf_mash-up', 10, 3, 5, -14278, -1162.03, 8591.03, -13961.3, -2027.97, 8697.03, 0, 0, 0, NULL), ('surf_mash-up', 11, 3, 1, -11242, 8268.79, 10297, -10945.2, 8592.57, 10399, 0, 0, 0, NULL), ('surf_mash-up', 12, 3, 6, -14271.6, -5699.17, 10270, -14036.8, -6274.96, 10372, 0, 0, 0, NULL), ('surf_mash-up', 13, 3, 3, -544.913, 9414.08, 4603.03, -1000.97, 8995.99, 4705.03, 0, 0, 0, NULL), ('surf_mash-up', 14, 3, 16, -7827.97, -11123.4, 10232, -7490.98, -11991, 10334, 0, 0, 0, NULL), ('surf_mash-up', 15, 3, 9, 11221, 7679.97, 7731.03, 10692.2, 7158.85, 7833.03, 0, 0, 0, NULL), ('surf_mash-up', 16, 3, 7, 3971, 3516.7, -2103.97, 4389.94, 2532.72, -2049.97, 0, 0, 0, NULL), ('surf_mash-up', 17, 3, 11, 11896.2, -4742.45, 8732.03, 11462.2, -4992.88, 8834.03, 0, 0, 0, NULL), ('surf_mash-up', 18, 3, 8, 5926.27, 10099, 7653.26, 5158.01, 9615.51, 7755.26, 0, 0, 0, NULL), ('surf_mash-up', 19, 3, 10, 11349.9, 4546.97, 6448.03, 11009.5, 4274.82, 6546.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_mash-up', 20, 3, 0, -13088.2, 11134.2, 9321.03, -13180, 11282.8, 9423.03, 0, 0, 0, NULL), ('surf_masonry-', 0, 5, 0, 557.068, -118.071, 6398.03, 284.478, 127.247, 6500.03, 0, 0, 0, NULL), ('surf_masonry-', 1, 2, 0, 14498.7, -533.297, -13378, 14614.9, 532.727, -13276, 0, 0, 0, NULL), ('surf_masonry-', 2, 2, 1, 14399.4, -469.045, -13378, 14498.8, 471.127, -13276, 0, 0, 0, NULL), ('surf_masonry-', 3, 2, 2, 14163.4, 111.624, -13378, 14315.3, -106.999, -13276, 0, 0, 0, NULL), ('surf_masonry-', 4, 2, 3, 14608.3, 568.288, -13378, 14722.5, -573.257, -13276, 0, 0, 0, NULL), ('surf_masonry-', 5, 2, 4, 14315.7, 404.973, -13378, 14402.2, -402.4, -13276, 0, 0, 0, NULL), ('surf_masonry-', 6, 3, 0, -14572.4, -94.2041, -3023.97, -14445.8, 64.5347, -2880.03, 0, 0, 0, NULL), ('surf_masonry-', 7, 2, 5, 14725, -572.763, -13378, 15263, 566.408, -13276, 0, 0, 0, NULL), ('surf_mellow', 0, 1, 0, 569.033, -431.969, -193.969, 253.753, 431.984, -91.9688, 0, 0, 0, NULL), ('surf_mellow', 1, 2, 0, 3579.61, -10768, -11394, 2640.96, -11757.2, -11124.5, 0, 0, 0, NULL), ('surf_mesa', 0, 2, 1, 398.873, 13056.4, -12297.9, -412.953, 14367.4, -12148.8, 0, 0, 0, NULL), ('surf_mesa', 1, 1, 1, 140.707, -81.4445, 10142, -143.587, -326.089, 10244, 0, 0, 0, NULL), ('surf_mesa', 2, 4, 0, 583.984, 12596.1, 7267.03, -455.323, 11711.9, 6514.76, 0, 0, 0, NULL), ('surf_mesa', 3, 4, 1, 684.452, 9216.07, 1383.11, -874.563, 8380.78, 460.522, 0, 0, 0, NULL), ('surf_mesa', 4, 4, 2, -506.892, -2654.27, -2877.23, 770.504, -3384.23, -3625.46, 0, 0, 0, NULL), ('surf_mesa', 5, 4, 3, 1588.19, -9400, -4576.03, -1703.87, -14506.3, -5589.53, 0, 0, 0, NULL), ('surf_mesa', 6, 4, 4, 724.195, -1054.87, -11469.3, -729.617, -420.594, -12174, 0, 0, 0, NULL), ('surf_mesa_aether', 0, 1, 0, -13606, -14798.2, 15794, -13526, -15003.7, 15888.5, 0, 0, 0, NULL), ('surf_mesa_aether', 1, 2, 0, 6030.69, 14147.3, -7937.97, 5487.85, 14803.6, -7836, 0, 0, 0, NULL), ('surf_mesa_aether', 2, 3, 0, 14823, 14193.4, 14701.3, 14997.5, 14829.5, 14744, 0, 0, 0, NULL), ('surf_mesa_mine', 0, 2, 0, 14432, -4925.47, -15362, 14236.8, -4728, -15276, 0, 0, 0, NULL), ('surf_mesa_mine', 1, 2, 1, 13949.5, -4344.59, -15378, 14722.5, -4727.97, -15276, 0, 0, 0, NULL), ('surf_mesa_mine', 2, 2, 2, 13968.2, -4195.74, -15378, 14703.6, -4337.99, -15276, 0, 0, 0, NULL), ('surf_mesa_mine', 3, 2, 3, 14050.7, -4061.63, -15378, 14607.3, -4197.27, -15276, 0, 0, 0, NULL), ('surf_mesa_mine', 4, 1, 0, -379.521, -13798.5, 15022, 378.696, -14053.4, 15124, 0, 0, 0, NULL), ('surf_mesa_mine', 5, 2, 4, 14185.1, -3979.11, -15378, 14480.6, -4062.92, -15276, 0, 0, 0, NULL), ('surf_mesa_mine', 6, 4, 0, 1038.89, -3426.06, 11937.1, 4714.67, -4223.25, 11075.2, 0, 0, 0, NULL), ('surf_mesa_mine', 7, 4, 1, 10558.4, -10445.9, 10318.2, 9699.13, -10840, 9630.47, 0, 0, 0, NULL), ('surf_mesa_mine', 8, 4, 2, 8936.87, 1741.11, 7146.16, 9633.45, 2802.02, 5907.75, 0, 0, 0, NULL), ('surf_mesa_mine', 9, 4, 3, 2534.64, -1324.61, 1121.18, 1939.74, -843.718, 443.958, 0, 0, 0, NULL), ('surf_mesa_mine', 10, 4, 4, -8542.78, 4180.25, -1201.87, -7777.64, 4693.18, -1818.58, 0, 0, 0, NULL), ('surf_mesa_mine', 11, 4, 5, -13489.2, 12926.6, -5779.13, -12819.1, 13427, -6600.65, 0, 0, 0, NULL), ('surf_mesa_mine', 12, 4, 6, -7859.14, -3264.02, -10039.4, -8490.44, -2718.06, -10708.6, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_mesa_mine', 13, 4, 7, 686.338, 12632.9, -13291.3, 2128, 14512.6, -14748.7, 0, 0, 0, NULL), ('surf_mesa_mine', 14, 4, 8, 13403.2, 3925.25, -14267.4, 15271.1, 2586.46, -15723.6, 0, 0, 0, NULL), ('surf_nightmare', 3, 2, 0, 6363.97, 717.969, 9326.03, 6497.59, 298.629, 9529.54, 0, 0, 0, NULL), ('surf_nightmare', 2, 3, 1, 2520.54, 3982.22, 4522.03, 2715.63, 4327.13, 4624.03, 0, 0, 0, NULL), ('surf_nightmare', 1, 1, 0, 5484.15, 7246.01, -1101.97, 5957.97, 8621.97, -999.969, 0, 0, 0, NULL), ('surf_nightmare', 0, 3, 0, -10804.2, -2045.93, 2502.03, -10247.6, -1471.78, 2604.03, 0, 0, 0, NULL), ('surf_christmas', 12, 1, 0, -14338.6, 5120.01, 7345.15, -15871.5, 3201.58, 6976.03, 0, 0, 2, 'BONUS 2'), ('surf_christmas', 13, 2, 0, -14580.4, 1386.41, 5565.1, -14837.8, 1119.69, 4725.17, 0, 0, 2, 'BONUS 2'), ('surf_metalwall-', 0, 2, 0, 6918.19, 11968.9, -9077.31, 6691.85, 11749.1, -8490.27, 0, 0, 0, NULL), ('surf_metalwall-', 1, 5, 0, -6991.97, -12418.1, 9950.03, -5008.03, -13200, 10052, 0, 0, 0, NULL), ('surf_metalwall-', 2, 4, 0, -4992.03, -13505.2, 5871.45, -7007.97, -12841, 5697.23, 0, 0, 0, NULL), ('surf_metalwall-', 3, 4, 1, -7007.97, -3900.1, 6616.26, -4992.03, -3339.92, 5948.66, 0, 0, 0, NULL), ('surf_metalwall-', 4, 4, 2, -5441.72, 4289.57, -848.654, -6561.57, 3179.2, -1108.2, 0, 0, 0, NULL), ('surf_metalwall-', 5, 4, 3, 3182.03, 5472.03, -3779.15, 2606.45, 7359.97, -4026.67, 0, 0, 0, NULL), ('surf_methadone', 0, 2, 0, -528.031, 11150.7, 1576.13, -1407.97, 10324.7, 1678.13, 0, 0, 0, NULL), ('surf_methadone', 1, 3, 3, 4848.1, 10491.6, 5224.13, 5423.97, 11065.6, 5326.13, 0, 0, 0, NULL), ('surf_methadone', 2, 1, 0, -6767.76, 1768.03, -892.81, -6473.4, 3111.97, -941.659, 0, 0, 0, NULL), ('surf_methadone', 3, 3, 2, 11338, -8511.97, -8275.39, 11644, -7296.03, -8316.67, 0, 0, 0, NULL), ('surf_methadone', 4, 3, 1, 6143.13, 621.622, -2069.87, 5824.03, 1134.07, -2024.21, 0, 0, 0, NULL), ('surf_methadone', 5, 3, 0, -11568, -11592, -875.869, -9424.03, -10834.2, -773.869, 0, 0, 0, NULL), ('surf_method', 0, 3, 0, -2548.01, -6731.66, 1055.52, -2769.51, -6893.94, 1155.03, 0, 0, 0, NULL), ('surf_method', 1, 3, 1, -2858.89, 13299.8, 1186.81, -2958.39, 13233.1, 1300.74, 0, 0, 0, NULL), ('surf_method', 2, 3, 2, 4803.27, -203.856, 2402.79, 5033.54, -33.3291, 2503.27, 0, 0, 0, NULL), ('surf_method', 3, 1, 1, -8068.03, 1094.97, 1280.03, -8283.58, 673.769, 1380.03, 0, 0, 0, NULL), ('surf_method', 4, 1, 2, -8029.97, 1089.97, 1280.03, -7811.57, 674.057, 1380.03, 0, 0, 0, NULL), ('surf_method', 5, 3, 6, 8173.03, 9884.95, 4063.01, 8503.55, 9601.03, 4163.03, 0, 0, 0, NULL), ('surf_method', 6, 3, 5, -13113.6, -13032.3, 3008.1, -12970.3, -12811.6, 3107.61, 0, 0, 0, NULL), ('surf_method', 7, 2, 1, 14480, 14240, 1364.03, 13756, 13626.4, 1464.03, 0, 0, 0, NULL), ('surf_method', 8, 3, 4, 13522.4, -1130.09, 2774.03, 13744.2, -989.273, 2874.52, 0, 0, 0, NULL), ('surf_method', 9, 3, 3, -12396.6, 12972.8, 2424.23, -12168.3, 13151.3, 2524.72, 0, 0, 0, NULL), ('surf_sunset_njv', 6, 1, 0, 767.438, -3390.15, 192.031, -959.969, -3196.19, 299.265, 0, 0, 1, 'BONUS 1'), ('surf_minuet_v1p', 0, 2, 1, -10650.9, -229.734, -2176.03, -10566.1, 251.599, -3583.97, 0, 0, 0, NULL), ('surf_minuet_v1p', 1, 1, 1, -10001, 1007.97, 6414.03, -10624, -1007.97, 6516.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_minuet_v1p', 2, 2, 2, -10170.1, 245.436, -3585.97, -10640, -252.11, -3483.97, 0, 0, 0, NULL), ('surf_minuet_v1p', 3, 4, 0, -12169.9, 1647.97, 3252.98, -10930.5, -1647.97, 256.673, 0, 0, 0, NULL), ('surf_minuet_v1p', 4, 4, 1, 8197.4, 3311.97, 1279.6, 6417.73, -3311.97, -972.559, 0, 0, 0, NULL), ('surf_minuet_v1p', 5, 4, 2, 1006.66, 1791.97, -2181.38, -426.396, -1778.99, -5631.97, 0, 0, 0, NULL), ('surf_minuet_v1p', 6, 6, 0, 8959.97, -1530.37, 7162.87, 4930.81, 767.969, 5635.08, 0, 0, 0, NULL), ('surf_minuet_v1p', 7, 6, 2, 6592.03, -104.947, 4863.17, 7103.97, -612.157, 4610.07, 0, 0, 0, NULL), ('surf_minuet_v1p', 8, 6, 2, 4918.21, 503.969, 5788.26, 4850.73, -503.969, 5708.12, 0, 0, 0, NULL), ('surf_minuet_v1p', 9, 6, 3, 4480.03, -760.787, 7163.75, 4905.09, 767.969, 5833.02, 0, 0, 0, NULL), ('surf_minuet_v1p', 10, 6, 4, 9271.82, 767.969, 6750.6, 8979.75, -749.791, 6528.03, 0, 0, 0, NULL), ('surf_misc', 8, 3, 4, 12613.8, 4435.19, -577.969, 12033.1, 4834.13, -467.859, 0, 0, 0, NULL), ('surf_misc', 7, 3, 2, -9393.02, 4275.78, 6447.03, -9808.65, 4837.66, 6571.51, 0, 0, 0, NULL), ('surf_misc', 6, 3, 1, -738.001, -9468.21, -5438.97, -894.969, -9669.98, -5336.97, 0, 0, 0, NULL), ('surf_misc', 5, 3, 3, -10166.3, -4921.98, -6163.97, -10665.7, -5430.62, -6068.97, 0, 0, 0, NULL), ('surf_misc', 4, 3, 0, -10838.5, 14085.9, -7861.93, -10161.8, 14279.1, -7759.93, 0, 0, 0, NULL), ('surf_misc', 3, 3, 5, 8101, -13316, 12524, 8383.81, -12598.1, 12626, 0, 0, 0, NULL), ('surf_missing_no', 0, 1, 1, 226.115, -28.0701, -1.96875, 402.093, 155.981, 100.031, 0, 0, 0, NULL), ('surf_missing_no', 1, 1, 2, -246.185, -35.1207, -1.96875, -393.686, 147.515, 100.031, 0, 0, 0, NULL), ('surf_missing_no', 2, 2, 1, -363.969, -8208.03, -15874, 363.988, -9195.97, -15772, 0, 0, 0, NULL), ('surf_molstration', 0, 3, 2, -151.969, 2695.97, 2054.03, 485.464, 2216.02, 2156.03, 0, 0, 0, NULL), ('surf_molstration', 1, 1, 1, -1159.96, -112, 12830, -485.632, 367.999, 12932, 0, 0, 0, NULL), ('surf_molstration', 2, 2, 0, 1629.69, 4681.92, -9645.46, 1757.45, 4853.27, -10283.8, 0, 0, 0, NULL), ('surf_molstration', 3, 3, 0, -823.969, 664.031, 9238.03, -128.245, 1143.99, 9340.03, 0, 0, 0, NULL), ('surf_molstration', 4, 3, 3, 184.031, 3471.97, -1537.97, 846.288, 2992.03, -1435.97, 0, 0, 0, NULL), ('surf_molstration', 5, 3, 4, 520.031, 4248, -5129.97, 1175.57, 3768, -5027.97, 0, 0, 0, NULL), ('surf_molstration', 6, 3, 5, 856.031, 5023.97, -8721.97, 1517.06, 4544, -8619.97, 0, 0, 0, NULL), ('surf_molstration', 7, 3, 1, -487.969, 1440.03, 5646.03, 179.424, 1913.1, 5748.03, 0, 0, 0, NULL), ('surf_mom_rg', 0, 3, 2, 2420.07, 800.01, 1408.03, 1920.01, 1791.97, 1508.03, 0, 0, 0, NULL), ('surf_mom_rg', 1, 3, 0, -2019.51, 4600.53, 512.031, -2520.37, 3591.28, 612.031, 0, 0, 0, NULL), ('surf_mom_rg', 2, 3, 1, -500.45, -2714.96, 856.031, -1506.18, -2214.46, 956.031, 0, 0, 0, NULL), ('surf_mom_rg', 3, 3, 3, 2839.98, -912.828, 512.031, 2336.03, -1914.92, 612.031, 0, 0, 0, NULL), ('surf_mom_rg', 4, 2, 1, 6304.03, 1247.97, -2031.97, 6751.97, 800.031, -1931.97, 0, 0, 0, NULL), ('surf_mom_rg', 5, 1, 1, -3106.3, 432.387, 512.031, -3276.31, -590.49, 612.031, 0, 0, 0, NULL), ('surf_mom_rg', 6, 3, 4, -6341.76, 4599.66, 512.031, -6839.61, 3588.21, 612.031, 0, 0, 0, NULL), ('surf_morbid-', 0, 1, 1, -12020.6, -742.487, -343.969, -11357.9, -1789.68, -241.969, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_morbid-', 1, 3, 3, -398.788, -1368.03, 4118.03, -171.578, -1767.97, 4220.03, 0, 0, 0, NULL), ('surf_morbid-', 2, 2, 1, 5757.94, 6432.35, 4128.85, 5412.44, 6658.82, 4227.63, 0, 0, 0, NULL), ('surf_morbid-', 3, 3, 1, 1077.03, -3254.02, -3378.01, 1311.71, -3624.93, -3276.01, 0, 0, 0, NULL), ('surf_morbid-', 4, 3, 4, 5377.69, 6916.3, 8701.28, 5103.03, 6522.03, 8803.03, 0, 0, 0, NULL), ('surf_morbid-', 5, 3, 2, -986.969, 847.969, 9.03125, -385.031, 157.031, 111.031, 0, 0, 0, NULL), ('surf_morbid-', 6, 3, 0, -4186.72, -9203.03, -9339.47, -3921.04, -9728.97, -9237.47, 0, 0, 0, NULL), ('surf_motion_v2', 0, 2, 1, -6305.03, -1847.97, -3983.97, -7006.97, -1599.74, -3842.97, 0, 0, 0, NULL), ('surf_motion_v2', 1, 1, 1, -4413.97, 2623.36, 5184.03, -2113.03, 2142.03, 5284.03, 0, 0, 0, NULL), ('surf_mushroom', 0, 2, 1, -4185.23, 2466.1, 7978.65, -4117.17, 2137.98, 8121.84, 0, 0, 0, NULL), ('surf_mushroom', 1, 2, 2, -4661.52, 2073.64, 7992.23, -4206.66, 2015, 8099.91, 0, 0, 0, NULL), ('surf_mushroom', 2, 2, 3, -4609.89, 2554.76, 7976.46, -4241.63, 2608.6, 8090.77, 0, 0, 0, NULL), ('surf_mushroom', 3, 2, 4, -4707.8, 2107.36, 7984.86, -4645.47, 2520.1, 8062.04, 0, 0, 0, NULL), ('surf_mushroom', 4, 2, 5, -4665.82, 2087.12, 7978.79, -4184.24, 2554.81, 8100.81, 0, 0, 0, NULL), ('surf_mushroom', 5, 2, 6, -4671.35, -2536.9, 7976.06, -4179.41, -2050.09, 8097.97, 0, 0, 0, NULL), ('surf_mushroom', 6, 3, 0, 2014.47, 248, 12158, 2311, -247.969, 12260, 0, 0, 0, NULL), ('surf_mushroom', 7, 2, 7, -4673.03, 2540.73, 7954.55, -4706.62, 2113.8, 8080.25, 0, 0, 0, NULL), ('surf_mushroom', 8, 1, 1, 48.0312, 239.109, 30.0312, 165.892, -210.434, 132.031, 0, 0, 0, NULL), ('surf_mynah_final', 0, 1, 0, 3063.36, -654.208, 8340.82, 2912.32, -969.461, 8249.03, 0, 0, 0, NULL), ('surf_mynah_final', 1, 3, 0, 5646.75, 2698.89, 11430.3, 6233.42, 4030.83, 11358.9, 0, 0, 0, NULL), ('surf_mynah_final', 2, 3, 1, 3498.71, -3071.86, 10207.5, 4068.29, -3577.8, 10154.4, 0, 0, 0, NULL), ('surf_mynah_final', 3, 3, 2, -5597.32, -2129.17, 12421.4, -5368.52, -2836.65, 12357.1, 0, 0, 0, NULL), ('surf_mynah_final_njv', 0, 2, 1, -9283.98, -2111.57, 9023.05, -9659.14, -2817.11, 9125.05, 0, 0, 0, NULL), ('surf_mynah_final_njv', 1, 3, 2, -5893.57, -2579.01, 12270.1, -5997.74, -2330.56, 12377, 0, 0, 0, NULL), ('surf_mynah_final_njv', 2, 3, 1, 3491.33, -3561.8, 10151.3, 3988.4, -3087.86, 10253.3, 0, 0, 0, NULL), ('surf_mynah_final_njv', 3, 3, 0, 5654.27, 4009.58, 11352.3, 6220.87, 2714.89, 11457.9, 0, 0, 0, NULL), ('surf_mynah_final_njv', 4, 1, 1, 2912.87, -652.309, 8247.03, 3026.73, -968.918, 8349.03, 0, 0, 0, NULL), ('surf_nem', 0, 1, 1, 366.383, 38.8017, 11846, 1022.24, 894.969, 11948, 0, 0, 0, NULL), ('surf_nem', 1, 2, 1, 4166, 9496.37, -12812, 3444.97, 10738.1, -12705.2, 0, 0, 0, NULL), ('surf_nemesis', 0, 1, 1, 372.474, 35.4927, 11846, 1010.05, 901.881, 11948, 0, 0, 0, NULL), ('surf_nemesis', 1, 2, 1, 4329.32, 9584.95, -12812, 3319.8, 10825.8, -12710, 0, 0, 0, NULL), ('surf_nemesis', 2, 2, 2, 3467, 9487.9, -12812, 4153.28, 9585.81, -12710, 0, 0, 0, NULL), ('surf_nemesis', 3, 2, 3, 3637.9, 9444.19, -12812, 4008.23, 9488.01, -12710, 0, 0, 0, NULL), ('surf_nemesis_csgo', 0, 2, 1, 4325.58, 9579.3, -12812, 3319.96, 10730.2, -12710, 0, 0, 0, NULL), ('surf_nemesis_csgo', 1, 1, 1, 382.284, 47.1154, 11846, 1023.71, 894.734, 11948, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_nemesis_d', 0, 1, 1, 385.012, 41.6905, 11846, 1010.77, 896.696, 11948, 0, 0, 0, NULL), ('surf_nemesis_fix', 0, 2, 1, 3998.38, 9442.51, -12812, 3631.89, 9490.43, -12710, 0, 0, 0, NULL), ('surf_nemesis_fix', 1, 2, 2, 4461.79, 9690.5, -12812, 4175.79, 10734.8, -12709.8, 0, 0, 0, NULL), ('surf_nemesis_fix', 2, 2, 3, 3174.68, 9689.09, -12812, 3439.95, 10735.3, -12709.1, 0, 0, 0, NULL), ('surf_nemesis_fix', 3, 2, 4, 4170.64, 9493.3, -12812, 3443.63, 10735.8, -12708.3, 0, 0, 0, NULL), ('surf_nemesis_fix', 4, 1, 1, 375.965, 891.253, 11846, 1016.37, 35.5382, 11948, 0, 0, 0, NULL), ('surf_neon_final', 0, 3, 1, -3110.41, 1727.97, -943.969, -2962.11, 1607.67, -573.969, 0, 0, 0, NULL), ('surf_neon_final', 1, 3, 2, -6798.96, -3039.97, 2912.03, -6954.01, -2942.22, 3092.03, 0, 0, 0, NULL), ('surf_neon_final', 2, 2, 1, -5411.03, 1089.03, 1952.03, -8351.97, 2510.99, 2052.03, 0, 0, 0, NULL), ('surf_neon_final', 3, 3, 0, 4234.48, -2767, 3536.03, 4085.7, -2659.55, 3806.03, 0, 0, 0, NULL), ('surf_neon_final', 4, 1, 1, 1828.81, -1007.99, 1168.03, 2279.49, -880.107, 1268.03, 0, 0, 0, NULL), ('surf_neoplasma', 0, 3, 1, 766.513, -30.8747, -1167.97, 432.031, 32.4286, -1067.97, 0, 0, 0, NULL), ('surf_neoplasma', 1, 3, 3, -5583.97, 4494.67, 1648.03, -5416.1, 4117.79, 1748.03, 0, 0, 0, NULL), ('surf_neoplasma', 2, 3, 2, -13744, -5119.99, 5360.03, -14640, -4544.03, 5460.03, 0, 0, 0, NULL), ('surf_neoplasma', 3, 1, 1, -1716.68, 213.284, -1889.97, -2063.29, -222.621, -1787.97, 0, 0, 0, NULL), ('surf_neoplasma', 4, 3, 0, 9231.97, -271.969, 2734.03, 8622.45, 271.969, 2836.03, 0, 0, 0, NULL), ('surf_neoplasma', 5, 2, 1, 4300.56, -2119.47, -7919.97, 4064.33, -2305.38, -7819.97, 0, 0, 0, NULL), ('surf_neoplasma', 6, 3, 4, -4911.97, -1888.03, 1328.03, -4095.71, -2495.99, 1428.03, 0, 0, 0, NULL), ('surf_neo_njv', 0, 1, 0, -495.969, 2594.61, 3526.03, 1391.97, 3199.98, 3628.03, 0, 0, 0, NULL), ('surf_neo_njv', 1, 2, 0, 1407.97, -12861.6, -5241.9, -255.969, -13460, -5119.97, 0, 0, 0, NULL), ('surf_neo_njv', 2, 4, 0, 1407.97, -5033.15, 1201.75, -507.696, -3945.35, 16.0313, 0, 0, 0, NULL), ('surf_neo_njv', 3, 4, 1, -526.841, 3760.03, 227.186, 1423.97, 3987.91, -80.5473, 0, 0, 0, NULL), ('surf_neo_njv', 4, 4, 2, 1422.8, -5667.97, -2181.27, -527.969, -4463.42, -2417.46, 0, 0, 0, NULL), ('surf_neo_njv', 5, 4, 3, -522.784, -6239.41, -3812.03, 1414.94, -5622.59, -5347.97, 0, 0, 0, NULL), ('surf_networked', 0, 2, 1, 143.989, -9550.9, -7391.97, -591.969, -9789.97, -7291.97, 0, 0, 0, NULL), ('surf_networked', 1, 1, 1, 2351.97, 3520, 5152.03, 1361.34, 3808.77, 5252.03, 0, 0, 0, NULL), ('surf_networked_', 0, 1, 0, 1361.88, 3825.69, 5166.03, 2351.97, 3521.46, 5252.03, 0, 0, 0, NULL), ('surf_networked_', 1, 2, 0, -590.341, -9536.03, -7393.97, 143.969, -9789.97, -7291.97, 0, 0, 0, NULL), ('surf_networked_', 2, 4, 0, -191.969, -3134.57, 4125.67, 575.969, -2776.66, 3239.31, 0, 0, 0, NULL), ('surf_networked_', 3, 4, 1, -1088.03, -1859.94, 2886.39, -1453.34, -2207.97, 2055.19, 0, 0, 0, NULL), ('surf_networked_', 4, 4, 2, -977.026, -523.179, 927.969, -1721.72, -949.25, -351.969, 0, 0, 0, NULL), ('surf_networked_', 5, 4, 3, 352.191, 1875.77, -96.0312, 735.308, 2392.8, -863.969, 0, 0, 0, NULL), ('surf_networked_', 6, 4, 4, -703.969, 4540.63, -2720.18, 255.969, 3897.15, -3148.95, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_networked_', 7, 4, 5, 255.969, -5820.41, -5395.35, -703.969, -6187.99, -5764.67, 0, 0, 0, NULL), ('surf_networked_', 8, 4, 6, -606.551, -13518, -6437.44, 159.969, -12838.3, -6862.42, 0, 0, 0, NULL), ('surf_networked_', 9, 4, 7, -607.969, -10830.3, -6900.04, 159.969, -11464.1, -7380.31, 0, 0, 0, NULL), ('surf_networked_', 10, 6, 0, 6253.13, -3109.03, 3328.41, 6441.11, -3272.42, 3365.46, 0, 0, 0, NULL), ('surf_networked_', 11, 6, 1, 6445.27, -5501.73, 3364, 6276.58, -5354.55, 3328.03, 0, 0, 0, NULL), ('surf_networked_', 12, 6, 2, 5764.03, -3167.39, 3492.22, 5828.17, -5462.97, 3396.79, 0, 0, 0, NULL), ('surf_networked_', 13, 6, 2, -191.969, -3086.92, 4299.18, 575.969, -2857.65, 4156.32, 0, 0, 0, NULL), ('surf_network_2008_final', 0, 2, 0, -687.969, -6729.2, -5873.97, 239.969, -6959.97, -5771.97, 0, 0, 0, NULL), ('surf_network_2008_final', 1, 1, 0, 2351.97, 3523.83, 5150.03, 1360, 3839.83, 5268.03, 0, 0, 0, NULL), ('surf_network_2008_final', 2, 1, 0, 5487.97, 4912.97, 958.031, 4752.03, 4609.92, 1060.03, 0, 0, 1, NULL), ('surf_network_2008_final', 3, 2, 0, 5488, 5755.79, -577.969, 4752.03, 6255.97, -475.969, 0, 0, 1, NULL), ('surf_calibration', 2, 4, 0, -511.969, 14095.9, 5373.46, 1279.68, 15483, 4032.06, 0, 0, 0, 'Start 0'), ('surf_network_2008_final', 4, 6, 0, 4832.03, -1036.52, 5816.91, 4879.71, -992.062, 5737.18, 0, 0, 0, NULL), ('surf_network_2009_njv', 0, 2, 1, -8943.97, 8246.16, -10626, -8080.03, 8559.98, -10524, 0, 0, 0, NULL), ('surf_network_2009_njv', 1, 1, 1, -137.798, 31.2764, -5.79702, 126.476, -252.176, 108.031, 0, 0, 0, NULL), ('surf_network_2013', 0, 2, 1, 1007.97, -12688, 3582.03, -1007.97, -14704, 3684.03, 0, 0, 0, NULL), ('surf_network_2013', 1, 1, 1, 1008, -261.372, 510.031, 640.608, -1007.97, 612.031, 0, 0, 0, NULL), ('surf_network_2013', 2, 1, 1, -1023.97, -276.246, 590.224, -652.173, -1023.97, 521.336, 0, 0, 0, NULL), ('surf_network_2013', 3, 4, 0, -475.492, 10208, 1222.57, 479.969, 9249.69, 798.383, 0, 0, 0, NULL), ('surf_network_2013', 4, 4, 1, 959.969, -1057.36, 7757.57, -959.969, -8.96512, 7171.51, 0, 0, 0, NULL), ('surf_network_2013', 5, 4, 2, 767.969, -3338.54, 1279.13, -759.594, -4052.68, -511.969, 0, 0, 0, NULL), ('surf_network_2013', 6, 4, 3, -959.893, 6842.49, 1215.97, 954.891, 7211.5, 64.0312, 0, 0, 0, NULL), ('surf_network_2013', 7, 4, 4, 2045.92, 7168.09, -5122.03, -1038.03, 8185.6, -6129.92, 0, 0, 0, NULL), ('surf_network_2013', 8, 4, 5, -511.969, -5713.55, -7424.9, 511.969, -5068.66, -8190.31, 0, 0, 0, NULL), ('surf_newb_hazard_r1', 3, 6, 0, -9537.97, -561.751, 9214.64, -13897.2, -2615.66, -9455.97, 0, 0, 0, ''), ('surf_newb_hazard_r1', 0, 1, 0, -7380.31, -431.969, 14501, -7908.54, 431.969, 14603, 0, 0, 0, ''), ('surf_newb_hazard_r1', 1, 2, 0, -1557.11, -3676.94, 327.82, -862.428, -3698.04, 938.578, 0, 0, 0, ''), ('surf_new_001_001', 0, 1, 1, 592.031, 495.969, 64.0312, 867.333, 2.03125, 164.031, 0, 0, 0, NULL), ('surf_new_001_001', 1, 1, 2, 431.997, 495.969, 64.0312, 155.577, 3.03125, 164.031, 0, 0, 0, NULL), ('surf_new_001_001', 2, 2, 1, -1265.61, 831.986, -7615.97, -1762, -701.969, -7468.97, 0, 0, 0, NULL), ('surf_misc', 2, 2, 1, 9007.15, 12686.2, 5388.03, 8401.95, 11950, 5490.03, 0, 0, 0, NULL), ('surf_misc', 1, 2, 0, 8517.4, 12711.3, 5388.03, 8903.45, 12772.2, 5490.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_misc', 0, 1, 0, -4450.4, 248.334, -1627.97, -5187.49, 787.743, -1525.97, 0, 0, 0, NULL), ('surf_minecraft', 11, 2, 0, 9947.53, -13109.3, 13905.2, 10578, -13267, 14365.3, 0, 0, 2, 'BONUS 2'), ('surf_minecraft', 10, 5, 0, 10462.9, -14003, 14157.4, 10061.6, -14436.2, 14132.2, 0, 0, 2, 'BONUS 2'), ('surf_minecraft', 9, 2, 3, 4444.38, -11730, 1981.31, 4194.91, -15186, 2554.61, 0, 0, 1, 'BONUS 1'), ('surf_minecraft', 8, 2, 2, 7769.38, -11986.4, 1977.03, 4186.03, -11735, 2387.94, 0, 0, 1, 'BONUS 1'), ('surf_minecraft', 7, 2, 1, 7511.97, -15182.1, 1977.03, 7765.49, -11730, 2422.56, 0, 0, 1, 'BONUS 1'), ('surf_minecraft', 6, 2, 0, 4186.03, -14929.9, 1982.47, 7769.69, -15186, 2354.04, 0, 0, 1, 'BONUS 1'), ('surf_minecraft', 5, 5, 0, 5893.41, -13331.7, 13515, 6120.61, -13592.5, 13599, 0, 0, 1, 'BONUS 1'), ('surf_ninja_go_b5', 0, 3, 0, 820.346, -3189.95, 526.031, 1050.85, -3370.43, 628.031, 0, 0, 0, NULL), ('surf_ninja_go_b5', 1, 2, 1, 3777.38, 3297.89, -3903.97, 2695.96, 3913.81, -3803.97, 0, 0, 0, NULL), ('surf_ninja_go_b5', 2, 1, 1, -3248, -3727.97, 3750.03, -2695.68, -3076.05, 3852.03, 0, 0, 0, NULL), ('surf_ninja_r4', 0, 3, 3, 817.837, -1859.61, 1030.03, 1063.1, -1619.18, 2054.33, 0, 0, 0, NULL), ('surf_ninja_r4', 1, 3, 1, -1195.24, -3083.56, 1406.03, -1880.01, -3699.24, 1690.42, 0, 0, 0, NULL), ('surf_ninja_r4', 2, 3, 0, -2534.98, -3555.65, -423.002, -3007.41, -3770.66, 935.591, 0, 0, 0, NULL), ('surf_ninja_r4', 3, 1, 1, -3327.44, -3276.46, 3750.03, -2634.12, -3079.34, 3852.03, 0, 0, 0, NULL), ('surf_ninja_r4', 4, 2, 1, 2709.32, 3304.79, -3905.97, 3775.79, 3909.14, -3803.97, 0, 0, 0, NULL), ('surf_ninja_r4', 5, 3, 2, 825.27, -3365.17, 526.031, 1042.65, -3195.38, 787.387, 0, 0, 0, NULL), ('surf_not_so_sinister', 0, 3, 3, 12368, 13966, -8577.97, 13872, 13472, -8475.97, 0, 0, 0, NULL), ('surf_not_so_sinister', 1, 3, 0, -4176.61, 8670.2, 7710.03, -5118.49, 9167.97, 7812.03, 0, 0, 0, NULL), ('surf_not_so_sinister', 2, 1, 0, -8707.31, 14813.5, 12382, -9655.93, 15312, 12484, 0, 0, 0, NULL), ('surf_not_so_sinister', 3, 3, 2, 7387.62, 13824.8, -1473.97, 6444.77, 14320, -1371.97, 0, 0, 0, NULL), ('surf_not_so_sinister', 4, 2, 0, 13904, -7028.79, -10210, 12336, -8031.97, -10108, 0, 0, 0, NULL), ('surf_not_so_sinister', 5, 3, 1, 1240.65, -2640.23, 4190.03, 302.731, -2144.03, 4292.03, 0, 0, 0, NULL), ('surf_ny_advance_nsf_v2', 0, 3, 6, 6092.92, 3600.03, 6952.18, 5797.88, 3979.79, 6928.03, 0, 0, 0, NULL), ('surf_ny_advance_nsf_v2', 1, 3, 5, 4794.38, -2522.91, 6926.03, 4525.82, -2325.7, 7028.03, 0, 0, 0, NULL), ('surf_ny_advance_nsf_v2', 2, 3, 4, 2920.23, -10784, 1486.03, 3217.98, -10618.7, 1588.03, 0, 0, 0, NULL), ('surf_ny_advance_nsf_v2', 3, 3, 8, -3769.29, -735.969, 8382.03, -3488.32, -531.231, 8484.03, 0, 0, 0, NULL), ('surf_ny_advance_nsf_v2', 4, 3, 3, 4760.68, -10720, -1265.97, 4505.7, -10532.8, -1163.97, 0, 0, 0, NULL), ('surf_ny_advance_nsf_v2', 5, 3, 2, 3224.55, -479.969, 3342.03, 2980.77, -309.058, 3444.03, 0, 0, 0, NULL), ('surf_ny_advance_nsf_v2', 6, 3, 1, -1406.11, -479.969, -1809.97, -1192.25, -290.475, -1707.97, 0, 0, 0, NULL), ('surf_ny_advance_nsf_v2', 7, 3, 7, 6054.86, -11760, 9640.33, 5800.73, -11379, 9608.03, 0, 0, 0, NULL), ('surf_ny_advance_nsf_v2', 8, 1, 0, 127.903, -138.976, -161.969, -121.63, -495.969, -59.9688, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_ny_advance_nsf_v2', 9, 2, 0, -3709.88, -3090.08, -2485.8, -3460.55, -3002.84, -2739.97, 0, 0, 0, NULL), ('surf_ny_advance_nsf_v2', 10, 3, 0, 1213.44, -490.594, 1470.03, 943.739, -352.516, 1572.03, 0, 0, 0, NULL), ('surf_ny_advance_nsf_v2', 11, 6, 0, 452.08, -63.9688, 10079.6, 1471.26, 959.969, 9866.38, 0, 0, 0, NULL), ('surf_ny_momentum2_ksf', 0, 2, 1, 130.323, -10814, -5633.97, -124.5, -10405.9, -5531.97, 0, 0, 0, NULL), ('surf_ny_momentum2_ksf', 1, 1, 1, 1067.08, 4171.13, 2326.01, 1496.78, 6618.67, 2406.72, 0, 0, 0, NULL), ('surf_ny_momentum2_ksf', 2, 1, 2, -1498.01, 6615.58, 2304.05, -1065.55, 4169.6, 2427.97, 0, 0, 0, NULL), ('surf_ny_momentum2_ksf', 3, 2, 2, 64.4839, -10878.9, -5633.97, -69.638, -10813.7, -5531.97, 0, 0, 0, NULL), ('surf_ny_momentum2_ksf', 4, 2, 3, -351.969, -10256, -5633.97, 351.969, -9904.01, -5531.97, 0, 0, 0, NULL), ('surf_ny_momentum_v3_1', 0, 2, 1, 4160.03, -8399.31, -13986, 4415.99, -9341.58, -13884, 0, 0, 0, NULL), ('surf_ny_momentum_v3_1', 1, 1, 1, 744.137, -763.146, 38.0945, 48.0312, 768.339, 132.031, 0, 0, 0, NULL), ('surf_ny_platinum', 0, 2, 1, -8725.12, -15488, -1893.33, -8451.57, -15361.9, -2079.97, 0, 0, 0, NULL), ('surf_ny_platinum', 1, 3, 3, -2039.75, -3060.55, 3390.03, -1472.92, -2568.7, 3492.03, 0, 0, 0, NULL), ('surf_ny_platinum', 2, 3, 4, -8631.97, -2047.41, 1086.03, -8488.03, -2241.8, 1180.03, 0, 0, 0, NULL), ('surf_ny_platinum', 3, 3, 0, 4415.49, -991.999, -1473.97, 4831.97, -32.0312, -1371.97, 0, 0, 0, NULL), ('surf_ny_platinum', 4, 1, 1, -111.728, -126.474, 254.031, -479.987, -894.223, 356.031, 0, 0, 0, NULL), ('surf_ny_platinum', 5, 3, 1, 493.226, -359.408, -4145.97, 715.107, -661.999, -4043.97, 0, 0, 0, NULL), ('surf_ny_platinum', 6, 3, 2, 2671.97, 6908.03, 9326.03, 2448.01, 7107.97, 9428.03, 0, 0, 0, NULL), ('surf_ny_platinum', 7, 2, 0, 8036.87, -4422.82, -14095.5, 7928.73, -4529.66, -13996.5, 0, 0, 1, NULL), ('surf_ny_platinum', 8, 1, 0, 7419.35, -3913.35, -6428.97, 7810.77, -3714.83, -6328.97, 0, 0, 1, NULL), ('surf_ny_superhappiest_b3', 0, 2, 0, 1755.74, 6124.37, -6931.13, 1288.09, 6089.53, -6505.07, 0, 0, 0, NULL), ('surf_ny_superhappiest_b3', 1, 1, 0, 154.201, -4212.49, -373.982, -324.556, -4562.31, -305.496, 0, 0, 0, NULL), ('surf_ny_superhappiest_b3', 2, 3, 0, 1407.06, -3585.02, -3201.97, 1661.12, -3813.71, -3099.97, 0, 0, 0, NULL), ('surf_ny_superhappiest_b3', 3, 6, 2, 1032.03, 2038.41, -12.3206, 2039.97, 1038.01, -528.244, 0, 0, 0, NULL), ('surf_n_bhop_beta1', 0, 1, 1, -70.9341, -1552, 10750, -312.779, -2544, 10852, 0, 0, 0, NULL), ('surf_n_bhop_beta1', 1, 2, 1, 3984.03, -3375.97, -16066, 6383.97, -976.031, -15964, 0, 0, 0, NULL), ('surf_n_bhop_beta1', 2, 0, 1, -575.969, -1860.74, 10933, -430.008, -1629.49, 10752, 0, 0, 0, NULL), ('surf_odyssey_', 0, 1, 1, -1514.03, -6371.88, 7749.03, -1583.97, -6312.69, 7856.03, 0, 0, 0, NULL), ('surf_odyssey_', 1, 2, 1, -3963.74, -7333.77, -7852.97, -3541.42, -6925.82, -7750.97, 0, 0, 0, NULL), ('surf_olympics_sns', 0, 3, 1, -5383.78, -10059.2, 4358.03, -4914.33, -9654.15, 4390.86, 0, 0, 0, NULL), ('surf_olympics_sns', 1, 3, 0, -9111.53, -10168.2, 5376.43, -8457.52, -9527.11, 5421.66, 0, 0, 0, NULL), ('surf_olympics_sns', 2, 3, 3, 5856.83, -13090.9, 5118.03, 6392.31, -12664.1, 5215, 0, 0, 0, NULL), ('surf_olympics_sns', 3, 3, 4, 9262.1, -13249.1, 4102.73, 10181.2, -12767.7, 4122.73, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_olympics_sns', 4, 3, 2, 241.814, -11041.6, 5134.03, 790.768, -10600.1, 5207.24, 0, 0, 0, NULL), ('surf_olympics_sns', 5, 1, 0, -12320.9, -10242.6, 6010.03, -13278.2, -9598.63, 6114.12, 0, 0, 0, NULL), ('surf_olympics_sns', 6, 2, 0, 87.4299, 10389.9, 6126.03, -804.082, 10683.3, 6231.03, 0, 0, 0, NULL), ('surf_olympics_sns', 7, 3, 5, 12843.1, -13303.4, 6012.03, 13483.7, -12797.8, 6027.03, 0, 0, 0, NULL), ('surf_oma', 0, 3, 1, -5665.07, -6119.82, 11066.5, -5288.02, -5892.77, 11168.5, 0, 0, 0, NULL), ('surf_oma', 1, 2, 1, 1035.21, 9254.9, 1594.64, 491.285, 10002.6, 1696.64, 0, 0, 0, NULL), ('surf_oma', 2, 1, 1, -3381.18, -3521.54, -6517.47, -3130.8, -2944.58, -6415.47, 0, 0, 0, NULL), ('surf_oma', 3, 3, 0, -262.063, -11125.8, 6954.53, -18.8149, -11374.5, 7056.53, 0, 0, 0, NULL), ('surf_omnibus_sns', 0, 3, 3, 6720.8, -3899.43, -737.969, 6416, -4229.16, -635.969, 0, 0, 0, NULL), ('surf_omnibus_sns', 1, 3, 4, -4585.73, -1263.97, -3041.97, -4791.77, -972.971, -2939.97, 0, 0, 0, NULL), ('surf_omnibus_sns', 2, 3, 1, -904.317, 191.969, -649.307, -762.973, -191.969, -700.87, 0, 0, 0, NULL), ('surf_omnibus_sns', 3, 2, 0, -4559.97, -624.016, -9697.97, -4525.08, -349.826, -9450.8, 0, 0, 0, NULL), ('surf_omnibus_sns', 4, 3, 5, 3186.64, 303.998, -2369.97, 2832.03, 15.1069, -2267.97, 0, 0, 0, NULL), ('surf_omnibus_sns', 5, 2, 1, -4559.97, -983.447, -9697.97, -4071.33, 26.3104, -9664.3, 0, 0, 0, NULL), ('surf_omnibus_sns', 6, 3, 9, -4559.97, -1371.13, -7009.97, -3942.24, 407.37, -6907.97, 0, 0, 0, NULL), ('surf_omnibus_sns', 7, 3, 2, 2128, 165.656, 670.031, 2524.84, -167.638, 826.444, 0, 0, 0, NULL), ('surf_omnibus_sns', 8, 3, 6, -1511.66, -943.969, 5662.03, -1999.97, 47.9688, 5764.03, 0, 0, 0, NULL), ('surf_omnibus_sns', 9, 1, 0, -5678.62, -368.01, 1278.03, -6085.45, -672.871, 1380.01, 0, 0, 0, NULL), ('surf_omnibus_sns', 10, 3, 0, -1552.03, -560.031, 1950.03, -1999.97, -1379.59, 2069.94, 0, 0, 0, NULL), ('surf_omnibus_sns', 11, 3, 8, -9763.31, -517.9, -1795.97, -9983.99, -1019.63, -1693.97, 0, 0, 0, NULL), ('surf_omnibus_sns', 12, 3, 7, -14110, -816.957, 5584.99, -13541.2, -184.031, 5540.82, 0, 0, 0, NULL), ('surf_oompa_loompa', 0, 2, 1, -7042.03, 2009.97, -14327, -7399.87, -1537.97, -14225, 0, 0, 0, NULL), ('surf_oompa_loompa', 1, 1, 1, -297.816, -2583.97, 16194.3, 390.637, -2094.1, 16262.2, 0, 0, 0, NULL), ('surf_orangewood', 0, 1, 1, -144.031, 2663.99, 1752.03, -1007.97, 2389.3, 1852.03, 0, 0, 0, NULL), ('surf_orangewood', 1, 3, 0, 621.198, 2608, 2252.03, 470.847, 2403.3, 2352.03, 0, 0, 0, NULL), ('surf_orangewood', 2, 3, 1, 1957.32, 2639.97, 5216.03, 2646.44, 1424.03, 5316.03, 0, 0, 0, NULL), ('surf_orangewood', 3, 3, 2, -3111.35, 5326.68, 5760.03, -3302.7, 3857.12, 5860.03, 0, 0, 0, NULL), ('surf_orangewood', 4, 1, 2, -378.512, 2382.84, 1752.03, -781.548, 2033.89, 1852.03, 0, 0, 0, NULL), ('surf_orangewood', 5, 2, 1, -494.006, 2097.9, 2172.03, -541.668, 2047.33, 2214.03, 0, 0, 0, NULL), ('surf_orbion_x', 0, 3, 1, 1615.42, 10157.6, -1461.97, 1279.48, 9953.92, -1359.97, 0, 0, 0, NULL), ('surf_orbion_x', 1, 3, 0, -2841.28, -824.001, 2430.03, -2649.67, -1031.97, 2532.03, 0, 0, 0, NULL), ('surf_orbion_x', 2, 5, 0, -1646.28, -6569.94, -3025.97, -1178.33, -6802, -2923.97, 0, 0, 0, NULL), ('surf_orbion_x', 3, 3, 2, 9344.6, 406.186, -9155.97, 9602.01, 606.368, -9053.96, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_orbion_x', 4, 3, 3, 5665.68, -7598.32, -3249.97, 5902.97, -7769.95, -3147.97, 0, 0, 0, NULL), ('surf_orbion_x', 5, 3, 4, 7520.2, -4172.66, 10398, 6637.09, -3424.38, 10500, 0, 0, 0, NULL), ('surf_orbion_x', 6, 2, 0, -6028.67, -3679.71, 5895.77, -6373.59, -3931.5, 5602.55, 0, 0, 0, NULL), ('surf_overgrowth', 0, 3, 3, 12223.8, 7020.78, 15486, 11656.7, 6672.03, 15604, 0, 0, 0, NULL), ('surf_overgrowth', 1, 3, 2, -13297.1, -14071, 13822, -12427.9, -13680, 13924, 0, 0, 0, NULL), ('surf_overgrowth', 2, 2, 0, 9896.41, 14345.6, -11138, 14014.6, 15856, -11036, 0, 0, 0, NULL), ('surf_overgrowth', 3, 2, 1, 11429.3, 13829.8, -11138, 12425.9, 14343.9, -11036, 0, 0, 0, NULL), ('surf_overgrowth', 4, 1, 0, 6959.97, -14160, 15508, 6153.16, -12735.5, 15370.6, 0, 0, 0, NULL), ('surf_overgrowth', 5, 3, 0, 3113.29, 11532.6, 15582, 3792.4, 11192, 15684, 0, 0, 0, NULL), ('surf_overgrowth', 6, 3, 1, 5811.07, -259.617, -2209.97, 6139.67, 441.312, -2110.1, 0, 0, 0, NULL), ('surf_overgrowth', 7, 1, 0, -5344.52, -6399.46, -3535.97, -6113.32, -5632.56, -3096.16, 0, 0, 1, NULL), ('surf_overgrowth', 8, 2, 0, -5570.53, -6154.49, -8483.04, -5877.98, -5870.03, -7787.76, 0, 0, 1, NULL), ('surf_overgrowth2', 0, 1, 1, 892.23, 891.448, 14948, 583.187, 584.928, 14848, 0, 0, 0, NULL), ('surf_overgrowth2', 1, 2, 1, 3827.43, 9531.28, -13056, 4737.03, 10850.8, -12932, 0, 0, 0, NULL), ('surf_overgrowth2', 2, 1, 2, 1727.15, 1727.04, 15008, 583.196, 583.777, 14848, 0, 0, 0, NULL), ('surf_overgrowth2', 3, 3, 1, -584.516, -1711.97, 14846, -1711.97, -579.163, 14948, 0, 0, 0, NULL), ('surf_overgrowth2', 4, 3, 3, 253.694, -2166.15, 13822, -266.69, -1861.45, 13924, 0, 0, 0, NULL), ('surf_overgrowth2', 5, 3, 2, -880.534, 914.292, 14590, -592.031, 1427.91, 14692, 0, 0, 0, NULL), ('surf_overgrowth2', 6, 3, 0, 592.001, -592.031, 14590, 895.518, -895.539, 14692, 0, 0, 0, NULL), ('surf_palette_v2', 0, 2, 0, -1086.76, 4701.48, 163.599, -866.889, 4858.08, 205.599, 0, 0, 0, NULL), ('surf_palette_v2', 1, 3, 0, -11425, 5448.82, 344.031, -11656, 5623.75, 444.031, 0, 0, 0, NULL), ('surf_palette_v2', 2, 1, 0, -13686.6, 6303.97, 442.031, -14003, 6140.77, 540.031, 0, 0, 0, NULL), ('surf_palette_v2', 3, 3, 3, -6463.44, -264.006, 2304.03, -6829.12, -475.908, 2404.03, 0, 0, 0, NULL), ('surf_palette_v2', 4, 3, 4, -11011.8, 693.787, 1874.03, -11182.4, 571.284, 1974.03, 0, 0, 0, NULL), ('surf_palette_v2', 5, 3, 5, -2993.79, 7131.12, 1304.03, -3155.31, 6922.21, 1404.03, 0, 0, 0, NULL), ('surf_palette_v2', 6, 3, 7, -1048.45, 6855.58, 2208.03, -896.115, 6738.88, 2308.03, 0, 0, 0, NULL), ('surf_palette_v2', 7, 3, 2, -8459.81, 1135.97, 1608.03, -8269.88, 1040.03, 1708.03, 0, 0, 0, NULL), ('surf_palette_v2', 8, 3, 1, -6285.23, 2436.64, 2288.03, -5951.27, 2264.03, 2388.03, 0, 0, 0, NULL), ('surf_palette_v2', 9, 3, 6, -14137.8, 1600.66, 3650.03, -13890.8, 1413.87, 3750.03, 0, 0, 0, NULL), ('surf_palette_v2', 10, 0, 0, -12541.2, 6503.97, 398.894, -12461, 6567.97, 244.373, 0, 0, 0, NULL), ('surf_pandemonium', 0, 1, 0, 9257.2, -9237.93, -8879.97, 9632.54, -8856.07, -8777.97, 0, 0, 0, NULL), ('surf_pandemonium', 1, 3, 0, 3869.65, 941.579, 3475.03, 4728.14, 81.772, 3442.03, 0, 0, 0, NULL), ('surf_pandemonium', 2, 3, 1, 512.128, -1410.19, 1376.03, -513.608, -2015.97, 1415.86, 0, 0, 0, NULL), ('surf_pandemonium', 3, 3, 2, 7948.33, -4524.03, 3619.59, 8934.27, -5547.97, 3683.43, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_pandemonium', 4, 3, 3, -3902.77, -13525.2, 2282.03, -4435.38, -12727, 2282.03, 0, 0, 0, NULL), ('surf_pandemonium', 5, 2, 0, 8588.69, -13548, 159.083, 9441.6, -12660.5, -37.9688, 0, 0, 0, NULL), ('surf_pandemonium', 6, 1, 0, -13264.5, -8826.38, 12480, -12825.1, -8381.59, 12192, 0, 0, 1, NULL), ('surf_pandemonium', 7, 2, 0, -13265, -7058.93, 9439.97, -13852, -7334.54, 8776.99, 0, 0, 1, NULL), ('surf_pandemonium', 8, 2, 0, -11498, -9383.75, 9439.97, -11780, -8818.58, 8778.17, 0, 0, 1, NULL), ('surf_pandemonium_njv', 0, 3, 0, 4700.46, 112.04, 3440.03, 3887.91, 917.85, 3542.03, 0, 0, 0, NULL), ('surf_pandemonium_njv', 1, 3, 2, 7928.26, -5467.54, 3550.03, 8865.66, -4593.41, 3662.62, 0, 0, 0, NULL), ('surf_pandemonium_njv', 2, 2, 1, -9902.63, -13259, -2085.97, -9748.15, -12835.6, -1381.47, 0, 0, 0, NULL), ('surf_pandemonium_njv', 3, 3, 3, -3726.27, -12834.9, 2264.03, -4479.57, -13322.9, 2366.03, 0, 0, 0, NULL), ('surf_pandemonium_njv', 4, 1, 1, 9256.55, -9232.94, -8879.97, 9626.52, -8861.66, -8777.97, 0, 0, 0, NULL), ('surf_pandemonium_njv', 5, 3, 1, -567.75, -1422.08, 1374.03, 571.991, -2000, 1476.03, 0, 0, 0, NULL), ('surf_parc_colore', 0, 3, 4, 80.0312, 3311.99, 1184.03, 203.153, 3241.69, 1300.03, 0, 0, 0, NULL), ('surf_parc_colore', 1, 1, 1, -1794.66, -6781.15, -2015.97, -2031.4, -6542.25, -1915.97, 0, 0, 0, NULL), ('surf_parc_colore', 2, 3, 3, -1371.86, 3811.82, 1072.03, -1048.48, 3621.41, 1172.03, 0, 0, 0, NULL), ('surf_parc_colore', 3, 2, 1, -512.27, -514.076, -399.969, -286.816, -291.86, -299.969, 0, 0, 0, NULL), ('surf_parc_colore', 4, 3, 2, 944.515, -2131.27, 1024.03, 777.192, -2478.15, 1124.03, 0, 0, 0, NULL), ('surf_parc_colore', 5, 3, 1, 2715.8, -771.028, 1392.03, 2468.37, -978.935, 1492.03, 0, 0, 0, NULL), ('surf_parc_colore', 6, 3, 0, 2305.08, 1968.03, 1808.03, 2791.97, 2447.97, 1908.03, 0, 0, 0, NULL), ('surf_paroxysm_njv', 0, 1, 1, 350.465, 158.381, 64.0312, -223.641, -415.513, 164.031, 0, 0, 0, NULL), ('surf_parrot_selector', 0, 1, 0, 6642.95, -503.279, 4798.03, 5633.33, 506.769, 4900.03, 0, 0, 0, NULL), ('surf_parrot_selector', 1, 2, 0, -9989.27, 1263.97, -15810, -12766.7, -1263.97, -15964, 0, 0, 0, NULL), ('surf_parrot_selector', 2, 4, 0, -5628, 511.969, 1533.91, -4685.38, -511.969, 1513.51, 0, 0, 0, NULL), ('surf_parrot_selector', 3, 4, 1, -3198.15, -353.807, -1448.62, -2457.4, 377.353, -2007.71, 0, 0, 0, NULL), ('surf_parrot_selector', 4, 4, 2, 302.385, -1096.08, -2656.03, 1545.2, 1535.97, -4446.3, 0, 0, 0, NULL), ('surf_parrot_selector', 5, 4, 3, -11264, -486.069, -7974.3, -9430.6, 375.2, -8229.87, 0, 0, 0, NULL), ('surf_parrot_selector', 6, 4, 4, 497.042, -789.998, -12602.2, -1023.97, 1252.68, -14320.9, 0, 0, 0, NULL), ('surf_pavilion_rg', 0, 3, 3, 5042.77, -2359.39, -8522.97, 4713.27, -2230.9, -8422.97, 0, 0, 0, NULL), ('surf_pavilion_rg', 1, 2, 1, 6252.15, -2152.35, -15870.5, 6156.94, -2078.82, -15770.5, 0, 0, 0, NULL), ('surf_pavilion_rg', 2, 3, 1, -10511, 3076.02, -1424.97, -10395.5, 3341.93, -1324.97, 0, 0, 0, NULL), ('surf_pavilion_rg', 3, 3, 0, -7902.97, 801.031, 9573.03, -7859.89, 872.99, 9679.03, 0, 0, 0, NULL), ('surf_pavilion_rg', 4, 1, 1, -7311.08, -1724.09, 14113, -7482.06, -2678.24, 14213, 0, 0, 0, NULL), ('surf_pavilion_rg', 5, 3, 2, -5790.76, 8838.94, -6691.97, -5625.76, 8962.28, -6591.97, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_perforated_restored', 0, 3, 1, 1920.31, 1381.18, 12222, 2267.98, 2121.52, 12324, 0, 0, 0, NULL), ('surf_perforated_restored', 1, 3, 3, 2105.66, 11117, 6068.9, 1677.67, 10299.5, 6319.49, 0, 0, 0, NULL), ('surf_perforated_restored', 2, 2, 1, 12425.8, 11155, 1368.03, 12064, 10280.4, 1468.03, 0, 0, 0, NULL), ('surf_perforated_restored', 3, 3, 2, -2123.9, -5260.94, 5295.57, -1691.14, -5698.23, 5401.47, 0, 0, 0, NULL), ('surf_perforated_restored', 4, 1, 1, -3194.04, 4992.03, -2225.97, -2560, 5279.97, -2123.97, 0, 0, 0, NULL), ('surf_perforated_restored', 5, 3, 0, -3175.03, 9686.24, 1424.03, -2994.92, 9851.57, 1526.03, 0, 0, 0, NULL), ('surf_pinkbash', 0, 3, 1, -133.737, 1335.81, 126.031, -432, 703.366, 228.031, 0, 0, 0, NULL), ('surf_pinkbash', 1, 3, 2, -431.996, 311.112, 126.031, -134.019, -317.583, 228.031, 0, 0, 0, NULL), ('surf_pinkbash', 2, 3, 0, -431.999, 2359.98, 126.031, -170.198, 1727.56, 228.031, 0, 0, 0, NULL), ('surf_pinkbash', 3, 2, 0, -431.997, 431.969, -961.969, -355.456, -431.969, -859.969, 0, 0, 0, NULL), ('surf_pinkbash', 4, 1, 0, -129.959, 3389.38, 126.031, -431.97, 2756.66, 228.031, 0, 0, 0, NULL), ('surf_pinkbash', 5, 2, 1, -144.031, -431.969, -961.969, -278.364, 431.969, -859.969, 0, 0, 0, NULL), ('surf_pinky', 0, 1, 1, 460.052, 480.184, 215.165, 278.031, 119.217, 315.165, 0, 0, 0, NULL), ('surf_pinky', 1, 3, 3, -1645.58, 5679.29, -2478.61, -1245.37, 6556.44, -2378.61, 0, 0, 0, NULL), ('surf_pinky', 2, 3, 1, 278.179, 2817.44, 465.031, 513.245, 3329.48, 565.031, 0, 0, 0, NULL), ('surf_pinky', 3, 2, 1, -2468.18, 5997.67, -10973.1, -2840.4, 6353.26, -10878.1, 0, 0, 0, NULL), ('surf_pinky', 4, 3, 2, 221.308, 5121.22, 396.927, 464.978, 5660.67, 496.927, 0, 0, 0, NULL), ('surf_pinky', 5, 3, 0, 264.001, 1303.6, 515.031, 503.887, 1802.51, 615.031, 0, 0, 0, NULL), ('surf_placid', 0, 2, 1, -2735.97, 5862.15, -10746, -912.031, 5088.03, -10580, 0, 0, 0, NULL), ('surf_placid', 1, 1, 1, -1594.38, -1471.97, 11650, -1154.16, 415.969, 11752, 0, 0, 0, NULL), ('surf_plaguelands_beta7a', 0, 3, 3, -1172.6, -9351.91, -4097.97, -778.165, -8999.73, -3987.97, 0, 0, 0, NULL), ('surf_plaguelands_beta7a', 1, 1, 1, 1312.01, 1445.21, -257.969, 1887.98, 1066.08, -155.969, 0, 0, 0, NULL), ('surf_plaguelands_beta7a', 2, 2, 1, 7295.22, 7820.75, -5249.97, 7035.47, 7185.95, -5147.97, 0, 0, 0, NULL), ('surf_plaguelands_beta7a', 3, 3, 0, 3808.03, 1456.81, -257.969, 4370.33, 952.441, -155.969, 0, 0, 0, NULL), ('surf_plaguelands_beta7a', 4, 3, 1, 4608.37, -9503.97, -6145.97, 4191.78, -8928.01, -6043.97, 0, 0, 0, NULL), ('surf_plaguelands_beta7a', 5, 3, 2, -3852.5, -2183.97, 3070.03, -4355.24, -1737.17, 3172.03, 0, 0, 0, NULL), ('surf_plaguelands_beta7a', 6, 3, 4, 7340.23, -46.8077, -1025.97, 6924.81, 225.856, -923.969, 0, 0, 0, NULL), ('surf_plethora_fix', 0, 2, 1, 9742.54, -4583.19, -14816, 6713.89, -1562.96, -14640.4, 0, 0, 0, NULL), ('surf_plethora_fix', 1, 1, 1, 852.678, -2968.23, 4260.03, 419.34, -3185.35, 4369.03, 0, 0, 0, NULL), ('surf_polygon', 0, 3, 0, 8313.04, -1927.79, 6142.03, 8061.02, -2177.18, 6244.03, 0, 0, 0, NULL), ('surf_polygon', 1, 3, 1, -7952.03, 14864, -609.969, -8431.97, 15344, -507.969, 0, 0, 0, NULL), ('surf_polygon', 2, 2, 0, 13296, 12801.9, 894.031, 12304, 13296, 996.031, 0, 0, 0, NULL), ('surf_polygon', 3, 3, 2, 12304, 12296.6, 638.031, 13296, 12784, 740.031, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_polygon', 4, 1, 0, 687.969, -7680.08, 638.031, -687.998, -7943.86, 740.031, 0, 0, 0, NULL), ('surf_porn_fix', 0, 1, 0, -8303.97, -7663.97, 13630, -8059.27, -6672, 13732, 0, 0, 0, NULL), ('surf_porn_fix', 1, 2, 0, -11113.4, -5163.57, 10560, -11322.4, -5375.97, 10268.4, 0, 0, 0, NULL), ('surf_porn_fix', 2, 4, 0, 3201.41, -8255.97, 12794.5, 3629.07, -6016.03, 11969.2, 0, 0, 0, NULL), ('surf_porn_fix', 3, 4, 1, 11776, -6013.45, 10366, 12352, -6483.89, 9601.55, 0, 0, 0, NULL), ('surf_porn_fix', 4, 4, 2, 3067, -6032.04, 2362.63, 3448.47, -8255.97, 3132.32, 0, 0, 0, NULL), ('surf_porn_fix', 5, 4, 3, 2750.68, 7487.97, -2816, 1928.84, 6764.72, -64.0312, 0, 0, 0, NULL), ('surf_porn_fix', 6, 4, 4, -6101.1, -3488.29, 14656, -4491.01, -5437.36, 12480, 0, 0, 0, NULL), ('surf_porn_fix', 7, 4, 5, -5676.68, 4144.62, 5759.97, -4648.58, 2496.03, 4125.89, 0, 0, 0, NULL), ('surf_portal_game4', 0, 2, 0, 3292.12, -724.578, -1297.28, 3165, -598.377, -1197.28, 0, 0, 0, NULL), ('surf_portal_game4', 1, 3, 2, -2829.97, -793.421, 2082.03, -2478.03, -917.794, 2176.03, 0, 0, 0, NULL), ('surf_portal_game4', 2, 1, 0, 2356.02, 626.391, 28.0312, 2927.97, 513.996, 128.031, 0, 0, 0, NULL), ('surf_portal_game4', 3, 3, 0, -3589.97, -2048.51, 20.0312, -3110.03, -2167, 120.031, 0, 0, 0, NULL), ('surf_portal_game4', 4, 3, 4, 2030.03, -783.092, -1008.97, 2253.97, -675.066, -908.969, 0, 0, 0, NULL), ('surf_portal_game4', 5, 3, 3, -3016.97, 2214.94, -1325.97, -2801.03, 1984.76, -1225.97, 0, 0, 0, NULL), ('surf_portal_game4', 6, 3, 1, 435.969, 577.934, -1211.97, 276.031, 481.996, -1111.97, 0, 0, 0, NULL), ('surf_pox', 0, 2, 1, -2212.97, -5570.97, -14727, -999.031, -4330.03, -14609, 0, 0, 0, NULL), ('surf_pox', 1, 1, 1, 2999.28, 4711.97, 1294.03, 2841.22, 4504.03, 1396.03, 0, 0, 0, NULL), ('surf_prelude_ksf', 0, 1, 1, -12032.6, 13040, 13086, -12322.3, 12540.9, 13188, 0, 0, 0, NULL), ('surf_prelude_ksf', 1, 2, 1, -1992.54, 425.649, -2816.03, -2010.48, 479.969, -2900.66, 0, 0, 0, NULL), ('surf_prelude_ksf', 2, 2, 2, 1065.71, -479.969, -4013.43, 2009.5, 479.969, -4439.8, 0, 0, 0, NULL), ('surf_prelude_ksf', 3, 4, 0, 12289, 4596.47, 9695.97, 15345.6, 2458.34, 6688.03, 0, 0, 0, NULL), ('surf_prelude_ksf', 4, 4, 1, -6143.97, -10277.8, 6899.3, -4352.03, -7962.7, 4231.46, 0, 0, 0, NULL), ('surf_prelude_ksf', 5, 4, 2, -11242, 4589.08, 5615.97, -7807.93, 2048.03, 363.591, 0, 0, 0, NULL), ('surf_prelude_ksf', 6, 4, 3, 5632.7, -4574.79, -2815.57, 2600.52, -2570.14, -5119.97, 0, 0, 0, NULL), ('surf_prelude_ksf', 7, 1, 0, 12033.1, -12544, 13437.7, 12149.8, -13046, 13088, 0, 0, 1, NULL), ('surf_prelude_ksf', 8, 2, 0, -2014.93, -479.969, -3999.18, -1074.66, 466.441, -4447.97, 0, 0, 1, NULL), ('surf_presmon_fix', 0, 3, 3, 588.291, 230.031, -4337.6, 1282.44, 545.471, -4447.06, 0, 0, 0, NULL), ('surf_presmon_fix', 1, 3, 4, 2309.03, 563.184, -766.142, 2764.49, 198.031, -801.616, 0, 0, 0, NULL), ('surf_presmon_fix', 2, 2, 1, 3393.32, 6565.97, -4775.76, 2245.03, 5358.68, -4834.57, 0, 0, 0, NULL), ('surf_presmon_fix', 3, 3, 0, -820.907, -5529.97, 864.531, -573.915, -5402.48, 832.031, 0, 0, 0, NULL), ('surf_presmon_fix', 4, 3, 1, -877.908, -249.969, -2066.33, -1125.32, 432.984, -2127.97, 0, 0, 0, NULL), ('surf_presmon_fix', 5, 5, 1, -3117.99, -141.969, 1286.68, -3640.83, -441.969, 1330.62, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_presmon_fix', 6, 3, 2, 776.426, -2169.97, -2004.55, 1476.97, -1912.98, -2047.48, 0, 0, 0, NULL), ('surf_primero', 0, 2, 1, -7519.97, -10592, -13186, -7631.99, -8848.03, -13100, 0, 0, 0, NULL), ('surf_primero', 1, 1, 1, 10768, -2445.54, 4862.03, 12272, -2927.97, 4964.03, 0, 0, 0, NULL), ('surf_primero', 2, 2, 2, -6273.19, -10592, -13186, -7519.97, -8736.03, -13084, 0, 0, 0, NULL), ('surf_minecraft', 4, 4, 2, 372.646, -5325.33, 3707.97, 701.927, -6712.26, 2812.03, 0, 0, 0, 'Start 0'), ('surf_minecraft', 3, 4, 1, -3460.95, -5314.03, 6257.86, -4083.78, -6719.52, 7131.97, 0, 0, 0, 'Start 0'), ('surf_minecraft', 2, 4, 0, 4772.03, -5319.5, 6743.28, 5891.97, -6683.71, 6545.05, 0, 0, 0, 'Start 0'), ('surf_minecraft', 1, 2, 1, 10833.1, -6733.29, 10844, 11896.6, -7866.64, 10944, 0, 0, 0, NULL), ('surf_minecraft', 0, 1, 1, 13699.5, -8656.35, 12070, 14211.2, -8531.39, 12172, 0, 0, 0, NULL), ('surf_metallic', 5, 3, 0, 6497.31, -2078.65, 270.031, 6296.03, -1928.01, 372.031, 0, 0, 0, NULL), ('surf_metallic', 4, 3, 3, -4026.53, 9517.51, 126.031, -4211.86, 9684.09, 228.031, 0, 0, 0, NULL), ('surf_metallic', 3, 1, 2, 3544.03, 136.148, 14.0312, 3642.68, 43.5939, 121.356, 0, 0, 0, NULL), ('surf_prime_time_r3vamp', 0, 5, 1, -13805.7, -10184.9, 13576.6, -13523.3, -10306.8, 13678, 0, 0, 0, NULL), ('surf_prime_time_r3vamp', 1, 2, 1, 3528.66, -11335.6, -4453.07, 3095.29, -11809.6, -4329.08, 0, 0, 0, NULL), ('surf_prime_time_r3vamp', 2, 2, 2, 8280.46, -11327.1, -4450.61, 7835.25, -11808.1, -4340.32, 0, 0, 0, NULL), ('surf_prime_time_r3vamp', 3, 5, 2, -7666.15, -10174.8, 13577.3, -7997.97, -10297.5, 13629.1, 0, 0, 0, NULL), ('surf_prolix', 0, 1, 0, 1167.97, 6246.86, 9640.17, -687.969, 6504.79, 9571.22, 0, 0, 0, NULL), ('surf_prolix', 1, 2, 0, 9191.06, 7898.74, -10462, 9680, 8606.34, -10360, 0, 0, 0, NULL), ('surf_prosaic_njv', 0, 1, 0, 1053, -4560.03, 190.031, 803.548, -5062.75, 298.582, 0, 0, 0, NULL), ('surf_prosaic_njv', 1, 3, 0, -10992, -5176.82, 158.031, -10707.1, -5656.29, 260.031, 0, 0, 0, NULL), ('surf_prosaic_njv', 2, 3, 1, -12144, -10147, 838.031, -11852, -10390.5, 940.031, 0, 0, 0, NULL), ('surf_prosaic_njv', 3, 2, 0, 7464.26, -5882.89, -2670.24, 7649.53, -5788.84, -2419.61, 0, 0, 0, NULL), ('surf_prosaic_njv', 4, 3, 2, -783.969, 5193.97, 1222.03, -610.906, 5415.97, 1324.03, 0, 0, 0, NULL), ('surf_prosaic_njv', 5, 3, 3, 7454.74, 2863.97, 1446.03, 7645.77, 2735.18, 1548.03, 0, 0, 0, NULL), ('surf_prosperity_v2', 0, 2, 1, -6906, 7864.03, -3443.97, -7193.94, 8151.97, -3341.97, 0, 0, 0, NULL), ('surf_prosperity_v2', 1, 3, 3, -9714.06, 10950, 2958.07, -10001.4, 10490, 3060.08, 0, 0, 0, NULL), ('surf_prosperity_v2', 2, 3, 2, 5770.4, 7596.05, 2763.53, 5104.38, 8281.13, 2865.53, 0, 0, 0, NULL), ('surf_prosperity_v2', 3, 3, 1, -5672.06, 10972, -1614.97, -5904.97, 10549.2, -1512.97, 0, 0, 0, NULL), ('surf_prosperity_v2', 4, 3, 0, 2224.03, 1856.24, -321.969, 2977.37, 1090.51, -219.969, 0, 0, 0, NULL), ('surf_prosperity_v2', 5, 1, 1, -7289.62, 3805.97, 1057.03, -7644.94, 3034.03, 1166.04, 0, 0, 0, NULL), ('surf_prosperity_v2', 6, 3, 4, -12874, 6696.97, 956.031, -12350.5, 4649.03, 1058.03, 0, 0, 0, NULL), ('surf_prosperity_v2', 7, 3, 5, 12784, 816.031, -1.96875, 13904, 1563.81, 100.031, 0, 0, 0, NULL), ('surf_proximity_final', 0, 1, 0, -1040, -367.811, 1022.03, -3055.63, -5.36322, 1124.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_proximity_final', 1, 3, 3, -2096, 324.466, 7422.03, -1998.73, 517.372, 7540.03, 0, 0, 0, NULL), ('surf_proximity_final', 2, 3, 2, 5561.29, 3551.97, 1022.03, 5088.03, 2592.03, 1124.03, 0, 0, 0, NULL), ('surf_proximity_final', 3, 2, 0, -1232.03, -2896.03, 9310.5, -2095.97, -3759.97, 9397.75, 0, 0, 0, NULL), ('surf_proximity_final', 4, 3, 4, 2797.22, 979.619, 191.031, 3078.92, 618.624, 223.031, 0, 0, 0, NULL), ('surf_proximity_final', 5, 3, 1, -1296.03, 6511.97, 6846.03, -1721.02, 5520.03, 7008.35, 0, 0, 0, NULL), ('surf_proximity_final', 6, 3, 0, -3424.03, 4446.75, 542.031, -3855.69, 5602.37, 644.031, 0, 0, 0, NULL), ('surf_psi', 0, 1, 1, -357.855, -410.031, 1171.03, -464.956, -532.988, 1266.72, 0, 0, 0, NULL), ('surf_psi', 1, 3, 1, 9959.94, 519.009, -12988, 10102, 708.055, -12886, 0, 0, 0, NULL), ('surf_psi', 2, 3, 0, 1727.99, -9182.71, -8917.51, 1133.03, -8875.03, -8815.75, 0, 0, 0, NULL), ('surf_psi', 3, 2, 0, 3290.53, 1742.97, -13119.7, 3429.61, 1639.91, -13283, 0, 0, 0, NULL), ('surf_psi', 4, 6, 0, 6629.03, -5015.28, -8461.57, 10206.9, -6144.81, -10250, 0, 0, 0, NULL), ('surf_psi_fixed', 0, 3, 1, 9958.95, 519.031, -12988, 10102, 733.242, -12886, 0, 0, 0, NULL), ('surf_psi_fixed', 1, 3, 0, 1727.97, -9181.22, -8917.51, 1133.03, -8875.03, -8815.75, 0, 0, 0, NULL), ('surf_psi_fixed', 2, 1, 1, -391.007, -225.496, 1171.07, -713.969, -694.861, 1266.72, 0, 0, 0, NULL), ('surf_psi_fixed', 3, 2, 1, 10191.9, -5815.03, -8888.97, 10133, -5720.86, -8713.17, 0, 0, 0, NULL), ('surf_psi_fixed', 4, 2, 2, 6645.03, -5706.97, -8890.97, 6710.17, -5821.26, -8743.39, 0, 0, 0, NULL), ('surf_psi_fixed', 5, 2, 3, 8295.97, -8064.97, -8792.97, 7991.03, -7760.03, -8690.97, 0, 0, 0, NULL), ('surf_psycho_njv', 0, 3, 2, -10336.4, -5550.88, 4427.48, -10564.1, -5965.06, 4529.48, 0, 0, 0, NULL), ('surf_psycho_njv', 1, 3, 0, -2017.48, -1104.19, 3128.53, -2738.99, -717.353, 3230.53, 0, 0, 0, NULL), ('surf_psycho_njv', 2, 3, 1, -11958.7, -6600.05, 7843.42, -11740.8, -6798.48, 7769.03, 0, 0, 0, NULL), ('surf_psycho_njv', 3, 3, 3, -10084.4, -4592.2, 2958.03, -10158, -4706.06, 3026.03, 0, 0, 0, NULL), ('surf_psycho_njv', 4, 2, 0, -3325.69, 642.969, 3833.03, -3480.09, 356.871, 3933.03, 0, 0, 0, NULL), ('surf_psycho_njv', 5, 1, 0, -399.922, -553.969, -319.969, -26.5198, 429.998, -217.969, 0, 0, 0, NULL), ('surf_psycho_njv', 6, 3, 4, -4725.19, -2010.97, 5849.92, -4972.53, -1442.3, 5785.03, 0, 0, 0, NULL), ('surf_pure_rg', 0, 3, 1, 3784.99, -1041.58, 1567.03, 4203.2, -686.07, 1667.03, 0, 0, 0, NULL), ('surf_pure_rg', 1, 3, 0, -3602.34, 3723.14, 3118.03, -3804.99, 3454.19, 3218.03, 0, 0, 0, NULL), ('surf_pure_rg', 2, 1, 1, -1.92713, 367.969, 1868.03, -265.086, 4.545, 1881.21, 0, 0, 0, NULL), ('surf_pure_rg', 3, 3, 2, 2370.81, 732.969, -6202.08, 2637.46, 660.565, -6102.08, 0, 0, 0, NULL), ('surf_pure_rg', 4, 3, 3, 7439.03, 939.348, 1609.56, 7523.17, 1106.24, 1731.62, 0, 0, 0, NULL), ('surf_pure_rg', 5, 3, 4, -3129.76, -64.8236, 3147.37, -2995.03, -184.336, 3247.37, 0, 0, 0, NULL), ('surf_pure_rg', 6, 2, 1, 9466.88, 2459.44, 1505.72, 9712.58, 2631.5, 1605.72, 0, 0, 0, NULL), ('surf_pure_rg', 7, 3, 5, 9344.14, 2857.39, 2913.72, 9843, 2908.02, 3013.72, 0, 0, 0, NULL), ('surf_purgatory', 0, 3, 2, 1585.03, 4976.67, 1911.03, 1765.19, 4770.72, 2009.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_purgatory', 1, 3, 0, -1381.71, -2196.1, -929.969, -1111.97, -2586.16, -827.969, 0, 0, 0, NULL), ('surf_purgatory', 2, 1, 1, -3171.63, -2826.24, 727.401, -2400.37, -2177.76, 829.401, 0, 0, 0, NULL), ('surf_purgatory', 3, 3, 4, 5683.03, 11376, 11009, 5853.39, 11153.4, 11167.1, 0, 0, 0, NULL), ('surf_purgatory', 4, 3, 1, -5756.89, -2751.97, -2349.97, -5312.89, -2432.48, -2247.97, 0, 0, 0, NULL), ('surf_purgatory', 5, 3, 3, -9143.86, -9601.49, 10718, -8627.5, -9846.17, 10820, 0, 0, 0, NULL), ('surf_purgatory', 6, 2, 1, 8592.03, 12240, 3115.03, 9602.16, 10288, 3217.03, 0, 0, 0, NULL), ('surf_pyrism_njv', 0, 2, 0, -9734.65, -5776.03, -289.969, -10224, -6511.97, -147.969, 0, 0, 0, NULL), ('surf_pyrism_njv', 1, 3, 0, -14417.3, -6455.5, 6798.03, -14007.9, -5796.82, 6900.03, 0, 0, 0, NULL), ('surf_pyrism_njv', 2, 5, 0, 3413.62, 121.702, 766.031, 3315.32, -110.636, 868.031, 0, 0, 0, NULL), ('surf_qlimax_q-', 0, 1, 1, 269.921, 957.994, -301.973, -257.009, 796.479, -219.969, 0, 0, 0, NULL), ('surf_qlimax_q-', 1, 3, 0, 2989.81, 1368.43, -2973.97, 3207.29, 1139.93, -2874.29, 0, 0, 0, NULL), ('surf_qlimax_q-', 2, 3, 3, 11472.6, 40.1152, -1711.47, 11671.5, -125.975, -1609.47, 0, 0, 0, NULL), ('surf_qlimax_q-', 3, 2, 1, 11724.4, 9120.02, -5147.47, 11458, 9631.69, -5026.47, 0, 0, 0, NULL), ('surf_qlimax_q-', 4, 3, 2, 8505.82, -607.969, -5949.53, 8238.43, -408.031, -5961.62, 0, 0, 0, NULL), ('surf_qlimax_q-', 5, 3, 1, 5977.17, 497.634, -1955.97, 5652.59, 184.665, -1969.97, 0, 0, 0, NULL), ('surf_qlimax_q-', 6, 3, 4, 342.512, -1944.03, -4346.97, 108.004, -2312.59, -4246.97, 0, 0, 0, NULL), ('surf_quantum_njv', 0, 2, 0, -1952.03, -1321.97, -12178, -4823.97, 585.969, -12076, 0, 0, 0, NULL), ('surf_quantum_njv', 1, 1, 0, -438.697, 136.248, 7028.29, 247.825, -279.988, 7122.03, 0, 0, 0, NULL), ('surf_quantum_njv', 2, 1, 1, -440.106, -459.81, 7020.03, 249.745, -879.187, 7137.22, 0, 0, 0, NULL), ('surf_quantum_njv', 3, 4, 0, -5061.78, 169.937, 5767.18, -5435.67, -785.879, 4921.52, 0, 0, 0, NULL), ('surf_quantum_njv', 4, 4, 1, -3313.35, 592.008, 4133.97, -3703.68, -1337.97, 3361.53, 0, 0, 0, NULL), ('surf_quantum_njv', 5, 4, 2, 2206.58, 10.139, -2833.03, 1725.89, -767.374, -4206.97, 0, 0, 0, NULL), ('surf_quantum_njv', 6, 4, 3, -7165.56, -1337.97, -4764.41, -7755.67, 601.969, -5621.14, 0, 0, 0, NULL), ('surf_quantum_njv', 7, 4, 4, -10817.7, -735.969, -7967.16, -10084, -2.54724, -8779.15, 0, 0, 0, NULL), ('surf_quartus_ksf', 0, 2, 0, -13577.8, -12272, -13186, -12144, -9744.03, -12588, 0, 0, 0, NULL), ('surf_quartus_ksf', 1, 1, 0, 855.365, 8144.02, 15134, -417.835, 7381.02, 15236, 0, 0, 0, NULL), ('surf_quartus_ksf', 2, 4, 0, -285.436, 16048, 11294.3, 788.692, 13552, 11159.8, 0, 0, 0, NULL), ('surf_quartus_ksf', 3, 4, 1, 1175.97, 5974.96, 6161.13, -689.726, 5072.03, 4968.04, 0, 0, 0, NULL), ('surf_quartus_ksf', 4, 4, 2, -1703.97, 5078.27, 9173.58, 2031.55, 5999.97, 8319.8, 0, 0, 0, NULL), ('surf_quartus_ksf', 5, 4, 3, 542.981, -2395.29, 5583.97, -245.675, -1557.86, 4736.03, 0, 0, 0, NULL), ('surf_quartus_ksf', 6, 4, 4, 1590.23, 690.753, -1024.03, -1215.97, -413.744, -2693, 0, 0, 0, NULL), ('surf_quartus_ksf', 7, 4, 5, 3586.71, -11878.8, -2304.03, 2624.03, -10163, -3665.31, 0, 0, 0, NULL), ('surf_quartus_ksf', 8, 4, 6, 6904.41, -11776, -6977.67, 6268.19, -10240, -7733.99, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_quartus_ksf', 9, 4, 7, -10863.1, -12245.4, -13264, -10375.6, -9767.95, -15744, 0, 0, 0, NULL), ('surf_quasar_final', 0, 3, 1, 2565.91, -6898.51, 420.191, 2404.04, -6761.41, 522.191, 0, 0, 0, NULL), ('surf_quasar_final', 1, 2, 1, 1355.03, -12596, -7320.97, 1849.72, -8856.8, -7002.38, 0, 0, 0, NULL), ('surf_quasar_final', 2, 3, 0, 4772.97, 3942.32, 6928.03, 4636.03, 4091.97, 7030.03, 0, 0, 0, NULL), ('surf_quasar_final', 3, 3, 2, 12820, -10570.2, 20.0312, 12570, -10822.7, 122.031, 0, 0, 0, NULL), ('surf_quasar_final', 4, 1, 1, -623.969, -128.429, -1.96875, 125.14, 452.912, 102.174, 0, 0, 0, NULL), ('surf_quasar_njv', 0, 6, 1, 5462.03, -4105.53, 4419.97, 6711.25, -2641.03, 4007.77, 0, 0, 0, NULL), ('surf_quasar_njv', 1, 1, 0, -639.969, 443.77, 86.8625, 127.969, -131.285, 6.95552, 0, 0, 0, NULL), ('surf_quasar_njv', 2, 3, 0, 4620.03, 3918.54, 6958.91, 4788.53, 4103.28, 6930.03, 0, 0, 0, NULL), ('surf_quasar_njv', 3, 3, 1, 3334.31, -6436.54, 481.096, 1677.2, -6729.18, 447.031, 0, 0, 0, NULL), ('surf_quasar_njv', 4, 3, 2, 12932.8, -10884.3, 60.0434, 12799.5, -10488.4, 22.0312, 0, 0, 0, NULL), ('surf_quattro', 0, 2, 1, -6917.77, -183.788, 4048.03, -7135.71, -1694.4, 4148.03, 0, 0, 0, NULL), ('surf_quattro', 1, 3, 2, -6203.05, -10740.6, 14237.1, -6339.09, -10572.7, 14337.1, 0, 0, 0, NULL), ('surf_quattro', 2, 1, 1, -637.069, -7547.96, -7967.97, -576.754, -7658.06, -7950.99, 0, 0, 0, NULL), ('surf_quattro', 3, 3, 0, 3905.08, -8392, -7323.35, 6308.12, -8164.15, -7218.36, 0, 0, 0, NULL), ('surf_quattro', 4, 3, 1, -348.89, 37.5254, 2023.22, -664.85, -902.958, 2119.14, 0, 0, 0, NULL), ('surf_quattro', 5, 2, 2, -5757.81, -1952.32, 4048.03, -6914.97, -182.425, 4148.03, 0, 0, 0, NULL), ('surf_quattro', 6, 2, 3, -5757.63, -189.71, 4048.03, -5604.16, -1865, 4148.03, 0, 0, 0, NULL), ('surf_quattro-', 0, 5, 0, -638.24, -7555.93, -7968.75, -519.672, -7995.31, -8031.97, 0, 0, 0, NULL), ('surf_quattro-', 1, 3, 0, 6329.74, -8399.66, -7269.32, 3878.48, -8173.33, -7321.36, 0, 0, 0, NULL), ('surf_quattro-', 2, 3, 1, -618.781, 271.969, 2343.33, -320.031, -1116.4, 2060.07, 0, 0, 0, NULL), ('surf_quattro-', 3, 3, 2, -6187.05, -10747.9, 14279.3, -6365.82, -10585.2, 14237.1, 0, 0, 0, NULL), ('surf_quattro-', 4, 2, 0, -6010.97, -1297.12, 4419.49, -6525.21, -746.502, 4127.12, 0, 0, 0, NULL), ('surf_quilavar-', 0, 1, 0, -600.456, 346.457, 6302.03, -1034.85, -347.613, 6404.03, 0, 0, 0, NULL), ('surf_quilavar-', 1, 2, 0, 5855.87, 14350.6, -15326, 5948.24, 14278.2, -15224, 0, 0, 0, NULL), ('surf_quilavar-', 2, 2, 1, 6031.97, 14792.4, -15326, 5286.7, 14350.5, -15171.1, 0, 0, 0, NULL), ('surf_quilavar-', 3, 2, 2, 5472.87, 14353.3, -15326, 5402.79, 14262.6, -15224, 0, 0, 0, NULL), ('surf_quilavar-', 4, 2, 3, 5857.72, 14220.3, -15326, 5470.24, 14356.2, -15224, 0, 0, 0, NULL), ('surf_quilavar-', 5, 4, 0, 6224.2, 383.969, 2357.87, 5269.46, -383.969, 1655.71, 0, 0, 0, NULL), ('surf_quilavar-', 6, 4, 1, 2438.8, 815.969, 830.891, 2600.61, -831.969, 65.0389, 0, 0, 0, NULL), ('surf_quilavar-', 7, 4, 2, 2025.51, -1728.47, -8592.03, 1250.57, 1839.97, -9749.25, 0, 0, 0, NULL), ('surf_quilavar-', 8, 4, 3, 5312.03, 2611.23, -11860.1, 5927.97, 2020.17, -12078.7, 0, 0, 0, NULL), ('surf_quilavar-', 9, 4, 4, 5951.97, 8458.2, -13553.5, 5312.03, 8826.88, -14128.4, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_ragequit_', 0, 2, 0, -1343.62, 7891.86, -5217.25, -1611.32, 9298.16, -4995.05, 0, 0, 0, NULL), ('surf_ragequit_', 1, 3, 1, 2776.33, -1081.31, -2406.97, 2144.69, -1655.51, -2304.97, 0, 0, 0, NULL), ('surf_ragequit_', 2, 3, 3, -1214.96, 761.031, -2685.97, -1555.71, 1031.7, -2583.97, 0, 0, 0, NULL), ('surf_ragequit_', 3, 3, 4, -2638.09, 8828.18, -2670.97, -2255.03, 8287.21, -2568.97, 0, 0, 0, NULL), ('surf_ragequit_', 4, 1, 0, -1600.64, -3451.43, -2067.97, -1231.15, -3676.97, -1965.97, 0, 0, 0, NULL), ('surf_ragequit_', 5, 3, 0, 8161.41, 7742.22, -1658.97, 9066.35, 7307.03, -1556.97, 0, 0, 0, NULL), ('surf_ragequit_', 6, 3, 2, -495.969, 495.146, 62.0312, 175.969, 208.031, 164.031, 0, 0, 0, NULL), ('surf_ragequit_', 7, 0, 0, 3020.03, -3188.52, -2790.92, 3497.87, -3663.97, -3107.81, 0, 0, 0, NULL), ('surf_rainbow', 0, 2, 0, -4479.48, -258.031, -15616, -4106.03, -766.969, -15516, 0, 0, 0, NULL), ('surf_rainbow', 1, 1, 0, -511.703, 7744.73, 12096, 511.166, 7280.03, 12196, 0, 0, 0, NULL), ('surf_rainbow', 2, 2, 1, 4479.1, -257.031, -15616, 4107.03, -766.969, -15516, 0, 0, 0, NULL), ('surf_rainbow', 3, 1, 0, -5944, -12862.6, 12304, -5464.03, -13104, 12404, 0, 0, 1, NULL), ('surf_rainbow', 4, 2, 0, -7795.97, -10494.9, 5248.03, -7184.03, -10128, 5348.03, 0, 0, 1, NULL), ('surf_rands_njv', 0, 5, 0, 58.8545, -16304, 16204.9, 1.19032, -15890, 16192, 0, 0, 0, NULL), ('surf_rands_njv', 1, 2, 1, -3840.03, 3288.03, -257.969, -4847.97, 3581.06, -155.969, 0, 0, 0, NULL), ('surf_rands_njv', 2, 0, 0, 1629.27, -15432, 16317.7, 1669.66, -15816, 16225, 0, 0, 0, NULL), ('surf_rands_njv', 3, 1, 0, -13735.5, 15312, 15455, -13384, 15107.9, 15404.4, 0, 0, 1, NULL), ('surf_rands_njv', 4, 2, 0, -12534.9, 575.031, 13090.6, -14576, 1024.71, 12951.9, 0, 0, 1, NULL), ('surf_rands_njv', 5, 4, 0, 726.733, -137.271, 15488, 1230.92, -895.969, 14996.8, 0, 0, 0, NULL), ('surf_rands_njv', 6, 4, 1, -211.2, -9241.17, 15238.3, 282.369, -8957.9, 14368, 0, 0, 0, NULL), ('surf_rands_njv', 7, 4, 2, -874.899, -12684.5, 13984, 803.325, -12284.1, 13531.1, 0, 0, 0, NULL), ('surf_rands_njv', 8, 4, 3, -577.727, -14448, 12499.6, 438.758, -13856, 11766.5, 0, 0, 0, NULL), ('surf_rands_njv', 9, 4, 4, 145.749, -14218.1, 11264, -487.216, -15600, 11036.4, 0, 0, 0, NULL), ('surf_rands_njv', 10, 4, 5, -5522.5, -8107.56, 7419.95, -5871.97, -8453.14, 6781.33, 0, 0, 0, NULL), ('surf_rands_njv', 11, 4, 6, -7992.14, -5184.03, 2862.96, -6283.96, -5826.27, 1968.03, 0, 0, 0, NULL), ('surf_rands_njv', 12, 4, 7, -10053.1, -4355.07, 2330.53, -11456, -3570.51, 1187.49, 0, 0, 0, NULL), ('surf_rands_njv', 13, 4, 8, 6015.97, -1381.21, -683.552, 5379.1, 217.117, -1747.44, 0, 0, 0, NULL), ('surf_rands_njv', 14, 4, 9, 2815.6, 133.07, -2704.03, 2400.03, -282.883, -3017.9, 0, 0, 0, NULL), ('surf_rands_njv', 15, 4, 10, 2687.97, 1851.44, -8048.07, 1280.03, 542.809, -8329.82, 0, 0, 0, NULL), ('surf_rands_njv', 16, 4, 11, 13376, 1878.44, -9888.29, 12878.6, 496.031, -10813.5, 0, 0, 0, NULL), ('surf_rands_njv', 17, 4, 12, 4108.64, 943.969, -10339, 3417.48, 496.031, -10795, 0, 0, 0, NULL), ('surf_rands_njv', 18, 4, 13, -6376.63, 518.571, -12032, -5104.33, 1573.75, -13184, 0, 0, 0, NULL), ('surf_rands_njv', 19, 4, 14, 10186, -1791.97, -13440.7, 9204.29, -1492.97, -13872.5, 0, 0, 0, NULL), ('surf_rands_njv', 20, 4, 15, 262.868, 3370.79, 15200, 737.38, 2767.28, 14149, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_rands_njv', 21, 4, 16, 2613.19, -2475.42, 12256, 5135.97, -3051.45, 11616.5, 0, 0, 0, NULL), ('surf_rands_njv', 22, 4, 17, 3473.68, 2127.16, 9071.97, 4249.69, 1577.36, 8448.03, 0, 0, 0, NULL), ('surf_rands_njv', 23, 4, 18, -151.484, -3487.73, 6431.97, 414.671, -3075.38, 5584.03, 0, 0, 0, NULL), ('surf_rands_njv', 24, 4, 19, -414.395, -1808.03, 4842.51, 773.504, -2671.97, 4656.45, 0, 0, 0, NULL), ('surf_rands_njv', 25, 4, 20, 741.051, -793.41, 4071.97, 234.974, -3711.97, 3472.88, 0, 0, 0, NULL), ('surf_rands_njv', 26, 4, 21, -3831.49, 14597.5, 311.969, -4856.26, 13904.4, -535.969, 0, 0, 0, NULL), ('surf_rapid', 0, 3, 2, -1907.19, -1734.97, 325.531, -1480.61, -1531.94, 411.51, 0, 0, 0, NULL), ('surf_rapid', 1, 3, 3, -5377.92, 4665.41, 1256.2, -5073.38, 4194.68, 1358.2, 0, 0, 0, NULL), ('surf_rapid', 2, 3, 1, 9753.79, 119.796, 2082.11, 11647.1, 514.078, 2185.01, 0, 0, 0, NULL), ('surf_rapid', 3, 3, 0, 8332.82, 6324.97, 1566.03, 8634.97, 4437.03, 1668.03, 0, 0, 0, NULL), ('surf_rapid', 4, 1, 1, 1331.61, 6639.97, 1374.03, 2347.72, 6512.03, 1476.03, 0, 0, 0, NULL), ('surf_rapid', 5, 2, 1, -5112.15, 7175.7, 751.855, -5327.04, 7327.36, 853.855, 0, 0, 0, NULL), ('surf_razer_final', 0, 2, 0, 528.031, -9081.21, -3135.97, 687.969, -9707.31, -3035.97, 0, 0, 0, NULL), ('surf_razer_final', 1, 1, 0, -1239.41, 2178.81, 126.031, -1010.74, 1526.66, 236.294, 0, 0, 0, NULL), ('surf_razer_final', 2, 3, 0, 1216.03, -6277.88, -1649.97, 1463.68, -6791.23, -1550.5, 0, 0, 0, NULL), ('surf_razer_final', 3, 3, 2, -1391.97, -9204.11, 1344.18, -897.068, -9581.96, 1444.18, 0, 0, 0, NULL), ('surf_razer_final', 4, 3, 1, 8400.88, -3327.79, 128.031, 8665.94, -3590, 228.031, 0, 0, 0, NULL), ('surf_rebel_resistance_njv', 0, 2, 1, -9223, 4280.84, -4616.97, -9093.03, 4859, -4514.97, 0, 0, 0, NULL), ('surf_rebel_resistance_njv', 1, 5, 1, -156.374, -14016.9, 14981, 111.807, -14862, 15081.8, 0, 0, 0, NULL), ('surf_rebel_scaz_njv', 0, 2, 1, -8382.97, 9449.97, -9820.97, -8244.31, 8861.03, -9718.97, 0, 0, 0, NULL), ('surf_rebel_scaz_njv', 1, 5, 1, 892.589, -9538.89, 9840.03, 708.351, -10368, 10008.1, 0, 0, 0, NULL), ('surf_redemption_b1', 0, 3, 2, -1948.97, -10801, 5533.53, -1262.34, -10998.9, 5637.53, 0, 0, 0, NULL), ('surf_redemption_b1', 1, 1, 1, -5316.05, -1160.1, -6025.97, -5532.95, -392.161, -5923.97, 0, 0, 0, NULL), ('surf_redemption_b1', 2, 3, 0, -8079.67, 11661, -5135.97, -7619.93, 11505.1, -5035.97, 0, 0, 0, NULL), ('surf_redemption_b1', 3, 3, 1, -10879, 3519.6, 8080.66, -9334.75, 5118.54, 8224.84, 0, 0, 0, NULL), ('surf_redemption_b1', 4, 2, 1, -824.031, -10436, -2214.47, -1571.51, -11347.6, -1726.77, 0, 0, 0, NULL), ('surf_refraxis', 0, 2, 1, 13824, 3770.83, -5569.97, 14688, 3536.03, -5467.97, 0, 0, 0, NULL), ('surf_refraxis', 1, 3, 6, 13763.3, -5243.35, -2241.97, 14752, -5499.42, -2139.97, 0, 0, 0, NULL), ('surf_refraxis', 2, 3, 4, 9024.84, -4179.27, -5089.97, 8763.7, -4367.97, -4987.97, 0, 0, 0, NULL), ('surf_refraxis', 3, 3, 3, 6737.15, -4384.89, -2273.97, 6959.99, -4651.64, -2171.97, 0, 0, 0, NULL), ('surf_refraxis', 4, 3, 1, 2896.23, -4844.61, 830.031, 3247.97, -5039.97, 932.031, 0, 0, 0, NULL), ('surf_refraxis', 5, 3, 2, 5308.2, -2165.31, -2817.97, 4925.55, -1936, -2715.97, 0, 0, 0, NULL), ('surf_refraxis', 6, 3, 0, 1404.99, -1312.94, 1676.43, 1647.32, -1519.97, 1780.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_refraxis', 7, 1, 1, -444.779, -1221.23, 1534.03, -64.7993, -1644.69, 1652.03, 0, 0, 0, NULL), ('surf_refraxis', 8, 3, 5, 11248, -1871.99, -3905.97, 10768, -1456, -3803.97, 0, 0, 0, NULL), ('surf_refraxis', 9, 1, 0, -4043.08, 104.399, -793.969, -3600.03, 650.302, -691.969, 0, 0, 1, NULL), ('surf_refraxis', 10, 2, 0, -7609.63, 79.3944, -3167.32, -7332.95, 648.111, -3059.63, 0, 0, 1, NULL), ('surf_reprise', 0, 1, 1, -3044.12, 1135.97, 14366, -3473.78, -1135.97, 14468, 0, 0, 0, NULL), ('surf_reprise', 1, 2, 1, 14818.8, -8322.52, -3265.97, 16272, -12572.6, -3163.97, 0, 0, 0, NULL), ('surf_reprise', 2, 4, 0, -149.982, -1137.88, 11744, -1735.9, 1152.81, 7939.7, 0, 0, 0, NULL), ('surf_reprise', 3, 4, 1, 2828.85, -1181.01, 7903.97, 1362.1, 1164.86, 4896.03, 0, 0, 0, NULL), ('surf_reprise', 4, 4, 2, 3140.04, 2983.4, 2783.97, 4758.73, -2964.38, 256.031, 0, 0, 0, NULL), ('surf_reprise', 5, 4, 3, 9712.53, -658.454, 223.969, 8320.03, 724.139, -1049.14, 0, 0, 0, NULL), ('surf_reprise', 6, 4, 4, 1954.2, 9567.41, 10704.4, 128.031, 12760.9, 10205.7, 0, 0, 0, NULL), ('surf_reprise', 7, 4, 5, -1055.97, 12746.3, 8188.87, 95.9688, 9515.26, 6986.98, 0, 0, 0, NULL), ('surf_reprise', 8, 4, 6, 1734.48, 9506.43, -1599.71, -29.354, 12812, -3615.97, 0, 0, 0, NULL), ('surf_reprise', 9, 4, 7, -8607.97, -12049.6, 3248.76, -6138.59, -8736.03, 1753.21, 0, 0, 0, NULL), ('surf_retroartz_s', 0, 1, 1, 8106.7, 1007.99, 15510, 8727.39, -239.969, 15612, 0, 0, 0, NULL), ('surf_retroartz_s', 1, 2, 1, 8783.58, -11056, -5505.97, 9519.97, -12784, -5371.97, 0, 0, 0, NULL), ('surf_retroartz_s', 2, 6, 6, 12159, 4145.5, 15528.5, 10516, 5147.97, 15295.2, 0, 0, 0, NULL), ('surf_retroartz_s', 3, 4, 0, -5061.45, -447.969, 10803.5, -6446.15, 1247.97, 8889.3, 0, 0, 0, NULL), ('surf_retroartz_s', 4, 4, 1, 4699.22, -424.872, 8599.97, 4934.77, 846.007, 6040.03, 0, 0, 0, NULL), ('surf_retroartz_s', 5, 4, 2, 4915.97, -1838.34, 5959.55, 4155.47, 2327.97, 4604.66, 0, 0, 0, NULL), ('surf_retroartz_s', 6, 4, 3, 1806.74, -3637.72, 1815.97, 3831.97, -4223.5, -196.231, 0, 0, 0, NULL), ('surf_retroartz_s', 7, 4, 4, 4079.97, -12788.2, -1568.02, 2101.82, -11040, -2039.93, 0, 0, 0, NULL), ('surf_retroartz_s', 8, 6, 12, 11084.3, 5408.03, 14303.3, 10208, 5898.98, 14054.5, 0, 0, 0, NULL), ('surf_ripper', 0, 3, 0, 3144.45, 8372.97, 4885.03, 2925.03, 8147.65, 4987.03, 0, 0, 0, NULL), ('surf_ripper', 1, 3, 1, 11324.3, 3530.41, 4021.61, 11616.2, 3360.44, 4095.82, 0, 0, 0, NULL), ('surf_ripper', 2, 3, 2, -12916, -1771.14, -3515.97, -12985.5, -1673.23, -3436.35, 0, 0, 0, NULL), ('surf_ripper', 3, 2, 1, -15147.5, -1540.38, -3393.36, -14923.6, -1565.37, -3096.63, 0, 0, 0, NULL), ('surf_ripper', 4, 1, 1, -7190.97, 7491.97, 4809.03, -6605.42, 7025.72, 4937.87, 0, 0, 0, NULL), ('surf_roman', 0, 1, 1, 12287.5, 126.98, 14336, 12045.4, -126.969, 14436, 0, 0, 0, NULL), ('surf_roman', 1, 2, 1, 12990.7, 254.969, 6016.03, 12497.1, -254.969, 6116.03, 0, 0, 0, NULL), ('surf_rookie', 0, 2, 1, -1552.03, 13808, 2816.02, -2559, 12546, 2948.03, 0, 0, 0, NULL), ('surf_rookie', 1, 3, 3, -1743.69, 4399.97, 5600.03, -2176, 3728.03, 5700.03, 0, 0, 0, NULL), ('surf_rookie', 2, 3, 5, -1276.07, 1999.98, -767.969, -1711.97, 1328.03, -667.969, 0, 0, 0, NULL), ('surf_rookie', 3, 3, 6, -964.283, -1632.03, -4431.97, -1399.97, -2335.97, -4331.97, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_rookie', 4, 3, 8, -7192.48, -4880.03, -9631.98, -7632, -6095.97, -9531.98, 0, 0, 0, NULL), ('surf_rookie', 5, 3, 13, 8420.65, 13232, 14881.2, 7984.03, 12016, 14981.2, 0, 0, 0, NULL), ('surf_rookie', 6, 3, 12, -11446.5, -8976.03, 641.267, -11888, -10192, 741.267, 0, 0, 0, NULL), ('surf_rookie', 7, 3, 9, -14847.6, 1127.97, 14168, -15280, -87.9688, 14268, 0, 0, 0, NULL), ('surf_rookie', 8, 3, 11, -13338.5, -5048.03, 1984.03, -13776, -6263.97, 2084.03, 0, 0, 0, NULL), ('surf_rookie', 9, 3, 10, -13591.9, -2712.03, 5720.03, -14032, -3927.97, 5820.03, 0, 0, 0, NULL), ('surf_rookie', 10, 3, 0, -1375.31, 10288, 11584, -1807.97, 9360.03, 11684, 0, 0, 0, NULL), ('surf_rookie', 11, 3, 16, -13950.8, 13808, 5472.03, -14398.6, 12546.9, 5619.14, 0, 0, 0, NULL), ('surf_rookie', 12, 3, 7, -956.356, -2960.03, -5951.97, -1391.97, -4143.97, -5851.97, 0, 0, 0, NULL), ('surf_rookie', 13, 1, 1, -1246.5, 11568, 13680, -1554.71, 10722, 13780, 0, 0, 0, NULL), ('surf_rookie', 14, 3, 15, 6867.09, -2096.03, 3873.23, 6432.03, -3311.99, 3973.23, 0, 0, 0, NULL), ('surf_rookie', 15, 3, 1, -1291.17, 9007.98, 9632.03, -1727.97, 8304.03, 9732.03, 0, 0, 0, NULL), ('surf_rookie', 16, 3, 2, -1100.47, 7983.97, 7824.03, -1535.97, 7312.03, 7924.03, 0, 0, 0, NULL), ('surf_rookie', 17, 3, 14, 6103.53, 5455.97, 9377.23, 5680.03, 4240.03, 9477.23, 0, 0, 0, NULL), ('surf_rookie', 18, 3, 4, -1731.56, 2544.03, 2867.14, -1897.05, 3245.85, 2800.03, 0, 0, 0, NULL), ('surf_metallic', 2, 3, 1, -8819.98, -8344.01, 130.031, -8612.03, -8487.99, 232.031, 0, 0, 0, NULL), ('surf_metallic', 1, 2, 1, -4479.97, -2865.44, -5305.97, -3776.03, -3232, -5203.97, 0, 0, 0, NULL), ('surf_metallic', 0, 3, 2, 11576, 3696.01, -2225.97, 11368, 3840.03, -2123.97, 0, 0, 0, NULL), ('surf_map', 10, 4, 8, 6016.78, -9215.97, -6783.98, 6299.41, -8192.03, -7303.81, 0, 0, 0, NULL), ('surf_royal_intox', 0, 3, 2, -10577, -3445.96, 9323.03, -12593, -3835.97, 9425.03, 0, 0, 0, NULL), ('surf_royal_intox', 1, 2, 1, 151.446, 2443.41, 8190.03, -73.0672, 2200.32, 8292.03, 0, 0, 0, NULL), ('surf_royal_intox', 2, 3, 1, 4852.14, -1760.99, 2439.03, 4586.96, -2025.72, 2541.03, 0, 0, 0, NULL), ('surf_royal_intox', 3, 1, 1, -517.732, 249.774, -1.96875, -249.634, -263.596, 100.031, 0, 0, 0, NULL), ('surf_royal_intox', 4, 3, 0, 223.986, -4403.75, 3234.03, 14.8283, -4206, 3332.03, 0, 0, 0, NULL), ('surf_rstar', 0, 1, 1, 12029.7, 9538.67, 14094, 11221.7, 9740.66, 14192, 0, 0, 0, NULL), ('surf_rstar', 1, 2, 1, -15026, 6415.97, -4468.36, -14734.9, 4411.03, -4224.36, 0, 0, 0, NULL), ('surf_map', 9, 4, 7, 9492.2, 3596.98, -5120.03, 8955.44, 4317.54, -5727.97, 0, 0, 0, NULL), ('surf_map', 8, 4, 6, 8448.29, 9318.96, -2048.03, 9983.97, 9947.8, -3004.7, 0, 0, 0, NULL), ('surf_map', 7, 4, 5, 3420.89, 4922.03, 2271.97, 4505.79, 4640.03, 1784.68, 0, 0, 0, NULL), ('surf_map', 6, 4, 4, 4302.71, 4270.21, 2543.58, 3899.83, 3909.08, 2092.7, 0, 0, 0, NULL), ('surf_salvia', 0, 2, 1, 1616.03, 389.661, -11264.1, 1652.23, -125.061, -10938.1, 0, 0, 0, NULL), ('surf_salvia', 1, 2, 2, 5694.18, 381.215, -11264.1, 1659.1, -126.394, -11164.1, 0, 0, 0, NULL), ('surf_salvia', 2, 1, 1, -15870.9, 18.0088, 1536.03, -16134.3, 239.998, 1636.03, 0, 0, 0, NULL), ('surf_sanding', 0, 3, 0, -267.947, -3515.37, 243.983, -396.065, -3659.35, 374.208, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_sanding', 1, 1, 0, -97.0902, -1857.57, 222.031, -463.969, -2238.94, 324.031, 0, 0, 0, NULL), ('surf_sanding', 2, 3, 1, -92.6204, 1741.58, 138.96, 45.1762, 1847.26, 380.674, 0, 0, 0, NULL), ('surf_sanding', 3, 3, 2, -951.732, -4882.96, 260.802, -817.997, -5097.92, 439.265, 0, 0, 0, NULL), ('surf_sanding', 4, 3, 3, 1568.03, -3672.51, 825, 1696.4, -3507.5, 672.031, 0, 0, 0, NULL), ('surf_sanding', 5, 3, 4, 3937.24, -1521.4, 1278.03, 4070.88, -1117.75, 1380.03, 0, 0, 0, NULL), ('surf_sanding', 6, 2, 0, 2328.17, -1899.29, -835.818, 2446.64, -881.809, -703.716, 0, 0, 0, NULL), ('surf_map', 5, 4, 3, 4607.97, -3836.35, 7163.38, 3591.72, -3328.03, 7137.32, 0, 0, 0, NULL), ('surf_map', 4, 4, 2, 927.969, 8194.88, 3069.31, -991.969, 8497.46, 2805.71, 0, 0, 0, NULL), ('surf_map', 3, 4, 1, 127.969, 3069.67, 3198.92, -126.43, 3044.16, 2944.03, 0, 0, 0, NULL), ('surf_map', 2, 4, 0, -767.969, 2520.34, 6622.79, 767.969, 1990, 6407.48, 0, 0, 0, NULL), ('surf_map', 1, 2, 1, 6266.77, -4047.97, -6881.97, 6017.26, -3364.04, -6779.97, 0, 0, 0, NULL), ('surf_sandman_v2_njv', 0, 1, 1, 9.61514, -6650.31, 3095.24, -446.747, -5810.51, 3195.49, 0, 0, 0, NULL), ('surf_sandman_v2_njv', 1, 3, 0, -4965.41, -3344.03, 4550.03, -5391.97, -3823.97, 4644.03, 0, 0, 0, NULL), ('surf_sandman_v2_njv', 2, 3, 2, -7421.99, 1281.03, 7054.03, -6912.81, 2300.76, 7156.03, 0, 0, 0, NULL), ('surf_sandman_v2_njv', 3, 3, 3, -5717.26, 4790.99, 6218.03, -5951.97, 4429.39, 6320.03, 0, 0, 0, NULL), ('surf_sandman_v2_njv', 4, 3, 1, -4448.62, -1215.27, 4894.03, -4223.56, -824.638, 4996.03, 0, 0, 0, NULL), ('surf_sandman_v2_njv', 5, 2, 1, 6447.81, 4897.62, -635.156, 6171.93, 4338.38, -400.738, 0, 0, 0, NULL), ('surf_savant_njv', 0, 3, 1, 11341.9, -11582.5, 2658.03, 11713.7, -11109, 2760.03, 0, 0, 0, NULL), ('surf_savant_njv', 1, 3, 4, 13662, -3919.97, 334.031, 13915.6, -3440.03, 436.031, 0, 0, 0, NULL), ('surf_savant_njv', 2, 3, 3, -6749, -6832.47, 3206.03, -7740.97, -7099, 3308.03, 0, 0, 0, NULL), ('surf_savant_njv', 3, 2, 1, 14385.4, 14297, -3235.47, 14737.4, 13235.3, -3075.2, 0, 0, 0, NULL), ('surf_savant_njv', 4, 3, 5, 13973, 13473, 373.531, 13675.2, 14065, 475.531, 0, 0, 0, NULL), ('surf_savant_njv', 5, 3, 0, -4232.03, 1707.81, 4064.03, -4839.97, 1384.03, 4166.03, 0, 0, 0, NULL), ('surf_savant_njv', 6, 3, 2, -1142.28, -2852.88, 2174.03, -964.888, -3480.87, 2276.03, 0, 0, 0, NULL), ('surf_savant_njv', 7, 1, 1, 248.327, -7967.46, 1886.03, -163.439, -7571.48, 1988.03, 0, 0, 0, NULL), ('surf_sci_fi', 0, 3, 1, -14057.8, -12250.8, 270.031, -13504.8, -11637.1, 372.031, 0, 0, 0, NULL), ('surf_sci_fi', 1, 2, 0, 14249.6, -12434, 618.196, 13814.2, -11427.5, 809.821, 0, 0, 0, NULL), ('surf_sci_fi', 2, 1, 0, 11126.6, 3479.16, 4864.53, 12627, 3344.03, 4966.53, 0, 0, 0, NULL), ('surf_sci_fi', 3, 3, 0, -2696.06, -3794.19, 2794.25, -2035.29, -3211.46, 2889.53, 0, 0, 0, NULL), ('surf_sc_colours', 0, 3, 2, -1070, 4677.03, 1861.53, -1218.7, 4859.46, 1963.53, 0, 0, 0, NULL), ('surf_sc_colours', 1, 3, 0, -1740.15, 2936, 1524.03, -1605.17, 2632.03, 1626.03, 0, 0, 0, NULL), ('surf_sc_colours', 2, 1, 1, 3200.11, -1997.97, 473.031, 3605.97, -1022.03, 575.031, 0, 0, 0, NULL), ('surf_sc_colours', 3, 3, 4, 2269.5, 2975.97, 1518.03, 2433.77, 2783.41, 1620.03, 0, 0, 0, NULL), ('surf_sc_colours', 4, 3, 3, 2872.03, -589.212, 1502.03, 3048.93, -403.82, 1604.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_sc_colours', 5, 3, 1, 1005.86, 2031.97, -513.969, 544.031, 1730.66, -423.229, 0, 0, 0, NULL), ('surf_sc_colours_rg', 0, 1, 1, 3203.69, -1022.03, 475.031, 3271.92, -1988.73, 575.031, 0, 0, 0, NULL), ('surf_sc_colours_rg', 1, 3, 5, -3884.69, 541.351, 1196.03, -3812.56, 609.561, 1296.03, 0, 0, 0, NULL), ('surf_sc_colours_rg', 2, 3, 0, -1740.17, 2718.29, 1526.03, -1680.26, 2843.21, 1626.03, 0, 0, 0, NULL), ('surf_sc_colours_rg', 3, 3, 1, 779.659, 2032, -503.969, 848.455, 1979.07, -403.969, 0, 0, 0, NULL), ('surf_sc_colours_rg', 4, 3, 2, -1135.75, 4800.71, 1871.53, -1067.31, 4712.67, 1979.53, 0, 0, 0, NULL), ('surf_sc_colours_rg', 5, 3, 6, -1459.27, 3896.21, 375.547, -1349.5, 4029.69, 475.547, 0, 0, 0, NULL), ('surf_sc_colours_rg', 6, 3, 7, 1510.82, 927.988, 1512.03, 1586.35, 880.097, 1612.03, 0, 0, 0, NULL), ('surf_sc_colours_rg', 7, 3, 4, 2323.51, 2975.99, 1528.03, 2390.44, 2917.33, 1628.03, 0, 0, 0, NULL), ('surf_sc_colours_rg', 8, 3, 3, 2872.71, -530.312, 1512.03, 2918.51, -462.916, 1612.03, 0, 0, 0, NULL), ('surf_sc_essence_v2_njv', 0, 3, 3, -2783.85, 1121.43, 3034.03, -2702.58, 1273.43, 3136.03, 0, 0, 0, NULL), ('surf_sc_essence_v2_njv', 1, 3, 4, -5207.79, -715.295, 3038.03, -5126, -532.271, 3140.03, 0, 0, 0, NULL), ('surf_sc_essence_v2_njv', 2, 3, 8, 114.326, -3581.3, 3038.03, 198.256, -3316.83, 3140.03, 0, 0, 0, NULL), ('surf_sc_essence_v2_njv', 3, 1, 0, 4432.72, 4199.19, 3039.03, 4628.47, 3616.69, 3140.03, 0, 0, 0, NULL), ('surf_sc_essence_v2_njv', 4, 3, 2, -5215.97, 1665.46, 3038.03, -5131.66, 1829.08, 3140.03, 0, 0, 0, NULL), ('surf_sc_essence_v2_njv', 5, 3, 6, -5215.97, -2136.84, 3038.03, -5132.03, -1891.37, 3140.03, 0, 0, 0, NULL), ('surf_sc_essence_v2_njv', 6, 3, 0, -5216, 2698.27, 3038.03, -5127.42, 3096.08, 3140.03, 0, 0, 0, NULL), ('surf_sc_essence_v2_njv', 7, 3, 5, 112.031, -708.635, 3038.03, 216.829, -514.9, 3140.03, 0, 0, 0, NULL), ('surf_sc_essence_v2_njv', 8, 3, 1, 1312, 2746.49, 3038.03, 1432.48, 3047.65, 3140.03, 0, 0, 0, NULL), ('surf_sc_essence_v2_njv', 9, 2, 0, 4786.55, -3721.97, -641.969, 5056, -3122.46, -539.969, 0, 0, 0, NULL), ('surf_sc_essence_v2_njv', 10, 3, 7, -5215.97, -3561.44, 3038.03, -5080.44, -3271.77, 3140.03, 0, 0, 0, NULL), ('surf_sc_essence_v2_njv', 11, 1, 0, 2429.61, 4732.86, -561.969, 2541.9, 4094.56, -459.969, 0, 0, 1, NULL), ('surf_sc_essence_v2_njv', 12, 2, 0, -2369.44, 4464, -1081.97, -2677.56, 4506.69, -979.969, 0, 0, 1, NULL), ('surf_seaworld_fix', 0, 2, 1, -955.42, -5958.69, -3521.97, 555.379, -6639.99, -3419.97, 0, 0, 0, NULL), ('surf_seaworld_fix', 1, 1, 1, -446.931, 2086.75, 2657.11, 62.4296, 2203.03, 2756.03, 0, 0, 0, NULL), ('surf_seaworld_fix', 2, 1, 2, -448.451, 2395.27, 2657.79, 65.8114, 2299.34, 2756.03, 0, 0, 0, NULL), ('surf_sempar_njv', 0, 3, 3, -1701.68, -4867.14, 554.031, -1981.01, -5626.02, 656.031, 0, 0, 0, NULL), ('surf_sempar_njv', 1, 3, 2, 8105.59, 2160.03, -2923.47, 8593.47, 2431.97, -2821.47, 0, 0, 0, NULL), ('surf_sempar_njv', 2, 2, 0, 3305.48, -11134.8, -13092, 3793.68, -10635.5, -12990, 0, 0, 0, NULL), ('surf_sempar_njv', 3, 3, 4, -11706, -11106.3, -2555.97, -11430.6, -10663.6, -2453.97, 0, 0, 0, NULL), ('surf_sempar_njv', 4, 3, 1, -6091.97, 4400.03, -6257.97, -4844.03, 4784.17, -6155.97, 0, 0, 0, NULL), ('surf_sempar_njv', 5, 1, 0, 5597.31, -735.329, -1987.97, 5320.03, -1497.45, -1885.97, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_sempar_njv', 6, 3, 0, 3176.03, 5003.97, -3137.97, 4263.99, 4682.09, -3035.97, 0, 0, 0, NULL), ('surf_sempar_njv', 7, 2, 0, 119.453, 1777.41, -3918.08, -125.003, 2314.48, -3816.08, 0, 0, 1, NULL), ('surf_sempar_njv', 8, 1, 0, -351.969, 4802.52, 328.683, 351.969, 5062.08, 314.663, 0, 0, 1, NULL), ('surf_sensation', 0, 3, 2, -5381.97, -3864.03, -1.96875, -5030.07, -4215.97, 100.031, 0, 0, 0, NULL), ('surf_sensation', 1, 3, 0, -2771.97, -49.0719, -160.507, -2403.26, 50.5615, -56.5581, 0, 0, 0, NULL), ('surf_sensation', 2, 3, 1, 2821.53, 8496.21, -684.469, 3237.47, 8058.03, -582.469, 0, 0, 0, NULL), ('surf_sensation', 3, 1, 0, 8026.37, 4925.23, -2945.97, 7916.04, 4023.94, -2843.97, 0, 0, 0, NULL), ('surf_sensation', 4, 2, 0, -3134.83, -3468.03, -3739.63, -3038.3, -4751.97, -3659.6, 0, 0, 0, NULL), ('surf_sensation', 5, 0, 0, 844.969, 11162.5, -447.03, -438.219, 11322.8, -735.264, 0, 0, 0, NULL), ('surf_sentient', 0, 2, 1, 1423.97, 8374.88, -2689.97, -623.996, 9712, -2587.97, 0, 0, 0, NULL), ('surf_sentient', 1, 1, 1, -15554, -9736.11, 15518, -15164.9, -10491.8, 15620, 0, 0, 0, NULL), ('surf_sewers', 0, 2, 0, 8208.03, -2223.97, -10690, 9711.97, 1199.99, -10588, 0, 0, 0, NULL), ('surf_sewers', 1, 1, 0, 14352, -336.031, 13621, 14832, -700.784, 13732, 0, 0, 0, NULL), ('surf_sexplizooimed', 0, 3, 0, 6982.53, -2780.71, -244.969, 6742.03, -3360.97, -142.969, 0, 0, 0, NULL), ('surf_sexplizooimed', 1, 3, 5, 7931.11, -7057.75, 2640.03, 7636.87, -7303.14, 2742.03, 0, 0, 0, NULL), ('surf_sexplizooimed', 2, 2, 1, 7417.87, -6525.87, -2415.97, 8182.87, -7804.23, -2313.97, 0, 0, 0, NULL), ('surf_sexplizooimed', 3, 1, 1, 1679, 10680.9, 1649.03, 2144.43, 10353.7, 1751.03, 0, 0, 0, NULL), ('surf_sexplizooimed', 4, 3, 1, 5065.52, 7241.97, 10685.2, 5274.95, 6282.03, 10640.4, 0, 0, 0, NULL), ('surf_sexplizooimed', 5, 3, 2, -4961.97, -6113.46, -622.449, -4646.87, -5707.92, -661.969, 0, 0, 0, NULL), ('surf_sexplizooimed', 6, 3, 3, 6525.75, 731.285, 7677.97, 7095.05, 328.047, 7779.97, 0, 0, 0, NULL), ('surf_sexplizooimed', 7, 3, 4, -3846.03, 3936.97, 6215.53, -4038.76, 4279.12, 6317.53, 0, 0, 0, NULL), ('surf_sexyartz_njv', 0, 1, 0, -6177.79, -2416, 14382, -6126.6, -2193.09, 14500, 0, 0, 0, NULL), ('surf_sexyartz_njv', 1, 1, 1, -6110.74, -2415.97, 14398, -6063.59, -2183.75, 14516, 0, 0, 0, NULL), ('surf_sexyartz_njv', 2, 2, 0, -6872.64, 4582.79, -10724.9, -10783.3, 3611.34, -9853.68, 0, 0, 0, NULL), ('surf_sexyartz_njv', 3, 4, 0, -14733.4, -3545.67, 12704, -14376, -1838.94, 11677.5, 0, 0, 0, NULL), ('surf_sexyartz_njv', 4, 4, 1, -8780.44, -2527.97, 8184.85, -9223.97, -2089.77, 7333.04, 0, 0, 0, NULL), ('surf_sexyartz_njv', 5, 4, 2, 5988.42, -4095.97, 4866.84, 6743.97, -520.873, 4150.91, 0, 0, 0, NULL), ('surf_sexyartz_njv', 6, 4, 3, -10014.3, -1344.04, -448.031, -9800.03, -2674.08, -2500.64, 0, 0, 0, NULL), ('surf_sexyartz_njv', 7, 4, 4, -12286.3, -1360.8, -6592.03, -9288.03, -3320.29, -6939.11, 0, 0, 0, NULL), ('surf_sexyartz_njv', 8, 4, 5, -4215.41, 10432, 12992.8, -4767.97, 8403.77, 11682, 0, 0, 0, NULL), ('surf_sexyartz_njv', 9, 4, 6, 8771.21, 6973.14, 7071.97, 8222.47, 10464, 6082.34, 0, 0, 0, NULL), ('surf_sexyartz_njv', 10, 4, 7, 7108.36, 8384.69, -1718.54, 6593.81, 9044.89, -2312.99, 0, 0, 0, NULL), ('surf_sexyartz_njv', 11, 4, 8, 11448, 1213.56, -7370.78, 6950.02, 138.917, -8607.97, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_sh', 0, 3, 0, -3392.04, 1794.97, 1411.03, -3691.97, 1187.03, 1513.03, 0, 0, 0, NULL), ('surf_sh', 1, 3, 2, -4668.58, -4616.03, 3410.03, -5131.97, -5287.97, 3512.03, 0, 0, 0, NULL), ('surf_sh', 2, 2, 1, -6203.12, -5319.97, -2797.97, -5124.78, -4594.09, -2375.23, 0, 0, 0, NULL), ('surf_sh', 3, 1, 1, -5049.42, -2992.03, 6142.03, -4944.11, -3727.97, 6244.03, 0, 0, 0, NULL), ('surf_sh', 4, 3, 1, 2200, -6583.4, 3306.03, 1848.03, -6092.03, 3408.03, 0, 0, 0, NULL), ('surf_shit_v3', 0, 2, 1, 4629.88, 80.3651, -696.03, 4479.34, 230.059, -616.982, 0, 0, 0, NULL), ('surf_shit_v3', 1, 3, 3, 4062.03, 1644.08, 3148.28, 5032.97, 1218.03, 3244.03, 0, 0, 0, NULL), ('surf_shit_v3', 2, 3, 2, -7422.8, -3012.62, 1903.03, -6720.83, -3383.98, 2003.03, 0, 0, 0, NULL), ('surf_shit_v3', 3, 3, 0, -791.031, -1689.04, 1475.03, -1482.99, -1785.97, 1575.03, 0, 0, 0, NULL), ('surf_shit_v3', 4, 1, 1, 797.031, -1383.19, 1076.03, 1387.97, -1640.68, 1173.03, 0, 0, 0, NULL), ('surf_shit_v3', 5, 3, 1, -4098.97, -2437.85, 1544.03, -3365.03, -2801.97, 1641.03, 0, 0, 0, NULL), ('surf_simpsons_go_rc2', 0, 3, 7, 1468.56, -10238.4, -385.969, 1007.47, -9544.45, -283.969, 0, 0, 0, NULL), ('surf_simpsons_go_rc2', 1, 3, 8, -9578.15, -8569.98, 1278.03, -10239.4, -7796.29, 1380.03, 0, 0, 0, NULL), ('surf_simpsons_go_rc2', 2, 3, 5, 12248.4, -7941.68, -513.969, 11661.3, -7288.84, -411.969, 0, 0, 0, NULL), ('surf_simpsons_go_rc2', 3, 3, 4, 6875.97, -13933.8, 142.031, 6327.22, -13231.9, 244.031, 0, 0, 0, NULL), ('surf_simpsons_go_rc2', 4, 3, 3, -10480, 26.4464, -1.96875, -10983.1, 797.372, 100.031, 0, 0, 0, NULL), ('surf_simpsons_go_rc2', 5, 3, 2, 147.302, 2976.35, -65.9688, -481.386, 3633.39, 65.3376, 0, 0, 0, NULL), ('surf_simpsons_go_rc2', 6, 3, 1, -5548.68, 6312.53, -481.969, -6239.11, 7021.19, -379.969, 0, 0, 0, NULL), ('surf_simpsons_go_rc2', 7, 3, 6, -3819.62, -3597.64, -705.969, -4435.53, -2790.8, -603.969, 0, 0, 0, NULL), ('surf_simpsons_go_rc2', 8, 1, 1, 5423.99, 4543.61, -193.969, 3923.8, 4172.25, -91.9688, 0, 0, 0, NULL), ('surf_simpsons_go_rc2', 9, 2, 1, -4834.49, -9191.98, -1793.97, -4120.03, -8720.03, -1675.97, 0, 0, 0, NULL), ('surf_simpsons_go_rc2', 10, 3, 0, 6512.26, -4304.03, -1409.97, 5825.17, -4945.4, -1307.97, 0, 0, 0, NULL), ('surf_singletons', 0, 3, 1, 1290.61, 135.218, 2944.03, 1081.13, -114.221, 3044.03, 0, 0, 0, NULL), ('surf_singletons', 1, 2, 1, -1488.66, 2221.27, -2179.44, -1265.46, 1893.02, -2131.44, 0, 0, 0, NULL), ('surf_singletons', 2, 3, 2, 2848.03, -4916.61, -2047.97, 3080.42, -5327.53, -1947.97, 0, 0, 0, NULL), ('surf_singletons', 3, 3, 0, 0.641043, -3492.03, 96.0312, -169.98, -3945.74, 196.031, 0, 0, 0, NULL), ('surf_singletons', 4, 3, 3, -1476.09, 2153.37, -2559.97, -1631.99, 1914.51, -2459.97, 0, 0, 0, NULL), ('surf_singletons', 5, 1, 1, -192.451, -1864.4, 96.0312, -48.2427, -2231.25, 196.031, 0, 0, 0, NULL), ('surf_sinister', 0, 1, 1, -9653.21, 15312, 12382, -8714.67, 14819.6, 12484, 0, 0, 0, NULL), ('surf_sinister', 1, 3, 2, 7341.65, 13909.3, -1361.97, 6407.5, 14400, -1259.97, 0, 0, 0, NULL), ('surf_sinister', 2, 3, 1, 1238.44, -2636.85, 4190.03, 298.406, -2144, 4292.03, 0, 0, 0, NULL), ('surf_sinister', 3, 3, 3, 12384, 13469.8, -8577.97, 13888, 13960, -8475.97, 0, 0, 0, NULL), ('surf_sinister', 4, 2, 1, 13920, -7025.39, -10402, 12352, -8034.17, -10300, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_sinister', 5, 3, 0, -5117.61, 9167.97, 7710.03, -4180.14, 8675.8, 7812.03, 0, 0, 0, NULL), ('surf_map', 0, 1, 1, -129.679, -4710.49, 6398.03, 116.302, -4849.28, 6500.03, 0, 0, 0, NULL), ('surf_loentra', 12, 2, 0, 15474.7, 12174.7, 11210.9, 15792, 10996.7, 11461.1, 0, 0, 2, 'BONUS 2'), ('surf_loentra', 11, 1, 0, -1457.5, 11184.6, 13511.9, -2415.97, 11817.3, 13606.6, 0, 0, 2, 'BONUS 2'), ('surf_loentra', 10, 4, 6, 2003.58, -14347, -11177.6, 2520.59, -10641.8, -12643.5, 0, 0, 0, ''), ('surf_loentra', 9, 4, 5, -2992.03, 7006.01, -13120, -6895.97, 6075.47, -14052.5, 0, 0, 0, ''), ('surf_loentra', 8, 4, 4, -2992.03, 4249.46, -7246.21, -6881.21, 5572.36, -5943.25, 0, 0, 0, ''), ('surf_loentra', 7, 4, 3, -3879.22, 2333.92, -2040.05, -6543.97, 1954.08, -2291.81, 0, 0, 0, ''), ('surf_loentra', 6, 4, 2, -5423.59, 7822.22, 2927.57, -4482.72, 7442.54, 2024.01, 0, 0, 0, ''), ('surf_loentra', 5, 4, 1, -3408.03, 2556.69, 7490.3, -6543.97, 3133.69, 7160.05, 0, 0, 0, ''), ('surf_skill8', 0, 1, 1, 638.95, 7535.97, 15742, 483.182, 7424.57, 15844, 0, 0, 0, NULL), ('surf_skill8', 1, 2, 1, 6786.17, 2192.03, -6529.97, 7025.87, 3698.63, -4840.17, 0, 0, 0, NULL), ('surf_skill8_e', 0, 2, 1, 8450.39, 3711.03, -6271.97, 9983.97, 2179.55, -5477.76, 0, 0, 0, NULL), ('surf_skill8_e', 1, 1, 1, 515.703, 7551.97, 15744.5, 637.195, 7424.03, 15802.1, 0, 0, 0, NULL), ('surf_loentra', 4, 4, 0, -5327.82, 7905.89, 11512, -4642.53, 8429.8, 11657.3, 0, 0, 0, ''), ('surf_skill8_m', 0, 1, 1, 639.555, 7550.97, 15744, 379.137, 7426.89, 15844, 0, 0, 0, NULL), ('surf_skill8_m', 1, 2, 1, 8450.68, 3709.92, -6271.97, 9983.97, 2179.2, -5380.09, 0, 0, 0, NULL), ('surf_sky_ages', 0, 2, 0, 15823, -73.878, 6019.17, 15612.1, 210.582, 6162.23, 0, 0, 0, NULL), ('surf_sky_ages', 1, 3, 2, -15033.5, 183.625, 14414, -14876.6, 19.0642, 14516, 0, 0, 0, NULL), ('surf_sky_ages', 2, 3, 1, 1935.97, -5759.97, 11098, 1673.77, -5408.19, 11200, 0, 0, 0, NULL), ('surf_sky_ages', 3, 3, 0, 9423.97, -3783.85, 6252.69, 8656.03, -3525.72, 6213.47, 0, 0, 0, NULL), ('surf_sky_ages', 4, 1, 0, 5721.08, -4375.48, 3718.03, 5597.52, -4137.06, 3812.03, 0, 0, 0, NULL), ('surf_sluice', 0, 2, 1, 11088, -14464, 862.031, 9776.03, -13456, 964.031, 0, 0, 0, NULL), ('surf_sluice', 1, 1, 1, -6125.9, -13582.2, 14846, -5889.51, -13371.7, 14948, 0, 0, 0, NULL), ('surf_sluice_final', 0, 3, 1000, -9724.31, -1775.97, -6495.97, -9474.27, -1552.08, -6395.97, 0, 0, 0, NULL), ('surf_sluice_final', 1, 3, 1003, 8473.93, 5079.03, -10208, 8266, 6308.97, -10108, 0, 0, 0, NULL), ('surf_sluice_final', 2, 3, 1002, -1664.03, 6180.94, -6783.97, -2143.97, 6468.15, -6683.97, 0, 0, 0, NULL), ('surf_sluice_final', 3, 3, 1001, -14112, -16.0018, -7599.97, -13664, -240.972, -7499.97, 0, 0, 0, NULL), ('surf_sluice_final', 4, 1, 1, -6143.58, -13704, 14848, -5888.36, -13375.3, 14948, 0, 0, 0, NULL), ('surf_sluice_final', 5, 2, 1, 11103, -14464, 864.031, 9761.03, -13456, 964.031, 0, 0, 0, NULL), ('surf_sluice_releasebuild_v6', 0, 2, 1, 11088, -14416, 862.031, 9776, -13456, 964.031, 0, 0, 0, NULL), ('surf_sluice_releasebuild_v6', 1, 1, 1, -5884.65, -13600.1, 14846, -6144.66, -13378.7, 15022.9, 0, 0, 0, NULL), ('surf_smaragd', 0, 3, 2, -10397.3, 144.106, 1694.55, -9996.24, 647.344, 1856.25, 0, 0, 0, NULL), ('surf_smaragd', 1, 3, 0, -3400.03, 8305.03, -215.969, -4008.69, 9520.99, -115.969, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_smaragd', 2, 3, 1, -11046, 6390.51, -239.969, -10550, 5413.2, -139.969, 0, 0, 0, NULL), ('surf_smaragd', 3, 3, 3, -2608.49, -4515.1, 3706.78, -2192.86, -4014.84, 3806.78, 0, 0, 0, NULL), ('surf_smaragd', 4, 3, 4, -10544, -7705.13, 868.031, -10101.3, -8250.78, 965.127, 0, 0, 0, NULL), ('surf_smaragd', 5, 2, 0, 2208.74, -8255.66, -1135.97, 2767.97, -7688.11, -987.969, 0, 0, 0, NULL), ('surf_smaragd', 6, 1, 0, -5870.79, 12080, -351.969, -6102.86, 10928, -251.969, 0, 0, 0, NULL), ('surf_smile', 0, 1, 0, -7103.97, 4456.34, 1861.03, -6814.3, 4678.78, 1808.03, 0, 0, 0, NULL), ('surf_smile', 1, 3, 0, -7297.98, 1056.03, 770.981, -7555.06, 2527.97, 802.27, 0, 0, 0, NULL), ('surf_smile', 2, 3, 1, -11847.1, -850.906, 1088.03, -12166.1, -1239.77, 1100.03, 0, 0, 0, NULL), ('surf_smile', 3, 3, 2, -6466.51, -4987.73, 1024.03, -7122.53, -5253.24, 1057.73, 0, 0, 0, NULL), ('surf_smile', 4, 2, 0, -2296.45, -11392, 389.764, -2618.4, -9344.03, 571.808, 0, 0, 0, NULL), ('surf_smile', 5, 3, 3, -1920.03, -10185.5, 1960.36, -2559.97, -10555.3, 1924.95, 0, 0, 0, NULL), ('surf_smile_njv', 0, 2, 1, 1584.03, -718.941, -481.969, 2333.83, -813.359, -379.969, 0, 0, 0, NULL), ('surf_smile_njv', 1, 3, 1, -12171.5, -827.908, 1086.03, -11882.2, -1292.15, 1214.88, 0, 0, 0, NULL), ('surf_smile_njv', 2, 3, 2, -7077.86, -4950.12, 1022.03, -6672.03, -5283.14, 1124.03, 0, 0, 0, NULL), ('surf_smile_njv', 3, 3, 3, -2544, -10189.2, 1918.03, -1936.02, -10545.2, 2020.03, 0, 0, 0, NULL), ('surf_smile_njv', 4, 3, 0, -7542.5, 2511.97, 766.031, -7299.63, 1072.03, 868.031, 0, 0, 0, NULL), ('surf_smile_njv', 5, 1, 1, -7077.08, 4761.41, 1803.72, -6720.37, 4460.59, 1881.19, 0, 0, 0, NULL), ('surf_spacejam', 0, 1, 0, -15361.9, -11264, 15242.4, -15697.4, -12288, 15105.5, 0, 0, 0, NULL), ('surf_spacejam', 1, 3, 0, -15116.4, -6092.21, 15104, -14869.6, -5654.92, 15249.6, 0, 0, 0, NULL), ('surf_spacejam', 2, 3, 1, 2953.01, -3546.8, 13536, 3527.38, -2467.93, 13424, 0, 0, 0, NULL), ('surf_spacejam', 3, 3, 2, -15010.1, 6948.48, 14405, -15580.2, 7515.02, 14305, 0, 0, 0, NULL), ('surf_spacejam', 4, 3, 3, -9381.03, 9219, 14923.7, -9886.22, 10109.5, 14823.7, 0, 0, 0, NULL), ('surf_spacejam', 5, 3, 4, -14834, 14076, 15040, -15600, 13067.6, 15146.7, 0, 0, 0, NULL), ('surf_spacejam', 6, 2, 0, 9272.53, -13216, -571.769, 9177.76, -13386.2, -719.969, 0, 0, 0, NULL), ('surf_spacejam', 7, 7, 0, -5155.53, -2424.43, 12547, -4474.77, -1727.35, 11150, 0, 0, 0, NULL), ('surf_spacejam', 8, 8, 1, -11153.8, 2879.12, 9861.13, -11985.6, 1604.59, 8744.15, 0, 0, 0, NULL), ('surf_spacejam', 9, 2, 0, -5871.97, -3455.22, -1985.75, -5136.03, -3115.5, -1908.11, 0, 0, 1, NULL), ('surf_spacejam', 10, 1, 0, -5140.29, -13301.8, -2015.97, -5871.97, -12866.2, -1922.8, 0, 0, 1, NULL), ('surf_spaceship_ksf', 0, 1, 1, -507.781, 13592, 4158.03, -226.643, 13859.2, 4260.03, 0, 0, 0, NULL), ('surf_spaceship_ksf', 1, 2, 1, -4599.99, -1791.24, -865.969, -3387.03, -560.007, -763.969, 0, 0, 0, NULL), ('surf_spectrum', 0, 3, 3, 1072.03, 1515.72, 15446, 1809.16, 2518.38, 15548, 0, 0, 0, NULL), ('surf_spectrum', 1, 3, 2, 4209.73, 5606.1, 13954, 3799.33, 4580.15, 14056, 0, 0, 0, NULL), ('surf_spectrum', 2, 3, 1, 12225.1, 8605.46, 15438.8, 11776, 7768.16, 15540.8, 0, 0, 0, NULL), ('surf_spectrum', 3, 3, 0, 14571.8, 10726.8, 15230, 15312, 11729.1, 15332, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_spectrum', 4, 1, 1, 12141.8, 13694.2, 15134, 11792, 12931.4, 15236, 0, 0, 0, NULL), ('surf_spectrum_njv', 0, 3, 2, 3810.09, 4622.46, 13954, 4187.73, 5599.29, 14056, 0, 0, 0, NULL), ('surf_spectrum_njv', 1, 3, 3, 1072, 2511.29, 15446, 1808.77, 1519.32, 15548, 0, 0, 0, NULL), ('surf_spectrum_njv', 2, 1, 1, 12143, 13694.4, 15134, 11792, 12931.2, 15236, 0, 0, 0, NULL), ('surf_spectrum_njv', 3, 2, 1, 9327.97, 2223.97, 13086, 9033.39, 1808.03, 13188, 0, 0, 0, NULL), ('surf_spectrum_njv', 4, 3, 0, 15312, 10722.3, 15230, 14564.4, 11740.7, 15332, 0, 0, 0, NULL), ('surf_spectrum_njv', 5, 2, 2, 9014.29, 2223.97, 13086, 8987.61, 1825.81, 13571.6, 0, 0, 0, NULL), ('surf_spectrum_njv', 6, 3, 1, 11785.7, 7703.53, 15438.8, 12149.5, 8687.93, 15540.8, 0, 0, 0, NULL), ('surf_stagejuan_ksf_', 0, 1, 0, -14139.1, 3165.94, 13278, -14529.2, 2489.54, 13379.1, 0, 0, 0, NULL), ('surf_stagejuan_ksf_', 1, 2, 0, -485.925, 9187.42, -13368, 485.925, 8220.08, -13266, 0, 0, 0, NULL), ('surf_static', 0, 2, 0, 10309.5, -3856, 3269.03, 11284, -2856.03, 3371.03, 0, 0, 0, NULL), ('surf_static', 1, 3, 5, 13160.6, 2210.46, 5327.03, 12289.7, 1749.16, 5429.03, 0, 0, 0, NULL), ('surf_static', 2, 3, 4, 10681.4, -615.969, 4054.03, 10860.3, -65.7179, 4156.03, 0, 0, 0, NULL), ('surf_static', 3, 3, 1, 6783.97, -521.969, 2103.03, 6640.23, -165.964, 2205.03, 0, 0, 0, NULL), ('surf_static', 4, 3, 0, 4634.38, 1137.05, 2060.03, 3927.85, 1502.25, 2162.03, 0, 0, 0, NULL), ('surf_static', 5, 3, 3, 8716.96, -4608.17, 5443.91, 8134.54, -3870.12, 5545.91, 0, 0, 0, NULL), ('surf_static', 6, 3, 2, 3829.93, 3594.24, 5742.03, 4147.38, 3907.23, 5844.03, 0, 0, 0, NULL), ('surf_static', 7, 1, 0, 1342.29, -2358.77, 2254.03, 2227.29, -2858.06, 2356.03, 0, 0, 0, NULL), ('surf_static', 8, 1, 0, 625.036, -4836, 4811.03, 309.196, -4518.94, 4691.03, 0, 0, 1, NULL), ('surf_static', 9, 2, 0, 1862.04, -5692.97, 2275.1, 2407.01, -3661.91, 1987.03, 0, 0, 1, NULL), ('surf_stick', 0, 3, 0, 10848, 15704.9, 554.031, 11323.8, 15319.8, 656.031, 0, 0, 0, NULL), ('surf_stick', 1, 1, 1, -15894, -15169.7, 344.131, -15736.3, -15428.5, 446.031, 0, 0, 0, NULL), ('surf_stick', 2, 2, 1, -1075.97, -3.96875, -15686, -794.21, 155.969, -15584, 0, 0, 0, NULL), ('surf_stick', 3, 3, 1, -13856, -13796.3, 14619.3, -13179.9, -14824.9, 14604, 0, 0, 0, NULL), ('surf_stick', 4, 3, 2, -13947.9, 15693.4, 15734.1, -14355.6, 15125.6, 15836.1, 0, 0, 0, NULL), ('surf_stick', 5, 3, 4, -15870.5, -174.5, -12156.6, -16121.1, -422.667, -12054.6, 0, 0, 0, NULL), ('surf_stick', 6, 3, 3, 7988.01, -15102, -10050, 8330.45, -14730.6, -9947.97, 0, 0, 0, NULL), ('surf_stickybutt_alpha', 0, 2, 1, -1005.95, 12667.5, -7409.98, 1004.45, 13307.7, -6596.29, 0, 0, 0, NULL), ('surf_stickybutt_alpha', 1, 1, 1, -307.318, 1129.16, 9230.03, 287.946, 1885.95, 9332.03, 0, 0, 0, NULL), ('surf_stoneage', 0, 2, 1, -9615.97, 3626.24, -7146.85, -8208.03, 3855.98, -6939.97, 0, 0, 0, NULL), ('surf_stoneage', 1, 1, 1, -1712, -258.774, 1614.03, -464.031, -495.969, 1716.03, 0, 0, 0, NULL), ('surf_stonework-', 0, 3, 1, -3295.97, -6911.48, 2477.53, -3146.51, -7372.58, 2579.53, 0, 0, 0, NULL), ('surf_stonework-', 1, 2, 0, 974.911, 12359.4, -11999.1, 944.393, 10790.6, -11366.1, 0, 0, 0, NULL), ('surf_stonework-', 2, 2, 1, 1443.09, 12977.7, -12002, 679.597, 11358.1, -11900, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_stonework-', 3, 3, 2, 10992, -8766.76, 4005.53, 10860, -9252.34, 4107.53, 0, 0, 0, NULL), ('surf_stonework-', 4, 3, 5, -10352, 11831.9, 693.531, -10226.7, 11342, 795.531, 0, 0, 0, NULL), ('surf_stonework-', 5, 3, 0, -1791.97, -5217.37, 3373.53, -1630.83, -4749.78, 3475.53, 0, 0, 0, NULL), ('surf_stonework-', 6, 1, 0, 1275.5, -1391.97, 3358.03, 763.911, -639.698, 3532.14, 0, 0, 0, NULL), ('surf_stonework-', 7, 3, 3, 10544, 3426.43, 3357.53, 10679, 2950.17, 3459.53, 0, 0, 0, NULL), ('surf_stonework-', 8, 3, 4, 2847.97, 7047.64, 2157.53, 2711.68, 7533.58, 2259.53, 0, 0, 0, NULL), ('surf_stonework-', 9, 2, 2, 680.532, 11345.2, -12002, 1435.66, 10193.3, -11900, 0, 0, 0, NULL), ('surf_stonework2', 0, 2, 0, -10761.2, -2031.97, -11250, -14320, 1007.97, -10876, 0, 0, 0, NULL), ('surf_stonework2', 1, 5, 0, 12356.3, 429.9, 12654, 12938.2, -440.444, 12756, 0, 0, 0, NULL), ('surf_stonework2', 2, 2, 1, -10761.9, 2031.97, -11250, -14320, -1007.97, -10876, 0, 0, 0, NULL), ('surf_stonework2', 3, 4, 0, -3536.03, 643.566, 10888.7, -2517.25, -591.977, 10096, 0, 0, 0, NULL), ('surf_stonework2', 4, 4, 1, -6846.96, -2234.87, 8203.85, -5761.95, 1043.67, 7078.31, 0, 0, 0, NULL), ('surf_stonework2', 5, 4, 2, -8941.51, 607.969, 454.966, -7664.03, -598.336, -554.557, 0, 0, 0, NULL), ('surf_stonework2', 6, 4, 3, 1785.38, -599.928, -6390.82, 1046.61, 607.969, -7157.61, 0, 0, 0, NULL), ('surf_stonework2', 7, 4, 4, 1977.13, -988.529, -8782.58, 1060.55, 995.241, -11520, 0, 0, 0, NULL), ('surf_jusched', 6, 4, 5, 2325.92, -14336, -6303.37, 940.498, -10358.2, -8191.97, 0, 0, 0, NULL), ('surf_jusched', 5, 4, 4, -3708.78, -5501.54, 5503.97, -1280.03, -7006.78, 5008.56, 0, 0, 0, NULL), ('surf_jusched', 4, 4, 3, 7040.03, -781.561, 11907.4, 7599.39, -1279.97, 11273.7, 0, 0, 0, NULL), ('surf_jusched', 3, 4, 2, -7510.03, 511.969, 13947.3, -5280.88, -2552.37, 11904, 0, 0, 0, NULL), ('surf_jusched', 1, 4, 0, -11148.8, 6143.97, 12632.7, -10195.8, 4100.58, 10904.7, 0, 0, 0, NULL), ('surf_jusched', 2, 4, 1, -5887.97, 5756.06, 10872.6, -5451.24, 4480.03, 10659.4, 0, 0, 0, NULL), ('surf_sundown_njv', 0, 2, 0, -11175.4, 1349.76, -7425.97, -12048, 3134.28, -7323.97, 0, 0, 0, NULL), ('surf_sundown_njv', 1, 1, 0, -3885.78, 1071.97, 14782, -4687.97, -943.969, 14884, 0, 0, 0, NULL), ('surf_sundown_njv', 2, 2, 1, -11183.1, -1228.45, -7425.97, -12048, -2999.3, -7323.97, 0, 0, 0, NULL), ('surf_sundown_njv', 3, 2, 2, -11920, 2316.91, -7425.97, -11935.8, 2166.7, -7226.59, 0, 0, 0, NULL), ('surf_sunnyhappylove', 0, 2, 0, -13536.6, 8944.03, -11570, -11104, 14640, -11468, 0, 0, 0, NULL), ('surf_sunnyhappylove', 1, 3, 2, 14096, 12346.3, 4318.03, 13323.8, 11229.4, 4420.03, 0, 0, 0, NULL), ('surf_sunnyhappylove', 2, 1, 0, 13808, 767.969, 4382.03, 14847.6, -1904.92, 4484.03, 0, 0, 0, NULL), ('surf_sunnyhappylove', 3, 3, 0, 13295.8, -8709.97, 3070.03, 13888, -6918.16, 3172.03, 0, 0, 0, NULL), ('surf_sunnyhappylove', 4, 3, 1, 9058.59, 5212.28, 3406.03, 9794.01, 4386.06, 3508.03, 0, 0, 0, NULL), ('surf_sunset', 3, 2, 1, 1715.43, -3616.03, 3982.03, 1357.73, -3773.09, 4084.03, 0, 0, 0, NULL), ('surf_sunset', 1, 3, 1, 9018.91, -71.9688, -4753.97, 9183.97, 71.9988, -4651.97, 0, 0, 0, NULL), ('surf_sunset', 7, 2, 0, 119.4, -1346.51, -2519.97, -124.393, -1775.97, -2268.85, 0, 0, 1, 'BONUS 1');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_sunset', 6, 1, 0, 767.438, -3390.15, 192.031, -959.969, -3196.19, 299.265, 0, 0, 1, 'BONUS 1'), ('surf_sunset', 2, 3, 0, 2446.03, 4112.03, -1265.97, 3015.18, 4230.99, -1188.61, 0, 0, 0, NULL), ('surf_sunset2', 0, 1, 1, -3439.97, -563.261, -2737.97, -2704.03, -799.932, -2635.97, 0, 0, 0, NULL), ('surf_sunset2', 1, 3, 2, -772.25, -4990.79, -2576.51, -962.512, -5265.79, -2498.28, 0, 0, 0, NULL), ('surf_sunset2', 2, 3, 1, -6160.03, -2832.03, -2033.97, -6368.12, -3311.99, -1915.97, 0, 0, 0, NULL), ('surf_sunset2', 3, 3, 3, -6437.72, 730.509, 5134.03, -7007.41, 279.193, 5291.74, 0, 0, 0, NULL), ('surf_sunset2', 4, 3, 4, -11127.6, -2880.31, 2062.03, -11425, -3230.41, 2164.03, 0, 0, 0, NULL), ('surf_sunset2', 5, 2, 1, -10256, -12220.2, -4665.97, -12287.2, -11292.5, -4210.11, 0, 0, 0, NULL), ('surf_sunset2', 6, 3, 0, -3447.56, -3204.03, 1550.03, -3719.02, -3088.03, 1652.03, 0, 0, 0, NULL), ('surf_sunset_njv', 0, 3, 3, -1814.74, 1806.11, -377.969, -2301.41, 2295.47, -275.969, 0, 0, 0, NULL), ('surf_sunset_njv', 1, 3, 1, 9018.91, -71.9688, -4753.97, 9183.97, 71.9988, -4651.97, 0, 0, 0, NULL), ('surf_sunset_njv', 2, 3, 0, 2446.03, 4112.03, -1265.97, 3015.18, 4230.99, -1188.61, 0, 0, 0, NULL), ('surf_sunset_njv', 3, 2, 1, 1715.43, -3616.03, 3982.03, 1357.73, -3773.09, 4084.03, 0, 0, 0, NULL), ('surf_sunset_njv', 4, 1, 1, 12601.9, -13206.7, -1025.97, 13001.8, -13504, -923.969, 0, 0, 0, NULL), ('surf_sunset_njv', 5, 3, 4, 1411.55, -6808.53, 7950.03, 1640.63, -6548.47, 8052.03, 0, 0, 0, NULL), ('surf_sup_', 0, 3, 4, -2823.68, 3319.84, 126.031, -2991.99, 2721.83, 228.031, 0, 0, 0, NULL), ('surf_sup_', 1, 3, 1, -5859.97, 1724.1, 1206.03, -5372.03, 1448.03, 1308.03, 0, 0, 0, NULL), ('surf_sup_', 2, 1, 0, -6576.97, 1815.38, 982.031, -6100, 1638.67, 1100.03, 0, 0, 0, NULL), ('surf_sup_', 3, 3, 3, -1520.84, 2164.6, 624.531, -1289.75, 1454.82, 663.905, 0, 0, 0, NULL), ('surf_sup_', 4, 3, 2, -3825.63, 1728.48, 1208.03, -4335.7, 1432.03, 1242.51, 0, 0, 0, NULL), ('surf_sup_', 5, 3, 0, -5123.97, 1732.58, 1206.03, -4636.03, 1448.03, 1308.03, 0, 0, 0, NULL), ('surf_sup_', 6, 3, 7, -2077.36, 959.969, 988.031, -3159.97, -1039.97, 1090.03, 0, 0, 0, NULL), ('surf_sup_', 7, 2, 0, 2447.45, -537.519, 81.0312, 2771.97, 461.08, 183.031, 0, 0, 0, NULL), ('surf_sup_', 8, 3, 6, 8954.96, -2818.82, 1534.03, 8445.85, -2306.75, 1636.03, 0, 0, 0, NULL), ('surf_sup_', 9, 3, 5, -1251.01, 4743.97, -1793.97, -1839.97, 3960.03, -1691.97, 0, 0, 0, NULL), ('surf_sup_', 10, 2, 0, -9271.32, -7027.23, -1589.87, -9174.83, -7209.72, -1470.62, 0, 0, 1, NULL), ('surf_sup_', 11, 1, 0, -9339.82, -2035.83, 2423.95, -9280.52, -1897.02, 2368.03, 0, 0, 1, NULL), ('surf_symbiosis_njv', 0, 1, 1, 2792.03, -560.299, 9142.03, 3042.26, -783.356, 9244.03, 0, 0, 0, NULL), ('surf_symbiosis_njv', 1, 2, 1, 12994.5, -1023.99, -3945.97, 12288, 399.969, -3843.97, 0, 0, 0, NULL), ('surf_symbiosis_njv', 2, 1, 2, 2792, -54.4894, 9142.03, 3047.97, 191.674, 9244.03, 0, 0, 0, NULL), ('surf_symbiosis_njv', 3, 4, 0, 3632.84, 2344.29, 6015.97, 2195.85, -3407.97, 4890.16, 0, 0, 0, NULL), ('surf_symbiosis_njv', 4, 4, 1, 1573.75, -927.969, 4354.66, 1136.67, 287.969, 4003.28, 0, 0, 0, NULL), ('surf_symbiosis_njv', 5, 4, 2, -5030.06, 1007.97, 3940.22, -5569.45, -1646.27, 3008.03, 0, 0, 0, NULL), ('surf_symbiosis_njv', 6, 4, 3, 12490.7, -845.368, 1071.97, 11835, 207.969, 225.689, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_symbiosis_njv', 7, 4, 4, 3138.59, 826.786, -1088.03, 3527.97, -694.895, -2076.96, 0, 0, 0, NULL), ('surf_symbiosis_njv', 8, 4, 5, -6470.45, -2175.97, -4064.69, -7967.97, 1588.43, -4994.09, 0, 0, 0, NULL), ('surf_syria_', 0, 3, 4, -11861.4, 1289.93, 355.031, -11626.4, 1746.3, 453.031, 0, 0, 0, NULL), ('surf_syria_', 1, 3, 3, 7726.42, -1429.07, -1545.97, 7319.35, -2063.26, -1443.97, 0, 0, 0, NULL), ('surf_syria_', 2, 3, 6, 5641.63, -4321.87, -2769.97, 5315.7, -4750.72, -2667.97, 0, 0, 0, NULL), ('surf_syria_', 3, 3, 2, 4932.42, 4152.87, 18.0312, 5366.07, 3577.68, 120.031, 0, 0, 0, NULL), ('surf_syria_', 4, 3, 1, -4124.97, -1185.46, 475.528, -3863.36, -901.94, 553.003, 0, 0, 0, NULL), ('surf_syria_', 5, 3, 0, -5462.83, 1676.11, -4629.97, -5747.46, 1404.92, -4527.97, 0, 0, 0, NULL), ('surf_syria_', 6, 2, 0, -4523.19, 1.53125, 7700.03, -5415.47, 897.469, 7802.03, 0, 0, 0, NULL), ('surf_syria_', 7, 1, 0, -5278.74, 4162.72, -1183.97, -4850.53, 3391.87, -1081.97, 0, 0, 0, NULL), ('surf_syria_', 8, 3, 5, -7465.88, 5200.26, 3684.03, -7120.4, 5717.28, 3786.03, 0, 0, 0, NULL), ('surf_syria_again', 0, 3, 4, -11862.5, 1188.65, 355.031, -11520.9, 1696.14, 457.031, 0, 0, 0, NULL), ('surf_syria_again', 1, 1, 1, -5273.95, 3397.95, -1183.97, -4850.53, 4163.95, -1081.97, 0, 0, 0, NULL), ('surf_syria_again', 2, 3, 0, -5731.03, 1700.09, -4629.97, -5464.73, 1344.09, -4527.97, 0, 0, 0, NULL), ('surf_syria_again', 3, 3, 1, -4124.97, -927.209, 475.528, -3794.33, -1151.22, 546.531, 0, 0, 0, NULL), ('surf_syria_again', 4, 3, 2, 5404.51, 3530.19, 18.0312, 4817.56, 4180.74, 120.031, 0, 0, 0, NULL), ('surf_syria_again', 5, 3, 3, 7737.5, -1988.4, -1537.97, 7285.91, -1510.34, -1443.97, 0, 0, 0, NULL), ('surf_syria_again', 6, 3, 5, 1385.28, -4522.77, -2270.97, 904.416, -4110.52, -2168.97, 0, 0, 0, NULL), ('surf_jusched', 0, 1, 1, 2178.18, 12537.3, 12798, 1405.04, 12798.1, 13029, 0, 0, 0, NULL), ('surf_infamous_ksf', 7, 2, 0, 4736.03, 7303.83, -4367.85, 5709.04, 7031.45, -4096.03, 0, 0, 1, 'BONUS 1'), ('surf_infamous_ksf', 6, 1, 0, 1374.63, 7423.61, -1375.97, 1116.24, 6910.29, -1288.03, 0, 0, 1, 'BONUS 1'), ('surf_infamous_ksf', 5, 3, 0, 9451.6, 239.273, 10750, 8976.3, -240.75, 10852, 0, 0, 0, NULL), ('surf_infamous_ksf', 4, 3, 1, -11728, 7503.97, 3758.03, -11138.9, 6705.28, 3860.03, 0, 0, 0, NULL), ('surf_infamous_ksf', 3, 3, 3, -504.64, -1802.83, 4910.03, 511.209, -1277.89, 5012.03, 0, 0, 0, NULL), ('surf_infamous_ksf', 2, 2, 1, -5264.03, 4326.6, -2001.97, -9071.97, 4847.98, -1771.97, 0, 0, 0, NULL), ('surf_system_lost_wr_rg', 0, 1, 1, -783.969, 1151.85, 192.031, 1231.97, 761.422, 292.031, 0, 0, 0, NULL), ('surf_system_lost_wr_rg', 1, 2, 1, 1359.97, 13110, -2117.92, -961.355, 11615.9, -1795.32, 0, 0, 0, NULL), ('surf_s_t_a_t_i_o_n', 0, 3, 3, 2447.97, -3968.93, -3799.12, 1896.55, -4228.62, -3716.78, 0, 0, 0, NULL), ('surf_s_t_a_t_i_o_n', 1, 3, 4, -7602.97, -6497.03, -2946.97, -7011.84, -6907.29, -2844.97, 0, 0, 0, NULL), ('surf_s_t_a_t_i_o_n', 2, 3, 5, 8202.65, -3776.39, -1883.66, 7715.04, -4293.55, -1784.02, 0, 0, 0, NULL), ('surf_s_t_a_t_i_o_n', 3, 2, 0, -2460.75, 6893.27, -6122.82, -2524.01, 6993.22, -6020.06, 0, 0, 0, NULL), ('surf_s_t_a_t_i_o_n', 4, 3, 2, -9027.97, 3673.79, -2547.97, -8686.12, 3954.36, -2445.97, 0, 0, 0, NULL), ('surf_s_t_a_t_i_o_n', 5, 3, 1, -6581.62, 1330.4, -1869.97, -6375.79, 1618.08, -1767.97, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_s_t_a_t_i_o_n', 6, 3, 0, 11515.4, -1793.01, -1889.97, 11041.7, -1161.76, -1787.97, 0, 0, 0, NULL), ('surf_s_t_a_t_i_o_n', 7, 1, 0, 6856.61, 5839.98, -4055.97, 6358.71, 5360.42, -3953.97, 0, 0, 0, NULL), ('surf_take1', 0, 2, 1, 14594.9, 668.577, -5313.97, 15312, 494.153, -5211.97, 0, 0, 0, NULL), ('surf_take1', 1, 1, 1, -12231, 1.62161, 12350, -13040, 705.911, 12452, 0, 0, 0, NULL), ('surf_taq_njv', 0, 1, 0, -3146.07, 1519.97, 15358, -2511.81, 513.839, 15460, 0, 0, 0, NULL), ('surf_taq_njv', 1, 3, 1, -1067.63, 5525.72, 13832.8, -773.638, 5818.96, 13934.8, 0, 0, 0, NULL), ('surf_taq_njv', 2, 2, 0, 8751.97, -1967.97, 15614, 8342.21, -1360, 15716, 0, 0, 0, NULL), ('surf_taq_njv', 3, 3, 0, -2747.11, -3083.38, 15614, -3371.1, -2505.1, 15716, 0, 0, 0, NULL), ('surf_tenacious', 0, 3, 0, -6837.81, -1225.98, 6551.53, -6584.1, -1484.56, 6653.53, 0, 0, 0, NULL), ('surf_tenacious', 1, 3, 1, 11359, 5038.2, 2253.53, 11089.5, 5293.33, 2355.53, 0, 0, 0, NULL), ('surf_tenacious', 2, 3, 2, 6116.97, 9096.03, -8186.47, 5253.33, 9563.97, -8084.47, 0, 0, 0, NULL), ('surf_tenacious', 3, 1, 1, 4989.59, -10753.6, 10326.5, 5230.89, -11145.2, 10428.5, 0, 0, 0, NULL), ('surf_tenacious', 4, 2, 1, -6450.6, 9101.69, -10521.6, -6389.6, 9535.42, -10071.6, 0, 0, 0, NULL), ('surf_tensile_njv', 0, 2, 0, 1140.03, 3728.03, -10957, 2127.97, 4719.97, -10855, 0, 0, 0, NULL), ('surf_tensile_njv', 1, 1, 0, -12499.7, 4719.97, 10814, -12850.8, 3728.03, 10916, 0, 0, 0, NULL), ('surf_tensile_njv', 2, 4, 0, -4042.61, 4736.23, 9957.5, -2456.36, 3712.03, 8622.36, 0, 0, 0, NULL), ('surf_tensile_njv', 3, 4, 1, 5733.39, 5045.17, 6597.36, 6535.63, 3423.65, 5752.03, 0, 0, 0, NULL), ('surf_tensile_njv', 4, 4, 2, 3648.47, 4719.97, 5224.71, -375.502, 3727.55, 3716.06, 0, 0, 0, NULL), ('surf_tensile_njv', 5, 4, 3, 2286.45, 4783.04, 456.031, 1278.43, 3672.77, 2271.97, 0, 0, 0, NULL), ('surf_tensile_njv', 6, 4, 4, 2392.13, 6714.97, -3474.79, 877.871, 1757.03, -5015.97, 0, 0, 0, NULL), ('surf_tensile_njv', 7, 4, 5, 2396.37, 7707.97, -7901.1, 873.453, 740.031, -8911.27, 0, 0, 0, NULL), ('surf_thembrium_sns', 0, 2, 0, 8041.03, 14691.5, 4544.03, 10057, 14940.5, 4646.03, 0, 0, 0, NULL), ('surf_thembrium_sns', 1, 3, 2, 2642.31, 13124.8, -9026.97, 2287.53, 12755.3, -8924.97, 0, 0, 0, NULL), ('surf_thembrium_sns', 2, 3, 3, 9272.25, 7784.61, 11256, 8793.49, 8167.45, 11358, 0, 0, 0, NULL), ('surf_thembrium_sns', 3, 3, 1, 1179.62, -5350, 1770.03, 842.031, -4869.03, 1872.03, 0, 0, 0, NULL), ('surf_thembrium_sns', 4, 3, 0, -3749.64, 4436.03, 1148.03, -4164.4, 5427.97, 1302.67, 0, 0, 0, NULL), ('surf_thembrium_sns', 5, 1, 0, -1911.05, 2671.91, -479.969, -885.534, 3102.97, -380.969, 0, 0, 0, NULL), ('surf_thembrium_sns', 6, 6, 0, 2905.37, 416.778, -1924.41, 1902.28, -352.025, -2031.27, 0, 0, 0, NULL), ('surf_theworldismine_njv', 0, 2, 1, 4527.99, -574.103, -13651, 4144.29, -67.6249, -13378, 0, 0, 0, NULL), ('surf_theworldismine_njv', 1, 1, 1, -1401.76, -832.277, 10347, -956.424, 192.485, 10447, 0, 0, 0, NULL), ('SURF_the_distance', 0, 1, 1, 3111.55, 1635.37, 13094.9, 2618.52, 926.41, 13190.2, 0, 0, 0, NULL), ('surf_infamous_ksf', 1, 3, 2, 5696.03, -6288.03, 4926.03, 6524.63, -6710.34, 5028.03, 0, 0, 0, NULL), ('surf_the_gloaming', 0, 1, 1, 7408.03, 751.969, 12466, 7766.07, 393.795, 12568, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_the_gloaming', 1, 2, 1, -1568.01, 14307.8, -993.969, -4575.97, 12320, -852.611, 0, 0, 0, NULL), ('surf_the_gloaming', 2, 1, 2, 7408.03, -751.969, 12466, 7766.3, -394.409, 12568, 0, 0, 0, NULL), ('surf_the_gloaming_rat', 0, 2, 1, -4585.9, 13942.2, -495.969, -1585.89, 15325.3, -16.0313, 0, 0, 0, NULL), ('surf_the_gloaming_rat', 1, 1, 1, 7408.03, 751.969, 12466, 7767.61, 392.011, 12568, 0, 0, 0, NULL), ('surf_the_gloaming_rat', 2, 1, 2, 7408.03, -751.969, 12466, 7764.65, -394.382, 12568, 0, 0, 0, NULL), ('surf_the_lost_city', 0, 1, 1, 48.0312, -704.031, 32.0312, 356.55, -1470.97, 132.031, 0, 0, 0, NULL), ('surf_this_njv', 0, 2, 0, 4225.15, -1598.47, -4319.97, 4726.67, 447.519, -3872.03, 0, 0, 0, NULL), ('surf_this_njv', 1, 1, 0, -4856.66, -2351.97, 15294, -4610.02, 1199.97, 15396, 0, 0, 0, NULL), ('surf_this_njv', 2, 4, 0, -751.522, -2321.59, 15041.8, -2314.39, 1209.69, 12928, 0, 0, 0, NULL), ('surf_this_njv', 3, 4, 1, -3130.74, -2367.97, 11130.9, -2208.39, 1215.97, 10109, 0, 0, 0, NULL), ('surf_this_njv', 4, 4, 2, 4613.63, -2367.97, 8174.64, 5828.36, 1211.35, 10240, 0, 0, 0, NULL), ('surf_this_njv', 5, 4, 3, 12119.8, -1074.86, 2929.16, 10832, -64.0312, 3938.43, 0, 0, 0, NULL), ('surf_this_njv', 6, 4, 4, -7.49481, -223.264, 2552.04, 227.685, -927.969, 1619.08, 0, 0, 0, NULL), ('surf_this_njv', 7, 4, 5, -8792.03, -2359.48, 1829.67, -7657.62, 1215.97, 3083.82, 0, 0, 0, NULL), ('surf_this_njv', 8, 4, 6, -14061.8, -2367.97, 3832.72, -15643.8, 1215.97, 2257.94, 0, 0, 0, NULL), ('surf_this_njv', 9, 4, 7, 4756.11, -2328.25, 2535.97, 5579.94, 1207.57, 832.031, 0, 0, 0, NULL), ('surf_this_njv', 10, 4, 8, 11023.4, -2367.97, -3309.93, 12121.5, 1215.97, -1301.23, 0, 0, 0, NULL), ('surf_this_njv', 11, 4, 9, -2368.03, -1146.02, -3338.7, -3160.25, -0.031219, -4214.38, 0, 0, 0, NULL), ('surf_timewarp_', 0, 1, 1, 32.0312, 16.0312, 2046.03, 297.206, 487.423, 2148.03, 0, 0, 0, NULL), ('surf_timewarp_', 1, 3, 3, -503.984, -11768.1, 7166.03, 506.251, -10753.5, 7268.03, 0, 0, 0, NULL), ('surf_timewarp_', 2, 3, 2, -4015.97, 11257.7, 6654.03, -3375.97, 10241.3, 6756.03, 0, 0, 0, NULL), ('surf_timewarp_', 3, 3, 0, -3983.97, -2576.03, 6654.03, -3594.21, -3578.77, 6756.03, 0, 0, 0, NULL), ('surf_timewarp_', 4, 3, 1, 571.452, -4165.97, -8033.97, 1400, -3777.37, -7931.97, 0, 0, 0, NULL), ('surf_timewarp_', 5, 1, 2, 32.0312, 2031.97, 2046.03, 282.733, 1573.96, 2148.03, 0, 0, 0, NULL), ('surf_timewarp_', 6, 2, 1, 10178.2, -2852.96, -5185.97, 11582, -4256.62, -5083.97, 0, 0, 0, NULL), ('surf_togo', 0, 2, 1, -1846, 665.956, -14754, -2066.26, 368.652, -14533.6, 0, 0, 0, NULL), ('surf_togo', 1, 1, 1, -6276.82, 5567.97, -865.969, -6568.62, 5335, -763.969, 0, 0, 0, NULL), ('surf_togo_njv', 0, 1, 1, -6275.97, 5567.97, -865.969, -6473.09, 5331.65, -763.969, 0, 0, 0, NULL), ('surf_togo_njv', 1, 2, 1, -1841.88, 694.214, -14752, -2028.79, 327.969, -14625.5, 0, 0, 0, NULL), ('surf_tomb_redone', 0, 2, 0, 5117.6, -495.969, -12098, 4600.69, -17.0042, -11980, 0, 0, 0, NULL), ('surf_tomb_redone', 1, 1, 0, 3247, 5.49697, 382.031, 2947.52, -515.063, 432.166, 0, 0, 0, NULL), ('surf_torque2', 0, 3, 1, -8021.98, 2662.32, 3742.03, -7905.96, 2936.21, 3844.03, 0, 0, 0, NULL), ('surf_torque2', 1, 3, 0, -86.0312, -3556.97, 3510.03, -574.722, -3285.03, 3612.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_torque2', 2, 1, 1, -3306.48, -190.277, 2694.03, -3090.03, 192.727, 2796.03, 0, 0, 0, NULL), ('surf_torque2_njv', 0, 3, 2, -3013.49, -7268.04, 7327.11, -2850.6, -6877.2, 7289.03, 0, 0, 0, NULL), ('surf_torque2_njv', 1, 1, 0, -3291.35, 156.214, 2696.03, -3090, -165.348, 2796.03, 0, 0, 0, NULL), ('surf_torque2_njv', 2, 2, 0, -10056, -6088.03, -9375.97, -8072.03, -8071.97, -9275.97, 0, 0, 0, NULL), ('surf_torque2_njv', 3, 3, 1, -8021.97, 2647.27, 3744.03, -7883.13, 2960.09, 3844.03, 0, 0, 0, NULL), ('surf_torque2_njv', 4, 3, 0, -86.0312, -3556.97, 3512.03, -539.276, -3285.03, 3612.03, 0, 0, 0, NULL), ('surf_torque2_njv', 5, 0, 0, 162.133, 229.549, 2373.03, 5.03125, -260.835, 2539.49, 0, 0, 0, NULL), ('surf_torque2_njv', 6, 0, 1, -5.03125, 246.688, 2559.86, -176.932, -257.852, 2373.03, 0, 0, 0, NULL), ('surf_torque2_njv', 7, 2, 0, -11213.6, -232.755, -5811.97, -11577, 239.304, -5447.03, 0, 0, 1, NULL), ('surf_torque2_njv', 8, 1, 0, 5704.68, 336.92, -4862.97, 5646.57, -343.607, -5032.97, 0, 0, 1, NULL), ('surf_torque_', 0, 3, 2, -2367.97, 5080.81, 2037.7, -2220.64, 5298.2, 2008.03, 0, 0, 0, NULL), ('surf_torque_', 1, 3, 0, -1410.03, -993.098, 369.452, -1599.3, -1193.73, 350.031, 0, 0, 0, NULL), ('surf_torque_', 2, 1, 0, 3928.69, 760.498, 2834.03, 4086.85, 968.902, 2944.03, 0, 0, 0, NULL), ('surf_torque_', 3, 3, 1, 10209, -3432.76, 3673.46, 10414.2, -3252.01, 3652.34, 0, 0, 0, NULL), ('surf_torque_', 4, 2, 0, 1986.44, 5688.77, -5233.97, 2975.21, 4699.62, -5133.97, 0, 0, 0, NULL), ('surf_torque_', 5, 1, 0, 3508.03, 4169.34, 2815.03, 3759.2, 3295.03, 2917.03, 0, 0, 1, NULL), ('surf_torque_', 6, 2, 0, 735.969, 4171.97, 2529.03, 328.839, 3295.03, 2631.03, 0, 0, 1, NULL), ('surf_trance_ksf', 0, 5, 1, -156.776, 2927.97, 16190, -38.0691, 2836.86, 16292, 0, 0, 0, NULL), ('surf_trance_ksf', 1, 2, 1, 11020, 4491.97, -11363, 10772, 3700.03, -11261, 0, 0, 0, NULL), ('surf_trance_ksf', 2, 5, 2, -371.063, 3231.97, 16030, -495.52, 3125.93, 15872, 0, 0, 0, NULL), ('surf_trance_ksf', 3, 5, 3, 683.746, 3231.97, 16030, 575.934, 3133.68, 15872, 0, 0, 0, NULL), ('surf_trance_ksf', 4, 5, 4, 226.593, 2943.97, 16309, 345.286, 2847.31, 16192, 0, 0, 0, NULL), ('surf_trance_ksf', 5, 1, 0, 227.854, 2927.97, 16190, 345.2, 2849.62, 16292, 0, 0, 1, NULL), ('surf_trance_ksf', 6, 2, 0, 2671.97, 11344, -15810, 2128, 12720, -15708, 0, 0, 1, NULL), ('surf_trance_ksf', 7, 4, 0, -8073.85, 7744.03, 14728.8, -10398, 8320.12, 13376, 0, 0, 0, NULL), ('surf_trance_ksf', 8, 4, 1, -530.108, -6079.97, 10793.2, 799.549, -2112.03, 8783.13, 0, 0, 0, NULL), ('surf_trance_ksf', 9, 4, 2, 8618.05, -6208.03, 6850.6, 9904.71, -6902.96, 4672.03, 0, 0, 0, NULL), ('surf_trance_ksf', 10, 4, 3, 5696.03, 986.015, 2682.7, 6263.67, 2144.29, 1088.03, 0, 0, 0, NULL), ('surf_trance_ksf', 11, 4, 4, 14330.5, 4621.84, -3136.03, 15808, 3442.83, -3694.16, 0, 0, 0, NULL), ('surf_trance_ksf', 12, 4, 5, -10176, 4601.99, -9157.5, -10176, 3586.78, -10230.9, 0, 0, 0, NULL), ('surf_trance_ksf', 13, 6, 0, 9034.91, 9145.13, 1439.73, 9497.69, 9056.03, 1314.87, 0, 0, 0, NULL), ('surf_gurus_njv', 5, 1, 1, 3345.97, 785.969, -1.96875, 2784.48, 374.233, 95.0376, 0, 0, 0, NULL), ('surf_gurus_njv', 4, 3, 0, -536.969, 2504.56, 1981.03, -55.6597, 2160.14, 2083.03, 0, 0, 0, NULL), ('surf_gurus_njv', 3, 3, 1, -577.736, 6244.2, -1225.97, -273.275, 6008.04, -1123.97, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_gurus_njv', 2, 3, 2, -3814.23, 618, 3083.03, -3244.58, 1099.05, 3185.03, 0, 0, 0, NULL), ('surf_gurus_njv', 1, 3, 4, 7194.03, -36.0312, 1403.03, 7298.95, -259.969, 1505.03, 0, 0, 0, NULL), ('surf_gurus_njv', 0, 2, 1, 8722.23, -2085.57, -4031.35, 9198.97, -2594.46, -3816.3, 0, 0, 0, NULL), ('surf_extremex2_5_njv', 6, 2, 1, -3520.03, 3074.49, -4861.53, -4028.44, 5115.56, -5055.97, 0, 0, 0, NULL), ('surf_extremex2_5_njv', 5, 3, 4, -372.146, 3136.03, -1608.18, -80.6841, 4947.36, -1687.97, 0, 0, 0, NULL), ('surf_extremex2_5_njv', 4, 3, 3, -271.969, -9376.07, -6664.14, 35.7087, -9075.14, -6751.97, 0, 0, 0, NULL), ('surf_extremex2_5_njv', 3, 3, 2, 2622.78, -13952, 3945.91, 2366.82, -14718.8, 3908.21, 0, 0, 0, NULL), ('surf_treespam', 0, 2, 1, -1983.2, 12047.5, 1849.85, -2118.63, 12143.6, 2156.53, 0, 0, 0, NULL), ('surf_treespam', 1, 3, 2, -5168.03, -10493.3, 3840.03, -7119.99, -10288, 3940.03, 0, 0, 0, NULL), ('surf_treespam', 2, 3, 1, -2298.83, 14626.2, 0.03125, -1792.07, 14198.7, 100.001, 0, 0, 0, NULL), ('surf_treespam', 3, 3, 0, 3909.19, 149.235, -2815.97, 4297.32, -253.916, -2715.97, 0, 0, 0, NULL), ('surf_treespam', 4, 1, 1, 255.609, 736.486, 256.031, -255.477, 975.969, 356.031, 0, 0, 0, NULL), ('surf_treespam', 5, 3, 3, -5956.91, -511.684, -991.969, -6337.21, -259.329, -891.969, 0, 0, 0, NULL), ('surf_trinity', 0, 3, 0, 124.276, 160.88, 0.03125, -142.218, -176.045, 100.031, 0, 0, 0, NULL), ('surf_trinity', 1, 2, 1, 1862.12, -6449.43, -1015.97, 1354.94, -6948.96, -915.969, 0, 0, 0, NULL), ('surf_trinity', 2, 3, 1, 437.872, -2246.78, -119.969, 557.511, -2364.76, -19.9688, 0, 0, 0, NULL), ('surf_trinity', 3, 3, 4, 1526.63, -6775.03, 1160.03, 1687.89, -6634.48, 1260.03, 0, 0, 0, NULL), ('surf_trinity', 4, 3, 3, 5614.67, -4319.46, 1211.03, 5765.91, -4121.15, 1311.03, 0, 0, 0, NULL), ('surf_trinity', 5, 3, 2, 1896, -3387.48, 836.031, 2113.8, -3043.93, 936.031, 0, 0, 0, NULL), ('surf_trinity', 6, 1, 1, -308.13, -1097.03, -359.969, -469.969, -1286.97, -259.969, 0, 0, 0, NULL), ('surf_tronia', 0, 1, 1, -2343.29, 501.689, 5972.03, -1779.32, -501.578, 6081.55, 0, 0, 0, NULL), ('surf_tronia', 1, 3, 1, 2107.03, 87.9688, -6976.47, 2279.95, -85.2994, -6866.47, 0, 0, 0, NULL), ('surf_tronia', 2, 3, 0, -319.653, -320.995, 1126.33, 317.739, 316.678, 1227.25, 0, 0, 0, NULL), ('surf_tronia_njv', 0, 1, 1, -2337.65, 503.395, 5972.03, -1769.72, -496.422, 6088.31, 0, 0, 0, NULL), ('surf_tronia_njv', 1, 2, 1, 10807.5, -550.926, -14968, 11500.1, 140.906, -14927, 0, 0, 0, NULL), ('surf_tronia_njv', 2, 3, 1, -11020.9, -567.262, -4232.86, -11591.8, 557.067, -4489.77, 0, 0, 0, NULL), ('surf_tronia_njv', 3, 3, 0, -308.095, -313.952, 1125.98, 318.011, 316.92, 1227.34, 0, 0, 0, NULL), ('surf_tronic_njv', 0, 3, 1000, -9036.97, 47.9688, 574.031, -8642.11, -46.0249, 676.031, 0, 0, 0, NULL), ('surf_tronic_njv', 1, 2, 1, -494.244, 467.969, -15226, 494.252, -468, -15124, 0, 0, 0, NULL), ('surf_tronic_njv', 2, 1, 1, -207.335, -208.117, 11186, 210.643, 209.684, 11288, 0, 0, 0, NULL), ('surf_tron_njv', 0, 1, 0, -14288, 126.31, 64.0312, -13821.2, -124.881, 164.031, 0, 0, 0, NULL), ('surf_tron_njv', 1, 2, 0, -11834.6, -2335.65, -8191.97, -12616.1, -1729.07, -8091.97, 0, 0, 0, NULL), ('surf_tron_njv', 2, 4, 0, -2556.89, 479.969, -1271.53, -2052.59, -479.969, -542.236, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_tron_njv', 3, 4, 1, 3617.17, -7124.41, -1568.03, 3028.13, -6144.03, -2580.03, 0, 0, 0, NULL), ('surf_tron_njv', 4, 4, 2, -6908.89, -7127.92, -513.126, -7279.04, -6043.08, -1535.97, 0, 0, 0, NULL), ('surf_tron_njv', 5, 4, 3, -3606.51, -1557.49, -1568.03, -2625.84, -2549.83, -2591.97, 0, 0, 0, NULL), ('surf_tron_njv', 6, 4, 4, -9718.32, -2524.92, -5856.03, -9458.09, -1536.03, -6851.24, 0, 0, 0, NULL), ('surf_extremex2_5_njv', 2, 3, 1, -5183.77, -8512.03, 6240.84, -4934.01, -9919.97, 6208.22, 0, 0, 0, NULL), ('surf_extremex2_5_njv', 1, 3, 0, 12882.3, -10620.8, 9088.03, 13132.3, -8839.13, 9118.03, 0, 0, 0, NULL), ('surf_extremex2_5_njv', 0, 1, 1, -9796.12, -1824.03, 2748.62, -10166.7, -2266.34, 2688.03, 0, 0, 0, NULL), ('surf_exile_njv', 7, 6, 0, 5232.51, 4587.49, 995.969, 5198.92, 4606.82, 986.875, 0, 0, 0, ''), ('surf_exile_njv', 6, 1, 2, 5607.97, 4376, 786.031, 5257.31, 4823.97, 888.031, 0, 0, 0, NULL), ('surf_two_colour', 0, 3, 1, -5511.38, -2655.97, 2954.03, -5734.92, -2447.57, 3056.03, 0, 0, 0, NULL), ('surf_two_colour', 1, 3, 4, -1163.86, 12138.4, -4228.97, -1475.34, 11810, -4131.97, 0, 0, 0, NULL), ('surf_two_colour', 2, 3, 3, 5112.68, -12824.2, 3856.03, 5304.62, -13008, 3956.03, 0, 0, 0, NULL), ('surf_two_colour', 3, 3, 0, 1240.62, -3519.97, 3726.03, 1048.68, -3146.03, 3828.03, 0, 0, 0, NULL), ('surf_two_colour', 4, 1, 0, 5398.76, -11908.5, 6910.03, 4896.66, -11543.1, 7012.03, 0, 0, 0, NULL), ('surf_two_colour', 5, 3, 2, -11009.7, -956.031, 2862.03, -11435.9, -1691.97, 2964.03, 0, 0, 0, NULL), ('surf_two_colour', 6, 2, 0, -4629.98, 1443.21, -5903.97, -3767.56, 2299.27, -5803.97, 0, 0, 0, NULL), ('surf_two_colour', 7, 6, 0, -823.381, -7473.95, 328.654, -2426.62, -9076.66, -1039.97, 0, 0, 0, NULL), ('surf_two_colour', 8, 6, 1, -11727.2, 1062.13, 2151.97, -11423.5, 1009.64, 2040.03, 0, 0, 0, NULL), ('surf_ultimate', 0, 3, 2, 1644.97, -2613.49, 11.5312, 1223.03, -2250.05, 113.531, 0, 0, 0, NULL), ('surf_ultimate', 1, 3, 1, 11416.1, 3035.66, 4514.37, 11310.8, 3527.44, 4621.5, 0, 0, 0, NULL), ('surf_ultimate', 2, 3, 3, 11279, -2068.55, -6275.22, 10911.5, -2208.4, -6189.93, 0, 0, 0, NULL), ('surf_ultimate', 3, 2, 1, 5960.03, -2305.47, -10567.5, 6442.47, -2038.5, -10565.5, 0, 0, 0, NULL), ('surf_ultimate', 4, 3, 0, 7331.94, 84.1344, 8905.8, 7045.72, 594.201, 8954.17, 0, 0, 0, NULL), ('surf_ultimate', 5, 1, 1, 9532.38, 1483.53, 998.531, 9183.82, 2131.49, 1218.23, 0, 0, 0, NULL), ('surf_ultimatum', 0, 1, 0, -6553.97, 363.969, 1434.03, -5594, 129.885, 1536.03, 0, 0, 0, NULL), ('surf_ultimatum', 1, 3, 0, -3085.88, 44.0312, 2394.03, -2766.64, 277.141, 2496.03, 0, 0, 0, NULL), ('surf_ultimatum', 2, 2, 0, -2633.97, -1015.03, -7509.97, -2282.03, -1366.97, -7407.97, 0, 0, 0, NULL), ('surf_ultimatum', 3, 3, 3, -6988, -1480.38, -4699.97, -6775.64, -1311.94, -4606.97, 0, 0, 0, NULL), ('surf_ultimatum', 4, 3, 2, 6598.97, 747.031, 1098.03, 6103.03, 986.969, 1200.03, 0, 0, 0, NULL), ('surf_ultimatum', 5, 3, 1, 262.031, 379.969, 1974.03, 901.969, 204.003, 2076.03, 0, 0, 0, NULL), ('surf_ultimatum', 6, 3, 4, -2418.03, -959.031, -4445.97, -2498, -1045.51, -4343.97, 0, 0, 0, NULL), ('surf_ultimatum', 7, 6, 0, -7531.01, 1250.32, 2016.97, -8279.28, 1998.97, 1769.78, 0, 0, 0, NULL), ('surf_underworld_go', 0, 2, 0, 9424.03, -14201.8, -15610, 9950.03, -15222.3, -15286.3, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_underworld_go', 1, 1, 1, 8841.74, -13760.9, 14858.9, 8237.33, -14274.1, 14956.3, 0, 0, 0, NULL), ('surf_underworld_go', 2, 1, 0, 8235.73, -13753.4, 14862.5, 8835.59, -13679.9, 14965, 0, 0, 0, NULL), ('surf_underworld_go', 3, 4, 0, -9070.6, -7272.03, 10163.8, -8600.01, -9514.14, 8448.03, 0, 0, 0, NULL), ('surf_underworld_go', 4, 4, 1, -648.997, -4010.81, 6919.87, 507.571, -5062.29, 5644.6, 0, 0, 0, NULL), ('surf_underworld_go', 5, 4, 2, 8141.53, -5696.02, 3473.97, 6142.71, -3045.73, 720.031, 0, 0, 0, NULL), ('surf_underworld_go', 6, 4, 3, -6247.3, -4991.97, -1123.48, -8247.97, -3772.15, -1875.9, 0, 0, 0, NULL), ('surf_underworld_go', 7, 4, 4, -12038.9, -2836.07, -4472.03, -12360, -5377.1, -5843.99, 0, 0, 0, NULL), ('surf_underworld_go', 8, 4, 5, 1912.44, -3439.63, -8056.03, 8.49634, -5260.69, -9567.97, 0, 0, 0, NULL), ('surf_underworld_go', 9, 4, 6, 14209.4, 3682.24, -9480.03, 15348, 4940.02, -10688, 0, 0, 0, NULL), ('surf_underworld_go', 10, 4, 7, 8629.68, 4601.2, -14592, 10753.6, 5125.12, -16160, 0, 0, 0, NULL), ('surf_underworld_go', 11, 4, 8, 15687.5, -13003.8, 237.969, 15720, -13016.2, 211.047, 0, 0, 0, NULL), ('surf_underworld_go', 12, 6, 0, 12488, -15688.2, 232.674, 15720, -13002.2, -855.739, 0, 0, 0, NULL), ('surf_unreal2', 0, 3, 0, -10629.7, 2815.97, 4247.03, -11144, 2400.03, 4349.03, 0, 0, 0, NULL), ('surf_unreal2', 1, 1, 1, 8422.35, -5078.13, 13962, 8947.56, -3678.94, 14064, 0, 0, 0, NULL), ('surf_unreal2', 2, 3, 1, -6171.56, -598.666, 12694, -6639.97, 514.486, 12796, 0, 0, 0, NULL), ('surf_unreal2', 3, 2, 1, -3388.48, 247.329, -8770.26, -3128.77, -182.329, -8668.26, 0, 0, 0, NULL), ('surf_unreal_njv', 0, 2, 1, 4057.42, -86.8078, -13118, 3873.29, -147.207, -13020.3, 0, 0, 0, NULL), ('surf_unreal_njv', 1, 2, 2, 3838.54, -86.2493, -13118, 4048.5, 102.681, -13016, 0, 0, 0, NULL), ('surf_unreal_njv', 2, 2, 3, 3824.66, -51.1051, -13118, 3769.51, 48.169, -13016, 0, 0, 0, NULL), ('surf_unreal_njv', 3, 1, 1, -7044.52, 153.413, 10617, -7534.99, -149.584, 10719, 0, 0, 0, NULL), ('surf_unreal_njv', 4, 2, 4, 4231.05, -281.133, -13118, 4052.47, 295.392, -13016, 0, 0, 0, NULL), ('surf_unreal_njv', 5, 2, 5, 4166.97, -131.031, -13118, 4181.09, 145.797, -12868.2, 0, 0, 0, NULL), ('surf_unreal_njv', 6, 2, 6, 4052.8, 102.188, -13118, 3881.33, 150.54, -13021.5, 0, 0, 0, NULL), ('surf_unusual_njv', 0, 2, 1, 4516.41, -8922.7, -1066.34, 6552.91, -8925.66, -777.133, 0, 0, 0, NULL), ('surf_unusual_njv', 1, 3, 2, 5028.77, 8839, 1631.03, 6045.69, 9260.47, 1731.03, 0, 0, 0, NULL), ('surf_unusual_njv', 2, 3, 1, 272.031, 7664.01, 1920.03, 1008, 8140.8, 2020.03, 0, 0, 0, NULL), ('surf_unusual_njv', 3, 3, 0, -2437.95, 4642.38, 1536.03, -2782.87, 4298.67, 1636.03, 0, 0, 0, NULL), ('surf_unusual_njv', 4, 1, 1, -7486.97, 2237.12, 1280.03, -5504.39, 2655.4, 1414.91, 0, 0, 0, NULL), ('surf_utopia_njv', 0, 1, 1, -13979.2, -528.841, 12798, -13758.3, 527.426, 12900, 0, 0, 0, NULL), ('surf_utopia_njv', 1, 2, 1, -13825.4, 503.964, -6225.97, -14320, -510.371, -6123.97, 0, 0, 0, NULL), ('surf_utopia_v3', 0, 1, 1, -13797.6, -512.931, 13051.9, -14320, 515.89, 13156, 0, 0, 0, NULL), ('surf_utopia_v3', 1, 2, 1, -14320, 168.726, -4433.97, -14249.6, -119.202, -4331.97, 0, 0, 0, NULL), ('surf_utopia_v3', 2, 1, 2, -13761.9, -511.173, 12800, -14336, 503.872, 12882.1, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_utopia_v3', 3, 6, 0, -999.046, -1407.1, -10087.6, 945.614, -1286.85, -10240, 0, 0, 0, NULL), ('surf_utopia_v3', 4, 6, 1, 1536.7, -1663.37, -9343.11, -1573.97, 1663.1, -10237.7, 0, 0, 0, NULL), ('surf_utopia_v3', 5, 4, 0, 12277.4, -1535.97, 8694.83, 11279.4, 1535.97, 7617.62, 0, 0, 0, NULL), ('surf_utopia_v3', 6, 4, 1, -3498.36, -4607.97, 5092.22, -494.913, 4607.97, 1062.64, 0, 0, 0, NULL), ('surf_utopia_v3', 7, 4, 2, -14205.8, 15521.7, 1663.97, -11147.4, 13972, 0.03125, 0, 0, 0, NULL), ('surf_utopia_v3', 8, 4, 3, -10981.6, -15552, 1646.32, -13789.7, -13908.9, 0.03125, 0, 0, 0, NULL), ('surf_utopia_v3', 9, 4, 4, 5660.75, 1738.41, -1344.03, 4612.84, -1740.68, -3071.97, 0, 0, 0, NULL), ('surf_utopia_v3', 10, 4, 5, 11469.2, -959.969, -3138.33, 9263.79, 959.969, -5084.69, 0, 0, 0, NULL), ('surf_val', 0, 3, 0, -2979.58, -1269.95, 1524.01, -2679.09, -942.85, 1659.85, 0, 0, 0, NULL), ('surf_val', 1, 1, 1, -1650.79, 2459.43, -11.9688, -1089.22, 3827.74, 95.3451, 0, 0, 0, NULL), ('surf_val', 2, 3, 1, -5588.84, 931.82, -340.969, -5846.16, 339.513, -238.969, 0, 0, 0, NULL), ('surf_val', 3, 3, 3, -3550.03, 7456.16, 2596.03, -3697.97, 7555.97, 2698.03, 0, 0, 0, NULL), ('surf_val', 4, 2, 1, -4680.93, 6112.27, -605.312, -5182.16, 5578.57, -506.969, 0, 0, 0, NULL), ('surf_val', 5, 3, 2, 2124.24, -1177.59, -265.969, 2438.3, -1373.27, -163.969, 0, 0, 0, NULL), ('surf_vector_final', 0, 3, 0, -664.969, -742.497, 1663.03, 1031, -582.718, 1765.03, 0, 0, 0, NULL), ('surf_vector_final', 1, 1, 0, 438.369, -1837.97, 3953.03, 657.969, -1550.03, 4039.03, 0, 0, 0, NULL), ('surf_vector_final', 2, 2, 0, -2024.78, -4655.03, 356.031, -1739.96, -6501.97, 458.031, 0, 0, 0, NULL), ('surf_vector_final', 3, 3, 2, 464.256, -6517.97, 3850.46, 51.3717, -4639.03, 3827.72, 0, 0, 0, NULL), ('surf_vector_final', 4, 3, 1, -3891.97, 5243.56, 1696.53, -3731.7, 3270.76, 1798.53, 0, 0, 0, NULL), ('surf_vegetables', 0, 3, 2, -3448.03, -1690, 796.031, -3911.97, -1277.61, 898.031, 0, 0, 0, NULL), ('surf_vegetables', 1, 3, 0, -8016.03, -3880.33, 718.031, -8379.02, -4312, 820.031, 0, 0, 0, NULL), ('surf_vegetables', 2, 1, 0, -10374.5, -959.812, 1150.03, -10546.2, -1143.73, 1252.03, 0, 0, 0, NULL), ('surf_vegetables', 3, 3, 4, 867.119, -2320.23, 805.031, 637.418, -2685.97, 908.829, 0, 0, 0, NULL), ('surf_vegetables', 4, 2, 0, 10854.3, 964.135, -3217.3, 11318.4, 863.66, -2899.15, 0, 0, 0, NULL), ('surf_vegetables', 5, 3, 8, 11581.3, -914.969, 3532.03, 10589.3, -369.272, 3634.03, 0, 0, 0, NULL), ('surf_vegetables', 6, 3, 7, 8043.83, -2950, 2358.03, 8509.44, -2421.43, 2460.03, 0, 0, 0, NULL), ('surf_vegetables', 7, 3, 6, 5020.42, 958.997, 3714.03, 5527, 814.736, 3824.03, 0, 0, 0, NULL), ('surf_vegetables', 8, 3, 5, 3353.98, -664.031, 1441.21, 2790.76, -742.141, 1542.19, 0, 0, 0, NULL), ('surf_vegetables', 9, 3, 1, -5644.08, -2784.35, 552.581, -5825.63, -2585.14, 654.511, 0, 0, 0, NULL), ('surf_vegetables', 10, 3, 3, -1104.02, 1184.59, 868.991, -1407.97, 1281.01, 970.991, 0, 0, 0, NULL), ('surf_vegetables', 11, 1, 0, 200.241, -10137.2, 730.031, -189.392, -10025.7, 832.031, 0, 0, 1, NULL), ('surf_vegetables', 12, 2, 0, -42.6156, -9371.08, -1168.38, 54.978, -9478.93, -1134.83, 0, 0, 1, NULL), ('surf_velocity_nsf', 0, 3, 0, 974.891, 2991.56, -3841.97, 282.987, 2317.52, -3739.97, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_velocity_nsf', 1, 1, 1, 2360.84, -6403.95, -4609.97, 1981.1, -5878.01, -4507.97, 0, 0, 0, NULL), ('surf_velocity_nsf', 2, 3, 3, 10588.2, -2900.84, -2391.92, 10982.5, -2586.58, -2300.03, 0, 0, 0, NULL), ('surf_velocity_nsf', 3, 2, 1, -4498.85, -2526.77, -4930.74, -4709.99, -2351.3, -4828.74, 0, 0, 0, NULL), ('surf_velocity_nsf', 4, 3, 4, 5503.61, -408.031, -7721.97, 5288.03, -615.969, -7619.97, 0, 0, 0, NULL), ('surf_velocity_nsf', 5, 3, 1, 4880.47, 1361.44, 566.031, 5227.69, 1072.03, 668.031, 0, 0, 0, NULL), ('surf_velocity_nsf', 6, 3, 2, -7135.92, 6877.16, -9233.97, -7550.47, 7331.53, -9131.97, 0, 0, 0, NULL), ('surf_voteforthisone', 0, 3, 6, 10555.2, -15120, -769.969, 10049.3, -14437.2, -624.644, 0, 0, 0, NULL), ('surf_voteforthisone', 1, 3, 3, -14165.9, -4502.14, 8830.03, -13635.7, -3905.8, 8932.03, 0, 0, 0, NULL), ('surf_voteforthisone', 2, 2, 0, 6544.03, -6983.94, -4414.49, 7792, -5680.03, -4251.98, 0, 0, 0, NULL), ('surf_voteforthisone', 3, 3, 4, -4063.97, 6221.6, 9505.75, -3866.66, 5832.33, 9472.03, 0, 0, 0, NULL), ('surf_voteforthisone', 4, 3, 5, 7124.69, -12035.3, 6846.03, 6938.11, -11342.2, 6948.03, 0, 0, 0, NULL), ('surf_voteforthisone', 5, 1, 0, -11505.2, -1914.13, 13998, -12286.8, -2884.44, 14100, 0, 0, 0, NULL), ('surf_voteforthisone', 6, 3, 0, -2095.97, 2400.03, 13758, -1104.03, 2820.81, 13860, 0, 0, 0, NULL), ('surf_voteforthisone', 7, 3, 1, 12484.5, 5426.9, 12734, 12005.6, 6031.93, 12836, 0, 0, 0, NULL), ('surf_voteforthisone', 8, 3, 2, -11536.6, 4015.97, 13502, -12528, 3579.45, 13604, 0, 0, 0, NULL), ('surf_water-run_b5', 0, 2, 1, 10644.7, -9556.18, -9781.97, 10845.3, -9771.96, -9679.97, 0, 0, 0, NULL), ('surf_water-run_b5', 1, 3, 0, -14109.4, -14338.7, -5089.97, -13804.5, -14576, -4987.97, 0, 0, 0, NULL), ('surf_water-run_b5', 2, 1, 1, -318.979, -11670, 510.031, 442.436, -12016, 612.031, 0, 0, 0, NULL), ('surf_water-run_b5', 3, 3, 1, 11029.6, -11850.3, -6049.97, 10405.1, -12474.2, -5947.97, 0, 0, 0, NULL), ('surf_waterworks', 0, 1, 0, -5182.38, 2616.03, 15230, -4708.03, 3743.99, 15332, 0, 0, 0, NULL), ('surf_waterworks', 1, 2, 0, -4622.27, 1746.47, -4097.97, -6140.64, -348.867, -3995.97, 0, 0, 0, NULL), ('surf_waterworks', 2, 4, 0, -7662.51, 8743.97, 11494.5, -6307.63, 4712.03, 7520.48, 0, 0, 0, NULL), ('surf_waterworks', 3, 4, 1, -8191.97, 6638.95, 7379.85, -4000.38, 9698.86, 5352.03, 0, 0, 0, NULL), ('surf_waterworks', 4, 4, 2, -1554.66, 6859.57, -85.9166, -4102.43, 4673.78, -2479.97, 0, 0, 0, NULL), ('surf_waterworks', 5, 4, 3, 14480, -12794.5, 7104.37, 16064, -15245.3, 3939.06, 0, 0, 0, NULL), ('surf_waterworks', 6, 4, 4, 36.9534, -11976.3, 2221.46, 1912.94, -16128, -1915.97, 0, 0, 0, NULL), ('surf_waterworks', 7, 4, 5, 8989.04, 1656.56, 101.407, 9846.84, -319.969, -1002.74, 0, 0, 0, NULL), ('surf_wazor', 0, 2, 0, 9170.45, -14995.4, -5875.29, 9308.15, -15115.3, -5756.47, 0, 0, 0, NULL), ('surf_wazor', 1, 3, 0, -1602.36, -1300.97, 4346.03, -1811.86, -1094.84, 4448.03, 0, 0, 0, NULL), ('surf_wazor', 2, 1, 0, -14016, 14658.9, 5114.03, -14560, 15320, 5216.03, 0, 0, 0, NULL), ('surf_wazor', 3, 3, 1, 13292.6, 12491.6, 9461.56, 13567.1, 12335.9, 9556.99, 0, 0, 0, NULL), ('surf_wazor', 4, 3, 2, -12474.1, -15736.8, 8181.03, -11770, -16096.1, 8283.03, 0, 0, 0, NULL), ('surf_wazor', 5, 3, 3, 5930.68, -14939.8, -993.969, 5794.47, -15148.1, -891.969, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_wazor', 6, 2, 1, -5002.99, -14265.8, 14734, -4930.75, -13421.9, 14836, 0, 0, 0, NULL), ('surf_whoknows', 0, 1, 1, 960.326, -12490.5, 14846, 580.079, -13568.5, 14948, 0, 0, 0, NULL), ('surf_whoknows', 1, 2, 1, -14128, -9735.4, -2561.97, -11024, -10630.7, -2459.97, 0, 0, 0, NULL), ('surf_whoknows', 2, 4, 0, 11776, -9458.63, 11056.3, 10496, -9054.27, 10108.8, 0, 0, 0, NULL), ('surf_whoknows', 3, 4, 1, -229.754, 12736, 9391, -4203.33, 9374.5, 7232.03, 0, 0, 0, NULL), ('surf_whoknows', 4, 4, 2, 813.847, -13315.6, 4159.97, 3372.35, -15227.2, 2816.03, 0, 0, 0, NULL), ('surf_whoknows', 5, 4, 3, 13819.8, -548.121, 3199.97, 11904, -2142.68, 2573.76, 0, 0, 0, NULL), ('surf_whoknows', 6, 4, 4, 2130.96, 15604.7, 1023.97, 2510.71, 13824, -537.733, 0, 0, 0, NULL), ('surf_whoknows', 7, 4, 5, -14144, -3406.5, -2281.29, -11036.8, -2113.47, -5631.97, 0, 0, 0, NULL), ('surf_whoknows', 8, 1, 0, 1432.44, -1040.03, -7418.56, 599.879, -772.172, -7487.97, 0, 0, 1, NULL), ('surf_whoknows', 9, 2, 0, 1983.97, -14368.9, -9797.38, 71.7366, -15168, -9901.89, 0, 0, 1, NULL), ('surf_wood', 0, 1, 0, 4383.68, 835.273, 6782.03, 4587.5, 321.435, 6884.03, 0, 0, 0, NULL), ('surf_wood', 1, 2, 0, -12120, 1392, -4705.97, -11375.6, -239.969, -4603.97, 0, 0, 0, NULL), ('surf_wood', 2, 2, 0, 3242.65, -4643.51, 4880.62, 3120.06, -5002.37, 4980.03, 0, 0, 1, NULL), ('surf_wood', 3, 1, 0, 213.618, -4968.39, 5193.03, 313.532, -4684.76, 5112.03, 0, 0, 1, NULL), ('surf_xc_simplicity', 0, 3, 1, -2828.97, -1034.06, -27.9688, -3184.77, -1363.21, 72.0312, 0, 0, 0, NULL), ('surf_xc_simplicity', 1, 3, 0, -532.765, 184.031, 512.031, -1375.97, 600, 612.031, 0, 0, 0, NULL), ('surf_xc_simplicity', 2, 1, 1, -7945.21, 4497.98, 1874.03, -8231.35, 4238.03, 1974.03, 0, 0, 0, NULL), ('surf_xc_simplicity', 3, 2, 1, -2774.06, 2050.93, -218.266, -3243.95, 1935.84, 128.109, 0, 0, 0, NULL), ('surf_x_rg', 0, 3, 6, 3948.22, 6956.17, 2032.03, 3308.97, 6629.55, 2132.03, 0, 0, 0, NULL), ('surf_x_rg', 1, 2, 1, 137.424, -67.0239, 203.089, 435.724, 458.302, 498.129, 0, 0, 0, NULL), ('surf_x_rg', 2, 1, 1, -828.834, 15.875, -311.764, -538.388, 367.988, -211.969, 0, 0, 0, NULL), ('surf_x_rg', 3, 3, 0, -485.139, 10608, 1653.18, -368.428, 10944, 1748.03, 0, 0, 0, NULL), ('surf_x_rg', 4, 3, 1, 665.622, 3681.42, 2592.03, 1416, 4452.78, 2692.03, 0, 0, 0, NULL), ('surf_x_rg', 5, 3, 2, -194.275, 9210.27, 5168.03, -393.132, 8897.14, 5268.03, 0, 0, 0, NULL), ('surf_x_rg', 6, 3, 3, 605.329, -3767.97, -3049.48, 1383.97, -3224.03, -2949.48, 0, 0, 0, NULL), ('surf_x_rg', 7, 3, 4, 5859.88, 2365.06, -743.969, 5608, 2115.61, -643.969, 0, 0, 0, NULL), ('surf_x_rg', 8, 3, 5, 2613.54, 8767.95, -1119.97, 2388.01, 9008.29, -1019.97, 0, 0, 0, NULL), ('surf_x_rg', 9, 3, 7, 3520.03, 15056.9, -9856.97, 3917.97, 14502.8, -9741.03, 0, 0, 0, NULL), ('surf_yay', 0, 2, 1, -1921.97, 614.031, -3074.97, -1305.6, 1320.97, -2974.97, 0, 0, 0, NULL), ('surf_yay', 1, 1, 1, 31.5784, -174.614, 0.03125, -222.686, -429.778, 100.031, 0, 0, 0, NULL), ('surf_yay', 2, 1, 2, 31.0053, -175.632, 0.03125, -224, -93.2234, 100.031, 0, 0, 0, NULL), ('surf_year3000', 0, 1, 1, 221.12, -2355.03, 9093.55, 678.828, -2958.97, 9195.55, 0, 0, 0, NULL), ('surf_year3000', 1, 2, 1, -5165.77, 8055.18, -5027.97, -5851.91, 8499.73, -4925.97, 0, 0, 0, NULL), ('surf_year3000', 2, 1, 2, -130.942, -2958.97, 9093.55, -591.296, -2355.03, 9195.55, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_y_rg', 0, 3, 21, -6671.97, -5104.03, 1104.03, -6441.81, -6607.97, 1204.03, 0, 0, 0, NULL), ('surf_y_rg', 1, 3, 20, 15088, -2160.31, 7648.03, 15824, -2651.68, 7748.03, 0, 0, 0, NULL), ('surf_y_rg', 2, 3, 19, 11962.1, -4427.06, 4880.03, 12116.1, -4146.38, 4980.03, 0, 0, 0, NULL), ('surf_y_rg', 3, 3, 22, -9744.03, -15344, 10752, -10090.9, -14352, 10852, 0, 0, 0, NULL), ('surf_y_rg', 4, 2, 1, -12720, -13282, 9600.03, -12546.3, -13598.4, 9700.03, 0, 0, 0, NULL), ('surf_y_rg', 5, 3, 18, -14302.1, -10681.9, 10915.7, -14178.9, -10822.6, 10972.1, 0, 0, 0, NULL), ('surf_y_rg', 6, 3, 12, -16238, 11056, 15998, -15957.7, 10304, 16098, 0, 0, 0, NULL), ('surf_y_rg', 7, 3, 4, -11103.8, -4897.73, 1488.03, -10736, -5401.57, 1588.03, 0, 0, 0, NULL), ('surf_y_rg', 8, 3, 5, 1490.2, -10464, 14064, 1436.03, -10563.2, 14164, 0, 0, 0, NULL), ('surf_y_rg', 9, 3, 11, 10826.8, -8140.34, 2132.03, 11093.2, -8510.26, 2259.06, 0, 0, 0, NULL), ('surf_y_rg', 10, 3, 10, -4317.92, -15357.8, 12560, -3990.85, -15709.3, 12660, 0, 0, 0, NULL), ('surf_y_rg', 11, 3, 9, -5603.46, -4144.03, 8864.03, -5839.97, -4495.97, 8964.03, 0, 0, 0, NULL), ('surf_y_rg', 12, 3, 6, 13616, 3827.39, 15392, 14032, 3664.03, 15492, 0, 0, 0, NULL), ('surf_y_rg', 13, 3, 7, 3806.93, -9679.4, 1824.03, 4048.13, -10033.1, 1924.03, 0, 0, 0, NULL), ('surf_y_rg', 14, 3, 13, 1838.79, 3410.38, 15484.2, 1658.36, 3737.94, 15584.2, 0, 0, 0, NULL), ('surf_y_rg', 15, 3, 3, -13152.9, -8991.97, 9912.03, -13020.1, -8825.7, 10012, 0, 0, 0, NULL), ('surf_y_rg', 16, 3, 17, -11487.3, 1069.34, 15152, -11261.9, 806.955, 15252, 0, 0, 0, NULL), ('surf_y_rg', 17, 3, 16, -1293.97, 6213.36, 14688, -238.031, 5934, 14788, 0, 0, 0, NULL), ('surf_y_rg', 18, 3, 15, 10192, -8047.97, 1824.03, 9704.58, -7760.03, 1924.03, 0, 0, 0, NULL), ('surf_y_rg', 19, 3, 14, 880.031, 6064.03, 13536, 2127.97, 6565.14, 13636, 0, 0, 0, NULL), ('surf_y_rg', 20, 1, 1, -6846.54, -10048.2, 8576.03, -6462.65, -9278.3, 8676.03, 0, 0, 0, NULL), ('surf_y_rg', 21, 3, 0, 15695.5, -11697.4, -913.969, 15763.4, -11628.5, -813.969, 0, 0, 0, NULL), ('surf_y_rg', 22, 3, 1, 14912, -9040.03, 2320.03, 15392, -9080.64, 2420.03, 0, 0, 0, NULL), ('surf_y_rg', 23, 3, 2, -4435.95, 6621.03, 13222.9, -4521.88, 6695.75, 13322.9, 0, 0, 0, NULL), ('surf_y_rg', 24, 3, 8, -11342, 13681.1, -1246.97, -10960.5, 13455.2, -1146.97, 0, 0, 0, NULL), ('surf_zion', 0, 3, 1, 6569.95, 623.969, 6590.03, 6138.46, 306.301, 6692.03, 0, 0, 0, NULL), ('surf_zion', 1, 3, 0, -3885.58, 495.969, 638.031, -4284.78, 179.919, 740.031, 0, 0, 0, NULL), ('surf_zion', 2, 1, 1, 433.677, 64.318, 638.031, -379.771, 495.995, 740.031, 0, 0, 0, NULL), ('surf_zion_njv', 0, 1, 1, -331.438, 65.05, 638.031, 329.117, 495.969, 740.031, 0, 0, 0, NULL), ('surf_zion_njv', 1, 3, 1, 6215.06, 454.111, 6590.03, 6471.56, 623.969, 6692.03, 0, 0, 0, NULL), ('surf_zion_njv', 2, 3, 0, -4215.33, 332.012, 638.031, -3970.71, 495.969, 740.031, 0, 0, 0, NULL), ('surf_zion_njv', 3, 2, 1, 4892.61, -4940.22, 11293.3, 4719.42, -5154.43, 11492.8, 0, 0, 0, NULL), ('surf_zion_njv', 4, 3, 3, 5780.33, 1508.22, 14782, 5467.67, 1313.35, 14884, 0, 0, 0, NULL), ('surf_zion_njv', 5, 3, 2, 360.696, 12691.2, 14846, 656.388, 12473.5, 14948, 0, 0, 0, NULL), ('surf_christmas', 11, 3, 4, -14592, -9222.65, 14715.2, -14082.8, -9398.97, 14560, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_halloween_tf', 4, 4, 2, 2336.22, 2566.68, -6436.95, 1926.71, 16.0312, -8485.59, 0, 0, 0, NULL), ('surf_halloween_tf', 5, 4, 3, -11733.4, 2575.97, -8604.9, -12308, 27.5203, -10648, 0, 0, 0, NULL), ('surf_halloween_tf', 6, 4, 4, -6172.61, -8176.03, 14597.6, -6594.05, -9672.41, 13032, 0, 0, 0, NULL), ('surf_halloween_tf', 7, 4, 5, -3955.91, -9961.95, 5224.03, -9338.43, -7921.4, 7719.97, 0, 0, 0, NULL), ('surf_halloween_tf', 8, 4, 6, -10123.7, -14576, 3102.57, -12041.8, -3337.77, 40.0311, 0, 0, 0, NULL), ('surf_lolrevlis2', 5, 4, 0, -38.2023, 1677.9, 2047.97, 359.454, 2439.97, 1329.35, 0, 0, 0, NULL), ('surf_lolrevlis2', 6, 4, 1, -117.954, -2551.97, 1685.86, -341.496, -1537.74, 1024.03, 0, 0, 0, NULL), ('surf_lolrevlis2', 7, 4, 2, -3644.13, -1528.03, 1915.08, -3346.46, -2551.97, 1082.04, 0, 0, 0, NULL), ('surf_lolrevlis2', 8, 4, 3, -1736.98, 712.175, 1007.97, -2462.93, 278.665, 604.385, 0, 0, 0, NULL), ('surf_lolrevlis2', 9, 4, 4, -2607.97, 944.285, 370.505, -1616.03, 1155.57, 5.03194, 0, 0, 0, NULL), ('surf_sewers', 2, 4, 0, 1289.22, -1471.97, 12537.5, -70.5302, 439.75, 10560, 0, 0, 0, NULL), ('surf_sewers', 3, 4, 1, -9231.08, 447.969, 12542.7, -9560.18, -1471.97, 11729.4, 0, 0, 0, NULL), ('surf_sewers', 4, 4, 2, 6993.34, 42.252, 5567.97, 8140.07, -1534.29, 2624.03, 0, 0, 0, NULL), ('surf_sewers', 5, 4, 3, -1717.61, 511.969, -641.353, -475.531, -1500.9, -2111.97, 0, 0, 0, NULL), ('surf_sewers', 6, 4, 4, -11778.7, -1535.97, -5764.99, -13907.9, 511.969, -6287.88, 0, 0, 0, NULL), ('surf_sewers', 7, 4, 5, 4964.77, 1215.97, -9732.44, 6542.71, -2237.78, -12160, 0, 0, 0, NULL), ('surf_sewers', 8, 6, 0, 9723.45, -128.031, -9536.83, 8640.03, -1277.72, -9661.09, 0, 0, 0, NULL), ('surf_vector_final', 7, 6, 0, -21.2757, -617.51, -1130.59, -942.154, 141.969, -2761.72, 0, 0, 0, ''), ('surf_vector_final', 6, 2, 0, -415.631, 5847.03, 4211.68, -1696.89, 5981.3, 3928.03, 0, 0, 1, 'BONUS 1'), ('surf_vector_final', 5, 1, 0, -3484.48, 11915.2, 7374.03, -3802.97, 10897.2, 7475.97, 0, 0, 1, 'BONUS 1'), ('surf_coralis_ksf-', 6, 2, 0, -724.571, -2592.03, 4234.75, 38.2156, -2368.03, 4563.33, 0, 0, 2, 'BONUS 2'), ('surf_coralis_ksf-', 5, 1, 0, -850.864, 3775.97, 6252.47, 84.6812, 3270.86, 6762.97, 0, 0, 2, 'BONUS 2'), ('surf_kz_protraining', 25, 2, 0, 9248.03, -12738.6, -2259.74, 9437.44, -13051.6, -2351.97, 0, 0, 4, 'syÃ¶pÃ¤bonus'), ('surf_kz_protraining', 24, 1, 0, 9249.95, -12672, -2077.43, 9434.13, -11792, -2359.63, 0, 0, 4, 'syÃ¶pÃ¤bonus'), ('surf_kz_protraining', 23, 2, 0, -11264, -2831.78, -10244.1, -11067.6, -2580.42, -10496, 0, 0, 3, 'iisibonus'), ('surf_kz_protraining', 22, 1, 0, -12352, -7392.95, -5910.47, -12162.4, -7798.4, -6143.97, 0, 0, 3, 'iisibonus'), ('surf_kz_protraining', 21, 3, 0, 2079.26, -11329.6, -55.0312, 1505.11, -11557.3, -129.969, 0, 0, 2, 'BONUS 2'), ('surf_kz_protraining', 20, 2, 0, -1920.03, -9729.66, 223.952, -1981.73, -9898.73, 160.031, 0, 0, 2, 'BONUS 2'), ('surf_kz_protraining', 19, 1, 0, 4351.24, -9728.03, 1855.4, 4542.98, -10221.3, 2079.97, 0, 0, 2, 'BONUS 2'), ('surf_mesa_mine', 15, 1, 0, -6071.97, -11463, -13006.9, -5856.47, -11145.2, -13072, 0, 0, 1, 'BONUS 1'), ('surf_mesa_mine', 16, 2, 0, -5796.75, -12770.5, -14497.1, -6302.61, -12478.4, -14544, 0, 0, 1, 'BONUS 1'), ('surf_newb_hazard_r1', 2, 2, 1, -1599.67, -3612.54, 486.694, -796.392, -3693.56, 923.901, 0, 0, 0, '');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_bbb', 9, 1, 0, -10975.5, 1167.97, -209.44, -11160, 661.708, -439.879, 0, 0, 2, 'BONUS 2'), ('surf_bbb', 10, 2, 0, -11160, 1155.92, -642.43, -10648, 664.182, -569.199, 0, 0, 2, 'BONUS 2'), ('surf_bbb', 11, 1, 1, -10840.9, 1167.97, -202.934, -10657, 661.852, -455.969, 0, 0, 2, 'BONUS 2'), ('surf_bbb', 12, 1, 2, -10648, 842.855, -203.766, -11157, 662.307, -455.969, 0, 0, 2, 'BONUS 2'), ('surf_bbb', 13, 1, 3, -11160, 1166.88, -201.226, -10665.1, 981.16, -455.969, 0, 0, 2, 'BONUS 2'), ('surf_coralis_ksf-', 8, 4, 1, 10458.8, -714.524, -5568.03, 8312.03, -278.34, -8498.2, 0, 0, 0, ''), ('surf_coralis_ksf-', 7, 4, 0, 8565.19, -13888, -58.3928, 10404.6, -13221.8, -1535.97, 0, 0, 0, ''), ('surf_coralis_ksf-', 9, 4, 2, -9460.96, 12710.6, 3183.97, -12504, 11404.5, 1398.01, 0, 0, 0, ''), ('surf_coralis_ksf-', 10, 4, 3, -4443.51, 12960, -8770.28, -6567.97, 14876.8, -12774.6, 0, 0, 0, ''), ('surf_lithium-', 8, 6, 0, 9088.03, -11059.5, -1064.11, 9780.47, -10038.3, -1407.97, 0, 0, 0, ''), ('surf_lithium-', 9, 1, 0, -5809.09, -3878.03, 2110.32, -5295.41, -3428.03, 2202.99, 0, 0, 1, 'BONUS 1'), ('surf_lithium-', 10, 2, 0, -6177.77, -6118.58, 468.455, -6077.11, -5951.66, 299.481, 0, 0, 1, 'BONUS 1'), ('surf_lithium-', 11, 2, 1, -5017.87, -6118.1, 468.283, -4922.16, -5949.33, 297.031, 0, 0, 1, 'BONUS 1'), ('surf_lt_unicorn', 12, 1, 0, -11770.8, -6764.21, 11464.9, -12033.8, -7089.62, 11561.3, 0, 0, 2, 'BONUS 2'), ('surf_lt_unicorn', 13, 2, 0, -10736.7, -6280.01, 12714.3, -11169.7, -5817.16, 12584.6, 0, 0, 2, 'BONUS 2'), ('surf_lithium2-', 6, 2, 1, -3523.43, 2493.01, 882.212, -3238.77, 1727.99, 668.277, 0, 0, 0, ''), ('surf_wood', 4, 4, 0, -2437.08, 2111.97, 4197.98, -1640.97, -959.969, 3105.88, 0, 0, 0, ''), ('surf_wood', 5, 4, 1, 6115.22, 834.111, 2015.97, 6505.71, 361.242, 2268.03, 0, 0, 0, ''), ('surf_wood', 6, 4, 2, 5637.9, 50.6005, -488.971, 6880.37, 1145.58, -855.359, 0, 0, 0, ''), ('surf_wood', 7, 4, 3, 3743.74, 128.031, -6353.99, 2790.36, 1019.49, -4768.03, 0, 0, 0, ''), ('surf_wood', 8, 7, 0, 2704.84, -865.711, -4768.03, 2332.79, 2047.97, -6366.34, 0, 0, 0, ''), ('surf_wood', 9, 8, 0, -10717.5, -887.947, -4768.03, -11689.5, 2047.97, -6294.55, 0, 0, 0, ''), ('surf_bob', 12, 6, 0, 3583.97, -8696.35, 11704, 2048.03, -8194.06, 11412.4, 0, 0, 0, ''), ('surf_kitsune2_GO', 0, 1, 0, -1690.49, -10883.4, 1824.03, -355.238, -11712, 1917.07, 0, 0, 0, 'Start 0'), ('surf_kitsune2_GO', 1, 3, 0, -4478.46, 14272, 6104.45, -5772.43, 13443.3, 5664.03, 0, 0, 0, 'Start 0'), ('surf_kitsune2_GO', 2, 3, 1, 2708.81, 13312, 8031.38, 1381.83, 12484.5, 7712.03, 0, 0, 0, 'Start 0'), ('surf_kitsune2_GO', 3, 3, 2, -4095.97, -4119.37, 14302.5, -2060, -5424.88, 13856, 0, 0, 0, 'Start 0'), ('surf_kitsune2_GO', 4, 3, 3, 7838.15, -2877.96, 14880, 6507.61, -2048.03, 15289.7, 0, 0, 0, 'Start 0'), ('surf_kitsune2_GO', 5, 3, 4, 9882.63, 13984.7, 13856, 8549.62, 14816, 14266.3, 0, 0, 0, 'Start 0'), ('surf_kitsune2_GO', 6, 3, 5, -12684.5, 14304, 14718.1, -13977.8, 13476.5, 14272, 0, 0, 0, 'Start 0'), ('surf_kitsune2_GO', 7, 3, 6, 13979.8, -4416.03, 12895.4, 12640, -3616.38, 13308.7, 0, 0, 0, 'Start 0'), ('surf_kitsune2_GO', 8, 3, 7, -11907.9, -14336, 14288.8, -10605.2, -8192.03, 13857.3, 0, 0, 0, 'Start 0'), ('surf_kitsune2_GO', 9, 3, 8, -6654.45, -14311, -3584.03, -5320.03, -12288, -4028.28, 0, 0, 0, 'Start 0');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_kitsune2_GO', 10, 3, 9, 13508.5, 12654.7, 1600.03, 14336, 13970.7, 2039.91, 0, 0, 0, 'Start 0'), ('surf_kitsune2_GO', 11, 3, 10, -14848, 620.813, 1277.67, -14017.3, -659.075, 832.031, 0, 0, 0, 'Start 0'), ('surf_kitsune2_GO', 12, 2, 0, -4122.53, -2033.81, -12320, -6136.78, 2047.97, -13947.9, 0, 0, 0, 'Start 0'), ('surf_kitsune2_GO', 13, 2, 1, -4101.04, 1023.97, -13959, -4253.45, -1023.97, -14265, 0, 0, 0, 'Start 0'), ('surf_kitsune2_GO', 14, 1, 0, 2967.18, 5768.05, -4032.03, 3785.47, 7098.14, -4447.97, 0, 0, 1, 'BONUS 1'), ('surf_kitsune2_GO', 15, 2, 0, 15308.9, 543.969, -8322.09, 12756, -2015.97, -8631.95, 0, 0, 1, 'BONUS 1'), ('surf_kitsune2_GO', 16, 1, 0, 9855.97, -265.953, -3077.45, 8580.97, -1091.95, -3487.97, 0, 0, 2, 'BONUS 2'), ('surf_kitsune2_GO', 17, 2, 0, 8576.03, -2343.14, -5120.76, 9838.75, -3183.97, -5530.73, 0, 0, 2, 'BONUS 2'), ('surf_kitsune2_GO', 18, 1, 0, -10084.4, 5920.03, -4857.46, -11416.3, 6745.99, -5279.97, 0, 0, 3, 'BONUS 3'), ('surf_kitsune2_GO', 19, 2, 0, -10090.8, 11072, -4798.74, -11418.8, 10244.1, -5279.97, 0, 0, 3, 'BONUS 3'), ('surf_kitsune2_GO', 20, 1, 0, 1469.43, -580.502, -1577.97, 580.562, -1469.79, -1727.97, 0, 0, 4, 'BONUS 4'), ('surf_kitsune2_GO', 21, 2, 0, -855.636, -1695.97, -5636.21, -646.612, -357.463, -6047.97, 0, 0, 4, 'BONUS 4'), ('surf_kitsune2_GO', 22, 2, 1, 1695.97, 855.33, -5633.07, 361.305, 646.898, -6047.97, 0, 0, 4, 'BONUS 4'), ('surf_kitsune2_GO', 23, 2, 2, 1695.97, -2908.71, -5636.89, 363.93, -2694.96, -6047.97, 0, 0, 4, 'BONUS 4'), ('surf_kitsune2_GO', 24, 2, 3, 2906.91, -371.661, -5632.03, 2694.81, -1665.34, -6047.97, 0, 0, 4, 'BONUS 4'), ('surf_refraxis', 11, 1, 0, 2560.03, 7027.32, -3471.96, 3070.41, 6849.79, -3583.97, 0, 0, 2, 'BONUS 2'), ('surf_refraxis', 12, 2, 0, 2560.14, 9987.33, -3807.97, 3071.97, 10405, -3687.58, 0, 0, 2, 'BONUS 2'), ('surf_creation', 7, 2, 0, -8033.17, 116.418, 4400.03, -8159.97, 423.966, 4591.56, 0, 0, 1, 'BONUS 1'), ('surf_creation', 6, 1, 0, -7309.37, 20.0957, 6016.03, -7048.32, 515.093, 6447.97, 0, 0, 1, 'BONUS 1'), ('surf_extremex', 8, 3, 6, -9570.33, 10139.9, 3071.97, -9074.4, 10430.4, 2816.03, 0, 0, 0, ''), ('surf_polygon', 5, 1, 0, -13056, 8962.28, 11447, -12544, 9157.94, 11234.6, 0, 0, 1, 'BONUS 1'), ('surf_polygon', 6, 2, 0, -13052.6, 12867, 6656.03, -12550.7, 13248, 6776.21, 0, 0, 1, 'BONUS 1'), ('surf_6', 2, 1, 0, -1826.54, 13349.7, 12468, -1581.09, 13602, 12368, 0, 0, 1, 'BONUS 1'), ('surf_6', 3, 2, 0, 6426.32, 13633.3, 11952, 6727.97, 13134.6, 12044, 0, 0, 1, 'BONUS 1'), ('surf_ace', 0, 1, 0, -1346.39, -892.208, 3232.03, -1789.12, 639.969, 3344.47, 0, 0, 0, 'Start 0'), ('surf_ace', 1, 3, 0, 1472.03, -892.279, 2729.84, 1913.9, 639.969, 2564.1, 0, 0, 0, 'Start 0'), ('surf_ace', 2, 3, 1, 6400.92, 639.969, 2173.35, 5955.73, -895.969, 2058.86, 0, 0, 0, 'Start 0'), ('surf_ace', 3, 3, 2, 4803.26, -890.564, 512.031, 5240.05, 639.969, 619.008, 0, 0, 0, 'Start 0'), ('surf_ace', 4, 3, 3, -2492.71, -895.969, -925.863, -2048.59, 639.969, -810.075, 0, 0, 0, 'Start 0'), ('surf_ace', 5, 3, 4, -11966.1, 639.969, -2335.01, -11526.9, -895.969, -2219.87, 0, 0, 0, 'Start 0'), ('surf_ace', 6, 3, 5, 1987.63, -895.969, -4816.28, 2424.7, 635.795, -4927.97, 0, 0, 0, 'Start 0'), ('surf_ace', 7, 3, 6, -3964.49, -895.969, -6758.57, -3520.03, 631.929, -6870.18, 0, 0, 0, 'Start 0');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_ace', 8, 2, 0, -11049.6, 2549.68, 9334.37, -11378.2, 2136.52, 9195.22, 0, 0, 0, 'Start 0'), ('surf_ace', 9, 1, 0, -11358.7, 12798.3, 8160.03, -9644.79, 12416, 8259.81, 0, 0, 1, 'BONUS 1'), ('surf_ace', 10, 2, 0, 8322.32, 8821.22, 7424.03, 8830.31, 11469, 7612.03, 0, 0, 1, 'BONUS 1'), ('surf_ace', 11, 1, 1, -9634.51, 7871.97, 8424.86, -11359.6, 7493.99, 8160.03, 0, 0, 1, 'BONUS 1'), ('surf_asrown', 2, 1, 0, -600.192, 11728.4, 7520.03, -985.456, 11968, 7624.83, 0, 0, 1, 'BONUS 1'), ('surf_asrown', 3, 2, 0, -2054.32, -4290, 5056.03, 471.969, -4782.87, 5248.55, 0, 0, 1, 'BONUS 1'), ('surf_beyer2', 2, 1, 0, -4677.69, -12928, 2083.52, -5119.01, -13824, 1922.12, 0, 0, 1, 'BONUS 1'), ('surf_beyer2', 3, 2, 0, -4446.38, -12896, -3809.96, -4073.26, -13853.2, -4127.97, 0, 0, 1, 'BONUS 1'), ('surf_beyer2', 4, 1, 0, -8927.97, -130.591, -6852.54, -6932.55, -482.324, -7135.97, 0, 0, 2, 'BONUS 2'), ('surf_beyer2', 5, 2, 0, -7457.09, -12477.2, -11936, -8324.39, -12097, -11104, 0, 0, 2, 'BONUS 2'), ('surf_beyer2', 6, 1, 0, -13090.8, -15585.4, 8159.03, -14621.1, -16160, 8271.05, 0, 0, 3, 'BONUS 3'), ('surf_beyer2', 7, 2, 0, -14878.1, -3105.8, -4809.97, -13348.2, -4250.98, -4959.97, 0, 0, 3, 'BONUS 3'), ('surf_beyer2', 8, 1, 0, -12687.7, -10082.5, 15200, -11680, -10391.8, 14948.4, 0, 0, 4, 'BONUS 4'), ('surf_beyer2', 9, 2, 0, -10914.3, 2945.67, 12182, -13467.2, 4218.83, 12032, 0, 0, 4, 'BONUS 4'), ('surf_beyer2', 10, 1, 0, 11808, -4321.5, 11163.6, 14880, -5070.9, 11080.4, 0, 0, 5, 'BONUS 5'), ('surf_beyer2', 11, 2, 0, 12833.6, 13473.4, 11478, 13848.5, 14491.6, 11328, 0, 0, 5, 'BONUS 5'), ('surf_borderlands', 0, 1, 0, 10113.1, -15968.6, 11466, 10879.6, -16223, 11366, 0, 0, 0, 'Start 0'), ('surf_borderlands', 1, 3, 0, 14081.4, -15968.7, 16000, 14839.6, -16192, 16065.2, 0, 0, 0, 'Start 0'), ('surf_borderlands', 2, 3, 1, 6146.08, -15969.1, 6630.03, 6908.47, -16192, 6690.32, 0, 0, 0, 'Start 0'), ('surf_borderlands', 3, 3, 2, 3362.22, -15969.1, -537.969, 4121.4, -16192, -462.16, 0, 0, 0, 'Start 0'), ('surf_borderlands', 4, 3, 3, -2494.75, -15968.7, -5145.97, -1733.02, -16192, -5089.85, 0, 0, 0, 'Start 0'), ('surf_borderlands', 5, 3, 4, -12092.5, -1428.13, 388.031, -11333.4, -1676.04, 288.031, 0, 0, 0, 'Start 0'), ('surf_borderlands', 6, 3, 5, -4605.08, -131.014, 6784.03, -3584.03, -375.907, 6865.03, 0, 0, 0, 'Start 0'), ('surf_borderlands', 7, 2, 0, -4764.02, 4547.69, 2112.03, -3431.65, 5090.64, 2538.4, 0, 0, 0, 'Start 0'), ('surf_canisius2_fix', 6, 2, 1, 6701.03, -4346.01, -2374.51, 7031.24, -3804.92, -2695.97, 0, 0, 0, ''), ('surf_cubic', 0, 1, 0, -11781.8, -11224.1, 8068.03, -13306.4, -10725.6, 7968.03, 0, 0, 0, 'Start 0'), ('surf_cubic', 1, 3, 0, -7032.87, -10725.3, 8068.03, -5511.23, -11225.4, 7968.03, 0, 0, 0, 'Start 0'), ('surf_cubic', 2, 3, 1, -761.119, -10725.5, 8068.03, 763.594, -11225.5, 7968.03, 0, 0, 0, 'Start 0'), ('surf_cubic', 3, 3, 2, 5510.02, -10721.3, 8068.03, 7034.21, -11222.5, 7968.03, 0, 0, 0, 'Start 0'), ('surf_cubic', 4, 3, 3, 11783.4, -10721.6, 8068.03, 13305, -11221.8, 7968.03, 0, 0, 0, 'Start 0'), ('surf_cubic', 5, 3, 4, -13305.6, -3685.42, 8068.03, -11782.6, -4185.47, 7968.03, 0, 0, 0, 'Start 0'), ('surf_cubic', 6, 3, 5, -7031.72, -3681.89, 8068.03, -5510, -4180.45, 7968.03, 0, 0, 0, 'Start 0'), ('surf_cubic', 7, 3, 6, -758.526, -3685.18, 8068.03, 760.999, -4185.69, 7968.03, 0, 0, 0, 'Start 0');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_cubic', 8, 3, 7, 5510.83, -3685.17, 8068.03, 7033.22, -4185.04, 7968.03, 0, 0, 0, 'Start 0'), ('surf_cubic', 9, 3, 8, 11783, -3681.01, 8068.03, 13306.2, -4181.05, 7968.03, 0, 0, 0, 'Start 0'), ('surf_cubic', 10, 3, 9, -13303.2, 3354.41, 8068.03, -11783.4, 2855.09, 7968.03, 0, 0, 0, 'Start 0'), ('surf_cubic', 11, 3, 10, -7031.3, 3353.22, 8068.03, -5511.19, 2854.38, 7968.03, 0, 0, 0, 'Start 0'), ('surf_cubic', 12, 3, 11, -761.836, 3355.38, 8068.03, 762.694, 2853.57, 7968.03, 0, 0, 0, 'Start 0'), ('surf_cubic', 13, 3, 12, 5510.96, 3358.76, 8068.03, 7034.51, 2858.34, 7968.03, 0, 0, 0, 'Start 0'), ('surf_cubic', 14, 3, 13, 11783.1, 3034.65, 8068.03, 13306.6, 2534.36, 7968.03, 0, 0, 0, 'Start 0'), ('surf_cubic', 15, 3, 14, -13302.8, -10721.4, 932.031, -11781.4, -11222.1, 832.031, 0, 0, 0, 'Start 0'), ('surf_cubic', 16, 3, 15, -5512.96, -11225, -123.969, -7035.71, -10725.6, -223.969, 0, 0, 0, 'Start 0'), ('surf_cubic', 17, 3, 16, 753.279, -11218.5, -123.969, -761.106, -10725.5, -223.969, 0, 0, 0, 'Start 0'), ('surf_cubic', 18, 3, 17, 5513.65, -10721.8, -123.969, 7034.58, -11221.4, -223.969, 0, 0, 0, 'Start 0'), ('surf_cubic', 19, 3, 18, 11782.6, -10725.1, -123.969, 13305.4, -11226.7, -223.969, 0, 0, 0, 'Start 0'), ('surf_cubic', 20, 3, 19, -13306.6, -3681.23, -123.969, -11781.4, -4182.13, -223.969, 0, 0, 0, 'Start 0'), ('surf_cubic', 21, 3, 20, -7034.5, -3685.2, -123.969, -5509.23, -4185.7, -223.969, 0, 0, 0, 'Start 0'), ('surf_cubic', 22, 3, 21, -761.324, -3685.28, -123.969, 763.44, -4186.99, -223.969, 0, 0, 0, 'Start 0'), ('surf_cubic', 23, 3, 22, 7032.08, -4186.85, -123.969, 5509.74, -3685.88, -223.969, 0, 0, 0, 'Start 0'), ('surf_cubic', 24, 3, 23, 13301.3, -4184.28, -123.969, 11780.4, -3685.69, -223.969, 0, 0, 0, 'Start 0'), ('surf_cubic', 25, 3, 24, -1415.29, -10209.8, -8635.97, 105.98, -10709.6, -8735.97, 0, 0, 0, 'Start 0'), ('surf_cubic', 26, 3, 25, 5514.17, -10722.8, -9339.97, 7032.97, -11222, -9439.97, 0, 0, 0, 'Start 0'), ('surf_cubic', 27, 3, 26, 11789.3, -10724, -9339.97, 13303.1, -11219.4, -9439.97, 0, 0, 0, 'Start 0'), ('surf_cubic', 28, 2, 0, 13306.3, -14042, -10476, 11783.4, -14510.7, -10776, 0, 0, 0, 'Start 0'), ('surf_deceptive_final', 7, 2, 0, -14073.1, 6659.83, 608.031, -14320, 6907.78, 764.607, 0, 0, 1, 'BONUS 1'), ('surf_distraction_v2', 8, 1, 0, -6905.51, -10784.6, 2575.03, -6517.49, -10449.2, 2830.97, 0, 0, 1, 'BONUS 1'), ('surf_distraction_v2', 9, 2, 0, -2253.49, 787.969, -7090.07, -2289.36, 726.779, -7324.14, 0, 0, 1, 'BONUS 1'), ('surf_sinsane_ksf', 5, 2, 0, 15407.3, 1467.92, -3487.97, 15485.4, 1535.97, -3283.22, 0, 0, 2, 'BONUS 2'), ('surf_sinsane_ksf', 4, 5, 0, 15552, 448.756, 1089.4, 14409, 1599.97, 970.776, 0, 0, 2, 'BONUS 2'), ('surf_sinsane_ksf', 3, 2, 0, 8655.97, 1125.84, -100.034, 8450.84, 970.598, -258.969, 0, 0, 1, 'BONUS 1'), ('surf_sinsane_ksf', 2, 1, 0, 13828.6, 1394.69, 13772, 14304, 636.922, 13941.1, 0, 0, 1, 'BONUS 1'), ('surf_sinsane_ksf', 1, 2, 2, 2334.15, 1238.8, 392.025, 2845.73, 867.222, 417.436, 0, 0, 0, NULL), ('surf_sinsane_ksf', 0, 1, 1, 14288, 641.778, 13770, 13830.3, 1400.12, 13872, 0, 0, 0, NULL), ('surf_sinister_evil', 7, 2, 0, -13859.7, -12843.1, -11552, -12926.5, -13344, -11336.8, 0, 0, 1, NULL), ('surf_fathom', 0, 1, 0, -7665.95, 1002.55, 16.0312, -7909.2, 16.0312, 97.6557, 0, 0, 0, 'Start 0');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_fathom', 1, 2, 0, 6161.36, -111.969, -12081.9, 7530.64, 1134.08, -12272, 0, 0, 0, 'Start 0'), ('surf_fathom', 2, 1, 0, -3329.83, -2819.3, -767.969, -3567.97, -3325.5, -665.688, 0, 0, 1, 'BONUS 1'), ('surf_fathom', 3, 2, 0, -2306.08, -2819.28, -5183.97, -2811.47, -3324.22, -4976.03, 0, 0, 1, 'BONUS 1'), ('surf_fathom', 4, 4, 0, -5353.15, 922.797, -5136.03, -4880.03, 137.514, -5683.14, 0, 0, 0, 'Start 0'), ('surf_fathom', 5, 4, 1, -3560.35, 1495.39, -6672.03, -4195.32, -479.969, -7203.06, 0, 0, 0, 'Start 0'), ('surf_fathom', 6, 4, 2, 3052.29, -479.969, -8203.75, 2816.03, 1472.56, -7509.76, 0, 0, 0, 'Start 0'), ('surf_flatliners', 0, 1, 0, -8833.38, 8191.04, 5120.03, -9196.87, 6144.03, 5272.45, 0, 0, 0, 'Start 0'), ('surf_iceworld', 0, 1, 0, -13892.3, -3719.3, 4746.03, -14253.9, -5814.02, 4864.4, 0, 0, 0, 'Start 0'), ('surf_iceworld', 1, 2, 0, 5645.07, -4218.53, -8977.42, 6195.53, -5295.32, -8198.03, 0, 0, 0, 'Start 0'), ('surf_iceworld', 2, 1, 0, -2947.44, -1503.97, 8801.77, -3199.86, 511.969, 8986.65, 0, 0, 1, 'BONUS 1'), ('surf_iceworld', 3, 2, 0, 2487.14, -322.019, 5504.03, 3519.97, -686.952, 5641.49, 0, 0, 1, 'BONUS 1'), ('surf_juturna', 0, 1, 0, 4208.2, -386.453, 5030.34, 3661.77, 381.007, 4837.95, 0, 0, 0, 'Start 0'), ('surf_juturna', 1, 2, 0, -510.948, -542.671, -13440, 209.376, 519.536, -12832, 0, 0, 0, 'Start 0'), ('surf_juturna', 2, 1, 0, -10580, 7519.97, 1960.5, -10852.8, 6048.03, 2303.17, 0, 0, 1, 'BONUS 1'), ('surf_juturna', 3, 2, 0, 10231.4, 5085.74, 31.9688, 9778.17, 8511.97, -493.09, 0, 0, 1, 'BONUS 1'), ('surf_mom', 0, 1, 0, -3105.49, -590.285, 512.031, -3631.97, 426.932, 616.339, 0, 0, 0, 'Start 0'), ('surf_mom', 1, 3, 0, -2017.42, 3585.14, 512.031, -2543.97, 4601.79, 614.063, 0, 0, 0, 'Start 0'), ('surf_mom', 2, 3, 1, -497.785, -2718.03, 856.031, -1517.82, -2192.03, 969.915, 0, 0, 0, 'Start 0'), ('surf_mom', 3, 3, 2, 2414.75, 1807.97, 1408.62, 1904.03, 788.294, 1544.23, 0, 0, 0, 'Start 0'), ('surf_mom', 4, 3, 3, 2846, -1917.7, 512.031, 2320.03, -907.939, 637.348, 0, 0, 0, 'Start 0'), ('surf_mom', 5, 3, 4, -6337.15, 4605.77, 512.031, -6863.97, 3579.77, 653.929, 0, 0, 0, 'Start 0'), ('surf_mom', 6, 2, 0, -2653.48, 5504.03, -1044.31, -3311.97, 6115.53, -1755.98, 0, 0, 0, 'Start 0'), ('surf_mom', 7, 2, 1, -3311.97, 2681.65, -1023.91, -2640.03, 2083.15, -1885.62, 0, 0, 0, 'Start 0'), ('surf_mom', 8, 6, 0, 6474.99, 784.031, -1809.11, 6305.9, 1259.12, -2031.97, 0, 0, 0, 'Start 0'), ('surf_mom', 9, 1, 0, 5135.69, 6094.99, -3071.97, 4853.76, 5872.03, -2960.57, 0, 0, 1, 'BONUS 1'), ('surf_mom', 10, 2, 0, 3022.88, 7152.93, -3119.97, 2848.05, 7437.69, -2928.03, 0, 0, 1, 'BONUS 1'), ('surf_overgrowth2', 7, 1, 0, 9308.86, -7346.54, 14928, 9555.91, -6991.74, 15104, 0, 0, 1, 'BONUS 1'), ('surf_overgrowth2', 8, 2, 0, 3505.46, -6978.38, 12744, 3708.97, -7357.19, 12960, 0, 0, 1, 'BONUS 1'), ('surf_overgrowth2', 9, 1, 0, 8172.19, 8665.75, 14624, 6656.03, 8163.19, 14746.6, 0, 0, 2, 'BONUS 2'), ('surf_overgrowth2', 10, 2, 0, 5376.08, 8860.36, 11872, 5950.9, 7968.03, 11552, 0, 0, 2, 'BONUS 2'), ('surf_overgrowth2', 11, 2, 1, 9469.4, 7971.6, 11872, 8927.88, 8863.97, 11553.4, 0, 0, 2, 'BONUS 2'), ('surf_placid', 2, 1, 0, 5422.74, 5769.18, -2529.03, 5335.4, 5672.03, -2555.41, 0, 0, 1, 'GOOD BONUS'), ('surf_placid', 3, 2, 0, 9999.87, 5375.45, -3008.03, 9264.3, 6112.07, -3263.97, 0, 0, 1, 'GOOD BONUS');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_the_gloaming_rat_gfl', 0, 1, 0, 7762.58, 766.487, 12467.5, 7392.03, 398.636, 12583.7, 0, 0, 0, 'Start 0'), ('surf_the_gloaming_rat_gfl', 1, 1, 1, 7762.83, -396.888, 12467.2, 7404.54, -767.969, 12647.3, 0, 0, 0, 'Start 0'), ('surf_the_gloaming_rat_gfl', 2, 2, 0, -1552.03, 13938.6, -494.619, -4591.97, 14488.8, -26.6151, 0, 0, 0, 'Start 0'), ('surf_the_gloaming_rat_gfl', 3, 6, 0, 12829.4, 9619.5, -9925.99, 9701.1, 12848.6, -10662.5, 0, 0, 0, 'Start 0'), ('surf_the_gloaming_rat_gfl', 4, 4, 0, 1526.57, -1441.11, 10269.7, 1026.82, 1536.97, 9922.08, 0, 0, 0, 'Start 0'), ('surf_the_gloaming_rat_gfl', 5, 4, 1, 2668.03, -4102.69, -31.8746, 4074.97, -4365.49, -757.665, 0, 0, 0, 'Start 0'), ('surf_the_gloaming_rat_gfl', 6, 4, 2, -2560.03, -2050.95, -2066.47, -3548.72, -2342.46, -3132.53, 0, 0, 0, 'Start 0'), ('surf_milkyway', 0, 2, 0, -6393.61, 1540.15, 11464, -4869.73, 2300.91, 12355, 0, 0, 0, 'End 0'), ('surf_milkyway', 1, 2, 1, -4861.48, 1795.81, 11456, -4096.03, 2550.81, 12104.1, 0, 0, 0, ''), ('surf_milkyway', 2, 2, 2, -6403.27, 1796.35, 11456, -7165.9, 2550.47, 12105.5, 0, 0, 0, ''), ('surf_milkyway', 3, 1, 0, -5891.34, 3350.6, 10365, -5355.89, 2809.58, 10333.3, 0, 0, 0, ''), ('surf_milkyway', 4, 4, 0, -8306.72, 3961.55, 95.9688, -2944.03, 2951.61, -251.219, 0, 0, 0, ''), ('surf_milkyway', 5, 4, 1, -3584.03, 3848.12, -4380.59, -7677.53, 4343.16, -6783.97, 0, 0, 0, ''), ('surf_milkyway', 6, 4, 2, -8695.79, -1524.07, -9184.03, -2463.62, -521.486, -11204.6, 0, 0, 0, ''), ('surf_milkyway', 7, 4, 3, -4881.94, -11557.7, 12478.3, -6399.97, -11017.1, 11172.8, 0, 0, 0, ''), ('surf_iceworld', 4, 4, 0, 106.258, -3512.35, 1006.03, -276.642, -5946.15, -85.9688, 0, 0, 0, 'Start 0'), ('surf_iceworld', 5, 4, 1, 12433.2, -4026.53, -363.744, 14240, -5538.63, -853.633, 0, 0, 0, 'Start 0'), ('surf_iceworld', 6, 4, 2, -1070.77, -5495.3, -4231.23, -361.931, -4036.71, -3366.03, 0, 0, 0, 'Start 0'), ('surf_iceworld', 7, 4, 3, -5169.75, -4231.46, -7334.03, -4974, -5306.16, -8424.92, 0, 0, 0, 'Start 0'), ('surf_6', 4, 4, 0, 10112, 445.796, 3049.72, 9217.75, -447.969, 2735.66, 0, 0, 0, 'Start 0'), ('surf_6', 5, 4, 1, -3210.4, -1456.82, 2719.97, -3745.29, 1467.48, 800.031, 0, 0, 0, 'Start 0'), ('surf_6', 6, 4, 2, -1152.03, 697.332, -421.902, -1404.52, -705.754, -1247.97, 0, 0, 0, 'Start 0'), ('surf_6', 7, 4, 3, 7013.89, 1471.97, -1385.38, 6181.49, -1461.78, -3295.97, 0, 0, 0, 'Start 0'), ('surf_6', 8, 4, 4, -3991, -1440.64, -3808.03, -4396.52, 1456.34, -5727.97, 0, 0, 0, 'Start 0'), ('surf_faint_fix', 14, 1, 0, 10145.3, -4834.5, -4020.97, 9945.47, -5403.15, -4120.97, 0, 0, 1, 'BONUS 1'), ('surf_faint_fix', 15, 2, 0, 9187.97, -5036.95, -6152.68, 9168.97, -5158.68, -6266.29, 0, 0, 1, 'BONUS 1'), ('surf_faint_fix', 16, 1, 0, 1908.22, 5451.66, 5988.73, 1520.42, 5122.21, 5888.73, 0, 0, 2, 'BONUS 2'), ('surf_faint_fix', 17, 2, 0, 2753.34, 4254.09, 3264.03, 698.512, 4070.99, 3487.97, 0, 0, 2, 'BONUS 2'), ('surf_faint_fix', 18, 2, 1, 703.993, 6553.64, 3264.03, 473.524, 4098.37, 3487.97, 0, 0, 2, 'BONUS 2'), ('surf_faint_fix', 19, 2, 2, 2754.25, 6305.13, 3264.03, 2920.64, 4127.55, 3487.97, 0, 0, 2, 'BONUS 2'), ('surf_faint_fix', 20, 2, 3, 698.492, 6307.04, 3264.03, 3007.97, 6490.26, 3478.42, 0, 0, 2, 'BONUS 2'), ('surf_faint_fix', 21, 2, 1, 1174.97, 186.055, -9657.31, 983.975, 15.8978, -9897.97, 0, 0, 1, 'BONUS 1');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_polygon', 11, 1, 0, 7034.29, -10374.9, 14194, 7305.76, -10102.2, 14112, 0, 0, 4, 'BONUS 4'), ('surf_polygon', 9, 1, 0, -1279.14, 4863.97, 8551.24, -1033.35, 4361.59, 8448.03, 0, 0, 3, 'BONUS 3'), ('surf_polygon', 10, 2, 0, -2039.98, 4863.97, 4638.28, -1800.8, 4357.91, 4608.03, 0, 0, 3, 'BONUS 3'), ('surf_polygon', 8, 2, 0, -6918.76, -12283, 6772.03, -7416.58, -11268.2, 6656.03, 0, 0, 2, 'BONUS 2'), ('surf_polygon', 7, 1, 0, 14846.3, -12284.8, 6784.03, 14342.5, -11264, 6864.07, 0, 0, 2, 'BONUS 2'), ('surf_psycho_njv', 7, 1, 0, -2176.11, 1584.59, 12930, -2548.68, 2471.97, 13039.5, 0, 0, 1, 'BONUS 1'), ('surf_psycho_njv', 8, 2, 0, -2301.58, 4589.6, -670.969, -2417.19, 4769.74, -685.969, 0, 0, 1, 'BONUS 1'), ('surf_polygon', 12, 2, 0, 7305.84, -10102.3, 10507, 7030.83, -10375.5, 10496, 0, 0, 4, 'BONUS 4'), ('surf_the_gloaming_rat', 3, 6, 0, 11324, 10142.2, -10662, 11206.4, 10032.9, -10672, 0, 0, 0, 'Start 0'), ('surf_the_gloaming_rat', 4, 6, 1, 10039.9, 11328.5, -10664, 10143.8, 11208.4, -10672, 0, 0, 0, 'Start 0'), ('surf_the_gloaming_rat', 5, 6, 2, 11324.5, 12492.9, -10663, 11208.3, 12385, -10672, 0, 0, 0, 'Start 0'), ('surf_the_gloaming_rat', 6, 6, 3, 12495.8, 11317.8, -10655, 12380.8, 11207.3, -10672, 0, 0, 0, 'Start 0'), ('surf_bork_nbv', 8, 1, 0, 4352.03, 1727.32, 616.816, 4774.11, 1463.87, 536.031, 0, 0, 1, 'BONUS 1'), ('surf_bork_nbv', 9, 2, 0, 4352.95, 1727.97, 802.511, 4774.22, 1463.96, 768.031, 0, 0, 1, 'BONUS 1'), ('surf_milkyway', 8, 6, 0, -7148.71, 3347.23, 11425, -4096.03, 2422.23, 11513.5, 0, 0, 0, 'Start 0'), ('surf_auroia_njv', 7, 1, 0, -8631.46, -1444.8, 2040.03, -9123.91, -951.396, 1944.03, 0, 0, 1, 'BONUS 1'), ('surf_auroia_njv', 8, 2, 0, -8628.95, -14261.5, -583.969, -9124.34, -14735, -486.527, 0, 0, 1, 'BONUS 1'), ('surf_airflow', 7, 1, 0, 2229.03, -4114.97, 13262.3, 4205.18, -1047.34, 12928, 0, 0, 1, 'BONUS 1'), ('surf_airflow', 8, 2, 0, -2892.81, -2227.03, 8958.01, -2403.39, -2929.87, 8544.03, 0, 0, 1, 'BONUS 1'), ('surf_commune_again_beta5-', 0, 1, 0, -9816.91, 12657.6, 6472.03, -10019.7, 12865.1, 6687.97, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 1, 3, 0, -14248.2, 12043.3, 308.958, -13934.1, 12304.1, 134.505, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 2, 3, 1, -64.0313, 14553.5, 13689.7, -415.121, 14757.4, 13600, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 3, 3, 2, -7389.45, -2817.08, 6064.03, -6883.64, -3065.2, 6239.97, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 4, 3, 3, -9738.72, -3816.87, 14354, -10298, -3583.04, 14554.3, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 5, 3, 4, -2236.31, 12990.3, -6991.97, -2687.97, 12510.8, -6809.44, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 6, 3, 5, -2038, 1440.13, -9411.97, -2399.97, 567.207, -9312.76, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 7, 2, 0, 4816.56, 10031.2, -7615.97, 4425.12, 10208.3, -7515.97, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 8, 6, 0, 6751.14, 9436.69, -6588.21, 6529.21, 9318.47, -6752.97, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 9, 6, 1, 6144.03, 8718.8, -5045.7, 6418.2, 8544.14, -5207.97, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 10, 6, 2, 6662.95, 8120.03, -4488.78, 8191.97, 9139.92, -5189.09, 0, 0, 0, 'Start 0');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_commune_again_beta5-', 11, 6, 3, 5072.74, 7061.03, -259.482, 4867.03, 7268.67, -393.832, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 12, 6, 4, 8353.85, 9800.03, -9607.53, 8071.35, 9954.91, -9723.97, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 13, 6, 5, 7499.98, 9578.47, -9932.03, 7460.03, 9503.47, -10047.8, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 14, 6, 6, 7514.02, 9638.03, -9932.99, 7463.98, 9745.97, -10051.7, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 15, 6, 7, 7513.11, 9873.97, -9933.25, 7464.18, 9768.68, -10054.1, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 16, 6, 8, 7514.97, 10002.5, -9933.5, 7467.22, 9899.67, -10054.1, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 17, 6, 9, 7514.97, 10129.6, -9932.66, 7468.63, 10024, -10054.1, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 18, 6, 10, 7514.7, 10264, -9933.59, 7461.5, 10153.2, -10054.1, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 19, 6, 11, 4074.46, 6423.97, -9104.12, 3859.47, 6248.03, -9263.03, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 20, 6, 12, 5504.03, 5798.49, -8665.24, 6916.86, 6703.97, -9282.05, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 21, 6, 13, 9015.8, 7351.53, -4273.03, 9477.81, 7127.82, -4464.97, 0, 0, 0, 'Start 0'), ('surf_commune_again_beta5-', 22, 6, 14, 9808.02, 6265.26, -4164.29, 8683.03, 7040, -4988.63, 0, 0, 0, 'Start 0'), ('surf_dynamics', 0, 5, 0, 115.744, -11124.2, 15328, -114.112, -12009.8, 15760, 0, 0, 0, 'SpeedStart 0'), ('surf_dynamics', 1, 4, 0, 941.396, -6796.26, 13456, -975.969, -6376.72, 12439.5, 0, 0, 0, ''), ('surf_dynamics', 2, 4, 1, -393.635, -5103.98, 7135.97, 388.479, -6454.4, 6592.03, 0, 0, 0, ''), ('surf_dynamics', 3, 4, 2, -508.571, -5264.07, 5983.97, 509.896, -6254.22, 5408.03, 0, 0, 0, ''), ('surf_dynamics', 4, 4, 3, 223.969, -5966.55, 1114.85, -223.094, -5520.03, 860.305, 0, 0, 0, ''), ('surf_dynamics', 5, 4, 4, 1023.97, 5764.71, -6749.78, -989.642, 5231.65, -4720.03, 0, 0, 0, ''), ('surf_dynamics', 6, 2, 0, -119.073, -10266.9, -5607.97, 119.556, -10585.6, -5080.03, 0, 0, 0, ''), ('surf_dynamics', 7, 2, 1, -247.403, -10528.3, -5607.97, -114.322, -10585.7, -5080.03, 0, 0, 0, ''), ('surf_dynamics', 8, 2, 2, 123.964, -10586, -5607.97, 236.176, -10527.9, -5080.03, 0, 0, 0, ''), ('surf_dynamics', 9, 1, 0, 120.366, -1559.55, -10448, -158.215, -1916.97, -10280.6, 0, 0, 1, 'BONUS 1'), ('surf_dynamics', 10, 2, 0, -118.986, -4650.96, -12464, 111.74, -4328.73, -11824, 0, 0, 1, 'BONUS 1'), ('surf_dynamics', 11, 2, 1, -229.39, -4331.1, -12464, -127.403, -4371.97, -11824, 0, 0, 1, 'BONUS 1'), ('surf_dynamics', 12, 2, 2, 228.988, -4326.55, -12464, 115.993, -4388.74, -11824, 0, 0, 1, 'BONUS 1'), ('surf_kalium2_', 0, 1, 0, 13880, 175.164, 14024.4, 14232, -175.568, 13961.4, 0, 0, 0, 'Start 0'), ('surf_kalium2_', 1, 4, 0, 4951.97, 175.911, 10876.5, 4728.03, -111.13, 10448.5, 0, 0, 0, 'Start 0'), ('surf_kalium2_', 2, 4, 1, 5012.64, -141.274, 6301.57, 4683.86, 191.969, 6243.8, 0, 0, 0, 'Start 0'), ('surf_kalium2_', 3, 4, 2, 3240.56, -1599.97, -649.736, 3867.12, 1637.84, -1055.97, 0, 0, 0, 'Start 0'), ('surf_kalium2_', 4, 4, 3, 473.294, -538.412, -10240, -735.386, -162.525, -10816, 0, 0, 0, 'Start 0'), ('surf_kalium2_', 5, 4, 4, 1567.97, -14337.2, 187.491, -1815.88, -14974.3, -959.969, 0, 0, 0, 'Start 0');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_kalium2_', 6, 4, 5, 959.969, -12475.9, -5634.62, -1171.99, -11840.1, -6284.73, 0, 0, 0, 'Start 0'), ('surf_kalium2_', 7, 4, 6, -7183.9, 4530.94, -8907.7, -5497.86, 5246.19, -10520.3, 0, 0, 0, 'Start 0'), ('surf_kalium2_', 8, 2, 0, 7749.62, 12704, -10179.1, 9048.06, 11904, -10996.7, 0, 0, 0, 'Start 0'), ('surf_map_h_', 3, 4, 0, -263.367, 1215.97, 4795.66, 263.901, 1089.43, 5087.97, 0, 0, 0, ''), ('surf_map_h_', 4, 4, 1, -991.969, 8187.01, 3083.4, 991.969, 7970.52, 2798.36, 0, 0, 0, ''), ('surf_map_h_', 5, 4, 2, 3072.03, -3237.17, 7002.53, 5119.97, -4087.72, 7118.85, 0, 0, 0, ''), ('surf_map_h_', 6, 4, 3, 3104.03, -256.693, 1531.07, 5087.97, -779.806, 546.804, 0, 0, 0, ''), ('surf_map_h_', 7, 4, 4, 9983.97, 10427.1, -2071.04, 8448.03, 11171.6, -2155.76, 0, 0, 0, ''), ('surf_map_h_', 8, 4, 5, 10208, 4319.89, -5093.91, 8224.03, 3445.57, -5211.57, 0, 0, 0, ''), ('surf_map_h_', 9, 4, 6, 5171.71, -7791.92, -6532.62, 6487.29, -8159.97, -7328.88, 0, 0, 0, ''), ('surf_map_h_', 10, 1, 0, -5892.74, -4098.92, -2915.61, -6192.74, -6122.43, -3029.63, 0, 0, 1, 'BONUS 1'), ('surf_map_h_', 11, 2, 0, 3586.39, -5630.34, -3583.97, 4095.97, -4612.72, -3464.48, 0, 0, 1, 'BONUS 1'), ('surf_map_h', 0, 2, 1, 6077.84, -3297.93, -6879.97, 6209.79, -3356.21, -6779.97, 0, 0, 0, NULL), ('surf_map_h', 1, 2, 2, 6016.2, -3359.12, -6879.97, 6272.76, -4061.97, -6779.97, 0, 0, 0, NULL), ('surf_map_h', 2, 1, 1, -126.552, -4708.4, 6400.03, 123.717, -4980.26, 6500.03, 0, 0, 0, NULL), ('surf_map_h', 3, 4, 0, -263.367, 1215.97, 4795.66, 263.901, 1089.43, 5087.97, 0, 0, 0, ''), ('surf_map_h', 4, 4, 1, -991.969, 8187.01, 3083.4, 991.969, 7970.52, 2798.36, 0, 0, 0, ''), ('surf_map_h', 5, 4, 2, 3072.03, -3237.17, 7002.53, 5119.97, -4087.72, 7118.85, 0, 0, 0, ''), ('surf_map_h', 6, 4, 3, 3104.03, -256.693, 1531.07, 5087.97, -779.806, 546.804, 0, 0, 0, ''), ('surf_map_h', 7, 4, 4, 9983.97, 10427.1, -2071.04, 8448.03, 11171.6, -2155.76, 0, 0, 0, ''), ('surf_map_h', 8, 4, 5, 10208, 4319.89, -5093.91, 8224.03, 3445.57, -5211.57, 0, 0, 0, ''), ('surf_map_h', 9, 4, 6, 5171.71, -7791.92, -6532.62, 6487.29, -8159.97, -7328.88, 0, 0, 0, ''), ('surf_map_h', 10, 1, 0, -5892.74, -4098.92, -2915.61, -6192.74, -6122.43, -3029.63, 0, 0, 1, 'BONUS 1'), ('surf_map_h', 11, 2, 0, 3586.39, -5630.34, -3583.97, 4095.97, -4612.72, -3464.48, 0, 0, 1, 'BONUS 1'), ('surf_oompa_loompa_', 0, 2, 1, -7042.03, 2009.97, -14327, -7399.87, -1537.97, -14225, 0, 0, 0, NULL), ('surf_oompa_loompa_', 1, 5, 0, -297.816, -2583.97, 16194.3, 390.637, -2094.1, 16262.2, 0, 0, 0, NULL), ('surf_oompa_loompa_', 2, 4, 0, 468.024, -3431.97, 10538.7, -183.969, -2794.83, 9319.59, 0, 0, 0, ''), ('surf_oompa_loompa_', 3, 4, 1, 3593.81, -5902.4, 7463.97, 4697, -6607.97, 6721.42, 0, 0, 0, ''), ('surf_oompa_loompa_', 4, 4, 2, 432.421, -8175.97, 5696.21, 1823.97, -7465.15, 4165.74, 0, 0, 0, ''), ('surf_oompa_loompa_', 5, 4, 3, -7234.29, -247.969, -2620.49, -7461.29, -15.7183, -3087.97, 0, 0, 0, ''), ('surf_oompa_loompa_', 6, 4, 4, -8073.96, -914.031, -5368.64, -8511.88, -1615.97, -7373.17, 0, 0, 0, ''), ('surf_parrot_selector_h', 0, 1, 0, 5637.35, 508.454, 4920.03, 6654.11, -509.83, 4800.03, 0, 0, 0, 'Start 0'), ('surf_pure-', 0, 3, 1, 3784.99, -1041.58, 1567.03, 4203.2, -686.07, 1667.03, 0, 0, 0, NULL), ('surf_pure-', 1, 3, 0, -3602.34, 3723.14, 3118.03, -3804.99, 3454.19, 3218.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_pure-', 2, 1, 1, -1.92713, 367.969, 1868.03, -265.086, 4.545, 1881.21, 0, 0, 0, NULL), ('surf_pure-', 3, 3, 2, 2370.81, 732.969, -6202.08, 2637.46, 660.565, -6102.08, 0, 0, 0, NULL), ('surf_pure-', 4, 3, 3, 7429.24, 1110.21, 1665.37, 7524.24, 969.244, 1617.77, 0, 0, 0, NULL), ('surf_pure-', 5, 3, 4, -3129.76, -64.8236, 3147.37, -2995.03, -184.336, 3247.37, 0, 0, 0, NULL), ('surf_pure-', 6, 2, 1, 9466.88, 2459.44, 1505.72, 9712.58, 2631.5, 1605.72, 0, 0, 0, NULL), ('surf_pure-', 7, 3, 5, 9344.14, 2857.39, 2913.72, 9843, 2908.02, 3013.72, 0, 0, 0, NULL), ('surf_pure-', 8, 6, 0, 6402.97, -7638.4, -5277.87, 600.224, -2717.97, -6657.71, 0, 0, 0, ''), ('surf_rapid_njv', 0, 3, 2, -1907.19, -1734.97, 325.531, -1480.61, -1531.94, 411.51, 0, 0, 0, NULL), ('surf_rapid_njv', 1, 3, 3, -5377.92, 4665.41, 1256.2, -5073.38, 4194.68, 1358.2, 0, 0, 0, NULL), ('surf_rapid_njv', 2, 3, 1, 9753.79, 119.796, 2082.11, 11647.1, 514.078, 2185.01, 0, 0, 0, NULL), ('surf_rapid_njv', 3, 3, 0, 8332.82, 6324.97, 1566.03, 8634.97, 4437.03, 1668.03, 0, 0, 0, NULL), ('surf_rapid_njv', 4, 1, 1, 1331.61, 6639.97, 1374.03, 2347.72, 6512.03, 1476.03, 0, 0, 0, NULL), ('surf_rapid_njv', 5, 2, 1, -5112.15, 7175.7, 751.855, -5313.31, 7322.01, 576.031, 0, 0, 0, NULL), ('surf_rapid_njv', 6, 6, 0, 7121.81, 25.0176, 1411.97, 5121.82, 1903.15, 892.031, 0, 0, 0, ''), ('surf_rapid_njv', 7, 6, 1, -6599.88, -2042.96, 2030.52, -3948.16, 3033.72, 767.878, 0, 0, 0, ''), ('surf_rapid_njv', 8, 6, 2, -4921.59, -2109.72, 1027.93, -5636.59, -1863, 748.515, 0, 0, 0, ''), ('surf_rapid_njv', 9, 6, 3, 3467.25, 3798.3, 880.031, 6789.39, 2395.75, 1775.97, 0, 0, 0, ''), ('surf_rapid_njv', 10, 1, 0, -1429.23, 4646.6, 4152.03, -2446.2, 5660.93, 4282.03, 0, 0, 1, 'BONUS 1'), ('surf_rapid_njv', 11, 2, 0, -1643.38, 5446.01, -2442.15, -2229.27, 4858.65, -2502.06, 0, 0, 1, 'BONUS 1'), ('surf_rebel_scaz_csgo', 0, 6, 0, -8736.03, 10207.2, -9604.69, -11175.5, 8138.67, -9320.03, 0, 0, 0, 'TeleToStart 0'), ('surf_rebel_scaz_csgo', 1, 6, 1, -10781.2, 8462.03, -9611.01, -9133.76, 9777.97, -10189.9, 0, 0, 0, ''), ('surf_rebel_scaz_csgo', 2, 1, 0, 109.519, -9540.45, 9664.03, 1512.61, -10368, 10233.8, 0, 0, 0, ''), ('surf_rebel_scaz_csgo', 3, 4, 0, -163.183, 2367.97, 3444.88, 1753.73, 4330.02, 1456.03, 0, 0, 0, ''), ('surf_rebel_scaz_csgo', 4, 4, 1, -8511.97, 3368.78, 669.589, -7923.16, 4495.97, -884.775, 0, 0, 0, ''), ('surf_rebel_scaz_csgo', 5, 2, 0, -8397.13, 8847.45, -9724.03, -8238.19, 9465.97, -9818.46, 0, 0, 0, ''), ('surf_seaworld', 0, 1, 0, -446.697, 2399.72, 2700.03, 63.0639, 2081.09, 2656.03, 0, 0, 0, 'Start 0'), ('surf_seaworld', 1, 6, 0, -209.851, 2239.12, 2775.99, -191.515, 2238.61, 2782.17, 0, 0, 0, 'Start 0'), ('surf_seaworld', 2, 4, 0, 703.969, -2238.43, 61.8456, -1087.97, -1864.69, -636.525, 0, 0, 0, 'Start 0'), ('surf_seaworld', 3, 4, 1, 831.969, 8255.45, -281.354, -732.088, 7543.48, -128.031, 0, 0, 0, 'Start 0'), ('surf_seaworld', 4, 4, 2, -447.969, 4031.51, -3586.88, -35.4504, 3392.05, -4047.35, 0, 0, 0, 'Start 0'), ('surf_seaworld', 5, 2, 0, 575.771, -5953.18, -3519.97, -959.288, -6503.58, -3136.03, 0, 0, 0, 'Start 0'), ('surf_skill8_', 0, 1, 1, 512.839, 7551.97, 15828.1, 637.175, 7424.03, 15744.7, 0, 0, 0, NULL), ('surf_skill8_', 1, 2, 1, 8449.84, 3709.32, -6271.97, 9983.97, 2177.44, -5349.18, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_skill8_', 2, 4, 0, 7680.31, -4096.03, 11516, 8959.97, -4984.3, 10928.1, 0, 0, 0, ''), ('surf_skill8_', 3, 4, 1, 9860.53, -3839.97, 8429.92, 9196.25, -0.03125, 5128.69, 0, 0, 0, ''), ('surf_skill8_', 4, 4, 2, -3327.21, -2687.97, 1530.83, -1666.38, -1024.03, 1410.7, 0, 0, 0, ''), ('surf_skill8_', 5, 4, 3, -912.261, -3811.55, -2048.03, -1551.69, -0.03125, -4091.7, 0, 0, 0, ''), ('surf_skill8_', 6, 4, 4, 1554.11, -1143.52, -7040.03, -2559.97, -2687.77, -8678.81, 0, 0, 0, ''), ('surf_skill8_', 7, 4, 5, 14045.4, 1151.97, -7095.42, 12916.9, -4991.97, -9335.08, 0, 0, 0, ''), ('surf_skill8_', 8, 4, 6, 2181.53, -8191.97, -11523.1, 3303.57, 4351.97, -13262.4, 0, 0, 0, ''), ('surf_skill8_', 9, 4, 7, -11779, 640.031, 13179.4, -12159.8, 3199.44, 12032, 0, 0, 0, ''), ('surf_skill8_', 10, 4, 8, 7166.82, 4221.48, -3455.97, 6622.07, 1541.35, 212.267, 0, 0, 0, ''), ('surf_skill8', 2, 4, 0, 7680.31, -4096.03, 11516, 8959.97, -4984.3, 10928.1, 0, 0, 0, ''), ('surf_skill8', 3, 4, 1, 9860.53, -3839.97, 8429.92, 9196.25, -0.03125, 5128.69, 0, 0, 0, ''), ('surf_skill8', 4, 4, 2, -3327.21, -2687.97, 1530.83, -1666.38, -1024.03, 1410.7, 0, 0, 0, ''), ('surf_skill8', 5, 4, 3, -912.261, -3811.55, -2048.03, -1551.69, -0.03125, -4091.7, 0, 0, 0, ''), ('surf_skill8', 6, 4, 4, 1554.11, -1143.52, -7040.03, -2559.97, -2687.77, -8678.81, 0, 0, 0, ''), ('surf_skill8', 7, 4, 5, 14045.4, 1151.97, -7095.42, 12916.9, -4991.97, -9335.08, 0, 0, 0, ''), ('surf_skill8', 8, 4, 6, 2181.53, -8191.97, -11523.1, 3303.57, 4351.97, -13262.4, 0, 0, 0, ''), ('surf_skill8', 9, 4, 7, -11779, 640.031, 13179.4, -12159.8, 3199.44, 12032, 0, 0, 0, ''), ('surf_skill8', 10, 4, 8, 7166.82, 4221.48, -3455.97, 6622.07, 1541.35, 212.267, 0, 0, 0, ''), ('surf_skill8_m', 2, 4, 0, 7680.31, -4096.03, 11516, 8959.97, -4984.3, 10928.1, 0, 0, 0, ''), ('surf_skill8_m', 3, 4, 1, 9860.53, -3839.97, 8429.92, 9196.25, -0.03125, 5128.69, 0, 0, 0, ''), ('surf_skill8_m', 4, 4, 2, -3327.21, -2687.97, 1530.83, -1666.38, -1024.03, 1410.7, 0, 0, 0, ''), ('surf_skill8_m', 5, 4, 3, -912.261, -3811.55, -2048.03, -1551.69, -0.03125, -4091.7, 0, 0, 0, ''), ('surf_skill8_m', 6, 4, 4, 1554.11, -1143.52, -7040.03, -2559.97, -2687.77, -8678.81, 0, 0, 0, ''), ('surf_skill8_m', 7, 4, 5, 14045.4, 1151.97, -7095.42, 12916.9, -4991.97, -9335.08, 0, 0, 0, ''), ('surf_skill8_m', 8, 4, 6, 2181.53, -8191.97, -11523.1, 3303.57, 4351.97, -13262.4, 0, 0, 0, ''), ('surf_skill8_m', 9, 4, 7, -11779, 640.031, 13179.4, -12159.8, 3199.44, 12032, 0, 0, 0, ''), ('surf_skill8_m', 10, 4, 8, 7166.82, 4221.48, -3455.97, 6622.07, 1541.35, 212.267, 0, 0, 0, ''), ('surf_loentra', 3, 2, 0, 12724.8, 3030.81, 2552.01, 13955.7, 5616.35, 2871.95, 0, 0, 1, NULL), ('surf_loentra', 2, 1, 0, 9584.03, 3921.84, 13554.4, 10218.9, 4814.22, 13500.2, 0, 0, 1, NULL), ('surf_loentra', 1, 2, 1, 12280.1, -12081.8, -14261.5, 13805.2, -12945.8, -14759.7, 0, 0, 0, NULL), ('surf_loentra', 0, 1, 1, -10068.8, 9674.42, 15669, -8849.23, 9246.77, 15771, 0, 0, 0, NULL), ('surf_jusched', 9, 2, 2, -13399, -12538.2, -5375.97, -14247.5, -12321.6, -5121.97, 0, 0, 0, ''), ('surf_jusched', 8, 2, 1, -13397.9, -11979.6, -5375.97, -14248, -12189, -5121.97, 0, 0, 0, ''), ('surf_jusched', 7, 2, 0, -13320, -12193.6, -5375.97, -14326.7, -12319.4, -5101.97, 0, 0, 0, ''), ('surf_skill8_e', 2, 4, 0, 7680.31, -4096.03, 11516, 8959.97, -4984.3, 10928.1, 0, 0, 0, '');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_skill8_e', 3, 4, 1, 9860.53, -3839.97, 8429.92, 9196.25, -0.03125, 5128.69, 0, 0, 0, ''), ('surf_skill8_e', 4, 4, 2, -3327.21, -2687.97, 1530.83, -1666.38, -1024.03, 1410.7, 0, 0, 0, ''), ('surf_skill8_e', 5, 4, 3, -912.261, -3811.55, -2048.03, -1551.69, -0.03125, -4091.7, 0, 0, 0, ''), ('surf_skill8_e', 6, 4, 4, 1554.11, -1143.52, -7040.03, -2559.97, -2687.77, -8678.81, 0, 0, 0, ''), ('surf_skill8_e', 7, 4, 5, 14045.4, 1151.97, -7095.42, 12916.9, -4991.97, -9335.08, 0, 0, 0, ''), ('surf_skill8_e', 8, 4, 6, 2181.53, -8191.97, -11523.1, 3303.57, 4351.97, -13262.4, 0, 0, 0, ''), ('surf_skill8_e', 9, 4, 7, -11779, 640.031, 13179.4, -12159.8, 3199.44, 12032, 0, 0, 0, ''), ('surf_skill8_e', 10, 4, 8, 7166.82, 4221.48, -3455.97, 6622.07, 1541.35, 212.267, 0, 0, 0, ''), ('surf_skill8_', 11, 6, 0, -1611.72, 6733.88, 15168, -2490.62, 6965.25, 14912, 0, 0, 0, ''), ('surf_stick-', 0, 3, 0, 10848, 15704.9, 554.031, 11323.8, 15319.8, 656.031, 0, 0, 0, NULL), ('surf_stick-', 1, 1, 1, -15894, -15169.7, 344.131, -15736.3, -15428.5, 446.031, 0, 0, 0, NULL), ('surf_stick-', 2, 2, 1, -14841.2, -194.046, -16227, -14959, -429.271, -16054.7, 0, 0, 0, NULL), ('surf_stick-', 3, 3, 1, -13856, -13796.3, 14619.3, -13179.9, -14824.9, 14604, 0, 0, 0, NULL), ('surf_stick-', 4, 3, 2, -13947.9, 15693.4, 15734.1, -14355.6, 15125.6, 15836.1, 0, 0, 0, NULL), ('surf_stick-', 5, 3, 4, -15870.5, -174.5, -12156.6, -16121.1, -422.667, -12054.6, 0, 0, 0, NULL), ('surf_stick-', 6, 3, 3, 7988.01, -15102, -10050, 8330.45, -14730.6, -9947.97, 0, 0, 0, NULL), ('surf_stickybutt_alpha-', 0, 2, 1, -1005.95, 12667.5, -7409.98, 1004.45, 13307.7, -6596.29, 0, 0, 0, NULL), ('surf_stickybutt_alpha-', 1, 1, 1, -307.318, 1129.16, 9230.03, 287.946, 1885.95, 9332.03, 0, 0, 0, NULL), ('surf_stickybutt_alpha-', 2, 4, 0, 495.969, 11786.8, 7677.16, -495.969, 13054.5, 7013.05, 0, 0, 0, ''), ('surf_stickybutt_alpha-', 3, 4, 1, 2031.97, 6133.4, 5370.95, -2015.48, 7151.97, 5057.33, 0, 0, 0, ''), ('surf_stickybutt_alpha-', 4, 4, 2, 470.985, -7433.97, -3905.97, -464.351, -6434.03, -4108.65, 0, 0, 0, ''), ('surf_infamous_ksf', 0, 1, 1, -9086.03, -8431.2, 9790.03, -8642.17, -8986.94, 9892.03, 0, 0, 0, NULL), ('surf_gurus_njv', 10, 2, 2, 9198.97, -2668.44, -3750.03, 8861.92, -2608.57, -4016.97, 0, 0, 0, ''), ('surf_gurus_njv', 9, 2, 1, 9198.97, -1994.97, -3775.01, 8898.16, -2072.71, -4032.97, 0, 0, 0, ''), ('surf_gurus_njv', 8, 6, 8, 391.662, -2715.97, 112.161, -1843.79, -116.031, -738.064, 0, 0, 0, NULL), ('surf_gurus_njv', 7, 3, 5, 1409.41, -2009.35, -2482.97, 1846.15, -2601.1, -2380.97, 0, 0, 0, NULL), ('surf_gurus_njv', 6, 3, 3, 2979.03, 9368.02, 6874.03, 3250.26, 9456.38, 6976.03, 0, 0, 0, NULL), ('surf_training', 0, 1, 0, -5891.06, -4591.04, 220.031, -6469.94, -4942.88, 336.694, 0, 0, 0, 'Start 0'), ('surf_training', 1, 3, 0, -5416.11, -4553.07, 220.031, -4824.36, -4943.97, 309.159, 0, 0, 0, 'Start 0'), ('surf_training', 2, 3, 1, -4370.92, -4554.5, 355.031, -3779.46, -4942.88, 459.866, 0, 0, 0, 'Start 0'), ('surf_training', 3, 3, 2, 4716.74, -4619.28, 446.031, 4121.34, -5013.88, 537.565, 0, 0, 0, 'Start 0'), ('surf_training', 4, 3, 3, 7557.16, -11432, 1306.78, 8143.17, -11838.8, 1402.36, 0, 0, 0, 'Start 0'), ('surf_training', 5, 2, 0, 8660.98, -368.118, -232.781, 6997.03, 24.7096, -829.174, 0, 0, 0, 'Start 0');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_training', 6, 0, 0, 1689.7, -2669.7, 482.95, 2838.3, -3035.32, 166.697, 0, 0, 0, 'Start 0'), ('surf_exile_njv', 5, 1, 1, 5160.03, 4823.97, 786.031, 5251.74, 4376.03, 888.031, 0, 0, 0, NULL), ('surf_exile_njv', 4, 3, 1, 4207.97, -12192, 1214.03, 3600.03, -11984.6, 1316.03, 0, 0, 0, NULL), ('surf_exile_njv', 3, 3, 2, -237.836, -13489.3, 911.031, -38.0394, -13411.5, 1018.01, 0, 0, 0, NULL), ('surf_exile_njv', 2, 3, 0, 3680.03, -6305.22, 2990.03, 4128, -6751.97, 3092.03, 0, 0, 0, NULL), ('surf_exile_njv', 1, 3, 3, -207.969, 847.969, 3262.03, -48.0312, 600.075, 3364.03, 0, 0, 0, NULL), ('surf_elysium2', 7, 1, 0, 10582.1, 13454, 14064.5, 10860.6, 13069.2, 13748, 0, 0, 1, 'BONUS 1'), ('surf_elysium2', 8, 2, 0, -5468.01, 12748.5, -2507.97, -5941.74, 13837.7, -1612.03, 0, 0, 1, 'BONUS 1'), ('surf_entropy_hardmode', 0, 3, 0, 484.833, -770.228, 1750.53, 292.625, -580.019, 1850.53, 0, 0, 0, NULL), ('surf_entropy_hardmode', 1, 3, 1, 8677.97, -196.969, -189.469, 9070.71, -55.0312, -89.4688, 0, 0, 0, NULL), ('surf_entropy_hardmode', 2, 3, 3, -11282.7, 2565.9, 1497.53, -11587, 1864.89, 1597.53, 0, 0, 0, NULL), ('surf_entropy_hardmode', 3, 1, 0, 2428, -2632.39, -42.4688, 1983.02, -3627.72, 57.5312, 0, 0, 0, NULL), ('surf_entropy_hardmode', 4, 2, 0, -9442.98, 2624.13, -892.469, -10046.9, 1806.03, -792.469, 0, 0, 0, NULL), ('surf_entropy_hardmode', 5, 3, 2, -2854.03, 2531.97, 1924.53, -2944.18, 2282.16, 2024.53, 0, 0, 0, NULL), ('surf_exile_njv', 0, 2, 1, 623.969, 6815.2, -961.969, -879.969, 7407.97, -875.969, 0, 0, 0, NULL), ('surf_rebel_scaz_csgo', 6, 6, 2, -9897.49, 9196.27, -9141.72, -10100.9, 8936.88, -8928.03, 0, 0, 0, ''), ('surf_diverge', 8, 3, 0, -11243, -3297.29, -5733.48, -10031.2, -3550.09, -5827.73, 0, 0, 1, 'BONUS 1'), ('surf_diverge', 9, 3, 1, -8056.03, -1621.31, -5127.28, -8437.97, -1539.73, -5183.98, 0, 0, 1, 'BONUS 1'), ('surf_frequency_njv', 4, 1, 0, 3680.22, -276.995, 2735.97, 2686.75, 565.506, 2360.03, 0, 0, 2, 'BONUS 2'), ('surf_frequency_njv', 5, 2, 0, 3084.77, -2217.47, -2499.97, 3311.14, -1914.03, -1892.23, 0, 0, 2, 'BONUS 2'), ('surf_overgrowth', 9, 5, 0, -8023.97, -9848.63, 1843.78, -7928.03, -9906.7, 1699.59, 0, 0, 2, 'BONUS 2'), ('surf_overgrowth', 10, 2, 0, -8905.03, -10197.8, -719.969, -9283.03, -9576.03, -544.626, 0, 0, 2, 'BONUS 2'), ('surf_the_gloaming_rat', 7, 4, 0, 1526.57, -1441.11, 10269.7, 1026.82, 1536.97, 9922.08, 0, 0, 0, 'Start 0'), ('surf_the_gloaming_rat', 8, 4, 1, 2668.03, -4102.69, -31.8746, 4074.97, -4365.49, -757.665, 0, 0, 0, 'Start 0'), ('surf_the_gloaming_rat', 9, 4, 2, -2560.03, -2050.95, -2066.47, -3548.72, -2342.46, -3132.53, 0, 0, 0, 'Start 0'), ('surf_lt_omnific_', 23, 1, 0, -14723.2, -14336, -2918.75, -15197.3, -13313, -3071.97, 0, 0, 2, 'BONUS 2'), ('surf_lt_omnific_', 24, 2, 0, -7749.94, -12757.6, 14949, -6581.02, -13868.6, 14848, 0, 0, 2, 'BONUS 2'), ('surf_lt_omnific_', 25, 1, 0, 1522.93, 7669.6, -3667.97, 517.017, 6660.29, -3935.97, 0, 0, 3, 'BONUS 3'), ('surf_lt_omnific_', 26, 2, 0, 718.569, 7463.38, -11412, 1332.26, 6860, -11488, 0, 0, 3, 'BONUS 3'), ('surf_beyer2', 12, 4, 0, 7762.2, -2124.28, 13024, 5280.03, -2660.77, 11063.3, 0, 0, 0, ''), ('surf_beyer2', 13, 4, 1, 7546.83, 2322.38, 6847.97, 5520.11, 2998.01, 4640.03, 0, 0, 0, ''), ('surf_beyer2', 14, 4, 2, 3984.18, -13663.8, 6399.97, 9061.9, -14423.4, 4928.03, 0, 0, 0, '');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_beyer2', 15, 4, 3, 9343.97, 5763.78, -2271.03, 3712.03, 7156.2, -2757.46, 0, 0, 0, ''), ('surf_beyer2', 16, 4, 4, 1726.97, -8895.97, -4520.59, 11360, -7849.54, -5530.81, 0, 0, 0, ''), ('surf_beyer2', 17, 4, 5, 4256.03, 5876.35, -8931.78, 8799.97, 5154.42, -9909.94, 0, 0, 0, ''), ('surf_placid', 4, 4, 0, 2232.21, -1624.33, 8711.97, 384.833, -2054.59, 7176.03, 0, 0, 0, 'Start 0'), ('surf_placid', 5, 4, 1, 2210.38, -2760.72, 6151.97, 384.031, -3230.68, 4304.75, 0, 0, 0, 'Start 0'), ('surf_placid', 6, 4, 2, -960.031, 4271.68, 3875.9, -2687.97, 3834.07, 2479.63, 0, 0, 0, 'Start 0'), ('surf_placid', 7, 4, 3, -2906.1, -6069.89, -37.118, -826.764, -5628.85, -951.969, 0, 0, 0, 'Start 0'), ('surf_placid', 8, 4, 4, -0.03125, -3618.7, -5707.28, -3687.67, -2717.67, -6855.48, 0, 0, 0, 'Start 0'), ('surf_placid', 9, 4, 5, -907.486, 4952.97, -10634.9, -2751.97, 3290.88, -11165.2, 0, 0, 0, 'Start 0'), ('surf_juturna', 4, 4, 0, -1625.93, -1517.17, 3423.24, -2379.57, 1517.17, 3538.85, 0, 0, 0, 'Start 0'), ('surf_juturna', 5, 4, 1, 2057.91, 1517.17, 1371.83, 1597.88, -1517.17, -868.053, 0, 0, 0, 'Start 0'), ('surf_juturna', 6, 4, 2, -1653.21, -250.624, -3584.03, -1257.86, 247.944, -3967.97, 0, 0, 0, 'Start 0'), ('surf_juturna', 7, 4, 3, 897.99, 543.969, -8968.72, 506.012, -543.969, -9894.79, 0, 0, 0, 'Start 0'), ('surf_juturna', 8, 4, 4, -10482.8, 255.969, -12281.9, -10437.7, -249.036, -12472.2, 0, 0, 0, 'Start 0'), ('surf_network_2008_final', 5, 4, 0, 0.03125, -4022.66, 3993.87, 382.797, -4001.89, 3488.03, 0, 0, 0, 'Start 0'), ('surf_network_2008_final', 6, 4, 1, -964.795, 1600.03, 938.184, -1727.97, 1221.64, -137.703, 0, 0, 0, 'Start 0'), ('surf_network_2008_final', 7, 4, 2, 320.031, -158.18, -2169.77, 222.149, 574.683, -3167.97, 0, 0, 0, 'Start 0'), ('surf_network_2008_final', 8, 4, 3, -703.969, -1694.39, -5394.2, 255.969, -1635.07, -5967.88, 0, 0, 0, 'Start 0'), ('surf_calibration', 3, 4, 1, 8896.33, 549.339, 6023.97, 9791.97, 1202.53, 5015.78, 0, 0, 0, 'Start 0'), ('surf_calibration', 4, 4, 2, 7295.01, 2774.96, -1728.03, 5598.58, 3462.09, -2943.97, 0, 0, 0, 'Start 0'), ('surf_calibration', 5, 4, 3, 896.031, -6888.46, -3336.91, 3903.97, -8697.67, -4792.45, 0, 0, 0, 'Start 0'), ('surf_calibration', 6, 4, 4, -854.269, 920.152, -5120.03, -1527.17, 3503.97, -7794.57, 0, 0, 0, 'Start 0'), ('surf_calibration', 7, 4, 5, -9666.89, -5179.81, -6488.03, -7882.59, -4679.43, -8087.97, 0, 0, 0, 'Start 0'), ('surf_stonework2', 8, 1, 0, 13423.4, 5696.03, 5837.57, 13082.4, 6589.23, 5632.03, 0, 0, 1, 'BONUS 1'), ('surf_stonework2', 9, 2, 0, -12782.8, 5696.03, 6009.5, -12383.3, 6591.97, 5633.14, 0, 0, 1, 'BONUS 1'), ('surf_frequency_njv', 6, 4, 0, -14464, 5403.96, 4778.69, -15483.7, 6943.97, 4537.3, 0, 0, 0, 'Start 0'), ('surf_frequency_njv', 7, 4, 1, -2951.11, 5280.03, 2447.06, -2718.1, 6943.97, 1963.61, 0, 0, 0, 'Start 0'), ('surf_frequency_njv', 8, 4, 2, 3968.03, 5951.49, -2777.61, 3968.03, 6304.83, -3248.33, 0, 0, 0, 'Start 0'), ('surf_ixtab_njv', 7, 5, 0, 6532.42, -10200.7, 1483.28, 5320.53, -10648.1, 1635.53, 0, 0, 1, 'BONUS 1'), ('surf_ixtab_njv', 8, 2, 0, 5544.64, -5770.59, 1547.28, 6232.11, -5270.96, 1389.28, 0, 0, 1, 'BONUS 1'), ('surf_pandemonium', 9, 1, 0, -2812.03, 9073.84, 10110, -2364.54, 9334.59, 9990.03, 0, 0, 2, 'FÃ¤ggotBonus');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_pandemonium', 10, 2, 0, -11341.8, 10078, 1709.69, -10768.6, 8326.03, 1905.01, 0, 0, 2, 'FÃ¤ggotBonus'), ('surf_bob', 13, 1, 0, 8192.03, -12284.6, 14013, 8695.36, -11786, 13824, 0, 0, 1, 'BONUS 1'), ('surf_bob', 14, 2, 0, 10240, -12287, 13566.5, 10120.4, -12171, 13440, 0, 0, 1, 'BONUS 1'), ('surf_asrown', 4, 4, 0, -12928, 4746.7, 14012.1, -13567.2, 4726.06, 13504, 0, 0, 0, ''), ('surf_asrown', 5, 4, 1, -12240, 9840.67, 9558, -14224, 9727.64, 6992.33, 0, 0, 0, ''), ('surf_asrown', 6, 4, 2, -13105.7, -2803.97, 6903.34, -12853.6, -2014.03, 5432.91, 0, 0, 0, ''), ('surf_voteforthisone', 9, 1, 0, 7711.91, 10528.9, 5375.94, 7203.3, 11264, 5522.51, 0, 0, 1, 'BONUS 1'), ('surf_voteforthisone', 10, 2, 0, 7182.37, 9778.12, -3999.97, 7737.41, 9024.03, -3631.17, 0, 0, 1, 'BONUS 1'), ('surf_fruits2', 16, 1, 0, -3534.7, 12530, 10753, -4142.97, 12879.6, 10913.7, 0, 0, 1, 'BONUS 1'), ('surf_fruits2', 17, 2, 0, -1905.48, 12882, 4571.79, -2286.97, 12503.1, 4349.41, 0, 0, 1, 'BONUS 1'), ('surf_sinsane_ksf', 12, 4, 1, 3072.03, 904.205, 8990.71, 3324.51, 1143.97, 8929.91, 0, 0, 1, 'BONUS 1'), ('surf_sinsane_ksf', 13, 4, 2, 1830.11, 1087.97, 7071.41, 1668.23, 962.604, 6904.03, 0, 0, 1, 'BONUS 1'), ('surf_sinsane_ksf', 14, 4, 3, -8725.53, 944.309, 4727.97, -8337.03, 1200.36, 4652.27, 0, 0, 1, 'BONUS 1'), ('surf_sinsane_ksf', 15, 4, 4, 1100.03, 952.655, 3118.18, 1213.37, 1142.65, 2967.03, 0, 0, 1, 'BONUS 1'), ('surf_sinsane_ksf', 16, 4, 5, 2309.62, 816.031, 432.016, 2821.39, 1255.48, 556.969, 0, 0, 1, 'BONUS 1'), ('surf_sinsane_ksf', 17, 4, 6, 7323.31, 1926.97, -1444.22, 6850.32, 168.296, -2194.97, 0, 0, 1, 'BONUS 1'), ('surf_skill8_h', 0, 1, 1, 639.713, 7550.97, 15744, 398.88, 7424.28, 15844, 0, 0, 0, NULL), ('surf_skill8_h', 1, 2, 1, 8451.1, 3711.97, -6270.37, 9945.15, 2176.03, -5305.83, 0, 0, 0, NULL), ('surf_skill8_h', 2, 4, 0, 7680.31, -4096.03, 11516, 8959.97, -4984.3, 10928.1, 0, 0, 0, ''), ('surf_skill8_h', 3, 4, 1, 9860.53, -3839.97, 8429.92, 9196.25, -0.03125, 5128.69, 0, 0, 0, ''), ('surf_skill8_h', 4, 4, 2, -3327.21, -2687.97, 1530.83, -1666.38, -1024.03, 1410.7, 0, 0, 0, ''), ('surf_skill8_h', 5, 4, 3, -912.261, -3811.55, -2048.03, -1551.69, -0.03125, -4091.7, 0, 0, 0, ''), ('surf_skill8_h', 6, 4, 4, 1554.11, -1143.52, -7040.03, -2559.97, -2687.77, -8678.81, 0, 0, 0, ''), ('surf_skill8_h', 7, 4, 5, 14045.4, 1151.97, -7095.42, 12916.9, -4991.97, -9335.08, 0, 0, 0, ''), ('surf_skill8_h', 8, 4, 6, 2181.53, -8191.97, -11523.1, 3303.57, 4351.97, -13262.4, 0, 0, 0, ''), ('surf_skill8_h', 9, 4, 7, -11779, 640.031, 13179.4, -12159.8, 3199.44, 12032, 0, 0, 0, ''), ('surf_skill8_h', 10, 4, 8, 7166.82, 4221.48, -3455.97, 6622.07, 1541.35, 212.267, 0, 0, 0, ''), ('surf_skill8_h', 11, 2, 1, -2495.97, 7610.18, 15164.7, -1602.68, 6720.03, 14914.9, 0, 0, 0, ''), ('surf_sunset_njv', 8, 3, 2, 3392.03, -5903.69, 6928.36, 3774.16, -5424.03, 7017.18, 0, 0, 0, ''), ('surf_stonework3', 0, 3, 4, 11357.6, 15342.7, 13838, 11156.2, 14911.1, 13908, 0, 0, 0, NULL), ('surf_stonework3', 1, 3, 0, -4751.97, -8046.7, -769.969, -4446.72, -7811.09, -667.969, 0, 0, 0, NULL), ('surf_stonework3', 2, 3, 5, 3245.96, 14305.6, 13566, 2962.34, 13722, 13668, 0, 0, 0, NULL), ('surf_stonework3', 3, 2, 1, 3800.92, 13767, 3582.03, 2319.63, 15334.4, 3778.82, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_stonework3', 4, 3, 3, 12031.6, -3695.97, 2605.03, 12541, -3270.85, 2659.03, 0, 0, 0, NULL), ('surf_stonework3', 5, 3, 2, -4853.23, -15344, 14894, -4351.9, -14881.9, 14980, 0, 0, 0, NULL), ('surf_stonework3', 6, 3, 1, -11643.7, -15480.1, 14574, -10863, -14816.4, 14676, 0, 0, 0, NULL), ('surf_stonework3', 7, 1, 1, -4591.97, -6751.15, 5150.03, -3088.03, -7228.56, 5252.03, 0, 0, 0, NULL), ('surf_syria_again_', 0, 3, 1, -3636.1, -588.729, 429.697, -4018.09, -1436.18, 567.508, 0, 0, 0, NULL), ('surf_syria_again_', 1, 1, 1, -5277.14, 3396.44, -1181.97, -4834.53, 4159.24, -1034.08, 0, 0, 0, NULL), ('surf_syria_again_', 2, 3, 3, 7737.49, -1312.53, -1545.97, 7119.74, -2160.47, -1443.97, 0, 0, 0, NULL), ('surf_syria_again_', 3, 3, 0, -5208.12, 1966.12, -4629.97, -5631.61, 1135.29, -4527.97, 0, 0, 0, NULL), ('surf_syria_again_', 4, 3, 4, -11862.5, 1106.63, 355.031, -11495, 1872.57, 457.031, 0, 0, 0, NULL), ('surf_syria_again_', 5, 3, 2, 4811.09, 3368.5, 18.0312, 5408.47, 4336.47, 120.031, 0, 0, 0, NULL), ('surf_syria_again_', 6, 3, 6, -7498.47, 5945.47, 3684.03, -7079.03, 4953.5, 3786.03, 0, 0, 0, NULL), ('surf_syria_again_', 7, 3, 5, 1492.97, -4789.97, -2270.97, 808.688, -3798.32, -2168.97, 0, 0, 0, NULL), ('surf_syria_again_', 8, 2, 1, -5415.47, 897.469, 7700.03, -4519.53, 1.53125, 7802.03, 0, 0, 0, NULL), ('surf_the_distance_', 0, 1, 1, 3129.39, 1634.38, 13094, 2790.03, 928.339, 13197.8, 0, 0, 0, NULL), ('surf_the_distance_', 1, 2, 1, -4006.43, 1793.91, -14836, -4246.5, 1890.27, -15232, 0, 0, 0, NULL), ('surf_the_distance_', 2, 4, 0, -8410.57, 480.031, 8445.3, -9057.29, 2015.97, 7434.29, 0, 0, 0, ''), ('surf_the_distance_', 3, 4, 1, -9811.93, -3308.02, 4265.87, -7936.58, -2848.03, 3119.48, 0, 0, 0, ''), ('surf_the_distance_', 4, 4, 2, -1721.08, -2900.69, -884.45, -3065.98, -3199.97, -1872.79, 0, 0, 0, ''), ('surf_the_distance_', 5, 4, 3, 9624.18, 4950.5, -7767.13, 9975.97, 3668.5, -8937.93, 0, 0, 0, ''), ('surf_the_distance_', 6, 4, 4, 12802.7, 13649.5, 8747.79, 12552.6, 13376, 8294.58, 0, 0, 0, ''), ('surf_the_distance_', 7, 4, 5, 14288.4, 15040.1, 958.237, 14849.1, 13881.9, 800.378, 0, 0, 0, ''), ('surf_the_distance_', 8, 4, 6, -2555.11, 10732.5, -1943.72, -2751.97, 11259.6, -2566.67, 0, 0, 0, ''), ('surf_the_distance_', 9, 4, 7, 1067.33, 1071.05, -10300.5, 2013.54, 1471.92, -11216.4, 0, 0, 0, ''), ('surf_the_distance_', 10, 4, 8, -13378.6, 14228.6, -5786.21, -11073.9, 13654.8, -7809.71, 0, 0, 0, ''), ('surf_the_distance_', 11, 4, 9, -13357.3, 14969, -11984, -13728, 14597.4, -12199.7, 0, 0, 0, ''), ('surf_the_distance_', 12, 1, 0, 15490.2, -15042.2, 697.898, 15028.6, -15540.6, 672.308, 0, 0, 1, 'BONUS 1'), ('surf_the_distance_', 13, 2, 0, 15518.6, -15552, -12624.1, 15008, -15044.2, -12746.9, 0, 0, 1, 'BONUS 1'), ('surf_timewarp', 0, 1, 1, 32.0312, 16.0312, 2046.03, 297.206, 487.423, 2148.03, 0, 0, 0, NULL), ('surf_timewarp', 1, 3, 3, -503.984, -11768.1, 7166.03, 506.251, -10753.5, 7268.03, 0, 0, 0, NULL), ('surf_timewarp', 2, 3, 2, -4015.97, 11257.7, 6654.03, -3375.97, 10241.3, 6756.03, 0, 0, 0, NULL), ('surf_timewarp', 3, 3, 0, -3983.97, -2576.03, 6654.03, -3594.21, -3578.77, 6756.03, 0, 0, 0, NULL), ('surf_timewarp', 4, 3, 1, 571.452, -4165.97, -8033.97, 1400, -3777.37, -7931.97, 0, 0, 0, NULL), ('surf_timewarp', 5, 1, 2, 32.0312, 2031.97, 2046.03, 282.733, 1573.96, 2148.03, 0, 0, 0, NULL);");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_timewarp', 6, 2, 1, 11581.9, -2850.28, -5053.97, 10180.1, -4251.22, -5183.97, 0, 0, 0, NULL), ('surf_treefort', 0, 2, 1, -912.031, 7791.97, 126.031, -1688.07, 7295.14, 228.031, 0, 0, 0, NULL), ('surf_treefort', 1, 3, 5, -9731.98, 6652.61, -1357.97, -10136.9, 5636.49, -1407.97, 0, 0, 0, NULL), ('surf_treefort', 2, 3, 4, -11100.2, 863.435, 14718, -11470.3, 1255.27, 14820, 0, 0, 0, NULL), ('surf_treefort', 3, 3, 6, 414.015, 423.926, 11966, -417.242, -408.291, 12068, 0, 0, 0, NULL), ('surf_treefort', 4, 1, 1, 8805.24, 9400, 1278.03, 9563.55, 8647.64, 1380.03, 0, 0, 0, NULL), ('surf_treefort', 5, 3, 0, 11070.6, -11312, 10150.6, 10956.9, -11220.4, 10096, 0, 0, 0, NULL), ('surf_treefort', 6, 3, 1, 9874.64, 11881.3, 14846, 9580.64, 11637.1, 14948, 0, 0, 0, NULL), ('surf_treefort', 7, 3, 3, -11792.9, -10408.5, 10533, -11664.1, -10557.5, 10496, 0, 0, 0, NULL), ('surf_treefort', 8, 3, 2, 9504.88, -9459.45, 1534.03, 8911.6, -8912.88, 1636.03, 0, 0, 0, NULL), ('surf_treefort', 9, 2, 2, -2671.97, 9071.97, 126.031, -2179.29, 8303.99, 228.031, 0, 0, 0, NULL), ('surf_treefort', 10, 2, 3, -2671.97, 6032.03, 126.031, -2181.73, 6821.27, 228.031, 0, 0, 0, NULL), ('surf_treefort', 11, 2, 4, -3951.97, 7312.03, 126.031, -3175.35, 7810.74, 228.031, 0, 0, 0, NULL), ('surf_tundra', 0, 1, 0, 14619, 8640.03, 8647.43, 15296, 10272, 8576.27, 0, 0, 0, NULL), ('surf_tundra', 1, 3, 0, -70.8005, -8384.03, 14635.2, -427.305, -11136, 14556.1, 0, 0, 0, NULL), ('surf_tundra', 2, 3, 1, -14605.5, 255.969, 5747.4, -15449.2, -1791.97, 5705.17, 0, 0, 0, NULL), ('surf_tundra', 3, 2, 0, -6657.08, 191.581, -2671.97, -7271.28, -189.367, -2370.75, 0, 0, 0, NULL), ('surf_tundra', 4, 2, 1, -6975.73, -509.471, -2671.97, -7295.97, 505.553, -2410.04, 0, 0, 0, NULL), ('surf_tundra', 5, 2, 0, -15360, 1658.51, 12419.7, -14336, 977.137, 13218, 0, 0, 1, NULL), ('surf_tundra', 6, 1, 0, -14080, 13206.9, 14045.5, -14175.6, 13121.2, 13984, 0, 0, 1, NULL), ('surf_tundra', 7, 3, 0, -13830.3, 12864, 14242.1, -14077, 13118.7, 14144, 0, 0, 1, 'BONUS 1'), ('surf_tundra', 8, 3, 1, -10980.5, 13120, 14331.5, -11252, 12902.6, 14080, 0, 0, 1, 'BONUS 1'), ('surf_tundra', 9, 3, 2, -7167.97, 14530.4, 14365.5, -6656.03, 14744.2, 14022, 0, 0, 1, 'BONUS 1'), ('surf_tundra', 10, 3, 3, -7932.43, 14176, 14622.9, -7741.45, 14335.5, 14368, 0, 0, 1, 'BONUS 1'), ('surf_tundra', 11, 3, 4, -9215.97, 4796.36, 13821.3, -8837.9, 4302.29, 13440, 0, 0, 1, 'BONUS 1'), ('surf_tundra', 12, 3, 5, -9277.69, 4287.35, 13664, -9224.01, 3840.03, 13823.5, 0, 0, 1, 'BONUS 1'), ('surf_tundra', 13, 3, 6, -10749, 7092.24, 14432, -10560, 6367.17, 13537.9, 0, 0, 1, 'BONUS 1'), ('surf_tundra', 14, 3, 7, -15360, 11025.1, 14119.1, -14333.5, 11961.6, 13504, 0, 0, 1, 'BONUS 1'), ('surf_unreal2_', 0, 3, 0, -10629.7, 2815.97, 4247.03, -11144, 2400.03, 4349.03, 0, 0, 0, NULL), ('surf_unreal2_', 1, 1, 1, 8422.35, -5078.13, 13962, 8947.56, -3678.94, 14064, 0, 0, 0, NULL), ('surf_unreal2_', 2, 3, 1, -6171.56, -598.666, 12694, -6639.97, 514.486, 12796, 0, 0, 0, NULL), ('surf_unreal2_', 3, 2, 1, -3098.77, 176.458, -8768.26, -3384.96, -165.127, -8665.27, 0, 0, 0, NULL), ('surf_unreal2_', 4, 1, 0, 9918.37, 4880.65, 1796.03, 9413.45, 5199.97, 1906.85, 0, 0, 1, 'BONUS 1'), ('surf_unreal2_', 5, 2, 0, 8049.67, 210.675, -1375.97, 11295.1, 447.389, -624.031, 0, 0, 1, 'BONUS 1');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_unreal2_', 6, 1, 0, 2877.8, -3144.03, 12082.9, 2112.03, -4292.48, 11933.5, 0, 0, 2, 'BONUS 2'), ('surf_unreal2_', 7, 2, 0, 511.324, -3144.03, 9892.85, 781.164, -4295.97, 10218.9, 0, 0, 2, 'BONUS 2'), ('surf_unreal_njv_', 0, 2, 1, 4057.42, -86.8078, -13118, 3873.29, -147.207, -13020.3, 0, 0, 0, NULL), ('surf_unreal_njv_', 1, 2, 2, 3838.54, -86.2493, -13118, 4048.5, 102.681, -13016, 0, 0, 0, NULL), ('surf_unreal_njv_', 2, 2, 3, 3824.66, -51.1051, -13118, 3769.51, 48.169, -13016, 0, 0, 0, NULL), ('surf_unreal_njv_', 3, 1, 1, -7044.52, 153.413, 10617, -7534.99, -149.584, 10719, 0, 0, 0, NULL), ('surf_unreal_njv_', 4, 2, 4, 4231.05, -281.133, -13118, 4052.47, 295.392, -13016, 0, 0, 0, NULL), ('surf_unreal_njv_', 5, 2, 5, 4166.97, -131.031, -13118, 4181.09, 145.797, -12868.2, 0, 0, 0, NULL), ('surf_unreal_njv_', 6, 2, 6, 4052.8, 102.188, -13118, 3881.33, 150.54, -13021.5, 0, 0, 0, NULL), ('surf_unreal_njv_', 7, 4, 0, -4437.98, 437.969, 10105.3, -3670.36, -428.695, 9939.03, 0, 0, 0, ''), ('surf_unreal_njv_', 8, 4, 1, 2998.07, -319.969, 7450.78, 3535.52, 319.969, 7287.95, 0, 0, 0, ''), ('surf_unreal_njv_', 9, 4, 2, 2918.02, 702.14, 2110.97, 3420.2, -703.969, 1839.6, 0, 0, 0, ''), ('surf_unreal_njv_', 10, 4, 3, 11351.2, -1.03558, -8331.99, 12335.7, -474.496, -8165.82, 0, 0, 0, ''), ('surf_elysium2', 6, 2, 2, -6288.47, -5023.47, -13154, -5847.8, -4772.5, -12485.7, 0, 0, 0, 'Start 0'), ('surf_elysium2', 5, 2, 1, -6290.2, -2774.8, -13154, -5844.18, -3022.51, -12486.5, 0, 0, 0, 'Start 0'), ('surf_elysium2', 4, 2, 0, -6540.03, -4767.06, -13154, -5846.97, -3030.67, -12479.7, 0, 0, 0, 'Start 0'), ('surf_elysium2', 3, 3, 2, -11453, 12124.5, -4837.97, -11572.7, 11996.1, -4450.03, 0, 0, 0, 'Start 0'), ('surf_elysium2', 2, 3, 1, -14553, -9417, -1311.97, -14670, -9535.59, -1152.03, 0, 0, 0, 'Start 0'), ('surf_elysium2', 1, 3, 0, -10533.5, -7627.81, 9798.03, -10846.3, -7316.06, 9568.03, 0, 0, 0, 'Start 0'), ('surf_elysium2', 0, 1, 0, 15186, -11436.1, 15200, 16192, -10190.9, 15403.4, 0, 0, 0, 'Start 0'), ('surf_discovery_njv', 5, 3, 2, -14236.2, -5568.59, 6046.03, -14756, -6219.96, 6140.03, 0, 0, 0, NULL), ('surf_discovery_njv', 4, 2, 0, 4777.85, -12897.9, -2356.69, 4457.26, -12475.3, -2156.18, 0, 0, 0, NULL), ('surf_discovery_njv', 3, 3, 3, -1547.28, -12905.6, 6462.03, -1991.97, -12425.4, 6564.03, 0, 0, 0, NULL), ('surf_discovery_njv', 2, 3, 0, -8005.48, 6208.52, -305.969, -8471.97, 5604.03, -203.969, 0, 0, 0, NULL), ('surf_discovery_njv', 1, 1, 0, 4267.42, 13588.2, 1044.74, 4345.39, 13090, 1159.67, 0, 0, 0, NULL), ('surf_discovery_njv', 0, 3, 1, -2057.11, 315.416, 3542.03, -2495.97, -569.484, 3644.03, 0, 0, 0, NULL), ('surf_dionysus', 1, 2, 1, 10020.3, 88.2658, -4655.97, 10073, -86.8786, -4576.03, 0, 0, 0, NULL), ('surf_dionysus', 0, 5, 1, -80.5421, -89.9065, 17.0312, -250.19, 92.0976, 104.031, 0, 0, 0, NULL), ('surf_unreal_njv_', 11, 4, 4, -809.89, -703.969, -10119.9, -1037.89, 689.898, -10795, 0, 0, 0, ''), ('surf_unreal_njv_', 12, 4, 5, -13397.5, -703.969, -10835.8, -13967.1, 703.969, -11081.2, 0, 0, 0, ''), ('surf_unreal_njv_', 13, 4, 6, -7094.48, -703.969, -11976.6, -7998.04, 689.827, -13187, 0, 0, 0, ''), ('surf_savant_njv', 8, 1, 0, -13798.2, 4798.5, 1926.89, -13423.9, 5134.22, 2215.97, 0, 0, 1, 'BONUS 1'), ('surf_savant_njv', 9, 2, 0, -14414.1, 14843.8, -1319.97, -12802.1, 14621, -1047.66, 0, 0, 1, 'BONUS 1');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_christmas', 14, 3, 0, -14689.4, 995.618, 5518.66, -14141.2, 186.85, 3648.03, 0, 0, 2, 'BONUS 2'), ('surf_commune_too_beta5', 8, 1, 0, 13311, 11995, 3654.08, 13999, 11034.2, 3498.79, 0, 0, 1, 'BONUS 1'), ('surf_commune_too_beta5', 9, 2, 0, -10789, -3218.76, 506.37, -10971, -3125.42, 354.042, 0, 0, 1, 'BONUS 1'), ('surf_commune_too_beta5', 10, 1, 0, -6258.88, -1410.21, -215.969, -6639.97, -2173.45, -101.289, 0, 0, 2, 'BONUS 2'), ('surf_commune_too_beta5', 11, 2, 0, -1362.06, -1712.03, -1325.65, -1519.97, -1869.72, -1581.73, 0, 0, 2, 'BONUS 2'), ('surf_construction', 4, 1, 0, -12289.7, -2046.1, -767.969, -13318.8, -1020.52, -48.0312, 0, 0, 1, 'BONUS 1'), ('surf_construction', 5, 2, 0, -14048, -1442.72, -3361.66, -13763.5, -1631.51, -3487.97, 0, 0, 1, 'BONUS 1'), ('surf_core_fix', 7, 1, 0, -8101.55, 509.031, -5301.82, -8723.73, 1148.79, -5445.47, 0, 0, 1, 'BONUS 1'), ('surf_core_fix', 8, 2, 0, -3521.39, 603.399, -9977.71, -4283.69, 1105.82, -9717.53, 0, 0, 1, 'BONUS 1'), ('surf_core_fix', 9, 1, 0, -5601.59, 4439.74, -6684.61, -4350.03, 3931.91, -6395.92, 0, 0, 2, 'BONUS 2'), ('surf_core_fix', 10, 2, 0, -7288.46, 4436.03, -8935.86, -7162, 3943.55, -8751.15, 0, 0, 2, 'BONUS 2'), ('surf_crystal', 10, 1, 0, -959.969, -2792.42, 6835.54, 447.969, -2180.04, 6721.56, 0, 0, 2, 'BONUS 2'), ('surf_crystal', 11, 2, 0, 2582.48, -2109.67, 6152.03, 3058.52, -2048.03, 6387.08, 0, 0, 2, 'BONUS 2'), ('surf_diminsion_', 9, 2, 4, -8320.03, -1793.26, 6914.94, -10365.3, -2047.97, 7243.32, 0, 0, 1, 'BONUS 1'), ('surf_diminsion_', 13, 2, 2, -4801.92, -11329.7, 2848.03, -4863.97, -12220.3, 3048.99, 0, 0, 2, 'BONUS 2'), ('surf_diminsion_', 14, 2, 3, -2625.11, -13441.1, 2848.03, -3517.5, -13504, 3027.3, 0, 0, 2, 'BONUS 2'), ('surf_extremex2_5_njv', 7, 1, 0, -13757.5, -9599.97, 11808.9, -13280.9, -8864.85, 11704, 0, 0, 1, 'BONUS 1'), ('surf_extremex2_5_njv', 8, 2, 0, 6705.75, -9172.78, 7450.86, 6806.06, -9260.66, 7542.19, 0, 0, 1, 'BONUS 1'), ('surf_globalchaos', 7, 1, 0, -12784, -493.11, -6796.76, -11827, -776.855, -6887.97, 0, 0, 1, 'BONUS 1'), ('surf_globalchaos', 8, 2, 0, -12470.6, -722.651, -8807.97, -12135.3, -490.031, -8702.12, 0, 0, 1, 'BONUS 1'), ('surf_goldarn', 9, 1, 0, 5915.93, 395.108, 13401.5, 6680.38, 161.031, 13484.8, 0, 0, 1, 'BONUS 1'), ('surf_goldarn', 10, 2, 0, 5722.12, 164.527, 11643.7, 6873.97, 2033.6, 11531.4, 0, 0, 1, 'BONUS 1'), ('surf_hyper-', 6, 1, 0, 7328.69, 8678.5, -12588, 7076.03, 8161.99, -12464.5, 0, 0, 1, 'BONUS 1'), ('surf_hyper-', 7, 2, 0, 7567.72, 9933.88, -8347.4, 7477.27, 9428.45, -8631.29, 0, 0, 1, 'BONUS 1'), ('surf_hyper-', 8, 4, 0, 7089.6, 6941.13, -10636, 6812.03, 6593.97, -10509.1, 0, 0, 1, 'BONUS 1'), ('surf_hyper-', 9, 4, 1, 12368.7, 4873.06, -8231.97, 12455.2, 4745.3, -7944.03, 0, 0, 1, 'BONUS 1'), ('surf_hyper-', 10, 4, 2, 6784.57, 9571.47, -5771.35, 7010.46, 9808.03, -5496.03, 0, 0, 1, 'BONUS 1'), ('surf_ing_njv', 4, 1, 0, -510.834, 3136.58, -7679.97, -16.0312, 3586.29, -7558.27, 0, 0, 2, 'BONUS 2'), ('surf_ing_njv', 5, 2, 0, -1794.22, 4671.12, -9385.97, -2302.33, 4162.14, -9535.97, 0, 0, 2, 'BONUS 2'), ('surf_injection_njv', 9, 1, 0, 5319.01, -2111.97, 1161.66, 5128.03, -1986.99, 1229.2, 0, 0, 1, 'BONUS 1'), ('surf_injection_njv', 10, 2, 0, 7793.37, -1857.52, -751.969, 8238.75, -2239.97, -530.363, 0, 0, 1, 'BONUS 1');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_injection_njv', 11, 2, 1, 7730.35, -1853.79, -527.969, 8239.2, -1552.03, -393.314, 0, 0, 1, 'BONUS 1'), ('surf_injection_njv', 12, 2, 2, 7729.29, -2241.54, -527.969, 8238.02, -2543.97, -394.632, 0, 0, 1, 'BONUS 1'), ('surf_inrage2_', 0, 1, 0, 7127.03, -2666.74, 6747.55, 4825.97, -2158.27, 6647.05, 0, 0, 0, 'Start 0'), ('surf_inrage2_', 1, 2, 0, -3918.89, 10160.1, -660.469, -3481.71, 10315.7, -563.046, 0, 0, 0, 'Start 0'), ('surf_inrage2_', 2, 2, 1, -3810.16, 10084.8, -560.469, -3590.49, 10156.4, -660.469, 0, 0, 0, 'Start 0'), ('surf_inrage2_', 3, 1, 0, 7126.04, -2664.66, 6647.05, 4820.83, -2152.23, 7175.97, 0, 0, 1, 'BONUS 1'), ('surf_inrage2_', 4, 2, 0, 69.4967, 232.963, -2304.03, 392.699, -103.651, -2176.03, 0, 0, 1, 'BONUS 1'), ('surf_inrage2_', 5, 4, 0, 4503.97, -8667.55, 4594.33, 7448.03, -7904.45, 3821.28, 0, 0, 0, 'Start 0'), ('surf_inrage2_', 6, 4, 1, 5557.9, 779.969, -66.165, 6423.47, 300.031, -302.505, 0, 0, 0, 'Start 0'), ('surf_inrage2_', 7, 4, 2, -3852.61, -10247.5, 6027.47, -3563.49, -10583.1, 5078.35, 0, 0, 0, 'Start 0'), ('surf_inrage2_', 8, 4, 3, -2288.03, -777.643, 2674.85, -5103.97, 1956.62, 1322.54, 0, 0, 0, 'Start 0'), ('surf_lessons', 12, 1, 0, 4899.97, -8593.29, -407.258, 4516.03, -8249.67, -347.44, 0, 0, 2, 'BONUS 2'), ('surf_lessons', 13, 2, 0, 4660.44, -9445.18, -1375.97, 4755.64, -9483.97, -1270.65, 0, 0, 2, 'BONUS 2'), ('surf_lessons', 14, 1, 0, 6874.53, -12165.9, 2032.03, 7378.26, -12682.4, 2123.18, 0, 0, 3, 'BONUS 3'), ('surf_lessons', 15, 2, 0, 2082.08, -8543.08, -4555.97, 1488.03, -8156.1, -4470.12, 0, 0, 3, 'BONUS 3'), ('surf_liberation2', 11, 1, 0, 1535.97, 15619.9, -796.19, 512.031, 15871.7, -703.499, 0, 0, 2, 'BONUS 2'), ('surf_liberation2', 12, 2, 0, 1533.45, 7072.03, -4334.36, 512.031, 7319.93, -4177.25, 0, 0, 2, 'BONUS 2'), ('surf_lore_e', 8, 1, 0, 1769.57, -2172.58, -653.488, 1622.26, -2023.67, -759.969, 0, 0, 1, 'BONUS 1'), ('surf_lore_e', 9, 2, 0, 1414.4, 2008.97, -1141.27, 1502.71, 2098.97, -1072.76, 0, 0, 1, 'BONUS 1'), ('surf_lore_e', 10, 0, 0, 870.031, -690.829, -608.721, 1105.53, -256.202, -822.332, 0, 0, 0, ''), ('surf_methadone', 6, 1, 0, 9533.41, 6631.97, 11749.4, 8961.08, 5352.03, 11891.5, 0, 0, 1, 'BONUS 1'), ('surf_methadone', 7, 2, 0, 12497.3, 5570.48, 1771.13, 12096, 6404.01, 1912.16, 0, 0, 1, 'BONUS 1'), ('surf_methadone', 8, 4, 0, 8512.03, 5676.28, 8168.4, 9151.39, 6311.97, 7832.18, 0, 0, 1, 'BONUS 1'), ('surf_methadone', 9, 4, 1, 9936.03, 5749.98, 1932.79, 9514.66, 7143.97, 1627.85, 0, 0, 1, 'BONUS 1'), ('surf_methadone', 10, 2, 1, 6892.69, 6413.25, 1774.13, 7295.97, 5578.51, 1932.08, 0, 0, 1, 'BONUS 1'), ('surf_plaguelands_beta7a', 7, 1, 0, 10048.6, -5097.97, -3148.7, 10431.5, -4799.23, -3277.99, 0, 0, 1, 'BONUS 1'), ('surf_plaguelands_beta7a', 8, 2, 0, 10305.7, -2718, -4239.97, 10173.8, -3079.97, -4098.24, 0, 0, 1, 'BONUS 1'), ('surf_plaguelands_beta7a', 9, 2, 1, 10399.8, -2812.42, -4239.97, 10311, -3079.97, -4124.49, 0, 0, 1, 'BONUS 1'), ('surf_plaguelands_beta7a', 10, 2, 2, 10078.4, -2812.42, -4239.97, 10169.8, -3079.97, -4118.65, 0, 0, 1, 'BONUS 1'), ('surf_plaguelands_beta7a', 11, 0, 0, -1049.47, 4092.95, -3072.03, -1199.21, 3072.03, -3262.3, 0, 0, 0, ''), ('surf_proximity_final', 7, 1, 0, -9895.97, 2957.8, 6674.74, -9767.92, 2577.33, 6949.97, 0, 0, 1, 'BONUS 1');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_proximity_final', 8, 2, 0, -6567.2, 2820.52, 4494.67, -6655.97, 3082.45, 4629.76, 0, 0, 1, 'BONUS 1'), ('surf_quasar_njv', 5, 2, 0, 1502.82, -12601.9, -6791.03, 1849.67, -8862.03, -7318.94, 0, 0, 0, ''), ('surf_sexplizooimed', 8, 1, 0, -1587.66, -10019, 3880.16, -2097.98, -9507.03, 3980.83, 0, 0, 1, 'BONUS 1'), ('surf_sexplizooimed', 9, 2, 0, -2324.51, -10113.2, -727.969, -2455.73, -9411.97, -344.031, 0, 0, 1, 'BONUS 1'), ('surf_sunset_njv', 7, 2, 0, 119.4, -1346.51, -2519.97, -124.393, -1775.97, -2268.85, 0, 0, 1, 'BONUS 1'), ('surf_togo_njv', 2, 4, 0, -11034.4, 6143.97, -2192.06, -10640.2, 4768.03, -2309.46, 0, 0, 0, ''), ('surf_togo_njv', 3, 4, 1, -14592, 5393.1, -3547.18, -14465.2, 5519.97, -3678.44, 0, 0, 0, ''), ('surf_togo_njv', 4, 1, 0, -10526.8, 10141, 1195.63, -9825.2, 9441.4, 1087.63, 0, 0, 1, 'BONUS 1'), ('surf_togo_njv', 5, 2, 0, -10207.9, 11476, 1391.63, -10144.1, 11432.3, 1599.63, 0, 0, 1, 'BONUS 1'), ('surf_togo_njv', 6, 2, 1, -11824.3, 9770.75, 1391.63, -11865, 9822.74, 1599.63, 0, 0, 1, 'BONUS 1'), ('surf_togo_njv', 7, 2, 2, -10142.4, 8147.86, 1470.35, -10204.9, 8101.11, 1599.63, 0, 0, 1, 'BONUS 1'), ('surf_togo_njv', 8, 2, 3, -8485.69, 9821.13, 1477.97, -8541.16, 9765.36, 1599.63, 0, 0, 1, 'BONUS 1'), ('surf_togo_njv', 9, 4, 2, -6013.54, 1777.1, -7584.03, -5655.86, -767.969, -8826.85, 0, 0, 0, ''), ('surf_togo_njv', 10, 4, 3, 6640.03, 708.956, -8475.7, 7166.93, 260.518, -8384.03, 0, 0, 0, ''), ('surf_togo_njv', 11, 4, 4, 9322.62, -470.979, -12448, 8961.33, 1503.97, -13328.6, 0, 0, 0, ''), ('surf_torque_', 7, 1, 0, 145.969, 3431.94, -419.842, 900.492, 2793.56, -569.969, 0, 0, 2, 'BONUS 2'), ('surf_torque_', 8, 2, 0, 6704.97, 3288.99, -891.591, 6741.03, 2940.72, -1225.08, 0, 0, 2, 'BONUS 2'), ('surf_torque2_njv', 9, 1, 0, 3769.35, 5632.36, 2072.51, 4114.37, 6396.56, 2732.97, 0, 0, 2, 'BONUS 2'), ('surf_torque2_njv', 10, 2, 0, 725.29, 6346.64, -2782.97, 981.969, 5724.25, -2652.97, 0, 0, 2, 'BONUS 2'), ('surf_tronia_njv', 4, 3, 2, 2548.96, 258.362, -6942.47, 2032.9, -259.961, -6714.53, 0, 0, 0, ''), ('surf_tronia_njv', 5, 5, 0, -139.903, 6664.03, 4891.49, -476.582, 7671.97, 5053.35, 0, 0, 1, 'BONUS 1'), ('surf_tronia_njv', 6, 2, 0, 15604.2, 7422.21, 4648.03, 15962, 6914.5, 4803.95, 0, 0, 1, 'BONUS 1'), ('surf_velocity_nsf', 7, 1, 0, -3035.09, -2330.66, -8391.97, -3415.97, -2583.57, -8288.33, 0, 0, 1, 'BONUS 1'), ('surf_velocity_nsf', 8, 2, 0, -1048.03, -2385.25, -9791.94, -1171.03, -2526.81, -9608.03, 0, 0, 1, 'BONUS 1'), ('surf_voteforthisone', 11, 1, 0, -8443.28, 8923.25, 10419, -8322.25, 9092.22, 10304, 0, 0, 2, 'BONUS 2'), ('surf_voteforthisone', 12, 2, 0, -9062.45, 13527.1, 2048.03, -7710.78, 12776, 2445.8, 0, 0, 2, 'BONUS 2'), ('surf_quasar_njv', 6, 1, 0, -10062.3, -12472.2, 10564, -10491.3, -10281, 10717.9, 0, 0, 1, 'BONUS 1'), ('surf_quasar_njv', 7, 2, 0, -9206.5, -11077.8, 3329.03, -8654.7, -11716.2, 3748.75, 0, 0, 1, 'BONUS 1'), ('surf_quasar_njv', 8, 2, 1, -8971.54, -10845.9, 3329.03, -8654.7, -11065.3, 3600.91, 0, 0, 1, 'BONUS 1'), ('surf_quasar_njv', 9, 2, 2, -8970, -11948.6, 3329.03, -8654.7, -11700.6, 3619.64, 0, 0, 1, 'BONUS 1'), ('surf_numbers', 0, 1, 0, 1278.13, 1599.97, 262.58, 994.97, 832.031, 193.533, 0, 0, 0, 'Start 0'), ('surf_numbers', 1, 3, 0, 5024.03, 1599.09, 929.849, 5312.03, 832.031, 896.394, 0, 0, 0, 'Start 0');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_numbers', 2, 3, 1, 9053.63, 1596.23, 896.031, 8769.86, 832.031, 924.342, 0, 0, 0, 'Start 0'), ('surf_numbers', 3, 3, 2, -5153.93, 1724.81, 864.031, -5439.97, 961.346, 893.764, 0, 0, 0, 'Start 0'), ('surf_numbers', 4, 3, 3, -10272.2, 1719.97, 192.146, -10549.5, 968.031, 218.296, 0, 0, 0, 'Start 0'), ('surf_numbers', 5, 3, 4, -14498.2, 1694.83, 192.031, -14779.7, 928.031, 226.373, 0, 0, 0, 'Start 0'), ('surf_numbers', 6, 3, 5, 1947.84, -1600.03, 3794.91, 1664.03, -2357.01, 3776.04, 0, 0, 0, 'Start 0'), ('surf_numbers', 7, 3, 6, 7037.56, -1632.03, 4020.39, 6752.03, -2398.75, 4000.9, 0, 0, 0, 'Start 0'), ('surf_numbers', 8, 3, 7, 11324.8, -1600.03, 3808.41, 11040.5, -2364.68, 3776.03, 0, 0, 0, 'Start 0'), ('surf_numbers', 9, 2, 0, -510.232, 347.327, 494.031, -338.113, 495.218, 384.031, 0, 0, 0, 'Start 0'), ('surf_numbers', 10, 1, 0, -13216.5, -4870.27, 2239.65, -13728, -5691.04, 2333.33, 0, 0, 1, 'BONUS 1'), ('surf_numbers', 11, 2, 0, -340.408, 495.715, 494.031, -514.715, 347.11, 384.031, 0, 0, 1, 'BONUS 1'), ('surf_numbers', 12, 1, 0, -7842, 6881.49, 1536.03, -8543.97, 5944.24, 1696.5, 0, 0, 2, 'BONUS 2'), ('surf_numbers', 13, 2, 0, -341.758, 493.023, 514.031, -511.655, 347.049, 384.031, 0, 0, 2, 'BONUS 2'), ('surf_skill8_e', 11, 2, 1, -2480.04, 7615.97, 15164.4, -1623.29, 6745.26, 14912, 0, 0, 0, ''), ('surf_milkyway_', 0, 2, 0, -6393.61, 1540.15, 11464, -4869.73, 2300.91, 12355, 0, 0, 0, 'End 0'), ('surf_skill8_', 12, 2, 1, -2495.97, 7074.23, 15166.2, -1681.46, 7362.99, 14912, 0, 0, 0, ''), ('surf_skill8_', 13, 0, 0, 507.576, 7554.06, 15870, 1.08252, 7756.9, 15744, 0, 0, 0, ''), ('surf_skill8_m', 11, 2, 1, -1635.05, 6788.91, 15168, -2454.82, 7584.47, 14912, 0, 0, 0, ''), ('surf_sunset', 4, 1, 1, 12601.9, -13206.7, -1025.97, 13001.8, -13504, -923.969, 0, 0, 0, NULL), ('surf_sunset', 8, 3, 2, 3392.03, -5903.69, 6928.36, 3774.16, -5424.03, 7017.18, 0, 0, 0, ''), ('surf_sunset', 0, 3, 3, -1814.74, 1806.11, -377.969, -2301.41, 2295.47, -275.969, 0, 0, 0, NULL), ('surf_sunset', 5, 3, 4, 1411.55, -6808.53, 7950.03, 1640.63, -6548.47, 8052.03, 0, 0, 0, NULL), ('surf_concept_njv', 8, 6, 0, -351.456, -4732.97, -11247.5, -80.1453, -3425.05, -11477.5, 0, 0, 0, 'SpeedStart 0'), ('surf_milkyway_', 1, 2, 1, -4861.48, 1795.81, 11456, -4096.03, 2550.81, 12104.1, 0, 0, 0, ''), ('surf_milkyway_', 2, 2, 2, -6403.27, 1796.35, 11456, -7165.9, 2550.47, 12105.5, 0, 0, 0, ''), ('surf_milkyway_', 3, 1, 0, -5891.34, 3350.6, 10365, -5355.89, 2809.58, 10333.3, 0, 0, 0, ''), ('surf_milkyway_', 4, 4, 0, -8306.72, 3961.55, 95.9688, -2944.03, 2951.61, -251.219, 0, 0, 0, ''), ('surf_milkyway_', 5, 4, 1, -3584.03, 3848.12, -4380.59, -7677.53, 4343.16, -6783.97, 0, 0, 0, ''), ('surf_milkyway_', 6, 4, 2, -8695.79, -1524.07, -9184.03, -2463.62, -521.486, -11204.6, 0, 0, 0, ''), ('surf_milkyway_', 7, 4, 3, -4881.94, -11557.7, 12478.3, -6399.97, -11017.1, 11172.8, 0, 0, 0, ''), ('surf_milkyway_', 8, 6, 0, -7148.71, 3347.23, 11425, -4096.03, 2422.23, 11513.5, 0, 0, 0, 'Start 0'), ('surf_pure-', 9, 6, 1, 9712.08, 2452.51, 1505.72, 9461.7, 2435.38, 1633.4, 0, 0, 0, 'Start 0'), ('surf_minecraft', 12, 4, 3, 9957.93, -5331.61, 4667.97, 10619.9, -6721.97, 3746.44, 0, 0, 0, ''), ('surf_sluice', 2, 4, 0, -2369.67, 4319.97, 11252.3, -2096.93, 3040.03, 10217.2, 0, 0, 0, 'Start 0');");
	SQL_AddQuery(h_addZones, "INSERT INTO `ck_zones` (`mapname`, `zoneid`, `zonetype`, `zonetypeid`, `pointa_x`, `pointa_y`, `pointa_z`, `pointb_x`, `pointb_y`, `pointb_z`, `vis`, `team`, `zonegroup`, `zonename`) VALUES ('surf_sluice', 3, 4, 1, 2176.03, 4582.25, 8959.7, 3769.34, 4700.49, 8192.03, 0, 0, 0, 'Start 0'), ('surf_sluice', 4, 4, 2, 3842.75, 7556.11, 4351.97, 5631.97, 7933.08, 2305.68, 0, 0, 0, 'Start 0'), ('surf_sluice', 5, 4, 3, 12416, 6528.36, -71.1629, 11136, 5046.21, -3000.83, 0, 0, 0, 'Start 0'), ('surf_mellow', 2, 4, 0, 438.166, 1664.03, -2760.94, -370.544, 1919.97, -2787.86, 0, 0, 0, 'Start 0'), ('surf_mellow', 3, 4, 1, 959.969, -4607.01, -5759.14, -926.202, -4544.5, -5376.03, 0, 0, 0, 'Start 0'), ('surf_mellow', 4, 4, 2, 796.33, -10752, -9221.39, 555.533, -11772.8, -10176, 0, 0, 0, 'Start 0'), ('surf_elysium', 5, 1, 0, -15108.7, 1472.03, 14753.4, -15616, 3005.91, 15095.1, 0, 0, 1, 'BONUS 1'), ('surf_elysium', 6, 2, 0, -4059.67, 3006.09, 9280.03, -2464.03, 1472.64, 9615.22, 0, 0, 1, 'BONUS 1'), ('surf_stagejuan_ksf_', 3, 2, 0, 494.896, -495.656, 2560.03, -504.061, 502.797, 3230.64, 0, 0, 1, 'BONUS 1'), ('surf_stagejuan_ksf_', 2, 1, 0, -4044.11, 2106.06, -2309.97, -4539.71, 1671.28, -2559.97, 0, 0, 1, 'BONUS 1'), ('surf_tronia_njv', 7, 1, 0, 10573.4, 527.421, -9514.12, 10616.4, 445.99, -9558.32, 0, 0, 2, 'BONUS 2'), ('surf_tronia_njv', 8, 2, 0, 10874.7, -327.876, -14972, 11483.3, 115.896, -14972, 0, 0, 2, 'BONUS 2');");
	SQL_ExecuteTransaction(g_hDb, h_addZones, SQLTxn_ZoneInsertSuccess, SQLTxn_ZoneInsertFailed, client);
}

public void SQLTxn_ZoneInsertFailed(Handle db, any data, int numQueries, const char[] error, int failIndex, any[] queryData)
{
	if (IsValidClient(data))
		PrintToChat(data, "[%cCK%c] Inserting zones %cfailed!%c. Check error logs.", MOSSGREEN, WHITE, RED, WHITE);

	g_insertingInformation = false;
	LogError("[ckSurf] SQL Zone insertion failed! Index: %i Error: %s", failIndex, error);
}

public void SQLTxn_ZoneInsertSuccess(Handle db, any data, int numQueries, Handle[] results, any[] queryData)
{
	if (IsValidClient(data))
		PrintToChat(data, "[%cCK%c] Successfully inserted map zones!", MOSSGREEN, WHITE);

	db_selectMapZones();
	g_insertingInformation = false;
}

public Action Admin_InsertMapZones(int client, int args)
{
	if (g_insertingInformation)
	{
		PrintToChat(client, "[%cCK%c] Wait for inserting to finish, before starting it again..", MOSSGREEN, WHITE);
		return Plugin_Handled;
	}

	Handle MapZoneMenu = CreateMenu(MapZoneHandler);
	SetMenuTitle(MapZoneMenu, "Insert MapZones\n WARNING: This action will delete all existing MapZone data\n and replace it with ckSurf's premade data.\n Do you wish to continue?");
	AddMenuItem(MapZoneMenu, "0", "NO");
	AddMenuItem(MapZoneMenu, "0", "NO");
	AddMenuItem(MapZoneMenu, "0", "NO");
	AddMenuItem(MapZoneMenu, "1", "YES");
	AddMenuItem(MapZoneMenu, "0", "NO");
	SetMenuExitBackButton(MapZoneMenu, true);
	DisplayMenu(MapZoneMenu, client, MENU_TIME_FOREVER);

	return Plugin_Handled;
}

public int MapZoneHandler(Handle tMenu, MenuAction action, int client, int item)
{
	switch (action)
	{
		case MenuAction_Select:
		{
			char selection[16];
			GetMenuItem(tMenu, item, selection, sizeof(selection));
			if (StringToInt(selection) == 1)
				db_deleteAllZones(client);
		}
		case MenuAction_End:
		{
			CloseHandle(tMenu);
		}
	}
}

public Action Admin_ResetRecords(int client, int args)
{
	if (args < 1)
	{
		ReplyToCommand(client, "[CK] Usage: sm_resetplayertimes <steamid> [<mapname>]");
		return Plugin_Handled;
	}
	else
	{
		char szSteamID[128];
		char szArg[128];
		Format(szSteamID, 128, "");
		for (int i = 1; i < 6; i++)
		{
			GetCmdArg(i, szArg, 128);
			if (!StrEqual(szArg, "", false))
				Format(szSteamID, 128, "%s%s", szSteamID, szArg);
		}
		if (args == 5)
		{
			db_resetPlayerRecords(client, szSteamID);
		}
		else if (args == 6)
		{
			char szMapName[128];
			GetCmdArg(6, szMapName, 128);
			db_resetPlayerRecords2(client, szSteamID, szMapName);
		}
	}
	return Plugin_Handled;
}

public Action Admin_RefreshProfile(int client, int args)
{
	if (args == 0)
	{
		ReplyToCommand(client, "[CK] Usage: sm_refreshprofile <steamid>");
		return Plugin_Handled;
	}
	if (args > 0)
	{
		char szSteamID[128];
		char szArg[128];
		Format(szSteamID, 128, "");
		for (int i = 1; i < 6; i++)
		{
			GetCmdArg(i, szArg, 128);
			if (!StrEqual(szArg, "", false))
				Format(szSteamID, 128, "%s%s", szSteamID, szArg);
		}
		RecalcPlayerRank(client, szSteamID);
	}
	return Plugin_Handled;
}

public Action Admin_ResetMapRecord(int client, int args)
{
	if (args != 6)
	{
		ReplyToCommand(client, "[CK] Usage: sm_resetplayermaptime <steamid> <mapname>");
		return Plugin_Handled;
	}
	else
	{
		char szSteamID[128];
		char szArg[128];
		Format(szSteamID, 128, "");
		for (int i = 1; i < 6; i++)
		{
			GetCmdArg(i, szArg, 128);
			if (!StrEqual(szArg, "", false))
				Format(szSteamID, 128, "%s%s", szSteamID, szArg);
		}
		if (args == 6)
		{
			char szMapName[128];
			GetCmdArg(6, szMapName, 128);
			db_resetPlayerMapRecord(client, szSteamID, szMapName);
		}
	}
	return Plugin_Handled;
}

public Action Admin_ResetChallenges(int client, int args)
{
	if (args == 0)
	{
		ReplyToCommand(client, "[CK] Usage: sm_resetplayerchallenges <steamid>");
		return Plugin_Handled;
	}
	if (args > 0)
	{
		char szSteamID[128];
		char szArg[128];
		Format(szSteamID, 128, "");
		for (int i = 1; i < 6; i++)
		{
			GetCmdArg(i, szArg, 128);
			if (!StrEqual(szArg, "", false))
				Format(szSteamID, 128, "%s%s", szSteamID, szArg);
		}
		db_resetPlayerResetChallenges(client, szSteamID);
	}
	return Plugin_Handled;
}

public Action Admin_ResetMapRecords(int client, int args)
{
	if (args != 1)
	{
		ReplyToCommand(client, "[CK] Usage: sm_resetmaptimes <mapname>");
		return Plugin_Handled;
	}
	if (args == 1)
	{
		char szMapName[128];
		GetCmdArg(1, szMapName, 128);
		db_resetMapRecords(client, szMapName);
	}
	return Plugin_Handled;
}

public Action Admin_DeleteMapReplay(int client, int args)
{
	if (args == 0)
	{
		ReplyToCommand(client, "[CK] Usage: sm_resetproreplay <mapname>");
		return Plugin_Handled;
	}
	if (args > 0)
	{
		char szMap[128];
		char szArg[128];
		Format(szMap, 128, "");
		for (int i = 1; i < 6; i++)
		{
			GetCmdArg(i, szArg, 128);
			if (!StrEqual(szArg, "", false))
				Format(szMap, 128, "%s%s", szMap, szArg);
		}
		DeleteReplay(client, 0, szMap);
	}
	return Plugin_Handled;
}

public Action Admin_ResetExtraPoints(int client, int args)
{
	SQL_TQuery(g_hDb, sql_selectMutliplierCallback, "UPDATE playerrank SET multiplier ='0'", client);
	return Plugin_Handled;
}

public void sql_selectMutliplierCallback(Handle owner, Handle hndl, const char[] error, any data)
{
	int client = data;
	PrintToConsole(client, "Extra points for all players reseted.");
}

public Action Admin_DeleteCheckpoints(int client, int args)
{
	for (int i = 0; i < MAXPLAYERS + 1; i++)
		for (int x = 0; x < MAXZONEGROUPS; x++)
			for (int k = 0; k < CPLIMIT; k++)
				g_fCheckpointTimesRecord[x][i][k] = 0.0;

	db_deleteCheckpoints();
}
